<?php
        $configPath = '../landing_pages/config.json';

        // Fetch existing configuration
        $config = json_decode(file_get_contents($configPath), true);

        // Handle API updates
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            $updatedAPIs = $_POST['apis'] ?? [];
            $config['api_credentials'] = $updatedAPIs;

            // Save updates to config.json
            file_put_contents($configPath, json_encode($config, JSON_PRETTY_PRINT));
            echo json_encode(['status' => 'success', 'message' => 'API configurations updated successfully']);
            exit;
        }

        // Display current API keys
        $currentAPIs = $config['api_credentials'];
        ?>

        <!DOCTYPE html>
        <html>
        <head>
            <title>API Management</title>
            <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
        </head>
        <body>
            <h1>Manage API Keys</h1>
            <form id="api-form">
                <div id="api-list">
                    <?php foreach ($currentAPIs as $api => $key): ?>
                        <div class="api-item">
                            <label><?= htmlspecialchars($api) ?></label>
                            <input type="text" name="apis[<?= htmlspecialchars($api) ?>]" value="<?= htmlspecialchars($key) ?>">
                            <button type="button" class="delete-api">Delete</button>
                        </div>
                    <?php endforeach; ?>
                </div>
                <button type="button" id="add-api">Add API</button>
                <button type="submit">Save Changes</button>
            </form>

            <script>
                // Add a new API input
                $('#add-api').on('click', function () {
                    $('#api-list').append(`
                        <div class="api-item">
                            <input type="text" name="apis[new_api]" placeholder="API Name">
                            <input type="text" name="apis[new_key]" placeholder="API Key">
                            <button type="button" class="delete-api">Delete</button>
                        </div>
                    `);
                });

                // Delete an API input
                $(document).on('click', '.delete-api', function () {
                    $(this).closest('.api-item').remove();
                });

                // Submit form via AJAX
                $('#api-form').on('submit', function (e) {
                    e.preventDefault();
                    $.ajax({
                        url: '/admin/api_management.php',
                        method: 'POST',
                        data: $(this).serialize(),
                        success: function (response) {
                            alert(response.message);
                        }
                    });
                });
            </script>
        </body>
        </html>