<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

require 'path.php';
require( 'include/constants.php' );
require( 'include/site_constants.php' );

//*************************************************************************************************

// Get the current page url
$_rewrite_hostName = '';
if ( isset( $_SERVER['HTTP_HOST'] ) ) {                 // if http host is set then use it
	$_rewrite_hostName = $_SERVER['HTTP_HOST'];
} elseif ( isset( $_SERVER['SERVER_NAME'] ) ) {         // else if server name is set then use that
	$_rewrite_hostName = $_SERVER['SERVER_NAME'];
}                                                       // if none of them is present then we are in ssh and we probably
														// do not need url rewrite anyway

// Build URL. Use SCRIPT_ROOT to decide if site is running in http or https
$_rewrite_pageUrl = ( stristr( SCRIPT_ROOT, 'https://' ) ? 'https' : 'http' ) . '://' . $_rewrite_hostName . $_SERVER['REQUEST_URI'];


// Get the current page slug/name
$_rewrite_pageName = str_replace( SCRIPT_ROOT, '', $_rewrite_pageUrl );
$_rewrite_pageName = explode( '?', $_rewrite_pageName );
$_rewrite_pageName = $_rewrite_pageName[0];


//*************************************************************************************************
// Handle admin/v2
//*************************************************************************************************

// Is URL for admin/v2
if ( substr($_rewrite_pageName, 0, strlen(ADMIN_FOLDER_NAME.'/v2/')) === ADMIN_FOLDER_NAME.'/v2/' ) {
	require PATH . ADMIN_FOLDER_NAME . '/v2/index.php';
	die;
}

// Is URL for admin
if ( substr($_rewrite_pageName, 0, strlen(ADMIN_FOLDER_NAME.'/')) === ADMIN_FOLDER_NAME.'/' && file_exists($_rewrite_pageName) ) {
	require PATH . $_rewrite_pageName;
	die;
}

//*************************************************************************************************
// If page name has .htm, then it means we can include a php against it (if exists)
//*************************************************************************************************

if ( substr( $_rewrite_pageName, - 4 ) == '.htm' ) {

	// Get page name without .htm
	$_rewrite_pageNameOnly = str_replace( '.htm', '', $_rewrite_pageName );

	// Load page if it exists
	$pageToLoad = rewriteLoadFile( $_rewrite_pageNameOnly );
	if ( $pageToLoad != '' ) {
		require $pageToLoad;
		die;
	}

}

//*************************************************************************************************
// If Seo url page names are defined, then use it land on a possible seo page
//*************************************************************************************************

if ( isset( $SEO_CONTENT_PAGE_NAMES ) && is_array( $SEO_CONTENT_PAGE_NAMES ) ) {

	// Check for each seo slug defined
	foreach ( $SEO_CONTENT_PAGE_NAMES as $_seo_pageName => $_seo_slug ) {

		// If slug matches the current page slug
		if ( $_rewrite_pageName == $_seo_slug || $_rewrite_pageName == $_seo_slug . '/' ) {

			// Load page if it exists
			$pageToLoad = rewriteLoadFile( $_seo_pageName );
			if ( $pageToLoad != '' ) {
				require $pageToLoad;
				die;
			}

			// Skip checking further slugs
			break;
		}
	}
}

//*************************************************************************************************

// Get parts of page name
$_rewrite_pageNameParts = explode( '/', $_rewrite_pageName );

//*************************************************************************************************
// Handle requests based on the base part of page name
//*************************************************************************************************

switch ( $_rewrite_pageNameParts[0] ) {

	//*************************************************************************************************
	// Handle for v9 style category url
	//*************************************************************************************************
	case 'c':
		array_shift( $_rewrite_pageNameParts );                                               // remove c
		$_GET['path'] = implode( '/', $_rewrite_pageNameParts );                              // get path
		$pageToLoad   = rewriteLoadFile( 'category' );                                          // load category.php
		if ( $pageToLoad != '' ) {
			require $pageToLoad;
			die;
		}
		break;

	//*************************************************************************************************
	// Handle for v9 style product url
	//*************************************************************************************************
	case 'p':
	    if ( defined('USE_SEO_URLS_FORMAT_V10') && USE_SEO_URLS_FORMAT_V10 ) {                              // V10 format: `/p/product-name/m1000/`
            array_pop( $_rewrite_pageNameParts );                                                           // remove last slash item `/p/product-name/m1000/`
            $productRewriteId = array_pop( $_rewrite_pageNameParts );                                       // get last part of path which contains productId
            if ( count( $_rewrite_pageNameParts ) == 2 ) {                                                        // if rewrite parts have sufficient items
                $_GET['apiType']   = substr( $productRewriteId, 0, 1 );
                $_GET['productId'] = substr( $productRewriteId, 1 );                                        // take product id
                if ( $_GET['productId'] > 2 ) {                                                                  // if valid product id
                    $pageToLoad = rewriteLoadFile( 'products' );                                        // load products.php
                    if ( $pageToLoad != '' ) {
                        require $pageToLoad;
                        die;
                    }
                }
            }
        }

		$_rewrite_lastPart       = array_pop( $_rewrite_pageNameParts );                              // get last part of path
		$_rewrite_lastPartArr    = explode( '.', $_rewrite_lastPart );                              // make its array
		$_rewrite_lastPartArrTot = count( $_rewrite_lastPartArr );                                          // find its array length
		if ( $_rewrite_lastPartArrTot > 2 ) {                                                               // if it has sufficient items
			$_GET['productId'] = (int) $_rewrite_lastPartArr[ $_rewrite_lastPartArrTot - 2 ];               // take its 2nd last item as product id
			if ( $_GET['productId'] > 2 ) {                                                                 // if valid product id
				$pageToLoad = rewriteLoadFile( 'products' );                                       // load products.php
				if ( $pageToLoad != '' ) {
					require $pageToLoad;
					die;
				}
			}
		}
		break;

	//*************************************************************************************************
	// Handle news url
	//*************************************************************************************************
	case 'news':
		$_GET['news'] = explode( '-', $_rewrite_pageNameParts[1] );                           // get slug exploded by hyphen
		$_GET['news'] = (int) $_GET['news'][0];                                              // get first part of slug i.e. news id
		$pageToLoad   = rewriteLoadFile( 'news' );                                              // load news.php
		if ( $pageToLoad != '' ) {
			require $pageToLoad;
			die;
		}
		break;

	//*************************************************************************************************
	// Handle coupons url
	//*************************************************************************************************
	case 'coupons':
		$_GET['catId'] = (int) $_rewrite_pageNameParts[1];                                   // get 2nd part of slugh that is cat id
		$pageToLoad    = rewriteLoadFile( 'coupons' );                                           // load coupons.php
		if ( $pageToLoad != '' ) {
			require $pageToLoad;
			die;
		}
		break;

	//*************************************************************************************************
	// Handle store urls
	//*************************************************************************************************
	case 'stores':
		if ( 'Profile' == $_rewrite_pageNameParts[2] ) {                                    // if store profile page
			$_GET['fn'] = $_rewrite_pageNameParts[1];                                       // get store slug
			$pageToLoad = rewriteLoadFile( 'merchant_detail' );                               // load merchant_detail.php
			if ( $pageToLoad != '' ) {
				require $pageToLoad;
				die;
			}
		}
		if ( 'Reviews' == $_rewrite_pageNameParts[2] ) {                                    // if store reviews page
			$_GET['fn'] = $_rewrite_pageNameParts[1];                                       // get store slug
			$pageToLoad = rewriteLoadFile( 'user_rating' );                                   // load user_rating.php
			if ( $pageToLoad != '' ) {
				require $pageToLoad;
				die;
			}
		}
		if ( 'Products' == $_rewrite_pageNameParts[2] ) {                                   // if store products page
			$_GET['mpp']   = 1;                                                               // mark it as merchant products page
			$_GET['merFN'] = $_rewrite_pageNameParts[1];                                    // get store slug
			$pageToLoad    = rewriteLoadFile( 'search_products' );                               // load search_products.php
			if ( $pageToLoad != '' ) {
				require $pageToLoad;
				die;
			}
		}
		break;

	//*************************************************************************************************
	// Handle store logo urls
	//*************************************************************************************************
	case 'logo':
		$matches = [];

		// try to find store logo thumb url
		preg_match( '/[a-zA-Z0-9&\-\+\.\_\'"]*-([a-zA-Z0-9\.\_]*)-([0-9]*)x([0-9]*).jpg/', $_rewrite_pageNameParts[1], $matches );
		if ( count( $matches ) > 0 ) {
			$_GET['f']  = 'upload/merchant/' . $matches[1] . '.jpg';                             // make logo path
			$_GET['w']  = $matches[2];                                                       // set logo width
			$_GET['h']  = $matches[3];                                                       // set logo height
			$pageToLoad = rewriteLoadFile( 'thumbnail' );                                     // load thumbnail.php
			if ( $pageToLoad != '' ) {
				require $pageToLoad;
				die;
			}
		}

		// try to find store logo image url
		preg_match( '/[a-zA-Z0-9&\-\+\.\_\'"]*-([a-zA-Z0-9\.\_]*).jpg/', $_rewrite_pageNameParts[1], $matches );
		if ( count( $matches ) > 0 ) {
			$_GET['f']  = 'upload/merchant/' . $matches[1] . '.jpg';                             // make logo path
			$pageToLoad = rewriteLoadFile( 'rf' );                                            // load rf.php
			if ( $pageToLoad != '' ) {
				require $pageToLoad;
				die;
			}
		}

		break;

	//*************************************************************************************************
	// Handle search urls
	//*************************************************************************************************
	case 'search':
		$_GET['searchText'] = urldecode( $_rewrite_pageNameParts[1] );                        // get search query
		$pageToLoad         = rewriteLoadFile( 'search_products' );                                   // load search_products.php
		if ( $pageToLoad != '' ) {
			require $pageToLoad;
			die;
		}
		break;

	//*************************************************************************************************
	// Handle product thumbs & images
	//*************************************************************************************************
	case 'product-thumbnails':

		// Get parameters
		$_GET['p']  = (int) $_rewrite_pageNameParts[1];                         // get the product id
		$_GET['pi'] = (int) $_rewrite_pageNameParts[2];                         // get the product image id

		// Get the dimensions
		$dimensions = $_rewrite_pageNameParts[3];
		list( $_GET['w'], $_GET['h'] ) = explode( 'X', $dimensions );
		$_GET['w'] = (int) $_GET['w'];
		$_GET['h'] = (int) $_GET['h'];

		// Get filename
		$matches = [];
		preg_match( '/(.*).jpg/', $_rewrite_pageNameParts[4], $matches );
		$_GET['pf'] = $matches[1];

		// Load page
		$pageToLoad = rewriteLoadFile( 'product-thumb' );
		if ( $pageToLoad != '' ) {
			require $pageToLoad;
			die;
		}

		break;

	case 'product-images':

		// Get parameters
		$_GET['p']  = (int) $_rewrite_pageNameParts[1];                          // get the product id
		$_GET['pi'] = (int) $_rewrite_pageNameParts[2];                         // get the product image id

		// Load image page
		$pageToLoad = rewriteLoadFile( 'product-image' );                        // load product-image.php
		if ( $pageToLoad != '' ) {
			require $pageToLoad;
			die;
		}

		break;

	//*************************************************************************************************
	// Handle brand logos & urls
	//*************************************************************************************************
	case 'brand':
		$_GET['manuText'] = urldecode( $_rewrite_pageNameParts[1] );                          // get brand search query
		$pageToLoad       = rewriteLoadFile( 'search_products' );                                   // load search_products.php
		if ( $pageToLoad != '' ) {
			require $pageToLoad;
			die;
		}
		break;

	case 'brand-image':
		$matches = [];
		preg_match( '/thumb-([0-9]+)-([0-9]*)-([0-9]*).jpg/', $_rewrite_pageNameParts[1], $matches );
		if ( count( $matches ) > 0 ) {
			$_GET['f']  = 'upload/brand/' . $matches[1] . '.jpg';                                // get thumb url
			$_GET['w']  = $matches[2];                                                       // get width
			$_GET['h']  = $matches[3];                                                       // get height
			$pageToLoad = rewriteLoadFile( 'rf' );                                            // load rf.php
			if ( $pageToLoad != '' ) {
				require $pageToLoad;
				die;
			}
		}
		break;

	//*************************************************************************************************
	// Handle brands page urls
	//*************************************************************************************************
	case 'brands':
		$matches = [];

		// handle alpha
		preg_match( '/alpha-[A-Z0-9]/', $_rewrite_pageNameParts[1], $matches );
		if ( count( $matches ) > 0 ) {
			$_GET['alpha']  = str_replace('alpha-', '', $matches[0]);
			$pageToLoad = rewriteLoadFile( 'brands' );                                     // load thumbnail.php
			if ( $pageToLoad != '' ) {
				require $pageToLoad;
				die;
			}
		}

		$pageToLoad = rewriteLoadFile( 'brands' );                       // load search_products.php
		if ( $pageToLoad != '' ) {
			require $pageToLoad;
			die;
		}

		break;

	//*************************************************************************************************
	// Handle all other cases
	//*************************************************************************************************
	default:

		//*************************************************************************************************
		// If its a brand page under a category
		//*************************************************************************************************
		if ( isset( $_rewrite_pageNameParts[1] ) && 'brand' == $_rewrite_pageNameParts[1] ) {
			$_GET['manuText'] = urldecode( $_rewrite_pageNameParts[2] );                      // get brand search query
			$matches          = [];
			preg_match( '/.+\.([0-9]+)/', $_rewrite_pageNameParts[0], $matches );
			if ( isset( $matches[1] ) ) {                                                       // If its url with category id
				$_GET['categoryId'] = (int) $matches[1];                                     // get category id
			} else {                                                                        // If its url without category id
				$_GET['categoryFn'] = urldecode( $_rewrite_pageNameParts[0] );                // get category slug
			}
			$pageToLoad = rewriteLoadFile( 'category' );                                      // load category.php
			if ( $pageToLoad != '' ) {
				require $pageToLoad;
				die;
			}
		}


		//*************************************************************************************************
		// If there is a second and third segment in url then its product page with this format:
		// http://domain.com/category-slug/product-slug/m1234
		//*************************************************************************************************
		if ( isset( $_rewrite_pageNameParts[1] ) && '' != $_rewrite_pageNameParts[1] && isset( $_rewrite_pageNameParts[2] ) && '' != $_rewrite_pageNameParts[2] ) {

			// default product page
			$productRewritePagename = 'products';

			// product id part
			$productRewriteId = $_rewrite_pageNameParts[2];

			// Product sub-page part if any
			$productSubpage = isset( $_rewrite_pageNameParts[3] ) ? $_rewrite_pageNameParts[3] : '';

			// if ebay page
			if ( 'ebay' == $productSubpage ) {
				$productRewritePagename = 'products_ebay';
			} // if review page
			elseif ( 'review' == $productSubpage ) {
				$productRewritePagename = 'product_rating';
			} // if discussion page
			elseif ( 'discussion' == $productSubpage ) {
				$productRewritePagename = 'products_discussion';
			}

			$_GET['apiType']   = substr( $productRewriteId, 0, 1 );
			$_GET['productId'] = substr( $productRewriteId, 1 );

			$pageToLoad = rewriteLoadFile( $productRewritePagename );
			if ( $pageToLoad != '' && $_GET['productId'] > 2 ) {
				require $pageToLoad;
				die;
			}
		}


		//*************************************************************************************************
		// If there is a second segment in url then its product page
		//*************************************************************************************************
		if ( isset( $_rewrite_pageNameParts[1] ) && '' != $_rewrite_pageNameParts[1] ) {

			// get product slug segments
			$productParts = explode( SCRIPT_SEO_FILENAME_DELIMITER, $_rewrite_pageNameParts[1] );

			// default product page
			$productRewritePagename = 'products';

			// product id part from the segments
			$lastSegmentIndex = '-' == SCRIPT_SEO_FILENAME_DELIMITER ? count( $productParts ) - 1 : 1;
			$productRewriteId = isset( $productParts[ $lastSegmentIndex ] ) ? $productParts[ $lastSegmentIndex ] : '';

			if ( '-' == SCRIPT_SEO_FILENAME_DELIMITER ) {

				$secondLastSegment = $productParts[ count( $productParts ) - 2 ];

				// if ebay page
				if ( 'ebay' == $secondLastSegment ) {
					$productRewritePagename = 'products_ebay';
				} // if review page
				elseif ( 'review' == $secondLastSegment ) {
					$productRewritePagename = 'product_rating';
				} // if discussion page
				elseif ( 'discussion' == $secondLastSegment ) {
					$productRewritePagename = 'products_discussion';
				}

			} else {

				// if ebay page
				if ( 'ebay-' == substr( $productRewriteId, 0, 5 ) ) {
					$productRewritePagename = 'products_ebay';
					$productRewriteId       = substr( $productRewriteId, 5 );
				}

				// if review page
				if ( 'review-' == substr( $productRewriteId, 0, 7 ) ) {
					$productRewritePagename = 'product_rating';
					$productRewriteId       = substr( $productRewriteId, 7 );
				}

				// if discussion page
				if ( 'discussion-' == substr( $productRewriteId, 0, 11 ) ) {
					$productRewritePagename = 'products_discussion';
					$productRewriteId       = substr( $productRewriteId, 11 );
				}

			}

			$_GET['apiType']   = substr( $productRewriteId, 0, 1 );
			$_GET['productId'] = substr( $productRewriteId, 1 );

			$pageToLoad = rewriteLoadFile( $productRewritePagename );
			if ( $pageToLoad != '' && $_GET['productId'] > 2 ) {
				require $pageToLoad;
				die;
			}
		}


		//*************************************************************************************************
		// Its category page, so take the 1st segment as category parts/slug
		//*************************************************************************************************
		$categoryParts = explode( SCRIPT_SEO_FILENAME_DELIMITER, $_rewrite_pageNameParts[0] );

		// Handle for hyphen
		if ( '-' == SCRIPT_SEO_FILENAME_DELIMITER ) {
			if ( isset( $_GET['seot'] ) ) {
				print_r( $categoryParts );
			}

			// Save the parts in temp array
			$temp = $categoryParts;

			// Get its total count
			$ttot = count( $temp );

			// Initialize the actual array with 3 elements as empty strings to hold filename, id and other stuff (like sorting, paging, etc.)
			$categoryParts = [ '', '', '' ];

			// How many parts to skip from last.
			// For normal url (seo-file-name-1299) it is only 1
			$skipFromLast = 1;
			// But for url with just paging (seo-file-name-1299-50-20), we check that the last three parts are integer
			if ( $ttot > 3 && isInt( $temp[ $ttot - 1 ] ) && isInt( $temp[ $ttot - 2 ] ) && isInt( $temp[ $ttot - 3 ] ) ) {
				// It is 3 (id, total, offset)
				$skipFromLast = 3;
			}
			// And for extendend url that has other things in it (seo-file-name-1299-50-0-RATING--list)
			if ( in_array( $temp[ $ttot - 1 ], [ 'list', 'grid' ] ) ) {
				// It is 6 (id, total, offset, sort key, sort order, view type)
				$skipFromLast = 6;
			}

			// Loop through all the parts with key as $dex to get the current number from 0 to onwards
			foreach ( $temp as $dex => $t ) {
				// Until we are parsing words of seo filename
				if ( $dex < $ttot - $skipFromLast ) {
					// Contact to seo filename
					$categoryParts[0] .= ( 0 == $dex ? '' : '-' ) . $t;
				} // When seo filename is over, check if id was not set
				elseif ( '' == $categoryParts[1] ) {
					$categoryParts[1] = $t;
				} // It must be the last entry of other stuff (like sorting, paging, etc.)
				else {
					$categoryParts[2] .= ( '' == $categoryParts[2] ? '' : '-' ) . $t;
				}
			}

			if ( isset( $_GET['seot'] ) ) {
				echo "\nSkipped : $skipFromLast\n\n";
				print_r( $categoryParts );
				die;
			}
		}

		// 1st segment is always category slug
		$_GET['categoryFn'] = $categoryParts[0];

		// 2nd and 3rd segments can be category id or other info
		if ( isset( $categoryParts[1] ) ) {
			rewriteParseCategorySegment( $categoryParts[1] );
		}
		if ( isset( $categoryParts[2] ) ) {
			rewriteParseCategorySegment( $categoryParts[2] );
		}

		// if its only category page then load it
		if ( isset( $_rewrite_pageNameParts[1] ) && '' == $_rewrite_pageNameParts[1] ) {
			$pageToLoad = rewriteLoadFile( 'category' );
			if ( $pageToLoad != '' ) {
				require $pageToLoad;
				die;
			}
		}

}


//*************************************************************************************************
// No page found, now show 404 print debug information
//*************************************************************************************************

require 'include/include.php';
$langFilename = '404';
require PATH . '404.php';

echo "<!--\n\n";
echo "Rewrite Page Name: $_rewrite_pageName\n";
print_r( $_rewrite_pageNameParts );
echo "\n\n";
print_r( $_SERVER );
echo "\n\n";
echo $_rewrite_pageName;
echo "\n\n-->";
die;

//*************************************************************************************************
// Helper functions
//*************************************************************************************************

/**
 * Return page path with given page name if exists.
 * Cannot load it here as it creates variables scope issue.
 *
 * @param string $pageName only page name without extension
 *
 * @return string path to include (or empty)
 */
function rewriteLoadFile( $pageName ) {

	// Make php page path
	$pagePath = PATH . $pageName . '.php';

	// Include it if it exists
	if ( file_exists( $pagePath ) ) {

		// Save the current page name in environment as it is used to load languages
		$_SERVER['PHP_SELF']        = str_replace( '_rewrite', $pageName, $_SERVER['PHP_SELF'] );
		$_SERVER['SCRIPT_NAME']     = str_replace( '_rewrite', $pageName, $_SERVER['SCRIPT_NAME'] );
		$_SERVER['SCRIPT_FILENAME'] = str_replace( '_rewrite', $pageName, $_SERVER['SCRIPT_FILENAME'] );

		// Return the page to load
		return $pagePath;
	}

	return '';
}

//*************************************************************************************************

/**
 * Parse category segment and load variables in _GET
 *
 * @param $segment
 */
function rewriteParseCategorySegment( $segment ) {
	// if segment is an integer and only an integer, then its category id
	if ( ! strstr( $segment, '-' ) ) {
		$categoryId = (int) $segment;
		if ( $categoryId > 0 ) {
			$_GET['categoryId'] = $categoryId;

			return;
		}
	}

	// otherwise split by hyphen (-) to get other parameters
	$params = explode( '-', $segment );

	// if 2 parameters are given
	if ( 2 == count( $params ) ) {

		// if its integer then must be paging params
		if ( is_numeric( $params[0] ) ) {
			$_GET['t'] = (int) $params[0];
			$_GET['x'] = (int) $params[1];
		} // must be sorting params
		else {
			$_GET['sk'] = $params[0];
			$_GET['so'] = $params[1];
		}

		return;
	}

	// if 3 parameters, then its sort and list/grid
	if ( 3 == count( $params ) ) {
		$_GET['sk'] = $params[0];
		$_GET['so'] = $params[1];
		$_GET['vt'] = $params[2];

		return;
	}

	// if 4 parameters, then its paging and sorting
	if ( 4 == count( $params ) ) {
		$_GET['t']  = (int) $params[0];
		$_GET['x']  = (int) $params[1];
		$_GET['sk'] = $params[2];
		$_GET['so'] = $params[3];

		return;
	}

	// if 5 parameters, then its paging, sorting and list/grid
	if ( 5 == count( $params ) ) {
		$_GET['t']  = (int) $params[0];
		$_GET['x']  = (int) $params[1];
		$_GET['sk'] = $params[2];
		$_GET['so'] = $params[3];
		$_GET['vt'] = $params[4];

		return;
	}
}

//*************************************************************************************************

/**
 * Check if the provided value is integer or not.
 *
 * @param $value
 *
 * @return boolean
 */
function isInt( $value ) {
	return strval( $value ) === strval( intval( $value ) );
}

//*************************************************************************************************
