<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

		require ("path.php");
		require (PATH."include/include.php");
		require ("cronjob_include.php"); 

//*************************************************************************************************

		set_time_limit(0);

//*************************************************************************************************

		$cleanPastXDays		= 15;
		$lastDate2Keep		= addDays(getTimezoneTime('Y-m-d'), -$cleanPastXDays);

//*************************************************************************************************

		echo "\n[".date('Y-m-d H:i:s')."] Starting to evaluate search tags...<br>\n\n";

//*************************************************************************************************

		// Collect all the filtering tokens
		$arrFTK = array('--', '/*', '*/', ',', '(');

		// Collect all the filtering words
		$arrRCF	= array('the', 'of', 'and', 'that', 'for', 'by', 'as', 'be', 'or', 'this', 'then', 'we', 'which', 'with', 'at', 'from', 'under', 'such', 'there', 'other', 'if', 'is', 'it', 'can', 'now', 'an', 'to', 'but', 'upon', 'where', 'these', 'when', 'whether', 'also', 'than', 'after', 'within', 'before', 'because', 'without', 'however', 'therefore', 'between', 'those', 'since', 'into', 'out', 'some', 'abs', 'about', 'accordingly', 'affecting', 'affected', 'again', 'against', 'all', 'almost', 'already', 'although', 'always', 'among', 'any', 'anyone', 'apparently', 'are', 'arise', 'aside', 'away', 'became', 'become', 'becomes', 'been', 'being', 'both', 'briefly', 'came', 'cannot', 'certain', 'certainly', 'could', 'etc', 'does', 'done', 'during', 'each', 'either', 'else', 'ever', 'every', 'following', 'found', 'further', 'gave', 'gets', 'give', 'given', 'giving', 'gone', 'got', 'had', 'hardly', 'has', 'have', 'having', 'here', 'how', 'itself', 'just', 'keep', 'kept', 'kg', 'knowledge', 'largely', 'like', 'made', 'mainly', 'make', 'many', 'mg', 'might', 'ml', 'more', 'most', 'mostly', 'much', 'must', 'nearly', 'necessarily', 'neither', 'next', 'none', 'nor', 'normally', 'not', 'noted', 'obtain', 'obtained', 'often', 'only', 'our', 'put', 'owing', 'particularly', 'past', 'perhaps', 'please', 'poorly', 'possible', 'possibly', 'potentially', 'predominantly', 'present', 'previously', 'primarily', 'probably', 'prompt', 'promptly', 'quickly', 'quite', 'rather', 'readily', 'really', 'recently', 'refs', 'regarding', 'regardless', 'relatively', 'respectively', 'resulted', 'resulting', 'results', 'said', 'same', 'seem', 'seen', 'several', 'shall', 'should', 'show', 'showed', 'shown', 'shows', 'significantly', 'similar', 'similarly', 'slightly', 'so', 'sometime', 'somewhat', 'soon', 'specifically', 'state', 'states', 'strongly', 'substantially', 'successfully', 'sufficiently', 'their', 'theirs', 'them', 'they', 'though', 'through', 'throughout', 'too', 'toward', 'unless', 'until', 'use', 'used', 'usefully', 'usefulness', 'using', 'usually', 'various', 'very', 'was', 'were', 'what', 'while', 'who', 'whose', 'why', 'widely', 'will', 'would', 'yet');
		$res	= executeQuery("SELECT DISTINCT(TITLE) AS WORD FROM ".PREFIX."RECENT_SEARCHES_FILTER");
		while ( ($row = getRow($res)) )
			$arrRCF[] = $row['WORD'];

		// Collect last 200 searched records
		$arrKwds = array();
		$maxTots = 0;
		$res = executeQuery("SELECT TEXT, SUM(SEARCH_COUNT) AS T FROM ".PREFIX."SEARCH GROUP BY TEXT ORDER BY LAST_SEARCH_ON DESC, T DESC LIMIT 200");
		while ( ($row = getRow($res)) )
		{
			$arrKwds[] = $row;
			$maxTots = $maxTots > $row['T'] ? $maxTots : $row['T'];
		}

		// Set so that getSearchCloudFontSize() evaluates font sizes on count and max
		$searchCloudFWD = false;

		// Collect final search tags (and font sizes)
		$arrWords	= array();
		$arrFinal	= array();
		$totFinal	= 0;
		foreach ( $arrKwds as $row )
		{
			$doSkip = false;
			foreach ( $arrFTK as $skipToken )
			{
				if ( stristr($row['TEXT'], $skipToken) )
				{
					$doSkip = true;
					break;
				}
			}
			if ( $doSkip ) continue;

			$doSkip = false;
			foreach ( $arrRCF as $skipWord )
			{
				if ( stristr(' '.$row['TEXT'].' ', ' '.$skipWord.' ') )
				{
					$doSkip = true;
					break;
				}
			}
			if ( $doSkip ) continue;

			if ( in_array($row['TEXT'], $arrWords) ) continue;
			$arrFinal[] = array('SEARCH_TEXT' => $row['TEXT'], 'FONT_WEIGHT' => getSearchCloudFontSize($row['T'], $maxTots));
			$arrWords[] = $row['TEXT'];
			if ( ++$totFinal > 20 )
				break;
		}

		// If less records collected, then get some from old set of records
		if ( $totFinal < 15 )
		{
			$res = executeQuery("SELECT SEARCH_TEXT, FONT_WEIGHT FROM ".PREFIX."SEARCH_CLOUD_AUTO");
			while ( ($row = getRow($res)) )
			{
				if ( in_array($row['SEARCH_TEXT'], $arrWords) ) continue;
				$arrFinal[] = $row;
				$arrWords[] = $row['SEARCH_TEXT'];
				if ( ++$totFinal > 20 )
					break;
			}
		}

		// Remove the old set of records
		executeUpdate("DELETE FROM ".PREFIX."SEARCH_CLOUD_AUTO");

		// Fill in the new set of records
		foreach ( $arrFinal as $row )
			executeUpdate("INSERT INTO ".PREFIX."SEARCH_CLOUD_AUTO(ID, SEARCH_TEXT, FONT_WEIGHT) VALUES('".getNextId('SEARCH_CLOUD_AUTO')."', '".handleSingleQuote($row['SEARCH_TEXT'])."', '".handleSingleQuote($row['FONT_WEIGHT'])."')");

//*************************************************************************************************

		echo "\n[".date('Y-m-d H:i:s')."] Starting to delete searches older than ".formatDate($lastDate2Keep)."<br>\n\n";

//*************************************************************************************************

		$res	= executeQuery("SELECT COUNT(*) AS C FROM ".PREFIX."SEARCH WHERE DATE<'".$lastDate2Keep."'");
		$row	= getRow($res);
		$tot	= $row['C'];

		$ret	= executeQuery("DELETE FROM ".PREFIX."SEARCH WHERE DATE<'".$lastDate2Keep."'");

		if ( $ret > 0 )
			echo "\n[".date('Y-m-d H:i:s')."] DONE. Total ".$tot." deleted!<br>\n\n";
		else
			echo "\n[".date('Y-m-d H:i:s')."] FAILED to delete ".$tot." record(s).<br>\n\n";

//*************************************************************************************************
?>