<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

require( "path.php" );
require( PATH . "include/include.php" );

require_once 'cronjob_constants.php';

//*************************************************************************************************

$isInSSH      = defined( 'IS_IN_SSH' ) && IS_IN_SSH == 1;
$doRunSSHJobs = $isInSSH && isset( $doRunSSHJobs ) ? $doRunSSHJobs : false;
$showSepRuler = $isInSSH ? "\n-------------------------------------------------------------------\n" : "\n<hr>\n";

//*************************************************************************************************

@set_time_limit( 0 );

//*************************************************************************************************

if ( ! $isInSSH ) {
	echo "<html><head><meta http-equiv='Content-Type' content='text/html; charset=" . DEFAULT_CHARSET . "'></head><body>";
	echo "<font size='1' face='verdana'>[" . date( 'Y-m-d H:i:s' ) . "] Starting daily cronjobs<br>\n\n";
} else {
	echo "";
}

//*************************************************************************************************

echo $showSepRuler;

if ( IS_PRODUCTFILTERS_INSTALLED == 1 ) {
	showOutput( "\n<b>Running Product Filters List - Manufacturer</b><br>\n" );
	echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_category_manufacturer.php' );
	echo $showSepRuler;

	showOutput( "\n<b>Running Product Filters List - Stores</b><br>\n" );
	echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_category_merchant.php' );
	echo $showSepRuler;

	if ( USE_PRODUCT_FEATURE_VIEW_TABLE == 1 ) {
		showOutput( "\n<b>Running SQL for deleting product view</b>\n" );
		echo executeUpdate( "TRUNCATE TABLE " . PREFIX . "PRODUCT_FEATURE_VIEW" );
		echo "<br>";

		showOutput( "\n<b>Running SQL for synching product view</b>\n" );
		echo executeUpdate( "INSERT INTO " . PREFIX . "PRODUCT_FEATURE_VIEW SELECT PF.VALUE_ID, PF.FEATURE_ID, P.* FROM " . PREFIX . "PRODUCT P, " . PREFIX . "PRODUCT_FEATURE PF WHERE P.ID = PF.PRODUCT_ID" );

		showOutput( "<br>" );
		echo $showSepRuler;

//				TRUNCATE TABLE PRICECOMPARISON_PRODUCT_FEATURE_VIEW;
//				INSERT INTO PRICECOMPARISON_PRODUCT_FEATURE_VIEW SELECT PF.VALUE_ID, PF.FEATURE_ID, P.* FROM PRICECOMPARISON_PRODUCT P, PRICECOMPARISON_PRODUCT_FEATURE PF WHERE P.ID = PF.PRODUCT_ID;
	}
}

if ( IS_POPULAR_INSTALLED == 1 ) {
	showOutput( "\n<b>Running Popular List</b><br>\n" );
	echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_popular.php' );
	echo $showSepRuler;

// 19-Aug-15: SALMAN: COMMENTED TO SAVE RESOUCE
//			showOutput("\n<b>Running Popular List - Each Product</b><br>\n");
//			echo readFromFile(CRONJOB_ROOT.ADMIN_FOLDER_NAME.'/cronjobs/cronjob_popular_ep.php');
//			echo $showSepRuler;
}

showOutput( "\n<b>Running Job - Homepage API Source Products Cache</b><br>\n" );
echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_build_api_source_homepage_cache.php' );
echo $showSepRuler;

showOutput( "\n<b>Running Report - Top Product Visitors</b><br>\n" );
echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_report_daily_top_product_visitors.php' );
echo $showSepRuler;

showOutput( "\n<b>Running Report - Top Visited Category</b><br>\n" );
echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_report_daily_top_visited_category.php' );
echo $showSepRuler;

showOutput( "\n<b>Running Report - Send Price Alerts</b><br>\n" );
echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_send_pricealerts.php' );
echo $showSepRuler;

showOutput( "\n<b>Running Merchant - Clickthroughs</b><br>\n" );
echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_merchant_clickthroughs.php' );
echo $showSepRuler;

showOutput( "\n<b>Running Merchant - Package</b><br>\n" );
echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_merchant_package.php' );
echo $showSepRuler;

showOutput( "\n<b>Running Merchant - Monthly Budget</b><br>\n" );
echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_merchant_monthly.php' );
echo $showSepRuler;

showOutput( "\n<b>Cleanup TEMP search</b><br>\n" );
echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_clean_search_filter_tables.php' );
echo $showSepRuler;


if ( DO_ENABLE_SEARCH_BY_MATCH == 1 ) {
	showOutput( "\n<b>Running Search By Match</b><br>\n" );
	echo executeJobSSHifAllowed( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_myisam_search.php' );
	echo $showSepRuler;
}

if ( IS_PRICEHISTORYGRAPH_INSTALLED == 1 ) {
	showOutput( "\n<b>Deleting price history past 180 days</b><br>\n" );
	executeUpdate( "DELETE FROM " . PREFIX . "PRODUCT_PRICE_HISTORY WHERE CHANGE_DATE='" . addDays( getTimezoneTime(), - 180 ) . "'" );
	echo $showSepRuler;
}

if ( IS_PRICE_GRID_MAP_INSTALLED == 1 ) {
	showOutput( "\n<b>GeoCoding merchant locations...</b><br>\n" );
	echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_location_geocode.php' );
	echo $showSepRuler;
}

if ( IS_SHOPPING_CART_INSTALLED == 1 ) {
	showOutput( "\n<b>Cleanup old shopping cart entries...</b><br>\n" );
	echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_cleanup_merchant_store_cart.php' );
	echo $showSepRuler;
}


showOutput( "\n<b>Cleanup older searches</b><br>\n" );
echo readFromFile( CRONJOB_ROOT . ADMIN_FOLDER_NAME . '/cronjobs/cronjob_cleanup_searches.php' );
echo $showSepRuler;


showOutput( "\n<b>Running SQL for deleting product visit logs</b>\n" );
echo executeUpdate( "TRUNCATE TABLE " . PREFIX . "PRODUCT_VISIT_LOG" );
echo "<br>";


showOutput( "\n<b>Running SQL for deleting visit logs</b>\n" );
echo executeUpdate( "TRUNCATE TABLE " . PREFIX . "VISIT_LOG" );
echo "<br>";


showOutput( "\n<b>Running SQL for deleting search restrict ip addresses</b>\n" );
echo executeUpdate( "TRUNCATE TABLE " . PREFIX . "SEARCH_CAPTCHA_LOCKED_IPS" );
echo "<br>";


//*************************************************************************************************

showOutput( "\n\n<br><br>[" . date( 'Y-m-d H:i:s' ) . "] Finished daily cronjobs<br><br>" );

if ( ! $isInSSH ) {
	echo "\n\nDont forget to run <a href='" . CRONJOB_ROOT . ADMIN_FOLDER_NAME . "/cronjobs/cronjob_category_lastlevel.php' target=_blank>this cronjob</a> in your favorite browser once a week.<br></font>";
	echo "</body></html>";
} else {
	echo "\n\nDont forget to run " . PATH . ADMIN_FOLDER_NAME . "/cronjobs/cronjob_category_lastlevel_ssh.php once a week.\n\n";
}

//*************************************************************************************************

function executeJobSSHifAllowed( $jobUrl ) {
	global $doRunSSHJobs;

	if ( ! $doRunSSHJobs ) {
		return readFromFile( $jobUrl );
	}

	$jobUrl = str_replace( CRONJOB_ROOT, PATH, $jobUrl );
	$jobUrl = str_replace( '.php', '_ssh.php', $jobUrl );
	$jobUrl = 'php ' . $jobUrl . ' > /dev/null & echo $!';

	$PID = shell_exec( $jobUrl );

	// Wait
	sleep( 5 );

	// Wait Until execution is complete
	while ( isProcessRunning( $PID ) ) {
		echo "\n" . '---- Please wait... Still running';

		// Wait Again
		sleep( 10 );
	}
}

//*************************************************************************************************

function isProcessRunning( $PID ) {
	exec( "ps " . $PID, $ProcessState );

	return ( count( $ProcessState ) >= 2 );
}

//*************************************************************************************************

function showOutput( $html ) {
	global $isInSSH;

	if ( ! $isInSSH ) {
		echo $html;

		return;
	}

	$html = str_replace( "\n", '', $html );
	$html = str_replace( '<br>', "\n", $html );
	$html = strip_tags( $html );

	echo $html;

	return;
}

//*************************************************************************************************
