<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

		include("path.php");
		require(PATH."include/include.php");
		require ("cronjob_include.php"); 

//*************************************************************************************************
//		RUNS DAILY TO INACTIVATE MERCHANTS THAT ARE OUT OF CREDIT LIMIT
//*************************************************************************************************
?>
<html>
	<head>
		<title>Cronjob For Merchant Credit Limit</title>
		<link rel='stylesheet' href='<?php echo SCRIPT_ROOT?>/style/main.css' type='text/css'>
	</head>
	
	<body bgcolor='#FFFFFF' text='#000000' leftmargin='10' marginheight='10' marginwidth='10' topmargin='10'>
	
		<font class='normal'>
			DateTime [<?php echo date('Y-m-d H:i:s')?>]<br><br>
<?php
//*************************************************************************************************

		// Check if a payed merchant is still marked as defaulter
		$res = executeQuery("SELECT DISTINCT(ES.ID) AS ID FROM ".PREFIX."USER_CLICKTHROUGH_EMAIL_SENT ES, ".PREFIX."CLICKTHROUGHS_PAYMENT CP WHERE CP.ID>ES.LAST_CLICKTHROUGH_PAYMENT_ID AND CP.ISVALID='Y' AND CP.MERCHANTID=ES.USERID");
		while ( ($row = getRow($res)) )
			preparedUpdate("DELETE FROM ".PREFIX."USER_CLICKTHROUGH_EMAIL_SENT WHERE ID = ?", array($row['ID']));

//*************************************************************************************************

		$clickthroughRate = getColumn('PREFERENCES', 1000, 'CLICKTHROUGH_RATE');

//*************************************************************************************************

		$res = executeQuery("SELECT USERID, IS_CLICKTHROUGH_FREE, CHARGE_PAYMENT_MIN, CHARGE_PAYMENT_AMOUNT FROM ".PREFIX."USER WHERE ISVALID='Y'");
		while ( ($row = getRow($res)) )
		{
			if ( $row['IS_CLICKTHROUGH_FREE'] == 'N' )
			{
				// Record un-balanced clickthrougs in user balance table
				$resUB = preparedQuery("SELECT COUNT(ID) C FROM ".PREFIX."CLICKTHROUGHS WHERE USERID = ? AND (ISPAYED = 'N' OR ISPAYED = 'X')", array($row['USERID']));
				$rowUB = getRow($resUB);
				$sumClickthroughsAmount	= $rowUB['C'] * $clickthroughRate;
				if ( $sumClickthroughsAmount > 0 )
				{
					$msg = '';
					addUserBalance($msg, $row['USERID'], 0, 'N', MSG_DAILY_CLICKTHROUGS, -$sumClickthroughsAmount);
				}

				// Mark them recorded in balance table
				// 6/16/2015: Mamda: now we mark based on the previous value
				executeUpdate("UPDATE ".PREFIX."CLICKTHROUGHS SET ISPAYED='B' WHERE USERID='".handleSingleQuote($row['USERID'])."' AND ISPAYED='N'");
				executeUpdate("UPDATE ".PREFIX."CLICKTHROUGHS SET ISPAYED='Y' WHERE USERID='".handleSingleQuote($row['USERID'])."' AND ISPAYED='X'");
				//tableUpdate('CLICKTHROUGHS', $row['USERID'], array('ISPAYED'=>'B'), 'USERID');

				// Find BALANCE of this user
				$balance = getUserBalance($row['USERID']);			// Negative value if clickthroughs are MORE than paid amount
				$credit  = getMerchantCreditLimit($row['USERID']);

				///////////////////////////////////////////////////////////////////////////////////////////////
				echo "<font color='blue'>Clickthrough Balance <b>".SCRIPT_DOLLAR.$balance."</b> for ".$row['USERID']."</font><br>";
				if ( $balance > 0 )
					cronjobMarkClickthroughPaid($row['USERID'], $balance, $clickthroughRate);

				///////////////////////////////////////////////////////////////////////////////////////////////
				// Pay if balance (either - / +) is less then the limit allowed
				if ( $balance < $row['CHARGE_PAYMENT_MIN'] )
				{
					$msg = '';
					echo "<font color='blue'>Making clickthrough payment for ".$row['USERID']."</font><br>";
					$ret = chargeClickthroughPayments($msg, $row['USERID'], $row["CHARGE_PAYMENT_MIN"], ($balance<0 ? ceil(abs($balance)):$row["CHARGE_PAYMENT_AMOUNT"]));
					echo "<font color='".($ret>0?"green":"red")."'> - ".$msg."</font><br>";
				}

//				echo "<hr>\n\n$row[USERID]";die;
				///////////////////////////////////////////////////////////////////////////////////////////////

				// Check for balance low notification
				if ( $balance < MERCHANT_BALANCE_NOTIFY_LOWER_LIMIT )
				{
					// If notification was not already sent
					if ( getColumn("USER_CLICKTHROUGH_EMAIL_SENT", $row['USERID'], "ID", 'USERID') <= 0 )
					{
						$ret = sendClickthroughBalanceLowLimitEmail($msg, $row['USERID'], $balance);
						echo "<font color='blue'>Email sent for Low Balance to ".$row['USERID']."</font><br>";
						if ( $ret > 0 )
						{
							$res1	= executeQuery("SELECT MAX(ID) AS ID FROM ".PREFIX."CLICKTHROUGHS_PAYMENT WHERE MERCHANTID='".$row['USERID']."' AND ISVALID='Y'");
							$row1	= getRow($res1);
							$lastId = (int)$row1['ID'];

							executeUpdate("INSERT INTO ".PREFIX."USER_CLICKTHROUGH_EMAIL_SENT(ID, USERID, LAST_CLICKTHROUGH_PAYMENT_ID) VALUES('".getNextId("USER_CLICKTHROUGH_EMAIL_SENT")."', '".$row['USERID']."', '".$lastId."')");
						}
					}
				}
				
				///////////////////////////////////////////////////////////////////////////////////////////////
				
				// Balance out checking
				echo "Credit limit of : <b>".$row['USERID']." [".$balance."/".$credit."] ";
				if ( ($balance + $credit) < 0 )
				{
					executeUpdate("UPDATE ".PREFIX."USER SET ISVALID='N' WHERE USERID='".$row['USERID']."'");

					sendClickthroughBalanceOutEmail($msg, $row['USERID'], $balance);
					
					echo "<font color='red'>NEGATIVE</font>";
				}
				else
				{
					echo "<font color='green'>OK</font>";
				}
				echo "</b><br>\n";
			}
			else
			{
				preparedUpdate("UPDATE ".PREFIX."CLICKTHROUGHS SET ISPAYED = 'Y' WHERE USERID = ?", array($row['USERID']));
				echo "\n<font color='blue'>Clickthroughs are free : <b>".$row['USERID']."</b> </font><br>\n";
			}
		}
		free($res);

//*************************************************************************************************
?>
		</font>
	</body>

</html>

<?php
//*************************************************************************************************
//*************************************************************************************************
//*************************************************************************************************

		function cronjobMarkClickthroughPaid($userId, $totalBalance, $rate=0)
		{
			echo "\n\n<!-- Marking clickthroughs for [$userId] with Total Balance [$totalBalance] and click rate [$rate] -->\n\n";
			
			if ( $userId == '' )
				return '';
				
			if ( $rate == 0 )
				$rate = getColumn("PREFERENCES", 1000, "CLICKTHROUGH_RATE");
			
				
			if ( IS_MERCHANTBID_INSTALLED == 1 )
				return markClickthroughsPaidByBid($userId);
			
			$msg = '';
			
			// Now mark clickthroughs as paid
			$ret = markClickthroughPaid($msg, $userId, $totalBalance, $rate);
			
			echo "\n\n<!-- $msg -->\n\n";
			
			return $ret;			
		}

//*************************************************************************************************

		function markClickthroughsPaidByBid($userId)
		{
			
			// Find the most recent clickthrough that is paid. Then get its payment id
			$res = executeQuery("SELECT C.PAYMENT_ID FROM ".PREFIX."BID_CLICKTHROUGHS C, ".PREFIX."USER_PRODUCT UP WHERE UP.ID = C.USER_PRODUCT_ID AND UP.USERID = '".$userId."' AND C.ISPAID='Y' AND C.PAYMENT_ID > 0 ORDER BY REDIRECT_TIME DESC LIMIT 1");
			if ( ($row = getRow($res)) )
			{
				$paymentId 	= $row['PAYMENT_ID'];
				$paymentRes	= getRecord("BID_PAYMENT", $paymentId);
				
				// Find the amount paid for that payment id
				$amount 	= $paymentRes['AMOUNT'];
				
				// Find the clickthoughs paid using that payment id
				$used		= getColumn('BID_CLICKTHROUGHS', $paymentId, 'SUM(AMOUNT_CHARGED)', 'PAYMENT_ID');
				$balance	= $amount - $used;
				
				if ( $balance > 0 )
				{
					$res2			= executeQuery("SELECT C.ID, C.AMOUNT_CHARGED FROM ".PREFIX."BID_CLICKTHROUGHS C, ".PREFIX."USER_PRODUCT UP WHERE UP.ID = C.USER_PRODUCT_ID AND UP.USERID = '".$userId."' AND C.ISPAID='N' ORDER BY REDIRECT_TIME");
					$allDone		= true;
					$totAmtPayable	= 0;

					// Make sure process gets completed
					@set_time_limit(0);

					while ( $row2 = getRow($res2) )
					{
						if ( $balance - $row2['AMOUNT_CHARGED'] < 0 )
							break;
							
						// Deduct clickthrough price from the amount paid
						$balance -= $row2['AMOUNT_CHARGED'];

						// Update Status of clickthrough
						executeUpdate("UPDATE ".PREFIX."BID_CLICKTHROUGHS SET ISPAID='Y', PAYMENT_ID = ".$paymentId." WHERE ID = ".$row2["ID"]);
					}
					free($res2);					
				}
				
			}
			
		}

//*************************************************************************************************
?>