<?php
//*************************************************************************************************

	require 'functions.php';
	require '../../path.php';
	require '../../include/site_constants.php';
	require '../../include/constants.php';

//*************************************************************************************************

	if ( getVar('doSubmit') != '' )
	{
		$dbServer				= postVar('dbServer');
		$dbUser					= postVar('dbUser');
		$dbPassword				= postVar('dbPassword');
		$dbName					= postVar('dbName');
		$dbCreate				= postVar('dbCreate');
		$dbPrefix				= postVar('dbPrefix');
		$dbDefCharset			= postVar('dbDefCharset');
		$dbConnCharset			= postVar('dbConnCharset');
		$dbConnCollation		= postVar('dbConnCollation');

		if ( $dbServer == '' || $dbUser == '' || $dbName == '' || $dbPrefix == '' || $dbDefCharset == '' )
		{
			echo getErrorForm($_POST, "install-6.php?info=".urlencode("Incomplete Form Submitted"));
			die;
		}

		// check database connection
		$msg = '';
		if ( !( $link = dbConnect($msg, $dbServer, $dbUser, $dbPassword) ) ) {
			echo getErrorForm($_POST, "install-6.php?info=".urlencode($msg));
			die;
		}

		// create database
		if ( $dbCreate == 'Y' ) {
			if ( !dbCreate($msg, $link, $dbName, $dbConnCharset, $dbConnCollation)) {
				echo getErrorForm($_POST, "install-6.php?info=".urlencode($msg));
				die;
			}
		}
		else
		{
			if ( !dbSelect($msg, $link, $dbName, $dbConnCharset, $dbConnCollation)) {
				echo getErrorForm($_POST, "install-6.php?info=".urlencode($msg));
				die;
			}
		}

		$constantsText  = getSiteConstantsText(SCRIPT_WEBMASTER, SCRIPT_DOMAIN, SCRIPT_ROOT, SCRIPT_ROOT_STATIC, SCRIPT_ROOT_SSL, SCRIPT_DOLLAR, SCRIPT_DOLLAR_NAME, SCRIPT_TIMEZONE, SCRIPT_TIMEZONE_NAME, USER_EMAIL_VERIFICATION, VISITOR_EMAIL_VERIFICATION, $dbServer, $dbUser, $dbPassword, $dbName, $dbPrefix);

		// write site_constants
		writeToFile("include/site_constants.php", $constantsText);

		// @todo: update the IS_PREPARED_STMT_NA define based on the fact that if prepared statments are available or not (see check in index.php)


		// write constants-preinstall.php - START
		$constFilepath	= 'include/config/constants-preinstall.php';
		$templFilepath	= 'include/config/constants-preinstall.example.php';
		$constData		= readFromFile($templFilepath);

		$constData = str_replace('{DEFINE_DEFAULT_CHARSET}', $dbDefCharset, $constData);
		$constData = str_replace('{MYSQL_CHARSET}', $dbConnCharset, $constData);
		$constData = str_replace('{MYSQL_COLLATION}', $dbConnCollation, $constData);

		writeToFile($constFilepath, $constData);
		// write constants-preinstall.php - END


		// redirect to next step
		header("Location: create.php");
		die;
	}

//*************************************************************************************************

	$step			= 6;
	$stepHeading	= 'Database Settings';
	$formAction		= 'install-6.php?doSubmit=1';

//*************************************************************************************************
	
	include("header.php");

//*************************************************************************************************
?>

		<table width="600" cellspacing="0" cellpadding="5" align="center">
			<tr valign="top">
				<td class="td" width="33%">Server :</td>
				<td class="td"><input type="text" name="dbServer" size="50" maxlength="50" class="effect" value="<?php echo  postVar('dbServer') ?>" alt="blank"><br><font color="gray">Eg: localhost</font></td>
			</tr>
			<tr valign="top">
				<td class="td">User Id :</td>
				<td class="td"><input type="text" name="dbUser" size="50" maxlength="50" value="<?php echo  postVar('dbUser') ?>" class="effect" alt="blank"></td>
			</tr>
			<tr valign="top">
				<td class="td">Password :</td>
				<td class="td"><input type="text" name="dbPassword" size="50" maxlength="50" value="<?php echo  postVar('dbPassword') ?>" class="effect"></td>
			</tr>
			<tr valign="top">
				<td class="td">Database Name :</td>
				<td class="td"><input type="text" name="dbName" size="38" maxlength="50" value="<?php echo  postVar('dbName') ?>" class="effect" alt="blank"><br><font size="" color="gray">Database must be already created</font></td>
			</tr>
			<tr valign="top">
				<td class="td">Table Prefix :</td>
				<td class="td"><input type="text" name="dbPrefix" size="50" maxlength="50" value="<?php echo  postVar('dbPrefix')==''?"PC7_":$_POST["dbPrefix"] ?>" class="effect" readonly></td>
			</tr>
		</table>
		<br>
		<b style="cursor:pointer" onclick="showAdvOpts();">Advanced Settings (Optional) &#x25BC;</b>
		<table width="600" cellspacing="0" cellpadding="5" align="center" id="idAdvOpts" style="display:none;margin-top:5px">
			<tr valign="top">
				<td class="td" width="33%">Default Charset :</td>
				<td class="td"><input type="text" name="dbDefCharset" size="50" maxlength="50" value="<?php echo  postVar('dbDefCharset')==''?'DEFAULT CHARSET=utf8':$_POST['dbDefCharset'] ?>" class="effect"></td>
			</tr>
			<tr valign="top">
				<td class="td">Connection Charset :</td>
				<td class="td"><input type="text" name="dbConnCharset" size="50" maxlength="50" value="<?php echo  postVar('dbConnCharset')==''?'utf8':$_POST['dbConnCharset'] ?>" class="effect"></td>
			</tr>
			<tr valign="top">
				<td class="td">Connection Collation :</td>
				<td class="td"><input type="text" name="dbConnCollation" size="50" maxlength="50" value="<?php echo  postVar('dbConnCollation')==''?'utf8_general_ci':$_POST['dbConnCollation'] ?>" class="effect"></td>
			</tr>
		</table>

		<script type="text/javascript">
		<!--
		function showAdvOpts()
		{
			document.getElementById('idAdvOpts').style.display = 'table';
		}
		//-->
		</script>

<?php
//*************************************************************************************************

	include("footer.php");

//*************************************************************************************************
?>