var lastStatusMessage = '';

function checkUpdateStatus() {

	// Call the update status ajax
	callAjax('update-status.php', '', function(data) {

		console.log('Update status called...');
		console.log(data);

		// If not valid response then show message and quit
		if ( !data || Object.prototype.toString.call(data) !== '[object Array]' ) {
			showProgress('Invalid response from server... Cannot continue.', 'error');
			return;
		}

		// If there are entries then process
		if ( data.length > 0 ) {

			for ( var i = 0; i < data.length; i++ ) {

				var obj = data[i];

				// If status is 0 then it means process is finished
				if ( 0 == obj.status ) {
					// If success
					if ( 'OK' == obj.message ) {
						showProgress('Update process completed successfully!', 'success bold');
						$('#idSuccessButton').show();
					}
					// If failure
					else {
						showProgress('FAILED : '+obj.message, 'error bold');
						$('#idFailureButton').show();
					}
					return;
				}

				// It is here means we need to check the message and show
				if ( obj.message != lastStatusMessage ) {
					lastStatusMessage = obj.message;
					showProgress(lastStatusMessage, 'info ' + (obj.classes ? obj.classes : ''));
				}

			}

		}

		// Setup next call to check status
		window.setTimeout('checkUpdateStatus()', 3000);
	});
}

function showProgress(msg, type) {
	jqPB = $('.progress-box');
	jqPB.append('<div class="'+type+'">'+msg+'</div>');
	jqPB.scrollTop(jqPB.prop('scrollHeight'));
}

function callAjax(url, qr, callback) {
	$.ajax({
		dataType: 'json',
		url: url
	}).done(function( resp ) {
		callback(resp);
	});
}

$(document).ready(function(){
	checkUpdateStatus();
});
