<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************
	
		// LOG SQL and Build Time stamp
		//define('DO_TIME_EACH_QUERY',	1);
		$pageStart = microtime(); 
		$pageStart = explode(" ", $pageStart); 
		$pageStart = $pageStart[1] + $pageStart[0]; 

//*************************************************************************************************

		require ("path.php");
		require (PATH."include/include.php");

//*************************************************************************************************

		$categoryId		= getVar('categoryId', 'int');
		$fidParts		= array();
		if ( $categoryId == 0 )
		{
			// Extract category from seo url if applicable
			$regexp = 'a-zA-Z0-9_\-\.:+\/';
			if ( defined('USES_CYRILIC_CHARS') && USES_CYRILIC_CHARS == 1 )
			{
				$regexp = '^[a-zA-Z0-9\p{Cyrillic}@_,\-\. ]+$';
				$flags	= 'u';
			}
			$catPath = getVar('path', $regexp, '', array('maxlen'=>255));
			if ( $catPath != '' )
			{
				$ret = extractCategoryListingFromUrl($catPath);
				if ( is_array($ret) )
				{
					$categoryId	= (int)$ret[0];
					$fidParts	= is_array($ret[1]) ? $ret[1] : array();
				}
			}

			if ( defined('HIDE_CATEGORY_ID_IN_SEO') && HIDE_CATEGORY_ID_IN_SEO == 1 && isset($_GET['categoryFn']) )
			{
				$categoryFn = getVar('categoryFn');
				if ( $categoryFn != '' )
					$categoryId = (int)getColumn('CATEGORY', $categoryFn, 'ID', 'FILENAME');
			}

			if ( $categoryId == 0 )
				showErrorPageAndDie(404, 'Category id is empty');
		}

		$categoryRec	= array();
		if ( !($categoryRec = getRecord('CATEGORY', $categoryId)) )
			showErrorPageAndDie(404, 'Category not found for ID '.$categoryId);

//*************************************************************************************************

/*
THIS FUNCTION IS COMMENTED AS IT HINDERS WITH THE GET VARIABLES

		// 1/19/2010: This code is added so that if webmaster changes FILENAME in CATEGORY table and new urls are generated,
		//			  then old urls cached on search engines when called, set a permanent moved header to new urls and donot cause
		//			  search engines to think its duplicate content.
		//			  We also needed to call session.php after that so that header sent error does not occur.
		if ( USE_MOD_REWRITE == 'Y' )
        {
            // Get the category path without script root
			$cPath	= getCategoryPath($categoryId);
            $cPath	= str_replace(SCRIPT_ROOT, '', $cPath);
			
            // Get this url without script root
			$tPath	= (strstr(SCRIPT_ROOT, 'https://')?'https://':'http://').$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
            $tPath	= str_replace(SCRIPT_ROOT, '', $tPath);
            
			// Check if this url matches with category url and that there is no / in this url which indicates the use of extra options
			// like brand filter passed in url, etc that could make the urls diffirent yet they are correct.
			// eg: 1000-old-filename.htm should redirect to 1000-new-filename.htm
			// but: 1000-new-filename/Brand1.htm should not redirect to 1000-new-filename.htm
			if ( !strstr($tPath, '/') && $cPath != $tPath )
            {
                header("HTTP/1.1 301 Moved Permanently");
                header("Location: ".SCRIPT_ROOT.$cPath);
                exit();
            }
        }
*/

//*************************************************************************************************
		
		include (PATH."session.php");

		// We handle $_GET['pg'] here because only now we now what the $pageSize is
		if ( isset($_GET['pg']) && $_GET['pg'] > 0 && $pageSize > 0 )
			$_GET['x'] = ($_GET['pg'] - 1) * $pageSize;

		// 8-8-2012: Salman: Print Debug info if SQL is being logged
		if ( DO_TIME_EACH_QUERY == 1 )
			echo "\n<!-- \n- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n\n category starts \n\n -->\n";

//*************************************************************************************************

		$categoryTitle		= $categoryRec['TITLE'];
		$categoryFilename	= $categoryRec['FILENAME'];

//*************************************************************************************************

		$pageHeading		= $categoryTitle;
		$pageTitle			= str_replace('"', "&quot;", $categoryRec['PAGE_TITLE']==''?strip_tags($categoryTitle):$categoryRec['PAGE_TITLE']);
		$pageKeywords		= str_replace('"', "&quot;", $categoryRec['PAGE_KEYWORDS']==''?strip_tags($categoryTitle):$categoryRec['PAGE_KEYWORDS']);
		$pageDescription	= str_replace('"', "&quot;", $categoryRec['PAGE_DESCRIPTION']==''?strip_tags($categoryRec['DETAIL']):$categoryRec['PAGE_DESCRIPTION']);
		
		$ogTitle			= $pageTitle;
		$ogDescription		= $pageDescription;
		$ogImage			= getReadFileLink('upload/category/'.$categoryId.'.jpg');
		$categoryLink		= getCategoryPath($categoryId, $categoryFilename);

		$pageBreadcrumb		= getCategoryBreadCrumb($categoryRec['PARENT_ID'], ' &gt; <a href="{FILEPATH}">{TITLE}</a>') . ' &gt; <a href="'.$categoryLink.'">'.$categoryTitle.'</a>';

//*************************************************************************************************

		// 8-8-2012: Salman: Print Debug info if SQL is being logged
		if ( DO_TIME_EACH_QUERY == 1 )
			echo "\n<!-- getRootCategory() starts in category -->\n";
		$tabCategoryId 	= getRootCategory($categoryRec['PARENT_ID']);
		if ( DO_TIME_EACH_QUERY == 1 )
			echo "\n<!-- getRootCategory() ends in category -->\n";


		// 8-8-2012: Salman: Print Debug info if SQL is being logged
		if ( DO_TIME_EACH_QUERY == 1 )
			echo "\n<!-- getLastLevelChildList() starts in category -->\n";
		$childListArr 	= SHOW_PRODUCTS_ON_MID_LEVEL_CATEGORIES == 1 ? getChildCategoryList($categoryId, $categoryTitle) : getLastLevelChildList($categoryId, $categoryTitle);
		$childList		= implode(',', $childListArr);
		$linkCatId		= (int)$categoryRec['LINK_CAT_ID'];
		if ( $linkCatId > 0 )
		{
			$childListArr = array_merge($childListArr, SHOW_PRODUCTS_ON_MID_LEVEL_CATEGORIES == 1 ? getChildCategoryList($linkCatId) : getLastLevelChildList($linkCatId));
			$childList = implode(',', $childListArr);
		}
		$childList		= $childList == '' ? '0' : $childList;
		if ( DO_TIME_EACH_QUERY == 1 )
			echo "\n<!-- getLastLevelChildList() ends in category -->\n";

//*************************************************************************************************

		// Set the cache sub-key for header / footer
		$cacheHFSubKey = 'cat-'.($tabCategoryId>0?$tabCategoryId:$categoryId);

//*************************************************************************************************

		// Set the flag to tell search_products.php that it is category listing
		$isSearch		= false;

		// If we are showing products listing any way then goto products page
		if ( SHOW_PRODUCTS_ON_MID_LEVEL_CATEGORIES == 1 )
		{
			// If it is an api, then go to listing page directly
			if ( $prefPrdSrc['SHOW_PRODUCTS_FROM_MYSQL'] != 1 )
			{
				include("search_products.php");
				die;
			}
		}

		// If manuText is provided then it must be a brand-category search
		$manuText = brandUrlDecode(getVar('manuText'));
		if ( $manuText != '' )
		{
			$isSearch = true;
			$_GET['catId'] = $categoryId;
			loadLanguageForPage($lang, 'search_products');
			include("search_products.php");
			die;
		}

		// If this category contains products then goto products page
		//  -- Check Mysql
		if ( $prefPrdSrc['SHOW_PRODUCTS_FROM_MYSQL'] == 1 )
		{
			$argIds		= array();

			// If mid-level shows products than check by child list
			if ( SHOW_PRODUCTS_ON_MID_LEVEL_CATEGORIES == 1 )
			{
				$argIds		= explode(',', $childList);
			}

			// Else only check by this category ids
			else
			{
				$argIds[]	= $categoryId;
				$linkCatId	= (int)$categoryRec['LINK_CAT_ID'];
				if ( $linkCatId > 0 )
					$argIds[] = $linkCatId;
			}

			$argArray	= array();
			$argString	= prepareArgs4Query($argArray, $argIds);
			$res = preparedQuery("SELECT ID FROM ".PREFIX."PRODUCT WHERE CATEGORY_ID IN (".$argString.") LIMIT 1", $argArray);
			if ( ($row = getRow($res)) )
			{
				include("search_products.php");
				die;
			}
		}

		// If SHOW_PRODUCTS_ON_MID_LEVEL_CATEGORIES = 0, only then we get here (see line # 125 above)
		// If this category does not have any child then $childList = $categoryId, so we show listing page
		if ( $childList == $categoryId )
		{
			//  -- Check Shopzilla
			if ( $prefPrdSrc['SHOW_PRODUCTS_FROM_SHOPZILLA'] == 1 )
			{
				if ( $categoryRec['SHOPZILLA_ID'] > 0 )
				{
					include("search_products.php");
					die;
				}
			}
			//  -- Check Amazon
			if ( $prefPrdSrc['SHOW_PRODUCTS_FROM_AMAZON'] == 1 )
			{
				if ( $categoryRec['AMAZON_BROWSE_NODE'] != '' && $categoryRec['AMAZON_SEARCH_INDEX'] != '' )
				{
					include("search_products.php");
					die;
				}
			}
			//  -- Check Kelkoo
			if ( $prefPrdSrc['SHOW_PRODUCTS_FROM_KELKOO'] == 1 )
			{
				if ( $categoryRec['KELKOO_ID'] != '' )
				{
					include("search_products.php");
					die;
				}
			}
			//  -- Check SDC
			if ( $prefPrdSrc['SHOW_PRODUCTS_FROM_SDC'] == 1 )
			{
				if ( $categoryRec['SDC_ID'] != '' )
				{
					include("search_products.php");
					die;
				}
			}
			//  -- Check AffWin
			if ( $prefPrdSrc['SHOW_PRODUCTS_FROM_AFFWIN'] == 1 )
			{
				if ( $categoryRec['AFFWIN_ID'] != '' )
				{
					include("search_products.php");
					die;
				}
			}
			//  -- Check NexTag
			if ( $prefPrdSrc['SHOW_PRODUCTS_FROM_NEXTAG'] == 1 )
			{
				if ( $categoryRec['NEXTAG_ID'] != '' )
				{
					include("search_products.php");
					die;
				}
			}
			//  -- Check PriceGrabber
			if ( $prefPrdSrc['SHOW_PRODUCTS_FROM_PRICEGRABBER'] == 1 )
			{
				if ( $categoryRec['PRICEGRABBER_ID'] != '' )
				{
					include("search_products.php");
					die;
				}
			}
			//  -- Check Affilinet
			if ( $prefPrdSrc['SHOW_PRODUCTS_FROM_AFFILINET'] == 1 )
			{
				if ( $categoryRec['AFFILINET_ID'] != '' )
				{
					include("search_products.php");
					die;
				}
			}
			//  -- Check Connexity
			if ( $prefPrdSrc['SHOW_PRODUCTS_FROM_CONNEXITY'] == 1 )
			{
				if ( $categoryRec['CONNEXITY_ID'] != '' )
				{
					include("search_products.php");
					die;
				}
			}
			//  -- Check PopShops
			if ( $prefPrdSrc['SHOW_PRODUCTS_FROM_POPSHOPS'] == 1 )
			{
				if ( $categoryRec['POPSHOPS_ID'] != '' )
				{
					include("search_products.php");
					die;
				}
			}
			//  -- Check Elasticsearch
			if ( defined('IS_ELASTICSEARCH_INSTALLED') && IS_ELASTICSEARCH_INSTALLED == 1 && $prefPrdSrc['SHOW_PRODUCTS_FROM_ELASTICSEARCH'] == 1 )
			{
				include("search_products.php");
				die;
			}
			//  -- Check Zanox
			if ( $prefPrdSrc['SHOW_PRODUCTS_FROM_ZANOX'] == 1 )
			{
				if ( $categoryRec['ZANOX_ID'] != '' )
				{
					include("search_products.php");
					die;
				}
			}
		}

//*************************************************************************************************

		$featuredStores	= array();

		if ( IS_PRODUCTFILTERS_INSTALLED == 1 && $childList != '' )
		{
			$argArray	= array();
			$argString	= prepareArgs4Query($argArray, explode(',', $childList));
			$featuredStores	= getTableRecArray('CATEGORY_MERCHANT CM, '.PREFIX.'USER U', 'DISTINCT(CM.USERID), CM.NAME', array("CM.CATEGORY_ID IN (".$argString.") AND U.USERID = CM.USERID AND U.ISFEATURED = 'Y'", $argArray), 'CM.NAME');
		}

//*************************************************************************************************

		$catArr			= getTableRecArray('CATEGORY', 'ID, FILENAME, TITLE, PRODUCTS', array("PARENT_ID = ? AND ISVALID = 'Y' ".(defined('HIDE_CATS_IF_PRODS_0')&&HIDE_CATS_IF_PRODS_0==1?"AND PRODUCTS>0":''), array($categoryId)), 'SORT_ORDER, TITLE LIMIT 500', 'CATEGORY', 'PARENT_ID', 'ID', 'ID, TITLE, FILENAME, PRODUCTS', "ISVALID = 'Y'", 'SORT_ORDER, TITLE', 'category', 'ID', 1);
		$noOfRecords 	= sizeof($catArr);
				
		$exceptionMsg	= '';
		if ( $noOfRecords == 0 )
			$exceptionMsg = NO_SUBCATEGORY;
			
//*************************************************************************************************

		// Load featured products
		$featuredProducts	= getTableRecArray('PRODUCT_FEATURED PF, '.PREFIX.'PRODUCT P', 'P.*', array("PF.CATEGORY_ID = ? AND P.ID = PF.PRODUCT_ID AND P.ISVALID = 'Y'", array($categoryId)), 'P.TITLE');

//*************************************************************************************************

        // Render template
        renderTemplate('category', [
            'categoryId'       => $categoryId,
            'categoryRec'      => $categoryRec,
            'categoryTitle'    => $categoryTitle,
            'categoryFilename' => $categoryFilename,
            'categoryLink'     => $categoryLink,
            'childList'        => $childList,
            'catArr'           => $catArr,
            'noOfRecords'      => $noOfRecords,
            'exceptionMsg'     => $exceptionMsg,
            'featuredProducts' => $featuredProducts,
            'featuredStores'   => $featuredStores,
            'prefPrdSrc'       => $prefPrdSrc,
        ]);

//*************************************************************************************************
