<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

		require ("path.php");
		require (PATH."include/include.php");

//*************************************************************************************************

		include (PATH."session.php");

//*************************************************************************************************

		$sCompareIds	= is_array($_SESSION['sessCompareIds']) ? $_SESSION['sessCompareIds'] : array();
		$compareIds		= implode(",", $sCompareIds);
		$compareIds		= trimUniqueCsvVals($compareIds, 'int', 1);

//*************************************************************************************************

		if ( $compareIds == '' )
		{
		    renderTemplate('error', [
		        'pageWriteup' => '<div class="info">'.NO_TWO_PRODUCTS_FOUND.'</div>',
            ]);
		}

//*************************************************************************************************

		$categoryId = getVar('categoryId', 'int');
		if ( $categoryId == 0 )
		{
			$argArray	= array();
			$argString	= prepareArgs4Query($argArray, explode(',', $compareIds));
			$res = preparedQuery("SELECT CATEGORY_ID FROM ".PREFIX."PRODUCT WHERE ID IN (".$argString.")", $argArray);
			if ( ($row = getRow($res)) )
				$categoryId = (int)$row['CATEGORY_ID'];

			if ( $categoryId == 0 )
			{
				echo INFO_134."<a href='".getSeoUrl('/')."'>".CLICK_HERE."</a> ".TO_GO_BACK;
				die;
			}
		}

//*************************************************************************************************

		if ( IS_PRODUCT_FEATURE_CMP_INSTALLED == 1 )
		{
			require("compare_products_filters.php");
			die;
		}

//*************************************************************************************************

		$argArray	= array();
		$argString	= prepareArgs4Query($argArray, explode(',', $compareIds));
		$res		= breakPages("SELECT P.ID, P.TITLE, P.FILENAME, P.CATEGORY_ID, P.MANUFACTURER, P.MANUFACTURER_CODE, MIN_PRICE AS PRICE_MAX, MAX_PRICE AS PRICE_MIN, P.STORE_COUNT, PRODUCT_RATING AS RATING FROM ".PREFIX."PRODUCT P WHERE P.ID IN (".$argString.") ORDER BY PRODUCT_RATING DESC", '', 0, $argArray);
		$totCount	= getTotalRows($res);

//*************************************************************************************************
		
		$exceptionMsg 			= '';
		if ( $totCount < 2 )
			$exceptionMsg = NO_TWO_PRODUCTS_FOUND; 		

//*************************************************************************************************

		$resCmpPrds	= breakPages("SELECT IFNULL(MAX(UP.ID), 0) AS UPID, COUNT(*) AS STORE_COUNT, P.*, IFNULL(AVG(UPR.RATING), -1) AS RATING, IFNULL(MAX(UP.PRICE), 0) AS PRICE_MAX, IFNULL(MIN(UP.PRICE), 0) AS PRICE_MIN FROM ".PREFIX."PRODUCT P LEFT OUTER JOIN ".PREFIX."USER_PRODUCT UP ON UP.PRODUCT_ID = P.ID AND UP.ISVALID='Y' LEFT OUTER JOIN ".PREFIX."PRODUCT_RATING UPR ON UPR.PRODUCT_ID=P.ID AND UPR.ISVALID='Y' WHERE P.ID IN (".$argString.") GROUP BY P.ID ORDER BY RATING DESC", '', 0, $argArray);
		$totCount	= getTotalRows($resCmpPrds);
		$count		= 0;
		$pDetails	= loadProductDetailFromIds($compareIds);

//*************************************************************************************************

        // Render template
        renderTemplate('compare_products', [
            'compareIds' => $compareIds,
            'categoryId' => $categoryId,
            'totCount' => $totCount,
            'exceptionMsg' => $exceptionMsg,
            'resCmpPrds' => $resCmpPrds,
            'pDetails' => $pDetails,
        ]);

//*************************************************************************************************
