<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

		$compareIds = trimUniqueCsvVals($compareIds, 'int', 1);
		$argArray	= array();
		$argString	= prepareArgs4Query($argArray, explode(',', $compareIds));
		
		$res	= preparedQuery("SELECT IFNULL(P.MIN_PRICE, 0) AS PRICE_MIN, IFNULL(P.MAX_PRICE, 0) AS PRICE_MAX, IFNULL(P.STORE_COUNT, 0) AS STORE_COUNT, P.ID AS ID, P.CATEGORY_ID AS CATEGORY_ID, P.TITLE AS TITLE, P.MANUFACTURER AS MANUFACTURER,  PRODUCT_RATING AS RATING FROM ".PREFIX."PRODUCT P WHERE P.ID IN (".$argString.") GROUP BY P.ID ORDER BY P.ID", $argArray);
		$proTot	= getTotalRows($res);
		$count	= 0;
		$proArr = array();

		while ( ($row = getRow($res)) )
			$proArr[] = $row;
		
		free($res);
		$total = sizeof($proArr);

//*************************************************************************************************

		$categoryRes	= preparedQuery("SELECT COUNT(DISTINCT(CATEGORY_ID)) AS TOTAL FROM ".PREFIX."PRODUCT WHERE ID IN (".$argString.")", $argArray);
		$categoryRow	= getRow($categoryRes);
		$categoryCount	= (int)$categoryRow['TOTAL'];		

//*************************************************************************************************

		// Get feature ids for this category
		$fcIds = array();
		$resFCIds = preparedQuery("SELECT FEATURE_ID FROM ".PREFIX."PRODUCT_FEATURE_IN_CATEGORY WHERE CATEGORY_ID = ?", array($categoryId));
		while ( ($rowFCIds = getRow($resFCIds)) )
		{
			$rowFCIds['FEATURE_ID'] = (int)$rowFCIds['FEATURE_ID'];
			if ( $rowFCIds['FEATURE_ID'] < 1 || in_array($rowFCIds['FEATURE_ID'], $fcIds) )
				continue;

			$fcIds[] = $rowFCIds['FEATURE_ID'];
		}

//*************************************************************************************************

		$fArr	= array();
		if ( $categoryCount < 2 && count($fcIds) > 0 )
		{
			$res = preparedQuery("SELECT P.ID, FC.PARENT_ID AS FEATURE_PARENT, FC.ID AS FEATURE_ID, FC.FEATURE, IFNULL(VALUE, 'N/A') AS VALUE FROM (".PREFIX."PRODUCT_FEATURE_CATEGORY FC, ".PREFIX."PRODUCT_FEATURE_CATEGORY FCP, ".PREFIX."PRODUCT P) LEFT OUTER JOIN ".PREFIX."PRODUCT_FEATURE F ON F.PRODUCT_ID = P.ID AND F.FEATURE_ID = FC.ID LEFT OUTER JOIN ".PREFIX."PRODUCT_FEATURE_VALUE FV ON FV.ID = F.VALUE_ID WHERE P.ID IN (".$argString.") AND FC.ID IN (".implode(',', $fcIds).") AND FCP.ID = FC.PARENT_ID AND FC.PARENT_ID <> 0 ORDER BY FCP.SORT_ORDER, FCP.FEATURE, FC.SORT_ORDER, FC.FEATURE, P.ID, FV.SORT_ORDER, FV.VALUE", $argArray);

			while ( ($row = getRow($res)) )
				array_push($fArr, $row);

			free($res);
		}
		$fTot	= sizeof($fArr);

//*************************************************************************************************

		// Get Filter Parents
		$pCount = 0;
		$parent	= '';
		if ( count($fcIds) > 0 )
		{
			$res = executeQuery("SELECT COUNT(ID) AS TOTAL FROM ".PREFIX."PRODUCT_FEATURE_CATEGORY WHERE PARENT_ID = 0 AND ID IN (".implode(',', $fcIds).")");
			if ( ($row = getRow($res)) )
				$pCount = $row['TOTAL'];
		}

//*************************************************************************************************

		$exceptionMsg	= '';
		if ( $proTot < 2 )
			$exceptionMsg = NO_TWO_PRODUCTS_FOUND;

//*************************************************************************************************

		$info 			= '';
		if ( getVar('info') != '' )
			$info = "<font class='info'>".getInfo(getVar('info'))."</font><br><br>"; 		

//*************************************************************************************************

		// Render template
		renderTemplate('compare_products_filters', [
			'compareIds' => $compareIds,
			'categoryId' => $categoryId,
			'categoryRow' => $categoryRow,
			'categoryCount' => $categoryCount,
			'proTot' => $proTot,
			'proArr' => $proArr,
			'total' => $total,
			'fTot' => $fTot,
			'fArr' => $fArr,
			'exceptionMsg' => $exceptionMsg,
			'parent' => $parent,
		]);

//*************************************************************************************************
