<?php
/**
 * This file contains add-on flags and their related constants.
 */

// Secure file from direct access
defined('PATH') or die('direct access not allowed!');


// Elasticsearch add-on
define("IS_ELASTICSEARCH_INSTALLED",		0);
define("ELASTICSEARCH_PREFIX",				'pc7_');
define("ELASTICSEARCH_FEED_IMPORT_ENABLED",	0);

// Set to 1 if Autofeed addon is installed
define('IS_AUTOFEED_INSTALLED',				1);

// Set to 1 if Advance search is installed
define('IS_ADVANCE_SEARCH_INSTALLED',		0);

// Set to 1 if PriceHistoryGraph is installed
define('IS_PRICEHISTORYGRAPH_INSTALLED',	1);

// Set to 1 if ProductFilters is installed
define('IS_PRODUCTFILTERS_INSTALLED',		1);

// Set to 1 if Product Feature Comparison is installed
define('IS_PRODUCT_FEATURE_CMP_INSTALLED',	1);

// Set to 1 if Popular Products is installed
define('IS_POPULAR_INSTALLED',				1);

// Set to 1 if brands addon is installed
define('IS_BRANDS_INSTALLED',				0);

// Set to 1 if MerchantBidding is installed
define('IS_MERCHANTBID_INSTALLED',			0);
define('BID_MIN_PAYMENT',					10);					// Minimum payment amount
define('BID_INCREMENT',						1);						// Bid incremental value and minimum bid amount

// Set to 1 if MerchantBidding is only used for CPC
define('IS_MERCHANTBID_USED_FOR_CPC',       0);

// Set to 1 if ProductMultipleImages is installed
define('IS_MULTIPLE_IMAGES_INSTALLED',		1);

// Set to 1 if Coupons are installed
define('IS_COUPONS_INSTALLED',				1);

// Set to 1 if Extended Rating is installed
define('IS_EX_RATING_INSTALLED',			0);

// Set to 1 if Proximity is installed
define('IS_ZIPCODE_PROXIMITY_INSTALLED',	0);

// Set to 1 if Map should be displayed on Price Grid page
define('IS_PRICE_GRID_MAP_INSTALLED',		1);
define('GOOGLE_MAPS_API_KEY',				'');

// Set to 1 if Auction addon is installed
define('IS_AUCTION_INSTALLED',				0);

// Set to 1 if KaonCart addon is installed
define('IS_KAONCART_INSTALLED',				0);

// Set to 1 if Advertiser addon is installed
define('IS_ADVERTISER_INSTALLED',			0);

// Set to 1 if EBAY addon is installed
define('IS_EBAY_INSTALLED',					1);
define('EBAY_PRODUCT_ID',					2);

// Set to 1 if Amazon addon is installed to fetch prices of products
define('IS_AMAZON_PRODUCT_PRICES_INSTALLED',0);

// Set to 1 if ProductFilters is installed
define('IS_WISHLIST_INSTALLED',				1);

// Set to 1 if news addon is installed
define('IS_NEWS_INSTALLED',					1);

// Set to 1 if merchant coupons is installed
define('IS_MERCHANT_COUPONS_INSTALLED',		0);

// Set to 1 if affiliates addon is installed
define('IS_AFFILIATES_INSTALLED',			1);

// Set to 1 if Cashbacks is installed
define('IS_CASHBACK_INSTALLED',				0);

// Set to 1 if BudgetList is installed
define('IS_BUDGETLIST_INSTALLED',			0);

// Set to 1 if ShoppingCart is installed
define('IS_SHOPPING_CART_INSTALLED',		0);

// Shopping Cart Constants - START ---------

define('SHOPPING_CART_CHECK_STOCK',					0);

define('ALLOW_CHECKOUT_WITHOUT_SIGNUP',				0);

define('SHOPPING_CART_COMBINED_STORE',				'~~default~~');

// Shopping Cart Constants - END -----------


// Pay Per Sale Preferences
define("IS_PPS_INSTALLED",							1);
define("PPS_ACTIVE",								'Y');
define("PPS_DEFAULT_RATE",							4);
define("PPS_DEFAULT_RATE_IS_PERCENTAGE",			'N');


// Set to 1 if youtube product video is installed
define('IS_YOUTUBE_PROD_VIDEO_INSTALLED',			0);

// Set to 1 if price extraction from merchant url installed
define('IS_MERCHANT_PRICE_EXTR_INSTALLED',			0);

// Set to 1 if product tags creator add-on is installed
define('IS_PRODUCT_TAGS_CREATOR_INSTALLED',			1);

// Set to 1 if ajax search auto-complete add-on is installed
define('IS_AJAX_SEARCH_AUTOCOMPLETE_INSTALLED',		1);
define('AJAX_SEARCH_AUTOCOMPLETE_WIDTH',			400);
define('AJAX_SEARCH_AUTOCOMPLETE_MINCHARS',			5);
define('AJAX_SEARCH_AUTOCOMPLETE_MILLISECONDS',	    800);
define('AJAX_SEARCH_AUTOCOMPLETE_THEME',			'classic');    // values: classic, modern

// Set to 1 if multi-domain redirection is installed
define('IS_MULTI_DOMAIN_REDIRECT_INSTALLED',		0);
define('DEFAULT_MULTI_DOMAIN_REDIRECT_URL',			'');

// Set to 1 if Mobile Site is installed
define('IS_MOBILE_SITE_INSTALLED',					0);

// Set to 1 if filters-import-from-datafeed is installed
define('IS_FILTERS_IMPORT_FROM_DATAFEED_INSTALLED', 0);

// Set to 1 if Sell Yours is installed
define('IS_SELL_YOURS_INSTALLED',				0);

// Set to 1 if Merchant Ex Rating is installed
define('IS_MERCHANT_EX_RATING_INSTALLED',		0);

