<?php
/**
 * This file contains all the definite constants that the script uses.
 * This includes enums and constant values that never (or very rarely) change.
 */

// Secure file from direct access
defined('PATH') or die('direct access not allowed!');


// Language Characters to be translated
$TRANSLATE_ARRAY = [
    "Á" => "A", "á" => "a", "À" => "A", "à" => "a", "Â" => "A", "â" => "a", "Ä" => "A", "ä" => "ae",
    "Ã" => "A", "ã" => "a", "Å" => "A", "å" => "a", "Æ" => "AE", "æ" => "ae", "Ç" => "C", "ç" => "c",
    "É" => "E", "é" => "e", "È" => "E", "è" => "e", "Ê" => "E", "ê" => "e", "Ë" => "E", "ë" => "e",
    "Í" => "I", "í" => "i", "Ì" => "I", "ì" => "i", "Î" => "I", "î" => "i", "Ï" => "I", "ï" => "i",
    "Ñ" => "N", "ñ" => "n", "Ó" => "O", "ó" => "o", "Ö" => "O", "ö" => "o", "Ò" => "O", "ò" => "o",
    "Õ" => "O", "õ" => "o", "Ô" => "O", "Œ" => "CE", "œ" => "ce", "ô" => "o", "Ø" => "oe", "ø" => "oe",
    "Ú" => "U", "ú" => "u", "Ù" => "U", "ù" => "u", "Û" => "U", "û" => "u", "Ü" => "U", "ü" => "ue",
    "Ý" => "Y", "ý" => "y", "Ÿ" => "Y", "ÿ" => "y", "ß" => "ss", "¿" => "i", "¡" => "i"
];


// Shopping Cart Add-on - Payment methods
define('DB_ENUM_PAYMENT_METHOD_PAYPAL',				1);
define('DB_ENUM_PAYMENT_METHOD_2CHECKOUT',			2);
define('DB_ENUM_PAYMENT_METHOD_AUTHORIZE_NET',		3);
define('DB_ENUM_PAYMENT_METHOD_OFFLINE',			4);
define('DB_ENUM_PAYMENT_METHOD_VCS_DIRECT',			5);
define('DB_ENUM_PAYMENT_METHOD_GOOGLE_CHECKOUT',	6);
define('DB_ENUM_PAYMENT_METHOD_PAYBOX',				7);
define('DB_ENUM_PAYMENT_METHOD_MULTISAFE',			8);
define('DB_ENUM_PAYMENT_METHOD_GOPAY',				9);
define('DB_ENUM_PAYMENT_METHOD_EGOLD',				10);
define('DB_ENUM_PAYMENT_METHOD_WESTERNUNION',		11);
define('DB_ENUM_PAYMENT_METHOD_ALERTPAY',			12);
define('DB_ENUM_PAYMENT_METHOD_MONEYBOOKER',		13);
define('DB_ENUM_PAYMENT_METHOD_LIBERTYRESERVE',		14);
define('DB_ENUM_PAYMENT_METHOD_WEBMONEY',			15);
define('DB_ENUM_PAYMENT_METHOD_EPASSPORTE',			16);
define('DB_ENUM_PAYMENT_METHOD_PROTX',				17);
define('DB_ENUM_PAYMENT_METHOD_LINKPOINT',			18);
define('DB_ENUM_PAYMENT_METHOD_MOIPBR',				19);


// Constants related to api listings and products
define('API_TYPE_MYSQL',					'm');
define('API_TYPE_SHOPZILLA',				's');
define('API_TYPE_AMAZON',					'a');
define('API_TYPE_KELKOO',					'k');
define('API_TYPE_SDC',						'd');
define('API_TYPE_AFFWIN',                   'w');
define('API_TYPE_NEXTAG',                   'x');
define('API_TYPE_ZANOX',                    'z');
define('API_TYPE_PRICEGRABBER',				'g');
define('API_TYPE_ELASTICSEARCH',            'e');
define('API_TYPE_AFFILINET',                'l');
define('API_TYPE_CONNEXITY',                'c');
define('API_TYPE_POPSHOPS',					'p');
$ARR_API_TYPE_NAME_VALS = [
    'MYSQL'         => API_TYPE_MYSQL,
    'SHOPZILLA'     => API_TYPE_SHOPZILLA,
    'AMAZON'        => API_TYPE_AMAZON,
    'KELKOO'        => API_TYPE_KELKOO,
    'SDC'           => API_TYPE_SDC,
    'AFFWIN'        => API_TYPE_AFFWIN,
    'NEXTAG'        => API_TYPE_NEXTAG,
    'ZANOX'         => API_TYPE_ZANOX,
    'PRICEGRABBER'  => API_TYPE_PRICEGRABBER,
    'ELASTICSEARCH' => API_TYPE_ELASTICSEARCH,
    'AFFILINET'     => API_TYPE_AFFILINET,
    'CONNEXITY'     => API_TYPE_CONNEXITY,
    'POPSHOPS'      => API_TYPE_POPSHOPS,
];
define('PCS_AMAZON_USERID',					'1');
define('PCS_SHOPZILLA_USERID',				'2');
define('PCS_KELKOO_USERID',					'3');
define('PCS_SDC_USERID',					'4');
define('PCS_AFFWIN_USERID',					'5');
define('PCS_NEXTAG_USERID',					'6');
define('PCS_EBAY_USERID',					'7');
define('PCS_ZANOX_USERID',					'8');
define('PCS_PRICEGRABBER_USERID',			'9');
define('PCS_AFFILINET_USERID',				'10');
define('PCS_CONNEXITY_USERID',				'11');
define('PCS_POPSHOPS_USERID',				'12');

