<?php

	defined('PATH') or die('direct access not allowed!');

    // Company Name already defined means this file is already included by _rewrite.php
    if ( defined('SCRIPT_COMPANY_NAME') ) {
        return;
    }

	// Company Name
	define('SCRIPT_COMPANY_NAME',			'Price Comparison Script');


	// Default Language ID
	define('SCRIPT_DEFAULT_LANGUAGE',       1000);


	// Mod Rewrite
	define('USE_MOD_REWRITE',				'Y');
	define('IS_LOCAL',						'N');
	define('EXTENSION',						(USE_MOD_REWRITE=='Y'?'htm':'php'));

	
	// Redirect to webpage of shop IF ONLY "One Store" is present for that product.
	define('REDIRECT_ON_ONE_STORE',					0);


	// Clickthrough recorded after X hours
	define('CLICKTHROUGH_RECORDED_AFTER',			5);


	// Send warning email to merchant for package expiry before X number of days
	define('MERCHANT_PACKAGE_EXPIRY_NOTIFY_DAYS',	15);


	// Send warning email to merchant for balance low X amount
	define('MERCHANT_BALANCE_NOTIFY_LOWER_LIMIT',	-5);


	// Default Charset used in admin and public panel
	define('DEFAULT_CHARSET',						'utf-8');
	
	// Default country in the dropdown
	define('DEFAULT_COUNTRY',						'United States');	
		
	// Disallow email from same domain
	define('DISALLOW_EMAIL_FROM_SAME_DOMAIN',		1);
	
	// Do shutdown site
	define('DO_SHUTDOWN_WEBSITE',					0);
	
	
	//********************************************************************************************************	
	// BASIC FLAGS -MIXED-	
	//********************************************************************************************************	

	// File upload valid extensions
	define('VALID_EXTENSIONS',					'jpg,jpeg,gif,png,txt,csv,xml,swf,zip,tar,gz');

	// Perform Refer Check
	define('DO_PERFORM_REFER_CHECK',			0);

	// Cleanup input for strict checking. Disable it for other languages
	define('DO_DISABLE_INPUT_FILTERING',		1);

	// Show Refer A Friend
	define('SHOW_REFER_A_FRIEND',				'1');

	// Display CurrencySymbol Before/After Price
	define('IS_CURRENCY_AFTER_PRICE',			0);

	// Perform Search By Words
	define('IS_SEARCH_BY_WORD',					0);

	// Enable Manufacturer CODE Search
	define('DO_ENABLE_SEARCH_BY_CODE',			0);

	// Enable Search by MYSQL MATCH
	define('DO_ENABLE_SEARCH_BY_MATCH',			0);

	// Max Execution Time for PRODUCT SPIDER per call
	define('MAX_EXECUTION_4_PRODUCT_SPIDER',	300);

	// In Europe , is used as decimal
	define('IS_COMMA_DECIMAL_SEPARATOR',		0);

	// Admin folder name - Useful as sometimes people want to change admin folder name.
	define('ADMIN_FOLDER_NAME',					'admin');

	// Is registration compulsory for Review/Rating.
	define('DO_WRITE_REVIEW_WITHOUT_LOGIN',		1);

	//********************************************************************************************************	
	// FUNCTIONALITY FLAGS
	//********************************************************************************************************

	// Set this option to YES if you want to Show PageBreaks with page numbers
	define('SHOW_PAGE_BREAKS_WITH_NUMBERS',		0);

	// Set this option to 1 if you want to hide shipping column in price comparison
	define('DO_HIDE_SHIPPING_COLUMN',			1);

	// Set this option to 1 if you want to show shipping column from database
	define('DO_SHOW_SHIPPING_FROM_DB',			0);

	// Set this option to 1 if you want to hide 468x60 banner on homepage
	define('DO_HIDE_BANNER_ON_HOMEPAGE',		0);

	// Set this option to 1 if you want to hide 468x60 banner below price comparison list
	define('DO_HIDE_BANNER_ON_PRICE_COMP',		0);

	// Set this option to 1 if you want to hide availability column
	define('DO_HIDE_AVAILABILITY_COLUMN',		0);

    // Show newsletter pop on homepage automatically once for a user (after 15 seconds)
    define('AUTOSHOW_NEWSLETTER_POP',           1);

    // Set this to the current theme, keep default if not sure
    define('CURRENT_THEME',                 '2018-1');

    // Set this to the current template, keep default if not sure
    // If you have changed the template here, you may also want to change theme above
    define('CURRENT_TEMPLATE',              '2018-1');

// ###wfwefdsfdsf123143242### Changeable constants below this line
	//********************************************************************************************************	

	//********************************************************************************************************
    //	INCLUDE SUB-FILES
	//********************************************************************************************************

    if (file_exists(PATH.'include/config/constants-preinstall.php')) {
        require 'config/constants-preinstall.php';
    }

    require 'config/constants-fixed.php';
    require 'config/constants-globals.php';
    require 'config/constants-critical.php';
    require 'config/constants-addons.php';
    require 'config/constants-seo.php';
    require 'config/constants-exfields.php';
    require 'config/constants-misc.php';

//********************************************************************************************************

// Removed due to not used:
//  SPIDER_DOLLAR
//  SELLER_PACKAGE_ID
//  SHOW_MYSQL_PRODS_ON_API_LISTINGS
//  IS_PRICE_BF4_CURRENCY
//  SHOW_SPREADSHEET_PANEL

//********************************************************************************************************
