<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

		defined('PATH') or die('direct access not allowed!');

//*************************************************************************************************

		// Disable debug for security, comment below line to enable the use of this debug variable
		unset($_GET['debug']);
		
//*************************************************************************************************

		// Fix for PHP 5.1
		if ( function_exists('date_default_timezone_set') ) // && phpversion() < "5.2.0"
			date_default_timezone_set("America/New_York");

//*************************************************************************************************

		// Apply autoloader to load composer dependencies
		if ( PHP_VERSION < "7.1" ) {
			require 'vendor-below-php7.1/autoload.php';
		} else {
			require 'vendor/autoload.php';
		}

//***********************************************************************************

		// Include sentry config if it exists
		if ( file_exists( PATH . 'include/config/constants-sentry.php' ) ) {
			require_once PATH . 'include/config/constants-sentry.php';
		}

		// Apply Sentry settings if set
		if ( defined( 'SENTRY_PHP_DSN' ) && SENTRY_PHP_DSN != '' ) {
			error_reporting( E_ALL & ~E_NOTICE );
			ini_set( 'display_errors', false );

			Sentry\init( [
				'dsn'         => SENTRY_PHP_DSN,
				'error_types' => E_ALL & ~E_NOTICE,
			] );
		} // End-if apply Sentry

		// Apply Kaon error handler if Sentry not set
		else {
			require PATH . 'include/kaon-err-handler.php';

			KaonErrHandler::$isEmailSent              = false;
			KaonErrHandler::$reportToEmail            = '';       // set as string for single email or array of strings for multiple emails
			KaonErrHandler::$isErrorDetailedEmailed   = false;
			KaonErrHandler::$isErrorDetailedDisplayed = true;
			KaonErrHandler::showFullErrorsFromPath( 'admin' );
			KaonErrHandler::initErrorHandler();
		}

//*************************************************************************************************

		require_once(PATH."include/site_constants.php");
		require_once(PATH."include/dbconst.php");
		require_once(PATH."include/constants.php");

//*************************************************************************************************

		if ( phpversion() <= "4.0.6" )
		{
			$_POST = ($HTTP_POST_VARS);
			$_GET  = ($HTTP_GET_VARS);
		}

//*************************************************************************************************

		$pageCount	= 1;
		$pageSize	= 20;
		$serverHost = $_SERVER["HTTP_HOST"];
		if ( $serverHost == '' ) $serverHost = $_SERVER["SERVER_NAME"];

//*************************************************************************************************

		$browserType	= '';

		if ( !(defined('IS_IN_SSH') && IS_IN_SSH == 1) )
			startSession();

		if ( isset($_GET['__bt']) )
		{
			$browserType		= $_GET['__bt'];								// Can't change _GET here because getVar is not declared yet
			$browserType		= preg_replace('/[^a-z]/', '', $browserType);	// Can't use kregexp here because its not declared yet
			$_SESSION['__bt']	= $browserType;
		}
		elseif ( isset($_SESSION['__bt']) && $_SESSION['__bt'] != '' )
			$browserType	= $_SESSION['__bt'];
		else
			$browserType	= 'default';

		if ( stristr($_SERVER['HTTP_USER_AGENT'], 'mobile') )
			$browserType	= 'mobile';
		elseif ( stristr($_SERVER['HTTP_USER_AGENT'], 'symbian') )
			$browserType	= 'symbian';
		elseif ( stristr($_SERVER['HTTP_USER_AGENT'], 'iphone') )
			$browserType	= 'iphone';
		elseif ( stristr($_SERVER['HTTP_USER_AGENT'], 'android') )
			$browserType	= 'android';

//*************************************************************************************************

		$templateSubFolder	= defined('IS_MOBILE_SITE_INSTALLED') && IS_MOBILE_SITE_INSTALLED == 1 && $browserType != 'default' ? 'mobile/' : '';

//*************************************************************************************************

		///////////////////////////////////////////////////////////////
		// Move domain.com to www.domain.com to avoid javascript errors
		if ( !(defined('IS_IN_SSH') && IS_IN_SSH == 1) )
		{
			$httpHostFilename = '';
			if ( isset($_SERVER['REQUEST_URI']) && $_SERVER['REQUEST_URI']!='' )
				$httpHostFilename = $_SERVER['REQUEST_URI'];
			elseif ( isset($_SERVER['PHP_SELF']) && $_SERVER['PHP_SELF']!='' )
				$httpHostFilename = $_SERVER['PHP_SELF'];
			
			if ( $httpHostFilename == '' )
				echo '<br><font size="1" color="red">Server environment variable for filename is empty</font><br>';


			$httpHostname = '';
			if ( isset($_SERVER['HTTP_HOST']) && $_SERVER['HTTP_HOST'] !='' )
				$httpHostname = $_SERVER['HTTP_HOST'];
			elseif ( isset($_SERVER['SERVER_NAME']) && $_SERVER['SERVER_NAME']!='' )
				$httpHostname = $_SERVER['SERVER_NAME'];
			
			// Must be in shell try to find hostname in the shell
			if ( $httpHostname == '' )
			{
				$httpHostname = php_uname("n");

				if ( $httpHostname == '' )
					$httpHostname = system('echo $HOSTNAME');
			}

			if ( $httpHostname == '' )
				echo '<br><font size="1" color="red">Server environment variable for hostname is empty</font><br>';


			$httpFullUrl = '';
            if ( $_SERVER['SERVER_PORT'] == 443 || $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https' )
				$httpFullUrl = "https://".$httpHostname.$httpHostFilename;
			else
				$httpFullUrl = "http://".$httpHostname.$httpHostFilename;


			if ( $httpHostname != '' )
			{
                // Check if url matches with SCRIPT_ROOT or SCRIPT_ROOT_SSL
                if ( substr($httpFullUrl, 0, strlen(SCRIPT_ROOT)) != SCRIPT_ROOT && substr($httpFullUrl, 0, strlen(SCRIPT_ROOT_SSL)) != SCRIPT_ROOT_SSL )
				{
					$installFolder	= SCRIPT_ROOT;
					$installFolder	= str_replace('http://www.', '', $installFolder);										// These two lines are to make sure we have
					$installFolder	= str_replace('http://', '', $installFolder);											// removed http:// and www.
					$installFolder	= str_replace(str_replace('www.', '', $httpHostname).'/', '', $installFolder);			// Now we remove the remaining host name from script root
																															// so that the residue is the installation folder.

					$redirectPath	= $httpHostFilename;
					$redirectPath	= str_replace($installFolder, '', $redirectPath);										// We remove the installation folder from request url
					$redirectPath	= substr($redirectPath, 1);																// which is the portion after host name

					header("Status: 301 Moved Permanently");

					if ( $redirectPath == 'index.php' || $redirectPath == 'index.htm' )
						header("Location: ".SCRIPT_ROOT);																	// Now we redirect to the above calculated end portion of
					else																									// url preceded by the SCRIPT_ROOT ONLY IF it is not index.php or index.htm
						header("Location: ".SCRIPT_ROOT.$redirectPath);														// Otherwise we just redirect to script root
																															
					die;
				}
			}
		}

//*************************************************************************************************

		// NOW INCLUDE OUR FUNCTIONS/MODULES
		include(PATH."include/include_blade.php");
		include(PATH."include/include_captcha.php");
		include(PATH."include/include_custom.php");
		include(PATH."include/include_date.php");
		include(PATH."include/include_db.php");
		include(PATH."include/include_options.php");
		include(PATH."include/include_email.php");
		include(PATH."include/include_file.php");
		include(PATH."include/include_geo.php");
		include(PATH."include/include_images.php");
		include(PATH."include/include_inputfilter.php");
		include(PATH."include/include_json.php");
		include(PATH."include/include_no_innodb.php");
		include(PATH."include/include_payment.php");
		include(PATH."include/include_server.php");
		include(PATH."include/include_richeditor.php");
		include(PATH."include/include_site.php");
		include(PATH."include/include_site_brand.php");
		include(PATH."include/include_site_category.php");
		include(PATH."include/include_site_product.php");
		include(PATH."include/include_site_user.php");
		include(PATH."include/include_site_user_product.php");
		include(PATH."include/include_site_html.php");

//*************************************************************************************************

        ///////////////////////////////////////////////////////////////
        // In case we have an Android app in Market and browser is Android
        if ( defined('IS_MOBILE_SITE_INSTALLED') && IS_MOBILE_SITE_INSTALLED != '' && defined('ANDROID_APP_ID') &&
            ANDROID_APP_ID != '' && $browserType == 'android' && !strstr($_SERVER['SCRIPT_NAME'], '/and_load_') &&
            !strstr($_SERVER['SCRIPT_NAME'], '/ask_android_app') && !strstr($_SERVER['SCRIPT_NAME'], '/open_android_app') )
        {
            startSession();
            if ( (!isset($_SESSION['androidLoadApp']) || $_SESSION['androidLoadApp'] != 'N')  )
            {
                header("Location: ".SCRIPT_ROOT."ask_android_app.php");
                die;
            }
        }

//*************************************************************************************************

		if ( IS_AFFILIATES_INSTALLED == 1 )
		{
			include(PATH."include/include_affiliates.php");
		}

		if ( IS_AUTOFEED_INSTALLED == 1 )
		{
			include(PATH."include/include_compress-uncompress.php");
			include(PATH."include/include_autofeed.php");
		}

		if ( IS_PRODUCTFILTERS_INSTALLED == 1 )
		{
			include(PATH."include/include_filter.php");
		}

		if ( IS_PRICEHISTORYGRAPH_INSTALLED == 1 )
		{
			include(PATH."include/include_price-history.php");
		}

		if ( IS_MULTIPLE_IMAGES_INSTALLED == 1 )
		{
			include(PATH."include/include_multi_image.php");
		}

		if ( IS_COUPONS_INSTALLED == 1 )
		{
			include(PATH."include/include_coupon.php");
		}

		if ( IS_MERCHANTBID_INSTALLED == 1 )
		{
			include(PATH."include/include_productbid.php");
		}

		if ( IS_ZIPCODE_PROXIMITY_INSTALLED == 1 )
		{
			include(PATH."include/include_proximity.php");
		}

		if ( IS_AUCTION_INSTALLED == 1 )
		{
			include(PATH."include/include_auction.php");
		}

		if ( IS_KAONCART_INSTALLED == 1 )
		{
			include(PATH."include/include_kaoncart.php");
		}

		if ( IS_CASHBACK_INSTALLED == 1 )
		{
			include(PATH."include/include_cashback.php");
		}

		if ( IS_MERCHANT_COUPONS_INSTALLED == 1 )
		{
			include(PATH."include/include_merchant_coupon.php");
		}

		if ( IS_PPS_INSTALLED == 1 )
		{
			include(PATH."include/include_site_user_product_sale.php");
		}

		if ( IS_SHOPPING_CART_INSTALLED == 1 )
		{
			include(PATH."include/include_site_user_store.php");
		}

		if ( ini_get('safe_mode') )
		{
			define('SCRIPT_FTP_HOSTNAME',	'');
			define('SCRIPT_FTP_USERNAME',	'');
			define('SCRIPT_FTP_PASSWORD',	'');
			define('SCRIPT_FTP_DIRECTORY',	'');

			include(PATH."include/include_file_safemode.php");
		}

		if ( IS_ELASTICSEARCH_INSTALLED == 1 )
		{
			include(PATH."include/include_elasticsearch.php");
		}

//*************************************************************************************************

		// Opens database connection for sitewide usage
		// 25/10/2012: This is not done in the include_db.php anymore due to inavailability of getMicroTime func
		openConnection();

        // Call the function to load site options/configuration from database
        loadSiteOptionsFromDB();


//*************************************************************************************************

		// Check if site is being reset
		if ( defined('IS_IN_DEMO_MODE') && IS_IN_DEMO_MODE == 1 && !(defined('IS_IN_SSH') && IS_IN_SSH == 1) )
		{
			if ( !strstr($httpHostFilename, 'admin/r-qry') && !strstr($httpHostFilename, 'admin/cronjobs') && !strstr($httpHostFilename, 'admin/_tools') )
			{
				$res = executeQuery("SELECT RESET_IN_PROCESS, UNIX_TIMESTAMP(START_TIME) AS TS_START, UNIX_TIMESTAMP() AS TS_NOW, UNIX_TIMESTAMP(LAST_END_TIME)-UNIX_TIMESTAMP(LAST_START_TIME) AS LAST_TOT_SECS FROM ".PREFIX."MASTER_RESET ORDER BY START_TIME DESC LIMIT 1");
				if ( ($row = getRow($res)) )
				{
					if ( $row['RESET_IN_PROCESS'] == 1 )
					{
						$tsStart		= $row['TS_START'];
						$tsNow			= $row['TS_NOW'];
						$tsEstmated		= ($row['LAST_TOT_SECS'] > 0 ? $row['LAST_TOT_SECS'] : 20*60) + $tsStart;	// Take last number of secs OR estimated 10 mins after job started
						$secondsLeft	= $tsEstmated - $tsNow;
						$secondsLeft	= $secondsLeft < 0 ? 0 : $secondsLeft;

						// Never say more than 15 min
						if ( $secondsLeft > 15*60 )
							$secondsLeft = 15*60;

						$timeRemaining	= '';
						if ( $secondsLeft < 3 )
							$timeRemaining	= 'a few seconds';
						elseif ( $secondsLeft > 60 )
						{
							$minutesLeft	= floor($secondsLeft/60);
							$secondsLeft	= $secondsLeft - $minutesLeft*60;

							if ( $minutesLeft == 1 )
								$timeRemaining	= $minutesLeft.' minute';
							else
								$timeRemaining	= $minutesLeft.' minutes';

							if ( $secondsLeft == 1 )
								$timeRemaining	.= ' and '.$secondsLeft.' second';
							elseif ( $secondsLeft > 0 )
								$timeRemaining	.= ' and '.$secondsLeft.' seconds';
						}
						else
							$timeRemaining	= $secondsLeft.' seconds';

						echo "<br><br><div style='background-color: #FCA0CA; border: 1px solid red; font-family: verdana; padding: 10px; text-align: center;'><font size='5' color='black' face='Verdana'>Demo Price Comparison Script is being refreshed...<br><br>Please check back in <font color=red>".$timeRemaining."</font></font></div>";
						echo "<!-- #KAON #X1Y2Z3A4B5C6 #KAON -->";
						die;
					}
				}
			}
		}

//*************************************************************************************************

		// Information Constants
		// 10/17/2014: Mamda: moved here so that getVar works
		define("INFO_19", "Spidering Successfull, click <a href='".SCRIPT_ROOT."rf.php?f=".urlencode("upload/logs/".date("Y-m-d")."_merchant.htm")."' target=_blank class='link'>here</a> to view details");
		define("INFO_20", "Spidering Successfull, click <a href='".SCRIPT_ROOT."upload/logs/".date("Y-m-d")."_dealer.htm' target=_blank class='link'>here</a> to view details");
		define("INFO_21", "Spidering Successfull, click <a href='".SCRIPT_ROOT."upload/logs/".date("Y-m-d")."_product.htm' target=_blank class='link'>here</a> to view details");
		define("INFO_23", "Task Completed Successfully.<br>However you must run product re-profiling as it may have affected product price profile.<br>Click <a href='".SCRIPT_ROOT."admin/product_price_profiling.php?uId=".getVar('uId', 'int')."' target=_blank class='link'>here</a> to perform profiling now.");
		define("INFO_24", "Delete Task Completed Successfully.<br>However you must run product re-profiling as it may have affected product price profile.<br>Click <a href='".SCRIPT_ROOT."admin/product_price_profiling.php?uId=".getVar('uId', 'int')."&del=Y' target=_blank class='link'>here</a> to perform profiling now.");

//*************************************************************************************************

		function startSession()
		{
			// for php >= 5.4.0
			if ( function_exists('session_status') )
			{
				if ( session_status() == PHP_SESSION_NONE )
					session_start();
			}

			// for php < 5.4.0
			else
			{
				if ( session_id() == '' )
					session_start();
			}
		}

//*************************************************************************************************
// Load all the preferences from database here

        // Load default currency from db if not defined already in site_constants.php
        if ( !defined('SCRIPT_DOLLAR') ) {
            // If db record found, then load from it
            if (($recDC = getRecord('CURRENCY', 1, 'IS_DEFAULT'))) {
                define('SCRIPT_DOLLAR', $recDC['SYMBOL']);
                define('SCRIPT_DOLLAR_NAME', $recDC['TITLE']);
            } // Otherwise set a default value
            else {
                define('SCRIPT_DOLLAR', '$');
                define('SCRIPT_DOLLAR_NAME', 'USD');
            }
        }

        // Define variables for global use
        $prefs = [];
        $prefPrdSrc = [];

        // If asked not to load preferences then do not load
        if ( !defined('DONOT_LOAD_DB_PREFS_IN_INCLUDE') ) {

            // Load system preferences
            if (!($prefs = getRecord('PREFERENCES', 1000))) {
                die('<div style="color:red">System Preferences not found. Please check your installation.</div>');
            }

            // Load product source preferences
            if (!($prefPrdSrc = getRecord('PRODUCT_SOURCE', 1000))) {
                die('<div style="color:red">Product Source Preferences not found. Please check your installation.</div>');
            }

        } // endif donot load db prefs

//*************************************************************************************************

        // Mark that all includes are loaded
        define('INCLUDES_LOADED', 1);

//*************************************************************************************************
