<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************
//
//		SEARCH SPECIFIC FUNCTIONS
//
//*************************************************************************************************

		defined('PATH') or die('direct access not allowed!');

//*************************************************************************************************

		// This function ensures that the given array has rows in it.
		// If only one row, then makes it at key = 0
		function getArrayWithZeroKey($arr)
		{
			if ( !is_array($arr[0]) )
			{
				$temp	= $arr;
				$arr	= array();
				$arr[0]	= $temp;
			}

			return $arr;
		}

//***********************************************************************************

		function buildArrayIndicesByArray($indices)
		{
			$ret	= '';
			foreach ( $indices as $index )
				$ret .= "['$index']";

			return $ret;
		}

//***********************************************************************************

		function collapseXMLArray($xmlArray)
		{
			if ( !is_array($xmlArray) ) return $xmlArray;

			$key = key($xmlArray);
			$len = sizeof($xmlArray);

			if ( $len == 1 && $key == '0' ) return collapseXMLArray($xmlArray[0]);

			if ( $len == 1 )
			{
				$xmlArray[$key] = collapseXMLArray($xmlArray[$key]);
			}
			else
			{
				$outArray = array();
				foreach ( $xmlArray as $key => $value )
				{
					$outArray[$key] = collapseXMLArray($value);
				}
				$xmlArray = $outArray;
			}

			return $xmlArray;
		}

//***********************************************************************************

		// return array if successfull, otherwise return error as string
		function getRecordsFromXMLFileGeneric($xmlFile, $engine='', $ignoreList='', $doCollapse=1)
		{
			global $depth, $xmlResult, $xmlIgnoreList, $ignoreTag;

			$depth			= array();
			$xmlResult		= array();
			$xmlIgnoreList	= is_array($ignoreList) ? $ignoreList : array();
			$ignoreTag		= '';

			// Create Parser
			$parser = xml_parser_create();

			// Register Start & End Element Handlers
			xml_set_element_handler($parser, "startElementHandlerGeneric", "endElementHandlerGeneric");

			// Register Character Data Parser
			xml_set_character_data_handler($parser, "dataHandlerGeneric");

			// If the file is remote, then save it locally and then parse it
			$file2chk = $xmlFile;
			if ( substr($xmlFile, 0, 4) == 'http' )
			{
				$localTmpFp = 'upload/temp/'.md5($xmlFile).'.xml';
				if ( readFromFile($xmlFile, '', $localTmpFp) > 0 )
					$file2chk = PATH.$localTmpFp;
			}

			// Open File for Reading
			if ( !($fp = @fopen($file2chk, 'r')) )
			{
				$errMsg = $engine.":\n\n(XML) ".COULD_NOT_OPEN_FILE_FOR_READING." : ".$xmlFile;
				return $errMsg;
			}

			// Read chunk of 4K and pass to Parser
			while ($xml = fread($fp, 51200))
			{
				if ( !xml_parse($parser, $xml, feof($fp)) )
				{
					$errMsg = $engine.":\n\nXML Error : Line ".xml_get_current_line_number($parser).", Col ".xml_get_current_column_number($parser).", Error ".xml_error_string(xml_get_error_code($parser))."\n\n$xml";
					return $errMsg;
				}
			}
			fclose($fp);

			if ( $doCollapse == 1 )
				$ret = collapseXMLArray($xmlResult);
			else
				$ret = $xmlResult;

			return $ret;
		}

//***********************************************************************************

		function getRecordsFromXMLGeneric($xml, $engine='', $ignoreList='', $doCollapse=1)
		{
			global $depth, $xmlResult, $xmlIgnoreList, $ignoreTag;

			$depth			= array();
			$xmlResult		= array();
			$xmlIgnoreList	= is_array($ignoreList) ? $ignoreList : array();
			$ignoreTag		= '';

			// Create Parser
			$parser = xml_parser_create();

			// Register Start & End Element Handlers
			xml_set_element_handler($parser, "startElementHandlerGeneric", "endElementHandlerGeneric");

			// Register Character Data Parser
			xml_set_character_data_handler($parser, "dataHandlerGeneric");

			if ( !xml_parse($parser, $xml) )
			{
				showDebugMsg("$engine:\n\nXML Error : Line ".xml_get_current_line_number($parser).", Col ".xml_get_current_column_number($parser).", Error ".xml_error_string(xml_get_error_code($parser))."\n\n$xml", 1);
				return array();
			}

			if ( $doCollapse == 1 )
				$ret = collapseXMLArray($xmlResult);
			else
				$ret = $xmlResult;

//print_r($xmlResult);
//print_r($ret);
//die;
			return $ret;
		}

//***********************************************************************************

		function startElementHandlerGeneric($parser, $name, $attribs)
		{
			global $depth, $xmlValue, $xmlResult, $xmlIgnoreList, $ignoreTag;

			if ( in_array($name, $xmlIgnoreList) )
			{
				$ignoreTag = $name;
				return;
			}

			if ( $ignoreTag != '' )
				return;
			
			array_push($depth, strtoupper($name));
			$nextDex	= 0;
		
			$var	= '$xmlResult'.buildArrayIndicesByArray($depth);
			$code	= "
			if ( is_array(".$var.") )
			{
				\$nextDex = sizeof(".$var.");
			}
			else
			{
				\$nextDex = 0;
			}

			if ( sizeof(\$attribs) > 0 )
			{
				".$var."[\$nextDex]['__ATTRIBUTES'] = \$attribs;
			}
";
			eval($code);

			array_push($depth, $nextDex);
		}

//***********************************************************************************

		function endElementHandlerGeneric($parser, $name)
		{				
			global $depth, $xmlValue, $xmlResult, $xmlIgnoreList, $ignoreTag;

			if ( $ignoreTag != '' )
			{
				if ( $ignoreTag == $name )
					$ignoreTag = '';

				$xmlValue	= '';
				return;
			}

			$value		= $xmlValue;
			$xmlValue	= '';

			$value		= str_replace("\\'", "'", trim($value));
			$value		= str_replace("'", "\\'", trim($value));

			if ( $value != '' )
			{
				$var	= '$xmlResult'.buildArrayIndicesByArray($depth);
				$code	= "
				if ( is_array(".$var.") )
				{
					".$var."[] = '".$value."';
				}
				elseif ( ".$var." != '' )
				{
					\$temp = ".$var.";
					".$var." = array();
					array_push(".$var.", \$temp);
					array_push(".$var.", '".$value."');
				}
				else
				{
					".$var." = '".$value."';
				}
";

				eval($code);
			}

			array_pop($depth);
			array_pop($depth);
		}

//***********************************************************************************

		function dataHandlerGeneric($parser, $data)
		{
			global $xmlValue;
				
			$xmlValue	.= $data;
		}

//***********************************************************************************

		function showDebugMsg($msg)
		{
			echo $msg;
		}

//***********************************************************************************
?>