<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************
//
//		SITE HTML SPECIFIC FUNCTIONS
//
//*************************************************************************************************

		defined('PATH') or die('direct access not allowed!');

//*************************************************************************************************

		function getReadFileLink($link)
		{
			if ( $link == '' )
				return 'The link passed cannot be empty -getReadFileLink-';

			return SCRIPT_ROOT.'rf.php?f='.urlencode($link);
		}

//*************************************************************************************************

		function getRecentlyVisitedProducts($categoryId)
		{
			$str	= "\n<!-- Recently Visited Cached Results -->\n";
			$var	= "recentlyVisited_".$categoryId;

			global $_SESSION;

			if ( $_SESSION[$var] != "" )
				return $_SESSION[$var];

			else
			{
				$res = preparedQuery("SELECT P.ID, COUNT(UR.ID) AS MOST_VISITED, MAX(P.TITLE) AS TITLE FROM ".PREFIX."PRODUCT P, ".PREFIX."USER_PRODUCT UP, ".PREFIX."CLICKTHROUGHS UR WHERE P.CATEGORY_ID = ? AND P.ISVALID='Y' AND P.ID=UP.PRODUCT_ID AND UR.USER_PRODUCT_ID=UP.ID AND UR.ISMERCHANT='N' GROUP BY P.ID ORDER BY MOST_VISITED DESC LIMIT 3", array($categoryId));

				if ( getTotalRows($res) )
					$str .= getRecentProductsTable($res, RECENTLY_VISITED);

				// Save in session
				$_SESSION[$var] = $str;

				// Now return
				return $str."\n<!-- 1ST GET ENDS HERE -->\n";

			} // if else ends here //

		} // function ends here //

//*************************************************************************************************

		function getRecentlyAddedProducts($categoryId)
		{
			$str	= "\n<!-- Recently Added Cached Results -->\n";
			$var	= "recentlyAdded_".$categoryId;

			global $_SESSION;

			if ( isset($_SESSION[$var]) && $_SESSION[$var] != '' )
				return $_SESSION[$var];

			else
			{
				$result = preparedQuery("SELECT ID, TITLE, FILENAME, CATEGORY_ID FROM ".PREFIX."PRODUCT WHERE CATEGORY_ID = ? AND ISVALID='Y' ORDER BY DATE_ADDED DESC LIMIT 3", array($categoryId));

				if ( getTotalRows($result) )
				{
					$str .= getRecentProductsTable($result, RECENTLY_ADDED);

				} // if of getRow ends here //

				// Save in session
				$_SESSION[$var] = $str;

				// Now return
				return $str."\n<!-- 1ST GET ENDS HERE -->\n";

			} // if else ends here //

		} // function ends here //

//*************************************************************************************************

		function getRecentProductsTable($result, $tblHeading)
		{

			$str = "<div class=HeadRow>".$tblHeading."</div>";
			$str .= "<div style='clear:both;'></div>";
			$str .= "<div class='RecentBox'>";

			while ( ($row = getRow($result)) )
			{
				$pLink = getProductPath($row['ID']);

				$str .= "<div style='width:33%; float:left; text-align:center;'>";
				$str .= "<center>".getProductThumbnail($row['ID'], $pLink, $row['TITLE'], $row['CATEGORY_ID'], 90, 90, '', '#CCCCCC', 'white', '', $row['FILENAME'])."</center>";
				$str .= "<a href=\"".$pLink."\" class='link'>".$row['TITLE']."</a>";
				$str .= "</div>";

			} // while ends here //
			free($result);

			$str .= "<div style='clear:both;'></div>";
			$str .= "</div>";

			return $str;

		} // function ends here //


//*************************************************************************************************

		function fixEncoding($dataIn, $fromCharset='iso-8859-1')
		{
			if ( $fromCharset == '' )
				$fromCharset = 'iso-8859-1';

			if ( function_exists('iconv') )
			{
				$msg		= 'Data is NOT in UTF8 and is being converted -iconv-';
				$dataOut	= iconv($fromCharset, DEFAULT_CHARSET, $dataIn);

				if ( $dataOut == '' && $dataIn != '' )
					$msg	= 'Data conversion failed in iconv - ['.$fromCharset.'|'.DEFAULT_CHARSET.']';
/*
				// TO FIND OUT THE GOOD CHARSET
				$tab	= array("UTF-8", "shift-jis", "ASCII", "CP1256", "Windows-1252", "ISO-8859-1", "ISO-8859-7", "ISO-8859-15", "ISO-8859-6");
				$chain	= "";
				foreach ($tab as $i)
					{
						foreach ($tab as $j)
						{
							$chain .= "\n<br> [$i | $j] ".iconv($i, $j, $dataIn);
						}
					}
				echo "<font face=arial size=2>DataIN: <font color=red><b>$dataIn</b></font>\n<br>DataOUT: <font color=gree><b>$dataOut</b></font>\n<br>".$chain."</font><br><hr><br>";
				/////////////////////////////////
*/

				return $dataOut;
			}
			elseif ( function_exists('utf8_encode') )
			{
				$msg		= 'Data is NOT in UTF8 and is being converted -encode-';
				$dataOut	= utf8_encode($dataIn);

//				echo "\n[UTF8:$msg]\n[IN:$dataIn]\n[OUT:$dataOut]\n<br>";

				return $dataOut;
			}
			else
			{
//				echo "UTF8 encode and ICONV not available. Cannot convert encoding";
				return $dataIn;
			}
		}

//*************************************************************************************************

		// 4/10/2012: SALMAN: Fix encoding is called in the datafeed import
		function fixEncodingForFeed(&$msg, $charset, $arrCols)
		{
			if ( $charset == '' )
			{
				$msg = 'Charset empty -fixEncodingForFeed-';
				return $arrCols;
			}

			if ( $charset != DEFAULT_CHARSET )
			{
				$msg .= '<br>..........................................<br>Encoding [FRM:'.$charset.'][TO:'.DEFAULT_CHARSET.']<br>';
				foreach ( $arrCols as $key=>$val)
				{
					if ( $val != '' )
					{
						$tempName = fixEncoding($val, $charset);
						if ( $tempName != '' )
						{
							$msg .= 'Encoding [FRM:'.$val.'][TO:'.$tempName.']<br>';
							$arrCols[$key] = $tempName;
						}
						else
						{
							$msg .= 'Encoding conversation empty ['.$val.']<br>';
						}
					}
				}
			}
			else
			{
				$msg .= 'Encoding SAME ['.$charset.']['.DEFAULT_CHARSET.']<br>';
			}

			return $arrCols;
		}

//*************************************************************************************************

		function isUTF8($string)
		{
			if ( function_exists('mb_detect_encoding') )
			{
				$curEncoding = mb_detect_encoding($string);

				// If already in UTF8 then just return
				if ( $curEncoding == "UTF-8" && mb_check_encoding($string, "UTF-8") )
					return 1;
				else
					return 0;
			}
			else
			{
				$isInUTF8 = isUTF8Preg($string);

				return $isInUTF8;
			}

		}

//*************************************************************************************************

		function isUTF8Preg($string)
		{
			if ( $string == '' )
				return 1;

			$arrChunks	= splitByLength($string, 10000);		//with 10000+ => segfault (apache/php)

			if ( !is_array($arrChunks) )
				return 1;


			// preg_match can do the SEGMENTATION FAULT
			$prevRecursionLimit = ini_set( "pcre.recursion_limit", 1000 );

			foreach ( $arrChunks as $chunk )
			{
				if
				(
					preg_match('%^(?:
					[\x09\x0A\x0D\x20-\x7E]              # ASCII
					| [\xC2-\xDF][\x80-\xBF]             # non-overlong 2-byte
					|  \xE0[\xA0-\xBF][\x80-\xBF]        # excluding overlongs
					| [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}  # straight 3-byte
					|  \xED[\x80-\x9F][\x80-\xBF]        # excluding surrogates
					|  \xF0[\x90-\xBF][\x80-\xBF]{2}     # planes 1-3
					| [\xF1-\xF3][\x80-\xBF]{3}          # planes 4-15
					|  \xF4[\x80-\x8F][\x80-\xBF]{2}     # plane 16
					)*$%xs',
					$chunk)
				)
					return 0;
			}

			// Revert To Old Recursion Limit
			ini_set( "pcre.recursion_limit", $prevRecursionLimit );

			return 1;
		}

//*************************************************************************************************

		function splitByLength($string, $chunkLength=1)
		{
			$chunkLength	= $chunkLength == 0 ? 1 : $chunkLength;
			$result			= array();
			$remainder		= strlen($string) % $chunkLength;
			$cycles			= ((strlen($string) - $remainder) / $chunkLength) + (($remainder != 0) ? 1 : 0);
			for ( $x=0; $x < $cycles; $x++ )
				$result[$x] = substr($string, ($x * $chunkLength), $chunkLength);

			return $result;
		}

//*************************************************************************************************

		function handleCharacterEncodingConvert(&$msg, $dataIn)
		{
			$dataOut	= '';

			if ( $dataIn == '' )
				return '';

			if ( !isUTF8($dataIn) )
			{
				$dataOut = fixEncoding($dataIn);
//				echo "<br>\n\nNOT UTF-8 [In: $dataIn][Out: $dataOut]<br><br>";
				return $dataOut;
			}
			else
			{
				$msg = 'Data is in UTF8';
//				echo "<br>\n\nIN UTF-8 [In: $dataIn][Out: $dataOut]<br><br>";
				return $dataIn;
			}
		}

//*************************************************************************************************

		function handleCharacterEncoding(&$msg, $arrIn)
		{
			global $userId, $logFeedFile;

			$arrOut		= array();

			if ( !is_array($arrIn) )
				return $arrOut;

			// Entire file is already transferred now dont transfer single data
			if ( DO_TRANSFER_ENCODING_FILE == 1 )
			{
				return $arrIn;
			}

			// Transfer for all merchants irrespective of $userId
			elseif ( DO_TRANSFER_ENCODING_GLOBAL == 1 )
			{
				$arrCount	= count($arrIn);
				for ($x=0; $x<$arrCount; $x++)
				{
					$arrOut[$x] = handleCharacterEncodingConvert($msg, $arrIn[$x]);
				}
				return $arrOut;
			}

			// Transfer for only a specific merchant
			else
			{
				if ( $userId == 'xxxxx' )
				{
					if ( IS_AUTOFEED_IMPORT == 1 )
					{
						if ( $logFeedFile != '' )
							appendToProductFeedLogFile($logFeedFile, '* <font color="#33FF00" size="1">Character Convertor Working ['.$userId.']</font>');
					}

					$arrCount	= count($arrIn);
					for ($x=0; $x<$arrCount; $x++)
					{
						$temp		= $arrIn[$x];
						$temp2		= iconv('ISO-8859-1', DEFAULT_CHARSET, $temp);
						$arrOut[$x] = $temp2;
					}

					return $arrOut;
				}
				else
				{
					if ( IS_AUTOFEED_IMPORT == 1 )
					{
						if ( $logFeedFile != '' )
							appendToProductFeedLogFile($logFeedFile, '* <font color="#CCCCCC" size="1">Character Convertor Skipped ['.$userId.']</font>');
					}

					return $arrIn;
				}
			}
		}

//*************************************************************************************************

		function handleCharacterEncodingOfWord(&$msg, $charIn)
		{
			global $userId, $categoryId, $url;

			$charOut = '';

			if ( $charIn == '' )
				return $charOut;

			if ( stristr($url, 'xxxxxxXXXXXyyyyy') )		// enter domain name here
			{
				$charOut	= fixEncoding($charIn);
				return $charOut;
			}
			else
			{
				return $charIn;
			}
		}

//*************************************************************************************************

		function handleCharacterEncodingForFile(&$msg, $filename)
		{
			$maxMemoryEx	= ini_get('memory_limit');
			if ( stristr($maxMemoryEx, 'M') )
			{
				$maxMemory  = str_replace('M', '', $maxMemoryEx);
				$maxMemory  = $maxMemory * 1024 * 1024; // Changed into Bytes

				$fileMemory	= filesize(getLocalizedPathForUpload($filename));
				if ( ($fileMemory + memory_get_usage() + 102400) > $maxMemory )	// 102400 = 100KB grace
				{
					$msg = 'Cannot read this file for conversion. File size is greater then MAX memory allowed. [FMem: '.number_format($fileMemory/1048576).'M][SMem: '.number_format($maxMemory/1048576).'M][SMem: '.$maxMemoryEx.']';
					return 0;
				}
			}

			if ( file_exists(getLocalizedPathForUpload($filename)) )
			{
				$fileContentIn		= readFromFile($filename);
				//$fileSizeIn			= strlen($fileContentIn);

				$msgEx				= '';
				$fileContentOut		= handleCharacterEncodingConvert($msgEx, $fileContentIn);
				//$fileSizeOut		= strlen($fileContentOut);

				/*
				if ( abs($fileSizeIn - $fileSizeOut) > 10000 )
				{
					$msg = 'File Data Conversion Failed. Data difference is too much ['.$fileSizeIn.']['.$fileSizeOut.'].<br>Error: '.$msgEx;
					return 0;
				}
				*/

				writeToFile($filename, $fileContentOut);

				return 1;
			}
			else
			{
				$msg				= 'File does not exists ['.$filename.']';
				return 0;
			}
		}

//*************************************************************************************************

		function fixCSVFileForQuotes(&$msg, $filename)
		{
			// Check if file exists
			if ( !file_exists(getLocalizedPathForUpload($filename)) )
			{
				$msg = "File does not exists on server. [".$filename."]";
				return 0;
			}

			$inFp	= fopen(getLocalizedPathForUpload($filename), 'r');
			if ( !$inFp )
			{
				$msg = "Cannot open file for reading [".$filename."]";
				return 0;
			}

			$outFp	= fopen(getLocalizedPathForUpload($filename).'.tmp', 'w');
			if ( !$outFp )
			{
				$msg = "Cannot open file for writing [".$filename.".tmp]";
				return 0;
			}

			while ( !feof($inFp) )
			{
				$data	= fread($inFp, 65535);

				$data	= str_replace('\\"",', '[^]', $data);
				$data	= str_replace('\\""', '""', $data);
				$data	= str_replace('[^]', '\\"",', $data);
				$data	= str_replace('\\"', '""', $data);

				if ( fwrite($outFp, $data) == FALSE )
				{
					$msg = "Error writing data to file [".$filename.".tmp]";
					return 0;
				}
			}

			fclose($inFp);
			fclose($outFp);

			@unlink(getLocalizedPathForUpload($filename));
			@rename(getLocalizedPathForUpload($filename).'.tmp', getLocalizedPathForUpload($filename));

			return 1;
		}

//*************************************************************************************************

		function openCSVFile(&$msg, $filename)
		{
			global $isFeedRecent;

			$isFeedRecent = (int)$isFeedRecent;

			// Check if file exists
			if ( !file_exists(getLocalizedPathForUpload($filename)) )
			{
				$msg = "File does not exists on server. [".$filename."]";
				return 0;
			}

			if ( $isFeedRecent == 0 )
			{
				if ( fixCSVFileForQuotes($msg, $filename) == 0 )
					return 0;
			}

			// Transfer complete file to correct encoding
			// If you dont transfer the complete file to the correct encoding then fgetcsv wont work fine on it.
			if ( $isFeedRecent == 0 && DO_TRANSFER_ENCODING_FILE == 1 )
			{
				$msgEx	= '';
				$ret	= handleCharacterEncodingForFile($msgEx, $filename);
				if ( $ret == 0 )
				{
					$msg = "Could not convert file encoding. Error: ".$msgEx." [".$filename."]";
					return 0;
				}
			}

			// Line endings for MAC
			if ( IS_EOL_AUTO_DETECT == 1 )
				ini_set('auto_detect_line_endings', true);


			// Open File for Reading
			if ( !($fp = fopen(getLocalizedPathForUpload($filename), "r")) )
			{
				$msg = "Could not open file for Reading. [".$filename."]";
				return 0;
			}

			if ( feof($fp) )
			{
				$msg = "End Of File occured right after opening it.";
				return 0;
			}

			return $fp;
		}

//*************************************************************************************************

		function readCSVFile($filePointer, $length, $delimiter=',', $enclosure='"')
		{
			$arrOut		= array();

			if ( $delimiter == "t" )
				 $delimiter = "\t";

			// In case of russian/ukraine language
			if ( defined('HANDLE_FGETCSV_MODE') && HANDLE_FGETCSV_MODE == 'russian' )
			{
				$arrOut		= array();
				$data		= fgets($filePointer, $length);

				if ( $data != '' )
				{
					$arrOut = explode($delimiter, $data);

					// Now remove the quotes enclosing the column
					for ($x=0; $x<sizeof($arrOut); $x++)
					{
						$arrOut[$x] = trim($arrOut[$x]);

						if ( $arrOut[$x] == '' )
							continue;

						if ( substr($arrOut[$x], 0, 1) == '"' )
							$arrOut[$x] = substr($arrOut[$x], 1);

						if ( substr($arrOut[$x], -1) == '"' )
							$arrOut[$x] = substr($arrOut[$x], 0, (strlen($arrOut[$x])-1));
					}
				}
				return $arrOut;
			}

			/* 12/21/2009
			This is added before calling fgetcsv() to prevent the bug it has reading first special characters of a different charset
			setlocale(LC_ALL, 'he_IL', 'he', 'hebrew'); // These locales are for Windows-1255. After the first argument, you can provide as many alternative locales as you can. Here we provided three ('he_IL', 'he', 'hebrew')
			*/

			$arrOut		= fgetcsv($filePointer, $length, $delimiter, $enclosure);
			return $arrOut;
		}

//***********************************************************************************

		function getInfoHtml($msg)
		{
			$isResp		= !defined('IS_ADMIN') || IS_ADMIN != 1;

			if ( !$isResp )
				return "<font class=info>".$msg."</font><br><br>";

			return "<div class='col-xs-12 col-sm-12 col-md-12 col-ld-12'><div class='alert alert-danger'>".$msg."</div></div><div style=clear:both></div>";
		}

//***********************************************************************************

		function getInfoMap($arr)
		{
			if ( !is_array($arr) || count($arr) == 0 )
				return '';

			$ret = '';

			foreach ( $arr as $key => $val )
				$ret .= '&infoMap[]='.urlencode($key.'~'.$val);

			return $ret;
		}

//***********************************************************************************

		function getInfo($id)
		{
			$id		= defined('IS_ADMIN') && IS_ADMIN == 1 ? $id : ((int)$id);

			if ( (defined('IS_ADMIN') && IS_ADMIN == 1 && $id == '') || (defined('IS_ADMIN') && IS_ADMIN != 1 && $id == 0) )
				return '';

			$var = 'INFO_'.$id;

			if ( defined($var) )
			{
				$msg = constant($var);

				if ( is_array($_GET['infoMap']) )
				{
					foreach ( $_GET['infoMap'] as $map )
					{
						$map = explode('~', $map);
						$msg = str_replace('{'.$map[0].'}', (float)$map[1], $msg);
					}
				}

				if ( defined('KM_USE_AJAX_INLINE') && KM_USE_AJAX_INLINE == 1 )
					return $msg;
				else
					return getInfoHtml($msg);
			}

			if ( defined('KM_USE_AJAX_INLINE') && KM_USE_AJAX_INLINE == 1 )
				return $id;
			else
				return getInfoHtml($id);
		}

//*************************************************************************************************

		function getInfoMsgText($msg)
		{
			return is_numeric($msg) ? strip_tags(getInfo($msg)) : $msg;
		}

//*************************************************************************************************

		function closePopupWindow($msg)
		{
?>
		<script language="JavaScript">
		<!--
			alert("<?php echo $msg; ?>");
			window.close();
		//-->
		</script>
<?php
		}

//*************************************************************************************************

		function getAJAXReloadQS()
		{
			$qs			= '';
			$qsPairs	= explode('&', $_SERVER['QUERY_STRING']);
			foreach ( $qsPairs as $qsPair )
			{
				list($key, $value)	= explode('=', $qsPair);

				if ( $key == '' || $value == '' || substr($key, 0, 3) == 'fId' || substr($key, 0, 3) == 'mer' || substr($key, 0, 4) == 'manu' || substr($key, 0, 4) == 'scat' || $key == 'random' || $key == 'ajax' )
					continue;

				$qs		.= $qsPair . '&';
			}

			return 'ajax=1&' . $qs;
		}

//*************************************************************************************************

		function getCharsetsComboOptions($selected='')
		{
			$arr = array('ascii', 'iso-8859-1', 'iso-8859-2', 'iso-8859-3', 'iso-8859-4', 'iso-8859-5', 'iso-8859-6', 'iso-8859-7', 'iso-8859-8', 'iso-8859-9', 'iso-8859-10', 'iso-8859-13', 'iso-2022-jp', 'shift-jis', 'windows-1250', 'windows-1251', 'windows-1252', 'windows-1254', 'windows-1257', 'utf-8');

			$ret = '';

			foreach ( $arr as $a )
				$ret .= '<option value="'.$a.'" '.($a==strtolower($selected)?'selected':'').'>'.$a.'</option>';

			return $ret;
		}

//*************************************************************************************************

		function loadLanguageForPage($langId, $pageName)
		{
/*			$langId	= (int)$langId;

			if ( is_array($pageName) )
			{
				foreach ( $pageName as $pageNm )
				{
					$res = preparedQuery("SELECT VAR_NAME, VAR_VALUE FROM ".PREFIX."LANGUAGE_DEFINES WHERE LANGUAGE_ID = ? AND PAGENAME = ?", array($langId, $pageNm));
					while ( ($row = getRow($res)) )
					{
						if ( !defined($row['VAR_NAME']) )
							define($row['VAR_NAME'], $row['VAR_VALUE']);
					}
				}
			}
			else
			{
				$res = preparedQuery("SELECT VAR_NAME, VAR_VALUE FROM ".PREFIX."LANGUAGE_DEFINES WHERE LANGUAGE_ID = ? AND PAGENAME = ?", array($langId, $pageName));
				while ( ($row = getRow($res)) )
				{
					if ( !defined($row['VAR_NAME']) )
						define($row['VAR_NAME'], $row['VAR_VALUE']);
				}
			}
*/

			$langId	= (int)$langId;
			$subSql = '';
			$srtSql = '';
			$arrTmp = array();
			$arArgs = array($langId);

			if ( is_array($pageName) )
			{
				$orSql = '';
				foreach ( $pageName as $pgNm )
				{
					$pgNm = trim($pgNm);
					if ( $pgNm == '' ) continue;
					$orSql .= ", ?";
					$arrTmp[] = $pgNm;
				}

				if ( $orSql == '' )
					return;

				$subSql = " AND PAGENAME IN (".substr($orSql, 2).")";
				$arArgs = array_merge($arArgs, $arrTmp);

				if ( count($pageName) > 1 )
				{
					$srtSql = ' ORDER BY FIELD(PAGENAME'.$orSql.')';
					$arArgs = array_merge($arArgs, $arrTmp);
				}
			}
			else
			{
				$subSql = " AND PAGENAME = ?";
				$arArgs[] = $pageName;
			}

			$res = preparedQuery("SELECT VAR_NAME, VAR_VALUE FROM ".PREFIX."LANGUAGE_DEFINES WHERE LANGUAGE_ID = ?".$subSql.$srtSql, $arArgs);
			while ( ($row = getRow($res)) )
			{
				if ( !defined($row['VAR_NAME']) )
					define($row['VAR_NAME'], $row['VAR_VALUE']);
			}

/*
			$subSql = '';
			$srtSql = '';

			if ( is_array($pageName) )
			{
				$orSql = '';
				foreach ( $pageName as $pgNm )
				{
					$pgNm = trim($pgNm);
					if ( $pgNm == '' ) continue;
					$orSql .= ", '".handleSingleQuote($pgNm)."'";
				}

				if ( $orSql == '' )
					return;

				$subSql = " AND PAGENAME IN (".substr($orSql, 2).")";

				if ( count($pageName) > 1 )
					$srtSql = ' ORDER BY FIELD(PAGENAME'.$orSql.')';
			}
			else
				$subSql = " AND PAGENAME = '".handleSingleQuote($pageName)."'";

			$res = executeQuery("SELECT VAR_NAME, VAR_VALUE FROM ".PREFIX."LANGUAGE_DEFINES WHERE LANGUAGE_ID='".((int)$langId)."'".$subSql.$srtSql);
			while ( ($row = getRow($res)) )
			{
				if ( !defined($row['VAR_NAME']) )
					define($row['VAR_NAME'], $row['VAR_VALUE']);
			}
*/
		}

//*************************************************************************************************

	function getRatingStars($rating, $width=9, $height=16, $type='')
	{
		$retVal = '';

		$rating = abs((int)$rating);

		for ( $i=0; $i<10; $i++ )
			$retVal .= "<img src=\"".SCRIPT_ROOT."images/spacer.gif\" align=absmiddle class=".$type."Star".($i<$rating?1:0).($i%2==0?'L':'R')." width=".$width." height=".$height." alt='".$rating."/10'>";

		return $retVal;
	}

//*************************************************************************************************

	function showCSSEditorLink($var, $value='', $callback='')
	{
		$value				= ' ' . $value;	// Add a space before css so we can use string between for whole words

		$width				=  stringBetween($value, ' width:', 'px;');
		$height				=  stringBetween($value, ' height:', 'px;');

		$paddingA			=  stringBetween($value, ' padding:', 'px;');
		$paddingL			=  stringBetween($value, ' padding-left:', 'px;');
		$paddingT			=  stringBetween($value, ' padding-top:', 'px;');
		$paddingR			=  stringBetween($value, ' padding-right:', 'px;');
		$paddingB			=  stringBetween($value, ' padding-bottom:', 'px;');
		$paddingMore		=  $paddingL.$paddingT.$paddingR.$paddingB != '';

		$marginA			=  stringBetween($value, ' margin:', 'px;');
		$marginL			=  stringBetween($value, ' margin-left:', 'px;');
		$marginT			=  stringBetween($value, ' margin-top:', 'px;');
		$marginR			=  stringBetween($value, ' margin-right:', 'px;');
		$marginB			=  stringBetween($value, ' margin-bottom:', 'px;');
		$marginMore			=  $marginL.$marginT.$marginR.$marginB != '';

		$fontColor			=  stringBetween($value, ' color:', ';');
		$fontFamily			=  stringBetween($value, ' font-family:', ';');
		$fontSize			=  stringBetween($value, ' font-size:', 'px;');
		$fontWeight			=  stringBetween($value, ' font-weight:', ';');
		$fontStyle			=  stringBetween($value, ' font-style:', ';');
		$textDeco			=  stringBetween($value, ' text-decoration:', ';');

		$backgroundColor	=  stringBetween($value, ' background-color:', ';');

		$borderSize			=  stringBetween($value, ' border-width:', 'px;');
		$borderColor		=  stringBetween($value, ' border-color:', ';');
		$borderStyle		=  stringBetween($value, ' border-style:', ';');

		$arrFonts			= array('' => ' - '._DEFAULT.' - ', 'Arial' => 'Arial', 'Arial Black' => 'Arial Black', 'Times New Roman' => 'Times New Roman', 'Verdana' => 'Verdana', 'Sans Serif' => 'Sans Serif');
		$arrFontWeights		= array('' => ' - '._DEFAULT.' - ', 'normal' => 'Normal', 'bold' => 'Bold', '900' => 'Thick');
		$arrFontStyles		= array('' => ' - '._DEFAULT.' - ', 'normal' => 'Normal', 'italic' => 'Italic', 'Oblique' => 'oblique');
		$arrTextDecos		= array('' => ' - '._DEFAULT.' - ', 'underline' => 'Underline', 'overline' => 'Overline', 'line-through' => 'Line Through', 'blink' => 'Blink');
		$arrBorderStyles	= array('' => ' - '._DEFAULT.' - ', 'solid' => 'Solid', 'dotted' => 'Dotted', 'dashed' => 'Dashed', 'double' => 'Double', 'inset' => 'Inset', 'outset' => 'Outset');
?>
		<a href="javascript:showCSSEditor('<?php echo $var; ?>', '<?php echo $callback; ?>');" class="link"><?php echo CHANGE_STYLE; ?></a>
		<div id="idCSSE_<?php echo $var; ?>" class="CSSE_Box">
			<input type="hidden" name="CSSE_<?php echo $var; ?>_callback" value="<?php echo str_replace('"', '&quot;', $callback); ?>">
			<input type="hidden" id="id<?php echo $var; ?>" name="<?php echo $var; ?>" value="<?php echo str_replace('"', '', $value); ?>">

			<input class="LblH" value="<?php echo DIMENSION; ?>:" style="width:105px;">
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo WIDTH; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_width" class="Txt Num" value="<?php echo $width; ?>"> px
			<input class="Lbl" value="<?php echo HEIGHT; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_height" class="Txt Num" value="<?php echo $height; ?>"> px
			<div class="Sep2"></div>

			<input class="LblH" value="<?php echo PADDING; ?>:" style="width:105px;">
			<input class="Lbl" value="<?php echo OVERALL; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_paddingA" class="Txt Num" value="<?php echo $paddingA; ?>"> px
			&nbsp; <a href="javascript:clearCSSEFields('<?php echo $var; ?>', 'padding')" class="link">&laquo; <?php echo CLEAR; ?></a>
			&nbsp; <a href="javascript:toggleCSSEPropertyMore('<?php echo $var; ?>', 'padding');" class="link" id="idCSSE_<?php echo $var; ?>_padding_more_link"><?php echo $paddingMore?LESS:MORE; ?></a>
			<span id="idCSSE_<?php echo $var; ?>_padding_more" style="display:<?php echo $paddingMore?'block':'none'; ?>;">
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo LEFT; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_paddingL" class="Txt Num" value="<?php echo $paddingL; ?>"> px
			<input class="Lbl" value="<?php echo TOP; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_paddingT" class="Txt Num" value="<?php echo $paddingT; ?>"> px
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo RIGHT; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_paddingR" class="Txt Num" value="<?php echo $paddingR; ?>"> px
			<input class="Lbl" value="<?php echo BOTTOM; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_paddingB" class="Txt Num" value="<?php echo $paddingB; ?>"> px
			</span>
			<div class="Sep2"></div>

			<input class="LblH" value="<?php echo MARGIN; ?>:" style="width:105px;">
			<input class="Lbl" value="<?php echo OVERALL; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_marginA" class="Txt Num" value="<?php echo $marginA; ?>"> px
			&nbsp; <a href="javascript:clearCSSEFields('<?php echo $var; ?>', 'margin')" class="link">&laquo; <?php echo CLEAR; ?></a>
			&nbsp; <a href="javascript:toggleCSSEPropertyMore('<?php echo $var; ?>', 'margin');" class="link" id="idCSSE_<?php echo $var; ?>_margin_more_link"><?php echo $marginMore?LESS:MORE; ?></a>
			<span id="idCSSE_<?php echo $var; ?>_margin_more" style="display:<?php echo $marginMore?'block':'none'; ?>;">
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo LEFT; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_marginL" class="Txt Num" value="<?php echo $marginL; ?>"> px
			<input class="Lbl" value="<?php echo TOP; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_marginT" class="Txt Num" value="<?php echo $marginT; ?>"> px
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo RIGHT; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_marginR" class="Txt Num" value="<?php echo $marginR; ?>"> px
			<input class="Lbl" value="<?php echo BOTTOM; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_marginB" class="Txt Num" value="<?php echo $marginB; ?>"> px
			</span>
			<div class="Sep2"></div>

			<input class="LblH" value="<?php echo TEXT; ?>:" style="width:95px;">
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo COLOR; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_fg" class="Txt Color" value="<?php echo $fontColor; ?>">
			<a href="javascript:cp_<?php echo $var; ?>.select($('INPUT[name=CSSE_CSS_<?php echo $var; ?>_fg]').get(0), 'CSSE_CSS_<?php echo $var; ?>_fg_pick', 'changedCSSE(\'<?php echo $var; ?>\')');" name="CSSE_CSS_<?php echo $var; ?>_fg_pick" id="CSSE_CSS_<?php echo $var; ?>_fg_pick"><img src="<?php echo SCRIPT_ROOT; ?>images/icon-colorpicker.gif" width="16" height="16" alt="color" align="top"></a>
			&nbsp; <a href="javascript:clearCSSEFields('<?php echo $var; ?>', 'fg')" class="link">&laquo; <?php echo CLEAR; ?></a>
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo FONT; ?>:"><?php echo getComboFromArray('CSSE_CSS_'.$var.'_fontFace', $arrFonts, $fontFamily, 'Cmb'); ?>
			&nbsp; <a href="javascript:clearCSSEFields('<?php echo $var; ?>', 'fontFace')" class="link">&laquo; <?php echo CLEAR; ?></a>
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo SIZE; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_fontSize" class="Txt Num" value="<?php echo $fontSize; ?>"> px
			&nbsp; <a href="javascript:clearCSSEFields('<?php echo $var; ?>', 'fontSize')" class="link">&laquo; <?php echo CLEAR; ?></a>
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo WEIGHT; ?>:"><?php echo getComboFromArray('CSSE_CSS_'.$var.'_fontWeight', $arrFontWeights, $fontWeight, 'Cmb'); ?>
			&nbsp; <a href="javascript:clearCSSEFields('<?php echo $var; ?>', 'fontWeight')" class="link">&laquo; <?php echo CLEAR; ?></a>
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo STYLE; ?>:"><?php echo getComboFromArray('CSSE_CSS_'.$var.'_fontStyle', $arrFontStyles, $fontStyle, 'Cmb'); ?>
			&nbsp; <a href="javascript:clearCSSEFields('<?php echo $var; ?>', 'fontStyle')" class="link">&laquo; <?php echo CLEAR; ?></a>
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo DECORATION; ?>:"><?php echo getComboFromArray('CSSE_CSS_'.$var.'_textDeco', $arrTextDecos, $textDeco, 'Cmb'); ?>
			&nbsp; <a href="javascript:clearCSSEFields('<?php echo $var; ?>', 'textDeco')" class="link">&laquo; <?php echo CLEAR; ?></a>
			<div class="Sep2"></div>

			<input class="LblH" value="<?php echo BORDER; ?>:" style="width:95px;">
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo SIZE; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_borderSize" class="Txt Num" value="<?php echo $borderSize; ?>"> px
			&nbsp; <a href="javascript:clearCSSEFields('<?php echo $var; ?>', 'borderSize')" class="link">&laquo; <?php echo CLEAR; ?></a>
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo STYLE; ?>:"><?php echo getComboFromArray('CSSE_CSS_'.$var.'_borderStyle', $arrBorderStyles, $borderStyle, 'Cmb'); ?>
			&nbsp; <a href="javascript:clearCSSEFields('<?php echo $var; ?>', 'borderStyle')" class="link">&laquo; <?php echo CLEAR; ?></a>
			<div class="Sep1"></div>
			<input class="Lbl" value="<?php echo COLOR; ?>:"><input type="text" name="CSSE_CSS_<?php echo $var; ?>_borderColor" class="Txt Color" value="<?php echo $borderColor; ?>">
			<a href="javascript:cp_<?php echo $var; ?>.select($('INPUT[name=CSSE_CSS_<?php echo $var; ?>_borderColor]').get(0), 'CSSE_CSS_<?php echo $var; ?>_borderColor_pick', 'changedCSSE(\'<?php echo $var; ?>\')');" name="CSSE_CSS_<?php echo $var; ?>_borderColor_pick" id="CSSE_CSS_<?php echo $var; ?>_borderColor_pick"><img src="<?php echo SCRIPT_ROOT; ?>images/icon-colorpicker.gif" width="16" height="16" alt="color" align="top"></a>
			&nbsp; <a href="javascript:clearCSSEFields('<?php echo $var; ?>', 'borderColor')" class="link">&laquo; <?php echo CLEAR; ?></a>
			<div class="Sep2"></div>

			<input class="LblH" value="<?php echo BACKGROUND; ?>:" style="width:95px;">
			<input type="text" name="CSSE_CSS_<?php echo $var; ?>_bg" class="Txt Color" value="<?php echo $backgroundColor; ?>"> <a href="javascript:cp_<?php echo $var; ?>.select($('INPUT[name=CSSE_CSS_<?php echo $var; ?>_bg]').get(0), 'CSSE_CSS_<?php echo $var; ?>_bg_pick', 'changedCSSE(\'<?php echo $var; ?>\')');" name="CSSE_CSS_<?php echo $var; ?>_bg_pick" id="CSSE_CSS_<?php echo $var; ?>_bg_pick"><img src="<?php echo SCRIPT_ROOT; ?>images/icon-colorpicker.gif" width="16" height="16" alt="color" align="top"></a>
			&nbsp; <a href="javascript:clearCSSEFields('<?php echo $var; ?>', 'bg')" class="link">&laquo; <?php echo CLEAR; ?></a>
			<div class="Sep2"></div>
		</div>
		<script language="JavaScript">var cp_<?php echo $var; ?> = new ColorPicker(); cp_<?php echo $var; ?>.writeDiv();</script>
<?php
	}

//*************************************************************************************************

	function getComboFromArray($name, $values, $selected='', $cssClass='', $onchange='')
	{
		$values = !is_array($values) ? array() : $values;

		$retVal = '<select title="Select '.$name.'" name="'.$name.'" class="'.$cssClass.'" onchange="'.$onchange.'">';

		foreach ( $values as $key => $val )
		{
			$key = isset($key) ? $key : $val;
			$retVal .= '<option value="'.$key.'" '.($selected==$key?'selected':'').'>'.$val.'</option>';
		}

		$retVal .= '</select>';

		return $retVal;
	}

//*************************************************************************************************

		function getTootlTipDisplay($msg, $width=250)
		{
			if ( $msg == '' )
				return '';

			$msg = str_replace('"', '&quot;', $msg);
			$msg = str_replace("'", '`', $msg);

			return '<div style="float:right;"><a onmouseover="this.T_WIDTH='.$width.';return escape(\''.$msg.'\')"><img src="'.SCRIPT_ROOT.ADMIN_FOLDER_NAME.'/images/icon-tip.gif" width="21" height="21" alt="'.$msg.'"></a></div>';
		}

//*************************************************************************************************

		function showPriceInputField($name, $value='', $size=5, $maxlen=10, $class='effect', $others='')
		{
			$size	=(int)$size;
			$maxlen	=(int)$maxlen;

			return SCRIPT_DOLLAR.' <input type="text" size="'.$size.'" maxlength="'.$maxlen.'" name="'.$name.'" class="'.$class.'" value="'.$value.'" '.$others.'>';
		}

//*************************************************************************************************

		function getWeightUnitComboOptions($selected = '')
		{
			?>
				<option value="">n/a</option>
				<option value="gms"<?php echo $selected=='gms'?' selected':''; ?>>gms</option>
				<option value="kg"<?php echo $selected=='kg'?' selected':''; ?>>kg</option>
				<option value="ou"<?php echo $selected=='ou'?' selected':''; ?>>ou</option>
				<option value="lb"<?php echo $selected=='lb'?' selected':''; ?>>lb</option>
			<?php
		}

//*************************************************************************************************

		function getDimensionUnitComboOptions($selected = '')
		{
			?>
				<option value="">n/a</option>
				<option value="in"<?php echo $selected=='in'?' selected':''; ?>>in</option>
				<option value="cm"<?php echo $selected=='cm'?' selected':''; ?>>cm</option>
				<option value="ft"<?php echo $selected=='ft'?' selected':''; ?>>ft</option>
				<option value="m"<?php echo $selected=='m'?' selected':''; ?>>m</option>
			<?php
		}

//*************************************************************************************************

		function getCurrentApiShortCode($prefPrdSrc)
		{
			return $prefPrdSrc['BASE_PRODUCT_SOURCE'];
		}

//*************************************************************************************************

		function getSortedCheckedApis($prefPrdSrc)
		{
			$ret = array();

			if ( !is_array($prefPrdSrc) )
				return $ret;

			foreach ( $prefPrdSrc as $key => $val )
			{
				if ( substr($key, 0, 19) != 'SHOW_PRODUCTS_FROM_' || $val == 0 )
					continue;

				$name = substr($key, 19);
				$type = getConstant('API_TYPE_'.$name);

				$ret[$type] = $prefPrdSrc['SORT_PRODUCT_SOURCE_'.$name];
			}

			asort($ret);

			return $ret;
		}

//*************************************************************************************************

		function getCurrentApiCode($prefPrdSrc)
		{
			global $ARR_API_TYPE_NAME_VALS;

			if ( !is_array($prefPrdSrc) || !is_array($ARR_API_TYPE_NAME_VALS) )
				return 'MYSQL';

			$baseProdSrc	= $prefPrdSrc['BASE_PRODUCT_SOURCE'];

			foreach ( $ARR_API_TYPE_NAME_VALS as $key => $val )
			{
				if ( $baseProdSrc == $val )
					return $key;
			}

			return 'MYSQL';
		}

//*************************************************************************************************

		function getCurrentApiName($prefPrdSrc)
		{
			global $ARR_API_TYPE_NAME_VALS;

			if ( !is_array($prefPrdSrc) || !is_array($ARR_API_TYPE_NAME_VALS) )
				return MYSQL;

			$baseProdSrc	= $prefPrdSrc['BASE_PRODUCT_SOURCE'];

			foreach ( $ARR_API_TYPE_NAME_VALS as $key => $val )
			{
				if ( $baseProdSrc == $val )
					return getConstant($key);
			}

			return MYSQL;
		}

//*************************************************************************************************

		function getCalendarField($args)
		{
			global $langFolder, $adminLangFolder, $COUNTRY_ALPHA2_TO_LANG_CODES;

			$langCode		= defined('IS_ADMIN') && IS_ADMIN == 1 && $adminLangFolder != '' ? $adminLangFolder : $langFolder;

			$fieldName		= isset($args['fieldName']) ? $args['fieldName'] : 'temp';
			$fieldId		= isset($args['fieldId']) ? $args['fieldId'] : 'id_'.$fieldName;
			$fieldValue		= isset($args['fieldValue']) ? $args['fieldValue'] : '';
			$showDate		= isset($args['showDate']) ? $args['showDate'] : true;
			$showTime		= isset($args['showTime']) ? $args['showTime'] : false;
			$className		= isset($args['className']) ? $args['className'] : 'effect';
			$dateFormat		= isset($args['dateFormat']) ? $args['dateFormat'] : 'mm/dd/yy';
			$kdateFormat	= str_replace('mm', 'm', str_replace('dd', 'd', str_replace('yy', 'Y', $dateFormat)));	// convert to kaon date format
			$onlyHtml		= isset($args['onlyHtml']) ? $args['onlyHtml'] : false;
			$onlyJS			= isset($args['onlyJS']) ? $args['onlyJS'] : false;
			$extraAttrs		= isset($args['extraAttrs']) ? $args['extraAttrs'] : '';	// These must be the last in the html tag

			$ret = '';

			if ( $showDate )
				$ret .= '<input name="'.$fieldName.'_disp" id="'.$fieldId.'_disp" value="'.formatDateTime($fieldValue, $kdateFormat).'" size="12" type=text class="'.$className.'" readonly placeholder="'.$dateFormat.'" '.$extraAttrs.'>';

			if ( $showTime )
				$ret .= ' <input name="'.$fieldName.'_time" id="'.$fieldId.'_time" value="'.formatDateTime($fieldValue, 'H:i').'" size="5" maxlength="5" type=text class="'.$className.'" onchange="$(\'#'.$fieldId.'\').val($(\'#'.$fieldId.'\').val().substring(0, 10)+\' \'+this.value);" placeholder="hh:mm" '.$extraAttrs.'>';

			$ret .= '<input name="'.$fieldName.'" id="'.$fieldId.'" value="'.$fieldValue.'" type=hidden>';

			if ( $onlyHtml )
				return $ret;

			$ret .= "<script language=JavaScript>\n";
			$ret .= "<!--\n";
			$ret .= "$(function() {\n";

			if ( $onlyJS )
				$ret = '';

			if ( $showDate )
			{
				$lkeys = array_keys($COUNTRY_ALPHA2_TO_LANG_CODES);

				if ( $langCode == '' || $langCode == 'en' || $langCode == 'eng' || !in_array($langCode, $lkeys) )
					$ret .= "defaults = $.datepicker.regional['en-GB'];\n";
				else
					$ret .= "defaults = $.datepicker.regional['".$langCode."'];\n";

				$ret .= "if ( defaults === undefined ) defaults = $.datepicker.regional['en-GB'];\n";
				$ret .= "if ( defaults === undefined ) defaults = {};\n";

				$ret .= "defaults['dateFormat']		= '".$dateFormat."';\n";
				$ret .= "defaults['altField']		= '#".$fieldId."';\n";
				$ret .= "defaults['altFormat']		= 'yy-mm-dd';\n";

				if ( $showTime )
					$ret .= "defaults['onSelect']		= function () { $('#".$fieldId."_time').change(); };\n";

				$ret .= "$('#".$fieldId."_disp').datepicker(defaults);\n";
				$ret .= "$('#".$fieldId."_disp').keyup(function(e){if(e.keyCode == 8 || e.keyCode == 46) { $.datepicker._clearDate(this); } });\n";
			}

			if ( $onlyJS )
				return $ret;

			$ret .= "});\n";
			$ret .= "//-->\n";
			$ret .= "</script>\n";

			return $ret;
		}

//*************************************************************************************************

/**
 * Get the seo url for given params.
 *
 * @param string $filename Seo slug to use.
 * @param string $params Query string to pass.
 * @param string $extension Can be used to change/remove default extension.
 *
 * @return string
 */
		function getSeoUrl( $filename, $params = '', $extension = EXTENSION )
		{
			global $SEO_CONTENT_PAGE_NAMES;

			$queryString = $params == '' ? '' : ($params=='?'?'?':'?'.$params);

			if ( $filename == '' || $filename == '/' )
			{
				if ( HOMEPAGE_LINK_FILENAME == '' )
					return SCRIPT_ROOT.$queryString;

				if ( USE_MOD_REWRITE != 'Y' )
					return SCRIPT_ROOT.HOMEPAGE_LINK_FILENAME.'.php'.$queryString;
				else
					return SCRIPT_ROOT.HOMEPAGE_LINK_FILENAME.'/'.$queryString;
			}

			if ( USE_MOD_REWRITE != 'Y' )
				return SCRIPT_ROOT.$filename.'.php'.$queryString;

			if ( isset($SEO_CONTENT_PAGE_NAMES[$filename]) )
				return SCRIPT_ROOT.$SEO_CONTENT_PAGE_NAMES[$filename].'/'.$queryString;

			return SCRIPT_ROOT . $filename . ( '' == $extension ? '/' : '.' . $extension ) . $queryString;
		}

//*************************************************************************************************

		function getResourceUrl($filename, $folder, $themeSpecific=false, $isStatic=true)
		{
			global $themeName;

			$rootUrl = $isStatic && defined('SCRIPT_ROOT_STATIC') && SCRIPT_ROOT_STATIC != '' && substr(SCRIPT_ROOT_STATIC, 0, 4) == 'http' ? SCRIPT_ROOT_STATIC : SCRIPT_ROOT;

			$folder = $folder == '' ? '' : $folder.'/';

			$themeFolder = $themeSpecific ? 'themes/'.$themeName.'/' : '';

			return $rootUrl . $themeFolder . $folder . $filename;
		}

//*************************************************************************************************

		function getTemplateFilePath($filename, $folder='', $commonFile=0)
		{
			global $templateName, $templateSubFolder;

			$folder = $folder == '' ? '' : $folder.'/';

			// If it is a common file then load from tpl root, else load from specific template
			$tplPath = $commonFile == 1 ? '' : $templateName.'/';

			$finalPath = $folder . 'templates/' . $tplPath . $templateSubFolder . $filename;

			if ( $templateSubFolder != '' && file_exists(PATH . $finalPath) )
			{
				// 10/27/2015: Mamda: make sure this file is included once only
				$checkDefine = 'TPL_INCLUDED_'.md5($finalPath);
				if ( defined($checkDefine) )
					die('Invalid template recursion');
				define($checkDefine, 1);

				return PATH . $finalPath;
			}

			$finalPath = $folder . 'templates/' . $tplPath . $filename;

			// If we are looking in specific template and file does not exist, then load from common files
			if ( $commonFile == 0 && !file_exists(PATH . $finalPath) )
				return getTemplateFilePath($filename, $folder, 1);

			// 10/27/2015: Mamda: make sure this file is included once only
			$checkDefine = 'TPL_INCLUDED_'.md5($finalPath);
			if ( defined($checkDefine) )
				die('Invalid template recursion');
			define($checkDefine, 1);

			return PATH . $finalPath;
		}

//*************************************************************************************************

		function getReferAFriendUrl($url)
		{
			$url	= strstr($url, SCRIPT_ROOT) ? $url : $_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'];
			$ts		= time();

			$url	= str_replace('&amp;', '&', $url);

			return SCRIPT_ROOT.'email_page_2_friend.php?url='.urlencode($url).'&hash='.md5('RF'.$url.SCRIPT_COMPANY_NAME.$ts).'&ts='.$ts.'&';
		}

//*************************************************************************************************

		function validateReferAFriendUrl($url, $ts, $hash)
		{
			return $hash == md5('RF'.$url.SCRIPT_COMPANY_NAME.$ts);
		}

//*************************************************************************************************

		function getFormattedPrice($price, $currency='', $rate=1)
		{
			$price = (float)$price;
			$rate = (float)$rate;

			if ( IS_CURRENCY_AFTER_PRICE )
			{
				if ( IS_COMMA_DECIMAL_SEPARATOR == 1 )
					return number_format($rate*$price, 2, ',', ' ').''.$currency;
				else
					return number_format($rate*$price, 2).''.$currency;
			}
			else
			{
				if ( IS_COMMA_DECIMAL_SEPARATOR == 1 )
					return $currency.''.number_format($rate*$price, 2, ',', ' ');
				else
					return $currency.''.number_format($rate*$price, 2);
			}
		}

//*************************************************************************************************

	function kregexpReplace($regExp, $flags, $replaceWith, $subjectStr)
	{
		return preg_replace('/'.$regExp.'/'.$flags, $replaceWith, $subjectStr);
	}

//*************************************************************************************************

	function kregexpMatch($regExp, $flags, $subjectStr)
	{
		return preg_match('/'.$regExp.'/'.$flags, $subjectStr);
	}

//*************************************************************************************************

		function replaceFilenameChars($filename)
		{
			global $TRANSLATE_ARRAY, $TRANSLATE_ARRAY_EX;

			// Trim Extra Spaces
			$filename = trim($filename);

			// 4/26/2011: Remove dot (.)
			$filename = str_replace('.', '-',							$filename);

//			// Danish Charset
//			$filename = str_replace('�', 'ae',							$filename);
//			$filename = str_replace('�', 'oe',							$filename);
//			$filename = str_replace('�', 'aa',							$filename);

			// Html characters replace
			$filename = str_replace('&eacute;','e',						$filename);
			$filename = str_replace('&egrave;','e',						$filename);
			$filename = str_replace('&agrave;','a',						$filename);
			$filename = str_replace('&ecirc;','e',						$filename);
			$filename = str_replace('&icirc;','i',						$filename);
			$filename = str_replace('&ocirc;','o',						$filename);
			$filename = str_replace('&ccedil;','c',						$filename);
			$filename = str_replace('eacute','e',						$filename);
			$filename = str_replace('egrave','e',						$filename);
			$filename = str_replace('agrave','a',						$filename);
			$filename = str_replace('ecirc','e',						$filename);
			$filename = str_replace('icirc','i',						$filename);
			$filename = str_replace('ocirc','o',						$filename);
			$filename = str_replace('ccedil','c',						$filename);

			if ( defined('INCLUDE_CONSTANTS_UTF8') && INCLUDE_CONSTANTS_UTF8 == 1 )
				require_once(PATH."include/constants_utf8.php");
			else
				$TRANSLATE_ARRAY_EX = array();

			foreach ( $TRANSLATE_ARRAY_EX as $key => $value )
				$filename = str_replace($key, $value,				$filename);

			foreach ( $TRANSLATE_ARRAY as $key => $value )
			{
				if ( DEFAULT_CHARSET == 'utf-8' || DEFAULT_CHARSET == 'UTF-8' ) {
                    $filename = str_replace(utf8_encode($key), utf8_encode($value),	$filename);
                    $filename = str_replace($key, $value,				$filename);
                }
				else
					$filename = str_replace($key, $value,				$filename);
			}

			$filename = str_replace('&nbsp;',' ',						$filename);
			$filename = str_replace('&amp;','$',						$filename);

			$filename = str_replace(' & ','$',							$filename); // (space)&(space) with (-)

			$filename = str_replace('-','$',							$filename); // Preserve (-)
			$filename = str_replace('+', '$',							$filename); // Replace (+) with (-). To search engine both are same.

			// Deprecated in 5.3
//			$filename = eregi_replace("&[A-Z0-9]*;", '',				$filename); // Remove HTML Tags (&amp);
//			$filename = eregi_replace("([^A-Z0-9 \.\$\_/])*", '',		$filename); // Remove all unwanted special characters
																					// Except (.), ($) -for dash-, (_), (/)

			$filename = kregexpReplace('&[A-Z0-9]*;', 'i', '',			$filename); // Remove HTML Tags (&amp);

			$filename = str_replace('&','$',							$filename); // Remaining & with (-)

//			$filename = preg_replace('/[^A-Z0-9 \.\$\_\/]*/i', '',      $filename); // Remove all unwanted special characters
																					// Except (.), ($) -for dash-, (_), (/)
			$filename = kregexpReplace('[^A-Z0-9 \$\_\/]*', 'i', '',	$filename); // 10/8/2010: We now also remove (.)
																					// Except ($) -for dash-, (_), (/)

			$filename = str_replace("\$",  "-",							$filename);	// Replace ($) with (-), (-) does not work well with ereg
			$filename = str_replace("\\",   '',							$filename);
			$filename = str_replace("/",   "-",							$filename);
			$filename = str_replace(" ",   "-",							$filename); // Repalce SPACE with (-)

			$filename = str_replace("--",  "-",							$filename); // Remove --- into --
			$filename = str_replace("--",  "-",							$filename); // Remove -- into -

			return strtolower($filename);
		}

//*************************************************************************************************

		function showErrorPageAndDie($errorCode, $errorMsg)
		{
			global $templateName, $themeName, $templateSubFolder;

			$errorCode = (int)$errorCode;
			if ( !in_array($errorCode, array(404, 403)) )
			{
				$errorMsg .= "\nWrong error code [".$errorCode."]";
				$errorCode = 404;
			}

			$langFilename = ''.$errorCode;
			include PATH.$errorCode.'.php';
			die;
		}

//*************************************************************************************************

		// Call with one argument that is associative array of image tag attributes
		//	must have the src attribute
		//	can have the data-src-retina attribute to load better quality images for retina devices
		function getImgTag($arrAttrs)
		{
			if ( !is_array($arrAttrs) || !isset($arrAttrs['src']) )
				return '<!-- invalid image tag attribs -->';

			// If we are using smart images loading script, then setup the image src tags for it
			if ( defined('USE_SMART_IMAGES_LOADING') && USE_SMART_IMAGES_LOADING == 1 )
			{
				// Set data-src to the actual image source
				$arrAttrs['data-src']	= $arrAttrs['src'];

				// Set image source to loading gif
				$arrAttrs['src']		= getResourceUrl('loading3.gif', 'images', false);
			}

			$attribs = '';
			foreach ( $arrAttrs as $key => $val ) {
				if ( 'border' == $key && '0' == $val ) {
					continue;
				}
				$attribs .= $key . '="' . $val . '" ';
			}

			return '<img '.$attribs.'/>';
		}

//*************************************************************************************************

		/**
		 * Reverse the smart loading script application.
		 * This is useful in situations where smart loading is not of very importance, and it causes troubles.
		 * @param string $html source html that has the image tag
		 * @return string return the edited html
		 */
		function reverseSmartLoading($html)
		{
			if ( strstr( $html, 'loading3.gif' ) ) {
				$html = str_replace( ' src=', ' old-src=', $html );
				$html = str_replace( ' data-src=', ' src=', $html );
			}

			return $html;
		}

//*************************************************************************************************

		// Get a constant only if it is defined
		function getConstant($name)
		{
			return defined($name) ? constant($name) : $name;
		}

//*************************************************************************************************

/**
 * Call this function with a USER_PRODUCT row and within href=" -- call here -- "
 * NOTE: This function will only work correct if called within href=" -- call here -- "
 *
 * @param $arr array holding the USER_PRODUCT record
 *
 * @return string url to redirect.php or buy url with onclick call to redirect.php
 */
		function getBuyUrlWithRedirectSkipCheck($arr)
		{
			// If redirect screen is to be shown
			if ( !defined('SKIP_REDIRECT_SCREEN') || 0 == SKIP_REDIRECT_SCREEN ) {
				return getSeoUrl('redirect', 'prod_id=' . $arr['ID'] . '&amp;isBuy=Y');
			}

			// If redirect screen is to be skipped
			return $arr['BUY_URL'] . '" onclick="logRedirectClick(' . $arr['ID'] . ');';
		}

//*************************************************************************************************

/**
 * Draw a line chart using google charts
 *
 * @param $params array:
 * 						id: The id of chart object to make it unique on page
 * 						title: An optional heading to print above the chart
 * 						main_label: Chart main object label
 * 						value_labels: Chart values labels as an array
 * 						width: Chart width in pixels
 * 						height: Chart height in pixels
 * 						data: Key/Value pair array for chart data, with values as an array
 */
		function drawLineChart($params)
		{
			// Initialize the google charts
			initGoogleCharts();

			// Check the parameters
			if ( !is_array($params) ) {
				echo "\n<!-- drawLineChart() parameters empty -->\n";
				return;
			}

			// Check if required parameters are present or not
			if ( !isset($params['id']) ) {
				echo "\n<!-- drawLineChart() 'id' parameter missing -->\n";
				return;
			}
			if ( !isset($params['data']) || !is_array($params['data']) ) {
				echo "\n<!-- drawLineChart() 'data' parameter missing or incorrect -->\n";
				return;
			}

			// Load default values
			$params['main_label']  = isset( $params['main_label'] ) ? $params['main_label'] : '';
			$params['value_label'] = isset( $params['value_label'] ) ? $params['value_label'] : '';
			$params['width']       = isset( $params['width'] ) ? $params['width'] : 320;
			$params['height']      = isset( $params['height'] ) ? $params['width'] : 220;

			// Load defaults for chart area
			$chart_area  = isset( $params['chart_area'] ) && is_array( $params['chart_area'] ) ? $params['chart_area'] : [];
			$chart_area['left'] = isset($chart_area['left']) ? $chart_area['left'] : '10%';
			$chart_area['top'] = isset($chart_area['top']) ? $chart_area['top'] : '5%';
			$chart_area['width'] = isset($chart_area['width']) ? $chart_area['width'] : '90%';
			$chart_area['height'] = isset($chart_area['height']) ? $chart_area['height'] : '75%';


			// Now draw the chart
?>
			<script type="text/javascript">

				$(document).ready(function () {
					google.charts.setOnLoadCallback(drawChart_<?= $params['id'] ?>);
				});

				function drawChart_<?= $params['id'] ?>() {
					var data = google.visualization.arrayToDataTable([
						['<?= $params['main_label'] ?>', <?= "'" . implode( "', '", $params['value_labels'] ) . "'" ?>]
						<?php
						foreach ( $params['data'] as $key => $val ) {
							if ( ! is_array( $val ) ) {
								$val = [ $val ];
							}
							echo ",\n\t['" . $key . "', " . implode( ', ', $val ) . "]";
						}
						?>
					]);

					var options = {
						<?php if ( isset( $params['title'] ) ) : ?>
						title: '<?= $params['title'] ?>',
						<?php endif; ?>
						legend: {position: 'bottom'},
						width: <?= $params['width'] ?>,
						height: <?= $params['height'] ?>,
						backgroundColor: '#fffbd6',
						chartArea: <?= json_encode( $chart_area ) ?>
					};

					chartData_<?= $params['id'] ?> = data;
					chartOpts_<?= $params['id'] ?> = options;
					renderChart_<?= $params['id'] ?>();
				}

				function renderChart_<?= $params['id'] ?>() {
					chartOpts_<?= $params['id'] ?>.width = $('#linechart_<?= $params['id'] ?>').width();
					var chart                            = new google.visualization.LineChart(document.getElementById('linechart_<?= $params['id'] ?>'));
					chart.draw(chartData_<?= $params['id'] ?>, chartOpts_<?= $params['id'] ?>);
				}

				$(window).resize(function () {
					renderChart_<?= $params['id'] ?>();
				});

			</script>
			<div id="linechart_<?= $params['id'] ?>"></div>
<?php
		}

//*************************************************************************************************

/**
 * Draw a pie chart using google charts
 *
 * @param $params array:
 * 						id: The id of chart object to make it unique on page
 * 						title: An optional heading to print above the chart
 * 						main_label: Chart main object label
 * 						value_label: Chart values label
 * 						is3d: true/false
 * 						width: Chart width in pixels
 * 						height: Chart height in pixels
 * 						data: Key/Value pair array for chart data
 */
		function drawPieChart($params)
		{
			// Initialize the google charts
			initGoogleCharts();

			// Check the parameters
			if ( !is_array($params) ) {
				echo "\n<!-- drawPieChart() parameters empty -->\n";
				return;
			}

			// Check if required parameters are present or not
			if ( !isset($params['id']) ) {
				echo "\n<!-- drawPieChart() 'id' parameter missing -->\n";
				return;
			}
			if ( !isset($params['data']) || !is_array($params['data']) ) {
				echo "\n<!-- drawPieChart() 'data' parameter missing or incorrect -->\n";
				return;
			}

			// Load default values
			$params['main_label'] = isset($params['main_label']) ? $params['main_label'] : '';
			$params['value_label'] = isset($params['value_label']) ? $params['value_label'] : '';
			$params['width'] = isset($params['width']) ? $params['width'] : 320;
			$params['height'] = isset($params['height']) ? $params['width'] : 220;

			// Now draw the chart
?>
			<script type="text/javascript">
				google.charts.setOnLoadCallback(drawChart_<?= $params['id'] ?>);
				function drawChart_<?= $params['id'] ?>() {
					var data = google.visualization.arrayToDataTable([
						['<?= $params['main_label'] ?>', '<?= $params['value_label'] ?>']
						<?php
						foreach ( $params['data'] as $key => $val ) {
							echo ",\n\t['". $key ."', ".$val."]";
						}
						?>
					]);

					var options = {
						<?php if ( isset($params['title']) ) : ?>
						title: '<?= $params['title'] ?>',
						<?php endif; ?>
						is3D: <?= isset($params['is3d']) && $params['is3d'] ? 'true' : 'false' ?>,
						width: <?= $params['width'] ?>,
						height: <?= $params['height'] ?>,
						backgroundColor: '#fffbd6',
						chartArea: {left:'5%',top:'5%',width:'95%',height:'90%'}
					};

					var chart = new google.visualization.PieChart(document.getElementById('piechart_<?= $params['id'] ?>'));
					chart.draw(data, options);
				}
			</script>
			<div id="piechart_<?= $params['id'] ?>"></div>
<?php
		}

//*************************************************************************************************

/**
 *  Initialize the google charts javascript, prints just once even if called many times.
 */
		$bGoogleChartsInitialized = false;
		function initGoogleCharts()
		{
			global $bGoogleChartsInitialized;
			if ( ! $bGoogleChartsInitialized ) {
?>
				<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
				<script type="text/javascript">
					google.charts.load("current", {packages:["corechart"]});
				</script>
<?php
				$bGoogleChartsInitialized = true;
			}
		}

//*************************************************************************************************

/**
 * Escape string for html attribute
 *
 * @param $str
 *
 * @return string
 */
function escAttr($str)
{
	$str = str_replace('"', '&quot;', $str);
	$str = str_replace("'", '`', $str);
	$str = str_replace("\n", ' ', $str);
	$str = str_replace("\t", ' ', $str);

	return $str;
}

//*************************************************************************************************

/**
 * Render template based on configuration
 * @param string $fileName view name without .blade.php
 * @param array|null|string $params parameters to be sent to the template
 */
function renderTemplate($fileName, $params='')
{
	// If params is not an array then make it
	$params = is_array($params) ? $params : [];

	// Load the required global variables
	global $langRec, $langISOCode, $doCallMasonry, $doCallJScrolPage, $doCallCalendar, $doCallLightbox, $isMemberPage,
		   $templateName, $themeName, $prefs, $isIndexPage, $isContentPage, $currentPagename, $DEMO_INSTALLED_TEMPLATES,
		   $BUILD_YOUR_THEME_COMPONENTS, $info, $pageBreadcrumb, $currencySymbol, $currencyRate, $visitorId, $visitorName,
		   $langFolder, $locCity, $locCountry, $locZip, $isVisitorSeller, $hideSetupStoreLink, $userRec, $merchantId,
		   $hideMerchantNavigation, $merchantName, $merchantLastLogin, $cacheHFSubKey, $prefPrdSrc;

	// Set default charset if not already set
	if ( ! defined('DEFAULT_CHARSET') ) {
		define('DEFAULT_CHARSET', 'iso-8859-1');
	}

	// Build cookie policy html
	$cookiePolicyHtml = MSG_COOKIE_NOTICE;
	$cookiePolicyHtml = str_replace('{SCRIPT_COMPANY_NAME}', SCRIPT_COMPANY_NAME, $cookiePolicyHtml);
	$cookiePolicyHtml = str_replace('{SCRIPT_ROOT}', getSeoUrl('/'), $cookiePolicyHtml);
	$cookiePolicyHtml = str_replace('{EXTENSION}', EXTENSION, $cookiePolicyHtml);
	$cookiePolicyHtml = str_replace('"', '\\"', $cookiePolicyHtml);

	// Load categories to send
	$arrLeftCat = defined('HEADER_LOAD_CATEGORIES_ARRAY') && HEADER_LOAD_CATEGORIES_ARRAY == 1 ? getCategoryHeirarchy(3) : [];

	// Create page breadcrumb vars
	$pageBreadcrumb = buildPageBreadcrumb();
	list($lastUrl, $lastTitle)  = getLastPageUrlAndTitle($pageBreadcrumb);

	// Build page cache vars
	buildPageCacheLiveParts();

	// Build language and currency display html
	$currencyString = buildCurrencyStringForHeader();
	$languageString = buildLanguageStringForHeader();

	// Load the parameters to send
	$baseParams = [
		'htmlLangAttrib'               => $langRec['HTML_ATTRIBS'] != '' ? $langRec['HTML_ATTRIBS'] : ($langISOCode == '' ? '' : 'lang="' . $langISOCode . '"'),
		'pageMetaTitle'                => cacheLivePart('header-page-title'),
		'pageMetaKeywords'             => cacheLivePart('header-page-keywords'),
		'pageMetaDescription'          => str_replace('"', "'", strip_tags(cacheLivePart('header-page-description'))),
		'pageMetaGoogleIndex'          => cacheLivePart('header-meta-google-index'),
		'pageMetaCharset'              => $langRec['META_CHARSET'] != '' ? $langRec['META_CHARSET'] : DEFAULT_CHARSET,
		'pageMetaOpenGraphTitle'       => cacheLivePart('header-og-title'),
		'pageMetaOpenGraphDescription' => cacheLivePart('header-og-description'),
		'pageMetaOpenGraphUrl'         => cacheLivePart('header-og-url'),
		'pageMetaOpenGraphImageTag'    => cacheLivePart('header-og-image'),
		'pageMetaOpenGraphAudioTag'    => cacheLivePart('header-og-audio'),
		'pageMetaOpenGraphVideoTag'    => cacheLivePart('header-og-video'),
		'facebookAppId'                => defined('FACEBOOK_APP_ID') && FACEBOOK_APP_ID != '' ? FACEBOOK_APP_ID : '',
		'pageCanonicalTag'             => cacheLivePart('header-canonical-url'),
		'pageBreadcrumb'               => $pageBreadcrumb,
		'lastUrl'                      => $lastUrl,
		'lastTitle'                    => $lastTitle,
		'cacheHFSubKey'                => $cacheHFSubKey,
		'isRTL'                        => strstr($langRec['HTML_ATTRIBS'], 'rtl'),
		'doCallMasonry'                => isset($doCallMasonry) && $doCallMasonry,
		'doCallJScrolPage'             => isset($doCallJScrolPage) && $doCallJScrolPage,
		'doCallCalendar'               => isset($doCallCalendar) && $doCallCalendar,
		'doCallLightbox'               => isset($doCallLightbox) && $doCallLightbox,
		'currentPagename'              => $currentPagename,
		'templateName'                 => $templateName,
		'themeName'                    => $themeName,
		'prefs'                        => is_array($prefs) ? $prefs : [],
		'prefPrdSrc'                   => is_array($prefPrdSrc) ? $prefPrdSrc : [],
		'isIndexPage'                  => isset($isIndexPage) && $isIndexPage != '',
		'isContentPage'                => isset($isContentPage) && $isContentPage != '',
		'DEMO_INSTALLED_TEMPLATES'     => is_array($DEMO_INSTALLED_TEMPLATES) ? $DEMO_INSTALLED_TEMPLATES : [],
		'BUILD_YOUR_THEME_COMPONENTS'  => is_array($BUILD_YOUR_THEME_COMPONENTS) ? $BUILD_YOUR_THEME_COMPONENTS : [],
		'isMemberPage'                 => isset($isMemberPage) ? $isMemberPage : '',
		'cookiePolicyHtml'             => $cookiePolicyHtml,
		'arrLeftCat'                   => $arrLeftCat,
		'langFolder'                   => $langFolder,
		'locCountry'                   => $locCountry,
		'locZip'                       => $locZip,
		'locCity'                      => $locCity,
		'currencySymbol'               => $currencySymbol,
		'currencyRate'                 => $currencyRate,
		'currencyString'               => $currencyString,
		'languageString'               => $languageString,
		'visitorId'                    => $visitorId,
		'visitorName'                  => $visitorName,
		'info'                         => $info,
		'isVisitorSeller'              => $isVisitorSeller,
		'hideSetupStoreLink'           => $hideSetupStoreLink,
		'userRec'                      => $userRec,
		'merchantId'                   => $merchantId,
		'merchantName'                 => $merchantName,
		'merchantLastLogin'            => $merchantLastLogin,
		'hideMerchantNavigation'       => $hideMerchantNavigation,
	];

	// Template file path
	$filePath = $fileName;

	// If a template exists in current template folder then show from there else keep showing from base
	if ( file_exists(PATH . BLADE_TEMPLATES_PATH . '/' . ACTIVE_TEMPLATE . '/' . $fileName . '.blade.php') ) {
		$filePath = ACTIVE_TEMPLATE . '/' . $fileName;
	}

	// Call the blade template current template
    // array_merge gives priority to 2nd argument if array key is textual. If key is numeric, it gives first array (left) priority
	renderBladeView( $filePath, array_merge( $baseParams, $params ) );
}

//*************************************************************************************************

function buildCurrencyStringForHeader()
{
	global $currencySymbol;

	if (!defined('HEADER_LOAD_CURRENCIES') || HEADER_LOAD_CURRENCIES != 1) {
		return '';
	}

	$resCurrency = executeQuery("SELECT ID, TITLE, SYMBOL FROM " . PREFIX . "CURRENCY WHERE ISVALID = 'Y' ORDER BY TITLE");
	$currencyString = '<select rel="relJQDDR" title="Select currency" name="cur" class="effect" onchange="location.href=\'' . SCRIPT_ROOT . 'currency.php?u=' . base64_encode($_SERVER['REQUEST_URI']) . '&c=\'+this.value" style="width:80px;">';
	$totCount = 0;
	while (($rowCurrency = getRow($resCurrency))) {
		$totCount++;

		$curUrl = SCRIPT_ROOT . 'images/spacer.gif';
		if (file_exists(PATH_SUBD . 'upload/currency/' . $rowCurrency['ID'] . '.jpg'))
			$curUrl = SCRIPT_ROOT . 'thumbnail.php?h=16&f=' . urlencode('upload/currency/' . $rowCurrency['ID'] . '.jpg');

		$currencyString .= '<option value="' . $rowCurrency['ID'] . '" title="' . $curUrl . '" ' . ($rowCurrency['SYMBOL'] == $currencySymbol ? 'selected' : '') . '>' . $rowCurrency['TITLE'] . '</option>';
	}
	free($resCurrency);
	$currencyString .= '</select>';
	$currencyString = $totCount <= 1 ? '' : $currencyString;

	return $currencyString;
}

//*************************************************************************************************

function buildLanguageStringForHeader()
{
	global $lang;

	if (!defined('HEADER_LOAD_LANGUAGES') || HEADER_LOAD_LANGUAGES != 1) {
		return '';
	}

	$resLanguage = executeQuery("SELECT ID, NAME FROM " . PREFIX . "LANGUAGE WHERE ISVALID = 'Y' ORDER BY NAME");
	$languageString = '<select rel="relJQDDR" title="Select language" name="lng" class="effect" onchange="location.href=\'' . SCRIPT_ROOT . 'language.php?u=' . base64_encode($_SERVER['REQUEST_URI']) . '&lang=\'+this.value" style="width:130px;">';
	$totCount = 0;
	while (($rowLanguage = getRow($resLanguage))) {
		$totCount++;

		$flagUrl = SCRIPT_ROOT . 'images/spacer.gif';
		if (file_exists(PATH_SUBD . 'upload/languages/' . $rowLanguage['ID'] . '.jpg'))
			$flagUrl = SCRIPT_ROOT . 'thumbnail.php?h=16&f=' . urlencode('upload/languages/' . $rowLanguage['ID'] . '.jpg');

		$languageString .= '<option value="' . $rowLanguage['ID'] . '" title="' . $flagUrl . '" ' . ($rowLanguage['ID'] == $lang ? 'selected' : '') . '>' . $rowLanguage['NAME'] . '</option>';
	}
	free($resLanguage);
	$languageString .= '</select>';
	$languageString = $totCount <= 1 ? '' : $languageString;

	return $languageString;
}

//*************************************************************************************************

function buildPageBreadcrumb()
{
	global $pageBreadcrumb, $pageUrl, $pageTitle;

	return !isset($pageBreadcrumb) || $pageBreadcrumb == '' ? ' &gt; <a href="' . $pageUrl . '">' . $pageTitle . '</a>' : $pageBreadcrumb;
}

//*************************************************************************************************

function getLastPageUrlAndTitle($pageBreadcrumb)
{
	global $isIndexPage;

	$lastUrl = '';
	$lastTitle = '';
	$arr = explode('&gt;', $pageBreadcrumb);
	for ($d = 0, $i = count($arr) - 1; $i >= 0 && $d < 2; $i--, $d++) {
		$a = isset($arr[$i]) ? trim($arr[$i]) : '';
		if ($a == '')
			continue;

		if ($d == 1) {
			$lastUrl = stringBetween($a, 'href="', '"');
			$lastTitle = strip_tags($a);
		}
	}
	if ($lastUrl == '' && $isIndexPage == '') {
		$lastUrl = getSeoUrl('/');
		$lastTitle = HOME;
	}

	return [$lastUrl, $lastTitle];
}

//*************************************************************************************************

function buildPageCacheLiveParts()
{
	global $canonicalLink, $prevPageLink, $nextPageLink, $pageTitle, $pageKeywords, $pageDescription,
		   $pageHeading, $pageUrl, $pageBreadcrumb, $ogTitle, $ogDescription, $ogUrl, $ogImage, $ogAudio,
		   $ogVideo, $searchTextEx, $cacheLiveParts;

	$canonicalTags = '';
	if (isset($canonicalLink) && $canonicalLink != '') $canonicalTags .= '<link rel="canonical" href="' . $canonicalLink . '"/>' . "\n";
	if (isset($prevPageLink) && $prevPageLink != '') $canonicalTags .= '<link rel="prev" href="' . $prevPageLink . '"/>' . "\n";
	if (isset($nextPageLink) && $nextPageLink != '') $canonicalTags .= '<link rel="next" href="' . $nextPageLink . '"/>' . "\n";

	// If cache is enabled, what will be the LIVE elements for header
	$cacheLiveParts = array(
		'header-page-title' => $pageTitle,
		'header-page-keywords' => $pageKeywords,
		'header-page-description' => $pageDescription,
		'header-page-heading' => $pageHeading,
		'header-page-breadcrumb' => $pageBreadcrumb,
		'header-meta-google-index' => isset($metaGoogleIndex) ? $metaGoogleIndex : 'INDEX',
		'header-page-url' => $pageUrl,
		'header-canonical-url' => $canonicalTags,
		'header-og-title' => $ogTitle,
		'header-og-description' => $ogDescription,
		'header-og-url' => $ogUrl,
		'header-og-image' => isset($ogImage) && $ogImage != '' ? '<meta property="og:image" content="' . $ogImage . '" />' : '<!-- No OG Image -->',
		'header-og-audio' => isset($ogAudio) && $ogAudio != '' ? '<meta property="og:audio" content="' . $ogAudio . '" />' : '<!-- No OG Audio -->',
		'header-og-video' => isset($ogVideo) && $ogVideo != '' ? '<meta property="og:video" content="' . $ogVideo . '" />' : '<!-- No OG Video -->',
		'header-search-text-ex' => isset($searchTextEx) ? $searchTextEx : ''
	);
}

//*************************************************************************************************

/**
 * Show error page in merchant section and then terminate execution of script
 *
 * @param string $heading
 * @param string $message
 */
function showMerchantErrorPage($heading = '', $message = '')
{
	renderTemplate('merchants/show-error', [
		'heading' => $heading,
		'message' => $message,
	]);
	die;
}

//*************************************************************************************************

/**
 * Get Facebook share url for a given url.
 * @param $url
 * @return string
 */
function getFacebookShareUrl($url)
{
    return 'https://www.facebook.com/sharer/sharer.php?u=' . urlencode($url);
}

//*************************************************************************************************

/**
 * Get Twitter tweet url for a given url.
 * @param $url
 * @param string $text
 * @return string
 */
function getTwitterTweetUrl($url, $text='')
{
    return 'https://twitter.com/intent/tweet?text=' . urlencode($text) . '&url=' . urlencode($url);
}

//*************************************************************************************************

/**
 * Get Google+ share url for a given url.
 * @param $url
 * @return string
 */
function getGooglePlusShareUrl($url)
{
    return 'https://plus.google.com/share?url=' . urlencode($url);
}

//*************************************************************************************************

/**
 * Get Whatsapp share url for a given url.
 * @param $url
 * @param $text
 * @return string
 */
function getWhatsappShareUrl($url, $text='')
{
    return 'whatsapp://send?text=' . urlencode($text . ' ' . $url);
}

//*************************************************************************************************

/**
 * Get LinkedIN share url for a given url.
 * @param $url
 * @param $text
 * @return string
 */
function getLinkedInShareUrl($url, $text='')
{
    return 'https://www.linkedin.com/shareArticle?mini=true&title=' . urlencode($text) . '&url=' . urlencode($url);
}

//*************************************************************************************************

/**
 * Get Pinterest create url for a given url.
 * @param $url
 * @param $text
 * @param $imageUrl
 * @return string
 */
function getPinterestCreateUrl($url, $text='', $imageUrl='')
{
    return 'https://pinterest.com/pin/create/button/?description=' . urlencode($text) . '&url=' . urlencode($url) . '&media=' . urlencode($imageUrl);
}

//*************************************************************************************************

// Only define if not exists (could be defined from _rewrite.php)
if ( !function_exists('isInt') ) {
	/**
	 * Check if the provided value is integer or not.
	 * @param $value
	 * @return boolean
	 */
	function isInt($value)
	{
		return strval($value) === strval(intval($value));
	}
}

//*************************************************************************************************
