<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

// Show installer if script is not installed
if (!file_exists('path.php') || !file_exists('include/site_constants.php')) {
	header("Location: admin/install");
	die;
}

//*************************************************************************************************

require( "path.php" );
require( PATH . "include/include.php" );
require( PATH . "products_listing_functions.php" );

//*************************************************************************************************

include( PATH . "session.php" );

$_SESSION['sess_fId']  = '';
$_SESSION['sess_mer']  = '';
$_SESSION['sess_manu'] = '';

//*************************************************************************************************

$cacheLiveParts = [
	'index-banner-1' => getBanner( 1000, 'R1' ),
];

if ( cacheGoThrough( 'index' ) ) {

//*************************************************************************************************

	$isIndexPage = "yes";

//*************************************************************************************************

	// Load Featured Products and Products of the Day
	$prodPOD = [];
	$prodArr = [];
	$apiType = $prefPrdSrc['BASE_PRODUCT_SOURCE'];

	if ( $prefPrdSrc['BASE_PRODUCT_SOURCE'] == API_TYPE_MYSQL || SHOW_ALWAYS_MYSQL_PRODS_ON_HOMEPAGE == 1 ) {
		$apiType = API_TYPE_MYSQL;
		if ( defined( 'HOMEPAGE_LOAD_FEATURED_PRODUCTS' ) && HOMEPAGE_LOAD_FEATURED_PRODUCTS == 1 ) {
			$prodArr = getTableRecArray( 'PRODUCT P, ' . PREFIX . 'CATEGORY C', 'IFNULL(P.MIN_PRICE, 0) AS PRICE_MIN, IFNULL(P.MAX_PRICE, 0) AS PRICE_MAX, IFNULL(P.STORE_COUNT, 0) AS STORE_COUNT, P.ID, P.TITLE, P.FILENAME, P.PRODUCT_RATING AS RATING, P.CATEGORY_ID', "P.SPECIAL_OFFER = 'Y' AND C.ID=P.CATEGORY_ID AND C.IS_18PLUS='N' AND P.ISVALID = 'Y'", 'P.STORE_COUNT DESC' );
			loadProductDetailInArray( $prodArr );
			pcsFillCategoryRec( API_TYPE_MYSQL, $prodArr, 1 );
		}

		if ( defined( 'HOMEPAGE_LOAD_PRODUCTS_OF_THE_DAY' ) && HOMEPAGE_LOAD_PRODUCTS_OF_THE_DAY == 1 ) {
			$prodPOD = getTableRecArray( 'PRODUCT P, ' . PREFIX . 'CATEGORY C, ' . PREFIX . 'PRODUCT_POD PPOD', "IFNULL(P.MIN_PRICE, 0) AS PRICE_MIN, IFNULL(P.MAX_PRICE, 0) AS PRICE_MAX, IFNULL(P.STORE_COUNT, 0) AS STORE_COUNT, P.ID, P.TITLE, P.FILENAME, P.PRODUCT_RATING AS RATING, P.CATEGORY_ID, IF(PPOD.ONLINE_DATE='" . getTimezoneTime( 'Y-m-d' ) . "', 1, 0) AS ONLINE", "P.ID = PPOD.PRODUCT_ID AND C.ID=P.CATEGORY_ID AND C.IS_18PLUS='N' AND P.ISVALID = 'Y'", 'ONLINE DESC, P.STORE_COUNT DESC' );
			loadProductDetailInArray( $prodPOD );
			pcsFillCategoryRec( API_TYPE_MYSQL, $prodPOD, 1 );
		}
	} else {
		if ( ( defined( 'HOMEPAGE_LOAD_PRODUCTS_OF_THE_DAY' ) && HOMEPAGE_LOAD_PRODUCTS_OF_THE_DAY == 1 ) || ( defined( 'HOMEPAGE_LOAD_FEATURED_PRODUCTS' ) && HOMEPAGE_LOAD_FEATURED_PRODUCTS == 1 ) ) {
			$tmpArr    = getTableRecArray( 'API_SOURCE_PRODUCT_CACHE', "CAT_ID, API_ID AS ID, MIN_PRICE AS PRICE_MIN, MAX_PRICE AS PRICE_MAX, STORE_COUNT AS STORE_COUNT, LINK_ID, TITLE, RATING, DETAIL, '" . $apiType . "' AS API_TYPE, IMAGE_URL", "TYPE = 'F'", 'STORE_COUNT DESC' );
			$tmpCIDs   = [];
			$added2pod = [];
			foreach ( $tmpArr as $row ) {
				list( $row['CATEGORY_ID'], $row['CTITLE'], $row['CFILENAME'] ) = pcsGetCategoryRec( $apiType, $row['CAT_ID'], 1, '', '' );

				$row['IMAGE_URL'] = fixMixedContentUrl( $row['IMAGE_URL'] );

				// Load first five products in POD (if not from same category) and the rest in Featured
				if ( count( $prodPOD ) < 5 && ! in_array( $row['CATEGORY_ID'], $tmpCIDs ) ) {
					$tmpCIDs[]             = $row['CATEGORY_ID'];
					$prodPOD[ $row['ID'] ] = $row;
					$added2pod[]           = $row['ID'];
				} else {
					$prodArr[] = $row;
				}
			}

			// If POD is less than 5 then add from featured anyway
			if ( count( $prodPOD ) < 5 ) {
				foreach ( $prodArr as $row ) {
					if ( ! in_array( $row['ID'], $added2pod ) ) {
						$prodPOD[] = $row;
						if ( count( $prodPOD ) > 4 ) {
							break;
						}
					}
				}
			}
		}
	}
	$noOfRecords = sizeof( $prodArr );

//*************************************************************************************************

	// Load Popular Products and Popular Categories if enabled
	$prodPOP = [];
	$catPOP  = [];

	if ( defined( 'IS_POPULAR_INSTALLED' ) && IS_POPULAR_INSTALLED == 1 ) {
		if ( $prefPrdSrc['BASE_PRODUCT_SOURCE'] == API_TYPE_MYSQL ) {
			$res = executeQuery( "SELECT C.ID, C.FILENAME, C.TITLE FROM " . PREFIX . "CATEGORY C, " . PREFIX . "POPULAR_CATEGORY PC WHERE C.ID=PC.CATEGORY_ID AND C.ISVALID='Y' ORDER BY PC.RANK LIMIT 24" );
			while ( ( $row = getRow( $res ) ) ) {
				$catPOP[] = $row;
			}

			$res = executeQuery( "SELECT P.ID, P.FILENAME AS PFILENAME, P.TITLE, P.CATEGORY_ID, IFNULL(MIN_PRICE, 0) AS PRICE_MIN, IFNULL(MAX_PRICE, 0) AS PRICE_MAX, IFNULL(STORE_COUNT, 0) AS STORE_COUNT FROM " . PREFIX . "PRODUCT P, " . PREFIX . "POPULAR_PRODUCT PP WHERE P.ID=PP.PRODUCT_ID AND P.ISVALID='Y' ORDER BY PP.RANK LIMIT 24" );
			while ( ( $row = getRow( $res ) ) ) {
				$prodPOP[] = $row;
			}

			pcsFillCategoryRec( API_TYPE_MYSQL, $prodPOP, 1 );
		} else {
			$tmpArr = getTableRecArray( 'API_SOURCE_PRODUCT_CACHE', "CAT_ID, API_ID AS ID, MIN_PRICE AS PRICE_MIN, MAX_PRICE AS PRICE_MAX, STORE_COUNT AS STORE_COUNT, LINK_ID, TITLE, RATING, DETAIL, '" . $apiType . "' AS API_TYPE, IMAGE_URL", "TYPE = 'P'", 'STORE_COUNT DESC' );

			$catIdsPOP = [];
			foreach ( $tmpArr as $row ) {
				list( $row['CATEGORY_ID'], $row['CTITLE'], $row['CFILENAME'] ) = pcsGetCategoryRec( $apiType, $row['CAT_ID'], 1, '', '' );

				$row['IMAGE_URL'] = fixMixedContentUrl( $row['IMAGE_URL'] );

				$cId = (int) $row['CATEGORY_ID'];

				if ( $cId > 0 && ! in_array( $cId, $catIdsPOP ) ) {
					$catPOP[]    = [ 'ID' => $cId, 'TITLE' => $row['CTITLE'], 'FILENAME' => $row['CFILENAME'] ];
					$catIdsPOP[] = $cId;
				}

				$prodPOP[] = $row;
			}
		}
	}

//*************************************************************************************************

	$searchCloudArr = [];
	$searchCloudFWD = true; // FWD means Font Weight is Direct

	if ( defined( 'HOMEPAGE_LOAD_SEARCH_CLOUD' ) && HOMEPAGE_LOAD_SEARCH_CLOUD == 1 ) {
		$searchCloudArr = getTableRecArray( 'SEARCH_CLOUD', 'SEARCH_TEXT AS T, FONT_WEIGHT AS C', '', 'SORT_ORDER, SEARCH_TEXT' );

		if ( count( $searchCloudArr ) == 0 ) {
			$searchCloudArr = getTableRecArray( 'SEARCH_CLOUD_AUTO', 'SEARCH_TEXT AS T, FONT_WEIGHT AS C' );
		}
	}

//*************************************************************************************************

	$newsArr = defined( 'HOMEPAGE_LOAD_NEWS' ) && HOMEPAGE_LOAD_NEWS == 1 ? getTableRecArray( "NEWS", "*", "ISVALID='Y'", "NEWS_DATE DESC LIMIT 5" ) : [];

//*************************************************************************************************

	$wishlistArr = [];
	if ( $visitorId != '' && defined( 'HOMEPAGE_LOAD_WISHLIST' ) && HOMEPAGE_LOAD_WISHLIST == 1 ) {
		$wishlistArr = getTableRecArray( "VISITOR_PRODUCT_LIST WL, " . PREFIX . "PRODUCT P", "DISTINCT(WL.PRODUCT_ID) AS ID, P.TITLE, P.CATEGORY_ID, P.FILENAME", [
			"WL.USERID = ? AND P.ID=WL.PRODUCT_ID AND P.ISVALID='Y'",
			[ $visitorId ],
		], "P.TITLE LIMIT 5" );
	}

//*************************************************************************************************

	$lastVisitedArr = [];
	if ( count( $visitorProdsVisited ) > 0 && defined( 'HOMEPAGE_LOAD_LAST_VISITED' ) && HOMEPAGE_LOAD_LAST_VISITED == 1 ) {
		$argArray       = [];
		$argString      = prepareArgs4Query( $argArray, array_slice( $visitorProdsVisited, 0, 5 ) );
		$lastVisitedArr = getTableRecArray( "PRODUCT", "ID, TITLE, CATEGORY_ID, FILENAME", [
			"ID IN (" . $argString . ") AND ISVALID='Y'",
			$argArray,
		], "TITLE LIMIT 20" );
	}

//*************************************************************************************************

	// Render template
	renderTemplate( 'index', [
		'prodPOD'        => $prodPOD,
		'prodArr'        => $prodArr,
		'noOfRecords'    => $noOfRecords,
		'catPOP'         => $catPOP,
		'prodPOP'        => $prodPOP,
		'newsArr'        => $newsArr,
		'searchCloudArr' => $searchCloudArr,
		'wishlistArr'    => $wishlistArr,
		'lastVisitedArr' => $lastVisitedArr,
	] );

//*************************************************************************************************

} // cacheGoThrough()

cacheFinalize();

//*************************************************************************************************
