<?php
//*************************************************************************************************

		require ("../path.php");
		require (PATH."include/include.php"); 

//*************************************************************************************************
//
//		To specify IPN url follow these steps:
//
//		1. Login to your googlecheckout account. 
//		2. Click on the settings tab. 
//		3. Then click on the "Integration" link on the left hand
//		4. Enter this file URL in the "API callback URL:" textbox [http://www.your-domain.com/ipn/payment-ipn-google.php]. 
//		4. Click Save. 
//

		$orderNotificationType	= postVar('_type');							// There are few notification types


		$orderStatus			= postVar('financial-order-state');			// The financial-order-state parameter identifies the financial status of an order
																			// REVIEWING - Google Checkout is reviewing the order.
																			// CHARGEABLE - The order is ready to be charged.
																			// CHARGING - The order is being charged; you may not refund or cancel an order until is the charge is completed.
																			// CHARGED - The order has been successfully charged; if the order was only partially charged, the buyer's account page will reflect the partial charge.
																			// PAYMENT_DECLINED - The charge attempt failed.
																			// CANCELLED - Either the buyer or the seller canceled the order. An order's financial state cannot be changed after the order is canceled. Learn more about when an order may be canceled.
																			// CANCELLED_BY_GOOGLE - Google canceled the order. Google may cancel orders due to a failed charge without a replacement credit card being provided within a set period of time or due to a failed risk check. If Google cancels an order, you will be notified of the reason the order was canceled in the reason parameter of an order-state-change-notification.

		$orderStatusFulFill		= postVar('fulfillment-order-state');		// The fulfillment-order-state parameter indicates the status of order.

																			// NEW - The order has been received but not prepared for shipping.
																			// PROCESSING - The order is being prepared for shipping.
																			// DELIVERED - The seller has shipped the order.
																			// WILL_NOT_DELIVER - The seller will not ship the order; this status is used for canceled orders.

		$pcsOrderId				= postVar('shopping-cart_items_item-1_item-description');	// 5000

		$serialNumber			= postVar('serial-number');									// GoogleCheckout serial number
		$referenceNumber		= postVar('google-order-number');							// GoogleCheckout order number

		$orderTotal				= postVar('order-total');									// Amount 11.54
		$orderCurrency			= postVar('order-total.currency');							// USD

		$transactionDate		= date('Y-m-d');											// 08/31/2007 05:08 AM

		$name					= postVar('buyer-billing-address.contact-name');			// John
		$address1				= postVar('buyer-billing-address.address1');				// 6626 W 93rd St
		$address2				= '';														// Address 2
		$city					= postVar('buyer-billing-address.city');					// City
		$state					= postVar('buyer-billing-address.region');					// CA [2 digit code]
		$country				= postVar('buyer-billing-address.country-code');			// US [2 digit code]
		$zipCode				= postVar('buyer-billing-address.postal-code');				// 60453
		$email					= postVar('buyer-billing-address.email');					// testaccount@plimus.com
		$workPhone				= postVar('buyer-billing-address.phone');					// 1-858-350-7473

		$buyerIpAddress			= '';														// 192.168.1.1

//*************************************************************************************************

		// get an print array of POST variable
		$out = '';
		foreach ($_POST as $key => $value) 
			$out .= $key." = ".$value."\n";

//*************************************************************************************************

		$msg = '';

//*************************************************************************************************

		// Save information in database
		if ( $pcsOrderId != '' )
		{
			list($packagePaymentId, $clickPaymentId, $featuredPaymentId, $salesPaymentId, $cartOrderId) = getIdsFromPaymentOrderNo($pcsOrderId);

			// Get notification type
			if ( $orderNotificationType != 'order-state-change-notification' )
			{
				$msg = 'Notification type is not state change ['.$orderNotificationType.']';
			} 
			else 
			{
				// Order Status in this notification type is in field: new-financial-order-state
				$orderStatus = postVar('new-financial-order-state');

				if ( $orderStatus == "CHARGED" )
				{
					$msg = '';

					if ( $packagePaymentId > 0 )
					{
						if ( ($packagePayment = getRecord('PACKAGE_PAYMENT', (int)$packagePaymentId)) )
						{
							if ( $packagePayment['ISVALID'] == 'Y' )
							{
								$newPPId = getNextId("PACKAGE_PAYMENT");
								$ret = tableInsert('PACKAGE_PAYMENT', array(
																				'ID'					=> $newPPId,
																				'MERCHANTID'			=> $packagePayment['MERCHANTID'],
																				'PACKAGE_ID'			=> (int)$packagePayment['PACKAGE_ID'],
																				'PAYMENT_TYPE'			=> (int)$packagePayment['PAYMENT_TYPE'],
																				'PAYMENT_DATETIME'		=> getTimezoneTime(),
																				'AMOUNT'				=> (float)$packagePayment['AMOUNT'],
																				'CLICKTHROUGH_UPFRONT'	=> $packagePayment['CLICKTHROUGH_UPFRONT'],
																				'PRODUCTS_MAXIMUM'		=> $packagePayment['PRODUCTS_MAXIMUM'],
																				'DAYS'					=> $packagePayment['DAYS'],
																				'CREDIT_LIMIT'			=> $packagePayment['CREDIT_LIMIT'],
																				'CLICKS_FREE'			=> $packagePayment['CLICKS_FREE'],
																				'ISTRY'					=> $packagePayment['ISTRY'],
																				'ISHIDDEN'				=> $packagePayment['ISHIDDEN'],
																				'ISACTIVE'				=> 'Y',
																				'ISVALID'				=> 'Y'
																			));
								if ( $ret > 0 )
									approveUserPackagePayment($msg, $newPPId, 'Y');
								else
									$msg = 'Recurring package payment record could not be inserted ['.$packagePaymentId.'].';
							}

							else
								approveUserPackagePayment($msg, $packagePaymentId, 'Y');
						}

						else
							$msg = 'Package Payment Record not found ['.$packagePaymentId.'].';
					}

					if ( $clickPaymentId > 0 )
						approveUserClickthroughPayment($msg, $clickPaymentId, 'Y');

					if ( $featuredPaymentId > 0 )
						approveUserFeaturedPayment($msg, $featuredPaymentId, 'Y');

					if ( $salesPaymentId > 0 )
						ppsApprovePayment($msg, $salesPaymentId, 'Y');

					if ( defined('IS_SHOPPING_CART_INSTALLED') && IS_SHOPPING_CART_INSTALLED == 1 && $cartOrderId > 0 )
						cartOrderPaymentStatusUpdate($msg, $cartOrderId, 'A');
				}
				else
				{
					$msg = 'Order status is not [CHARGED]';
				}
			}
		}
		else 
			$msg = 'OrderId is empty. Cannot verify order.';

//*************************************************************************************************

		header('HTTP/1.0 200 OK');
		echo "_type=notification-acknowledgment&serial-number=".$serialNumber;

//*************************************************************************************************

		sendMail(SCRIPT_WEBMASTER, SCRIPT_WEBMASTER, 'GoogleCheckout# '.$pcsOrderId. ' ['.$orderStatus.']', "Following data was sent from GoogleCheckout in response to payment:\n\n".$out."\n\n[Msg:".$msg."]", 0);

//*************************************************************************************************
?>