<?php
//*************************************************************************************************

		require ("../path.php");
		require (PATH."include/include.php"); 

//*************************************************************************************************

		require_once(PATH.'include/gopay/api/gopay_config.php');
		require_once(PATH.'include/gopay/api/gopay_helper.php');
		require_once(PATH.'include/gopay/api/gopay_soap.php');

		GopayConfig::init(GOPAY_TEST_API ? GopayConfig::TEST : GopayConfig::PROD);

//*************************************************************************************************

		$returnedPaymentSessionId						= getVar('paymentSessionId');
		$returnedGoId									= getVar('eshopGoId');
		$returnedVariableSymbol							= getVar('variableSymbol');
		$returnedEncryptedSignature						= getVar('encryptedSignature');

		if ( $returnedPaymentSessionId == '' )			dieWithStatusEmail('Empty payment session id.');
		if ( $returnedGoId == '' )						dieWithStatusEmail('Empty eshop Go id.');
		if ( $returnedVariableSymbol == '' )			dieWithStatusEmail('Empty order id.');
		if ( $returnedEncryptedSignature == '' )		dieWithStatusEmail('Empty encrypted signature.');

//*************************************************************************************************

		$orderRecFromSessionId							= getRecord('GOPAY_ORDER_SESSION', $returnedPaymentSessionId, 'SESSION_ID');
		$orderIdFromSessionId							= $orderRecFromSessionId['ORDER_ID'];
		$orderIdFromSessionId							= $orderIdFromSessionId == '0' ? '' : $orderIdFromSessionId;

		if ( $orderIdFromSessionId == '' )				dieWithStatusEmail('Order Id cannot be retrieved from session id ['.$returnedPaymentSessionId.'].');

//*************************************************************************************************

		if ( !GopayHelper::checkPaymentIdentity(
													(float)$returnedGoId,
													(float)$returnedPaymentSessionId,
													$returnedVariableSymbol,
													$returnedEncryptedSignature,
													(float)$prefs['GOPAY_ACCOUNT_ID'],
													$orderIdFromSessionId,
													$prefs['GOPAY_SECRET']
												)
		)
			dieWithStatusEmail('Payment Identity check failed ['.$returnedGoId.'] ['.$returnedPaymentSessionId.'] ['.$returnedVariableSymbol.'] ['.$orderIdFromSessionId.']');

//*************************************************************************************************

		$res	= GopaySoap::isEshopPaymentDone(
													(float)$returnedPaymentSessionId,
													(float)$prefs['GOPAY_ACCOUNT_ID'],
													$orderIdFromSessionId,
													(int)$orderRecFromSessionId['AMOUNT'],
													$orderRecFromSessionId['TITLE'],
													$prefs['GOPAY_SECRET']
												);

		$orderStatus	= $res['code'];

//*************************************************************************************************

		if ( $orderStatus == GopayHelper::PAYMENT_DONE )
		{
			// Save information in database
			if ( $orderIdFromSessionId != '' )
			{
				list($packagePaymentId, $clickPaymentId, $featuredPaymentId, $salesPaymentId, $cartOrderId) = getIdsFromPaymentOrderNo($orderIdFromSessionId);

				if ( $packagePaymentId > 0 )
					approveUserPackagePayment($msg, $packagePaymentId, 'Y');

				if ( $clickPaymentId > 0 )
					approveUserClickthroughPayment($msg, $clickPaymentId, 'Y');

				if ( $featuredPaymentId > 0 )
					approveUserFeaturedPayment($msg, $featuredPaymentId, 'Y');

				if ( $salesPaymentId > 0 )
					ppsApprovePayment($msg, $salesPaymentId, 'Y');

				if ( defined('IS_SHOPPING_CART_INSTALLED') && IS_SHOPPING_CART_INSTALLED == 1 && $cartOrderId > 0 )
					cartOrderPaymentStatusUpdate($msg, $cartOrderId, 'A');
			}
			else 
				$msg = 'OrderId is empty. Cannot verify order.';
		}
		elseif ( $orderStatus == GopayHelper::WAITING )
			$msg = 'Payment waiting for approval.';

		elseif ( $orderStatus == GopayHelper::CANCELED )
			$msg = 'Payment cancelled.';

		elseif ( $orderStatus == GopayHelper::TIMEOUTED )
			$msg = 'Payment timed out.';

		else
			$msg = 'Payment failed.';

//*************************************************************************************************
// HELPER FUNCTIONS
//*************************************************************************************************

		function dieWithStatusEmail($msg)
		{
			global $returnedVariableSymbol, $orderStatus;

			sendMail(SCRIPT_WEBMASTER, SCRIPT_WEBMASTER, 'GoPay# '.$returnedVariableSymbol. ' ['.$orderStatus.']', "Following data was sent from GoPay in response to payment:\n\n".$_SERVER['QUERY_STRING']."\n\n[Msg:".$msg."]\n", 0);

			die("Msg - [".$msg."]");
		}

//*************************************************************************************************
?>