<?php
//*************************************************************************************************

		require ("../path.php");
		require (PATH."include/include.php"); 

//***********************************************************************************

		if ( !function_exists('getRecordsFromXMLGeneric') )
			require(PATH.'include/include_search.php');

//*************************************************************************************************
		
		$msg					= '';

		$transId				= getVar('transactionid');
		if ( $transId == '' )
			dieWithStatusEmail('Empty transaction id.');

		$status					= getStatus($msg, $transId);

		die("[$status][$msg]");

		$transactionDate		= date('Y-m-d');					// 08/31/2007 05:08 AM

		$orderTotal				= postVar('amount');
		$pcsOrderId				= postVar('orderId');
		$authNo					= postVar('auth');
		$orderStatus			= postVar('err');
		$signature				= postVar('sign');

		$buyerIpAddress			= '';								// 192.168.1.1
			
//*************************************************************************************************

		$qryStr					= $_SERVER['QUERY_STRING'];

		$checkSign				= payboxVerifySign($qryStr, PATH.'paybox.pubkey.pem');
		if ( $checkSign < 1 )
		{
			$msg	= $checkSign == 0 ? "Signature is invalid" : "Error during signature verification, please check your setup";
		}
		else
		{

//*************************************************************************************************

			// Save information in database
			if ( $pcsOrderId != '' )
			{
				list($packagePaymentId, $clickPaymentId, $featuredPaymentId, $salesPaymentId, $cartOrderId) = getIdsFromPaymentOrderNo($pcsOrderId);

				if ( $orderStatus == '00000' )
				{
					if ( $packagePaymentId > 0 )
						approveUserPackagePayment($msg, $packagePaymentId, "Y");

					if ( $clickPaymentId > 0 )
						approveUserClickthroughPayment($msg, $clickPaymentId, "Y");

					if ( $featuredPaymentId > 0 )
						approveUserFeaturedPayment($msg, $featuredPaymentId, "Y");

					if ( $salesPaymentId > 0 )
						ppsApprovePayment($msg, $salesPaymentId, "Y");

					if ( defined('IS_SHOPPING_CART_INSTALLED') && IS_SHOPPING_CART_INSTALLED == 1 && $cartOrderId > 0 )
						cartOrderPaymentStatusUpdate($msg, $cartOrderId, 'A');
				}

			}
			else 
				$msg = 'OrderId is empty. Cannot verify order.';

//*************************************************************************************************

		} // End If Signature Verification

//*************************************************************************************************
// HELPER FUNCTIONS
//*************************************************************************************************

		function dieWithStatusEmail($msg)
		{
			global $transId, $orderStatus;

			sendMail(SCRIPT_WEBMASTER, SCRIPT_WEBMASTER, 'MultiSafePay# '.$transId. ' ['.$orderStatus.']', "Following data was sent from MultiSafePay in response to payment:\n\n".$_SERVER['QUERY_STRING']."\n\n[Msg:".$msg."]\n", 0);

			die("Msg - [".$msg."]");
		}

//*************************************************************************************************

		function payboxVerifySign($qrystr, $keyfile)
		{
			$key = payboxLoadKey($keyfile);
			if ( !$key )
				return -1;

			$data = $sig = '';
			payboxGetSignedData($qrystr, $data, $sig);

			return openssl_verify($data, $sig, $key);
		}

//*************************************************************************************************

		function payboxLoadKey($keyfile)
		{
			$fp = $filedata = $key = false;

			$fsize = filesize($keyfile);
			if ( !$fsize )
				return false;

			$fp = fopen($keyfile, 'r');
			if ( !$fp )
				return false;

			$filedata = fread($fp, $fsize);
			fclose($fp);
			if ( !$filedata )
				return false;

			return openssl_pkey_get_public($filedata);
		}

//*************************************************************************************************

		function payboxGetSignedData($qrystr, &$data, &$sig)
		{
			$pos	= strrpos($qrystr, '&');
			$data	= substr($qrystr, 0, $pos);
			$pos	= strpos($qrystr, '=', $pos) + 1;
			$sig	= substr($qrystr, $pos);
			$sig	= urldecode($sig);
			$sig	= base64_decode($sig);
		}

//*************************************************************************************************

		function getStatus(&$msg, $transId)
		{
			global $prefs;

			$request = '<?xml version="1.0" encoding="UTF-8"?>
						<status ua="KConnect 1.0">
							<merchant>
								<account>' .          $prefs['MULTISAFEPAY_ACCOUNT_ID'] . '</account>
								<site_id>' .          $prefs['MULTISAFEPAY_SITE_ID'] . '</site_id>
								<site_secure_code>' . $prefs['MULTISAFEPAY_SITE_CODE'] . '</site_secure_code>
							</merchant>
							<transaction>
								<id>' .               $transId . '</id>
							</transaction>
						</status>
						';

			$header = array();
			$header[] = "Content-Type: text/xml";
			$header[] = "Connection: close";

			$ch = curl_init(MULTISAFEPAY_BASE_URL);

			curl_setopt($ch, CURLOPT_POST,           true);
			curl_setopt($ch, CURLOPT_HTTPHEADER,     $header);
			curl_setopt($ch, CURLOPT_POSTFIELDS,     $request);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_TIMEOUT,        30);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, false);
			curl_setopt($ch, CURLOPT_MAXREDIRS,      5);
			curl_setopt($ch, CURLOPT_HEADER,         true);

			// Set certificates for ssl if set
			if ( defined( 'SSL_CERTIFICATE_PATH' ) && SSL_CERTIFICATE_PATH != '' ) {
				curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, 0 );
				curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, 1 );
				curl_setopt( $ch, CURLOPT_CAINFO, SSL_CERTIFICATE_PATH );
				curl_setopt( $ch, CURLOPT_CAPATH, SSL_CERTIFICATE_PATH );
			}

			$data = curl_exec($ch);

			if ( curl_errno($ch) )
			{
				$msg = "CURL error: " . curl_errno($ch);
				return '';
			}

			curl_close($ch);

			$xml	= substr($data, strpos($data, '<?xml'));

			$res	= getRecordsFromXMLGeneric($xml, 'MSP', '', 0);

			appendToFile('upload/logs/multisafepay-ipn.txt', getTimezoneTime()."] \n\n".print_r($res, 1)."\n\n");
			die;

			if ( !isset($res['STATUS'][0]) )
			{
				$msg = 'Invalid status xml returned.';
				return '';
			}

			$res = $res['STATUS'][0];

			if ( !isset($res['__ATTRIBUTES']['RESULT']) )
			{
				$msg = 'Status result not set.';
				return '';
			}

			if ( $res['__ATTRIBUTES']['RESULT'] == 'error'  )
			{
				$msg = 'Error: Code - '.(isset($res['ERROR'][0]['CODE'][0])?$res['ERROR'][0]['CODE'][0]:'n/a').', Msg - '.(isset($res['ERROR'][0]['DESCRIPTION'][0])?$res['ERROR'][0]['DESCRIPTION'][0]:'n/a');
				return '';
			}

			print_r($res);die();

			return $reply_xml;
		}

//*************************************************************************************************
?>