<?php
//*************************************************************************************************

		require ("../path.php");
		require (PATH."include/include.php"); 

//*************************************************************************************************
		
		$msg					= '';

		$transactionDate		= date('Y-m-d');					// 08/31/2007 05:08 AM

		$orderTotal				= postVar('amount');
		$pcsOrderId				= postVar('orderId');
		$authNo					= postVar('auth');
		$transNo				= postVar('trans');
		$orderStatus			= postVar('err');
		$signature				= postVar('sign');

		$buyerIpAddress			= '';								// 192.168.1.1
			
//*************************************************************************************************

		$qryStr					= $_SERVER['QUERY_STRING'];

		$checkSign				= payboxVerifySign($qryStr, PATH.'paybox.pubkey.pem');
		if ( $checkSign < 1 )
		{
			$msg	= $checkSign == 0 ? "Signature is invalid" : "Error during signature verification, please check your setup";
		}
		else
		{

//*************************************************************************************************

			// Save information in database
			if ( $pcsOrderId != '' )
			{
				list($packagePaymentId, $clickPaymentId, $featuredPaymentId, $salesPaymentId, $cartOrderId) = getIdsFromPaymentOrderNo($pcsOrderId);

				if ( $orderStatus == '00000' )
				{
					if ( $packagePaymentId > 0 )
						approveUserPackagePayment($msg, $packagePaymentId, "Y");

					if ( $clickPaymentId > 0 )
						approveUserClickthroughPayment($msg, $clickPaymentId, "Y");

					if ( $featuredPaymentId > 0 )
						approveUserFeaturedPayment($msg, $featuredPaymentId, "Y");

					if ( $salesPaymentId > 0 )
						ppsApprovePayment($msg, $salesPaymentId, "Y");

					if ( defined('IS_SHOPPING_CART_INSTALLED') && IS_SHOPPING_CART_INSTALLED == 1 && $cartOrderId > 0 )
						cartOrderPaymentStatusUpdate($msg, $cartOrderId, 'A');
				}

			}
			else 
				$msg = 'OrderId is empty. Cannot verify order.';

//*************************************************************************************************

		} // End If Signature Verification

//*************************************************************************************************

		sendMail(SCRIPT_WEBMASTER, SCRIPT_WEBMASTER, 'Paybox# '.$pcsOrderId. ' ['.$orderStatus.']', "Following data was sent from PAYBOX in response to payment:\n\n".$qryStr."\n\n[Msg:".$msg."]\n", 0);

//*************************************************************************************************
// HELPER FUNCTIONS
//*************************************************************************************************

		function payboxVerifySign($qrystr, $keyfile)
		{
			$key = payboxLoadKey($keyfile);
			if ( !$key )
				return -1;

			$data = $sig = '';
			payboxGetSignedData($qrystr, $data, $sig);

			return openssl_verify($data, $sig, $key);
		}

//*************************************************************************************************

		function payboxLoadKey($keyfile)
		{
			$fp = $filedata = $key = false;

			$fsize = filesize($keyfile);
			if ( !$fsize )
				return false;

			$fp = fopen($keyfile, 'r');
			if ( !$fp )
				return false;

			$filedata = fread($fp, $fsize);
			fclose($fp);
			if ( !$filedata )
				return false;

			return openssl_pkey_get_public($filedata);
		}

//*************************************************************************************************

		function payboxGetSignedData($qrystr, &$data, &$sig)
		{
			$pos	= strrpos($qrystr, '&');
			$data	= substr($qrystr, 0, $pos);
			$pos	= strpos($qrystr, '=', $pos) + 1;
			$sig	= substr($qrystr, $pos);
			$sig	= urldecode($sig);
			$sig	= base64_decode($sig);
		}

//*************************************************************************************************
?>