<?php
//*************************************************************************************************

		require ("../path.php");
		require (PATH."include/include.php"); 

//*************************************************************************************************

		// Notify PayFast that information has been received
		header( 'HTTP/1.0 200 OK' );
		flush();

//*************************************************************************************************

		// Variable initialization
		$pfError		= false;
		$pfErrMsg		= '';
		$pfData			= array();
		$output			= '';
		$pfParamString	= '';
		$pfHost			= PAYFAST_TEST_API ? 'www.payfast.co.za' : 'sandbox.payfast.co.za';
		 
		// Dump the submitted variables and calculate security signature
		if( !$pfError )
		{
			$output = "Posted Variables:\n\n";
		 
			// Strip any slashes in data
			foreach( $_POST as $key => $val )
				$pfData[$key] = stripslashes( $val );
		 
			// Dump the submitted variables and calculate security signature
			foreach( $pfData as $key => $val )
			{
			   if( $key != 'signature' )
				 $pfParamString .= $key .'='. urlencode( $val ) .'&';
			}
		 
			// Remove the last '&' from the parameter string
			$pfParamString = substr( $pfParamString, 0, -1 );
			$signature = md5( $pfParamString );
		 
			$result = ( $_POST['signature'] == $signature );
		 
			$output .= "Security Signature:\n\n";
			$output .= "- posted     = ". $_POST['signature'] ."\n";
			$output .= "- calculated = ". $signature ."\n";
			$output .= "- result     = ". ( $result ? 'SUCCESS' : 'FAILURE' ) ."\n";
		}
		 
		//// Verify source IP
		if ( !$pfError )
		{
			$validHosts = array('www.payfast.co.za', 'sandbox.payfast.co.za', 'w1w.payfast.co.za', 'w2w.payfast.co.za');
			$validIps = array();
			foreach ( $validHosts as $pfHostname )
			{
				$ips = gethostbynamel( $pfHostname );
				if ( $ips !== false )
					$validIps = array_merge( $validIps, $ips );
			}

			// Remove duplicates
			$validIps = array_unique( $validIps );
		 
			if ( !in_array( $_SERVER['REMOTE_ADDR'], $validIps ) )
			{
				$pfError = true;
				$pfErrMsg = 'Bad source IP address';
			}
		}
		 
		// Connect to server to validate data received
		if( !$pfError )
		{
			// Use cURL (If it's available)
			if ( function_exists( 'curl_init' ) )
			{
				$output .= "\n\nUsing cURL\n\n";
		 
				// Create default cURL object
				$ch = curl_init();
		 
				// Base settings
				$curlOpts = array(
					// Base options
					CURLOPT_USERAGENT => 'Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)', // Set user agent
					CURLOPT_RETURNTRANSFER => true,  // Return output as string rather than outputting it
					CURLOPT_HEADER => false,         // Don't include header in output
					CURLOPT_SSL_VERIFYHOST => true,
					CURLOPT_SSL_VERIFYPEER => false,
		 
					// Standard settings
					CURLOPT_URL => 'https://'. $pfHost . '/eng/query/validate',
					CURLOPT_POST => true,
					CURLOPT_POSTFIELDS => $pfParamString,
				);
				curl_setopt_array( $ch, $curlOpts );

				// Set certificates for ssl if set
				if ( defined( 'SSL_CERTIFICATE_PATH' ) && SSL_CERTIFICATE_PATH != '' ) {
					curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, 0 );
					curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, 1 );
					curl_setopt( $ch, CURLOPT_CAINFO, SSL_CERTIFICATE_PATH );
					curl_setopt( $ch, CURLOPT_CAPATH, SSL_CERTIFICATE_PATH );
				}

				// Execute CURL
				$res = curl_exec( $ch );
				curl_close( $ch );

				if ( $res === false )
				{
					$pfError = true;
					$pfErrMsg = 'An error occurred executing cURL';
				}
			}

			// Use fsockopen
			else
			{
				$output .= "\n\nUsing fsockopen\n\n";
		 
				// Construct Header
				$header = "POST /eng/query/validate HTTP/1.0\r\n";
				$header .= "Host: ". $pfHost ."\r\n";
				$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
				$header .= "Content-Length: " . strlen( $pfParamString ) . "\r\n\r\n";
		 
				// Connect to server
				$socket = fsockopen( 'ssl://'. $pfHost, 443, $errno, $errstr, 10 );
		 
				// Send command to server
				fputs( $socket, $header . $pfParamString );
		 
				// Read the response from the server
				$res = '';
				$headerDone = false;
		 
				while ( !feof( $socket ) )
				{
					$line = fgets( $socket, 1024 );
		 
					// Check if we are finished reading the header yet
					if( strcmp( $line, "\r\n" ) == 0 )
					{
						// read the header
						$headerDone = true;
					}
					// If header has been processed
					else if( $headerDone )
					{
						// Read the main response
						$res .= $line;
					}
				}
			}
		}
		 
		// Get data from server
		if( !$pfError )
		{
			// Parse the returned data
			$lines = explode( "\n", $res );
		 
			$output .= "\n\nValidate response from server:\n\n";
		 
			foreach( $lines as $line )
				$output .= $line ."\n";
		}
		 
		// Interpret the response from server
		if( !$pfError )
		{
			// Get the response from PayFast (VALID or INVALID)
			$result = trim( $lines[0] );
		 
			$output .= "\nResult = ". $result;
		 
			// If the transaction was valid
			if ( strcmp( $result, 'VALID' ) == 0 )
			{
				$msg		= '';
				$status		= $pfData['payment_status'];
				$pcsOrderId	= $pfData['pf_payment_id'];

				if ( $status == 'COMPLETE' && $pcsOrderId != '' )
				{
					list($packagePaymentId, $clickPaymentId, $featuredPaymentId, $salesPaymentId, $cartOrderId) = getIdsFromPaymentOrderNo($pcsOrderId);

					if ( $packagePaymentId > 0 )
					{
						if ( ($packagePayment = getRecord('PACKAGE_PAYMENT', (int)$packagePaymentId)) )
						{
							if ( $packagePayment['ISVALID'] == 'Y' )
							{
								$newPPId = getNextId('PACKAGE_PAYMENT');
								$ret = tableInsert('PACKAGE_PAYMENT', array(
																				'ID'					=> $newPPId,
																				'MERCHANTID'			=> $packagePayment['MERCHANTID'],
																				'PACKAGE_ID'			=> (int)$packagePayment['PACKAGE_ID'],
																				'PAYMENT_TYPE'			=> (int)$packagePayment['PAYMENT_TYPE'],
																				'PAYMENT_DATETIME'		=> getTimezoneTime(),
																				'AMOUNT'				=> (float)$packagePayment['AMOUNT'],
																				'CLICKTHROUGH_UPFRONT'	=> $packagePayment['CLICKTHROUGH_UPFRONT'],
																				'PRODUCTS_MAXIMUM'		=> $packagePayment['PRODUCTS_MAXIMUM'],
																				'DAYS'					=> $packagePayment['DAYS'],
																				'CREDIT_LIMIT'			=> $packagePayment['CREDIT_LIMIT'],
																				'CLICKS_FREE'			=> $packagePayment['CLICKS_FREE'],
																				'ISTRY'					=> $packagePayment['ISTRY'],
																				'ISHIDDEN'				=> $packagePayment['ISHIDDEN'],
																				'ISACTIVE'				=> 'Y',
																				'ISVALID'				=> 'Y'
																			));
								if ( $ret > 0 )
									approveUserPackagePayment($msg, $newPPId, 'Y');
								else
									$msg = 'Recurring package payment record could not be inserted ['.$packagePaymentId.'].';
							}

							else
								approveUserPackagePayment($msg, $packagePaymentId, 'Y');
						}

						else
							$msg = 'Package Payment Record not found ['.$packagePaymentId.'].';
					}

					if ( $clickPaymentId > 0 )
						approveUserClickthroughPayment($msg, $clickPaymentId, 'Y');

					if ( $featuredPaymentId > 0 )
						approveUserFeaturedPayment($msg, $featuredPaymentId, 'Y');

					if ( $salesPaymentId > 0 )
						ppsApprovePayment($msg, $salesPaymentId, 'Y');

					if ( defined('IS_SHOPPING_CART_INSTALLED') && IS_SHOPPING_CART_INSTALLED == 1 && $cartOrderId > 0 )
						cartOrderPaymentStatusUpdate($msg, $cartOrderId, 'A');
				}

				$output .= "\nMsg = " . $msg;
			}

			// If the transaction was NOT valid
			else
			{
				// Log for investigation
				$pfError = true;
				$pfErrMsg = 'The data received is invalid';
			}
		}
		 
		// If an error occurred
		if( $pfError )
		{
			$output .= "\n\nAn error occurred!";
			$output .= "\nError = ". $pfErrMsg;
		}
		 
//*************************************************************************************************

		sendMail(SCRIPT_WEBMASTER, SCRIPT_WEBMASTER, 'PayFast IPN', $output, 0);

//*************************************************************************************************
?>