<?php
//*************************************************************************************************

		require ("../path.php");
		require (PATH."include/include.php"); 

//*************************************************************************************************

		// read the post from PayPal system and add 'cmd'
		$req = 'cmd=_notify-validate';
		$out = '';

		foreach ($_POST as $key => $value) 
		{
			$out .= $key." = ".$value."\n";
			$value = urlencode(stripslashes($value));
			$req .= "&$key=$value";
		}

		// post back to PayPal system to validate
		$header .= "POST /cgi-bin/webscr HTTP/1.0\r\n";
		$header .= "Host: www.paypal.com:80\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
		$fp = fsockopen ('www.paypal.com', 80, $errno, $errstr, 30);

//*************************************************************************************************
		
		// assign posted variables to local variables
		$transactionDate		= date('Y-m-d');					// 08/31/2007 05:08 AM

		$pcsOrderId				= postVar('item_number');
		$referenceNumber		= postVar('txn_id');

		$orderStatus			= postVar('payment_status');
		$paymentType			= postVar('payment_type');
		$orderTotal				= postVar('mc_gross');
		$orderCurrency			= postVar('mc_currency');

		$receiver_email			= postVar('receiver_email');

		
		$firstname				= postVar('first_name');			// John
		$lastname				= postVar('last_name');				// Doe
		$country				= postVar('residence_country');		// US [2 digit code]
		$email					= postVar('payer_email');			// testaccount@paypal.com

		$buyerIpAddress			= '';								// 192.168.1.1
		
		$msg				= '';

//*************************************************************************************************

		if ( $receiver_email == $prefs['PAYPAL_EMAIL'] )
		{
			// Save information in database
			if ( $pcsOrderId != '' )
			{
				list($packagePaymentId, $clickPaymentId, $featuredPaymentId, $salesPaymentId, $cartOrderId) = getIdsFromPaymentOrderNo($pcsOrderId);

				// Verify With Paypal and update Status (if required)
				if (!$fp) 
				{
					// HTTP ERROR
					$msg = 'Connection to paypal server failed for verification';
				} 
				else 
				{
					fputs ($fp, $header . $req);
					while (!feof($fp))
					{
						$res = fgets ($fp, 1024);
						if (strcmp ($res, "VERIFIED") == 0) 
						{
							// This order is processed and completed.
							$arrInvalidStatus = array('Denied', 'Expired', 'Failed', 'Voided');
//							if ( !in_array($orderStatus, $arrInvalidStatus) )
							if ( $orderStatus == 'Completed' ) // 5/25/2015: Only act if order status is completed, otherwise we endup having many payment records in db
							{
								if ( $pcsOrderId != '' )
								{
									$msg = "";

									if ( $packagePaymentId > 0 )
									{
										if ( ($packagePayment = getRecord('PACKAGE_PAYMENT', (int)$packagePaymentId)) )
										{
											if ( $packagePayment['ISVALID'] == 'Y' )
											{
												$lastPaymentDate	= $packagePayment['PAYMENT_DATETIME'];
												$packageDays		= (int)getColumn('PACKAGE', $packagePayment['PAYMENT_ID'], 'DAYS');
												$packageDays		= $packageDays < 1 ? 1 : $packageDays;

												// Check if enough days elapsed to last successfull payment, then it means its next recurring payment
												if ( addDays($lastPaymentDate, $packageDays-3) < getTimezoneTime('Y-m-d') )
												{
													$newPPId = getNextId("PACKAGE_PAYMENT");
													$ret = tableInsert('PACKAGE_PAYMENT', array(
																									'ID'					=> $newPPId,
																									'MERCHANTID'			=> $packagePayment['MERCHANTID'],
																									'PACKAGE_ID'			=> (int)$packagePayment['PACKAGE_ID'],
																									'PAYMENT_TYPE'			=> (int)$packagePayment['PAYMENT_TYPE'],
																									'PAYMENT_DATETIME'		=> getTimezoneTime(),
																									'AMOUNT'				=> (float)$packagePayment['AMOUNT'],
																									'CLICKTHROUGH_UPFRONT'	=> $packagePayment['CLICKTHROUGH_UPFRONT'],
																									'PRODUCTS_MAXIMUM'		=> $packagePayment['PRODUCTS_MAXIMUM'],
																									'DAYS'					=> $packagePayment['DAYS'],
																									'CREDIT_LIMIT'			=> $packagePayment['CREDIT_LIMIT'],
																									'CLICKS_FREE'			=> $packagePayment['CLICKS_FREE'],
																									'ISTRY'					=> $packagePayment['ISTRY'],
																									'ISHIDDEN'				=> $packagePayment['ISHIDDEN'],
																									'ISACTIVE'				=> 'Y',
																									'ISVALID'				=> 'Y'
																								));
													if ( $ret > 0 )
														approveUserPackagePayment($msg, $newPPId, 'Y');
													else
														$msg = 'Recurring package payment record could not be inserted ['.$packagePaymentId.'].';
												}
												else
													$msg = 'Payment already active till: '.formatDate(addDays($lastPaymentDate, $packageDays)).' ['.$packagePaymentId.'].';
											}
											else
												approveUserPackagePayment($msg, $packagePaymentId, 'Y');
										}

										else
											$msg = 'Package Payment Record not found ['.$packagePaymentId.'].';
									}

									if ( $clickPaymentId > 0 )
										approveUserClickthroughPayment($msg, $clickPaymentId, 'Y');

									if ( $featuredPaymentId > 0 )
										approveUserFeaturedPayment($msg, $featuredPaymentId, 'Y');

									if ( $salesPaymentId > 0 )
										ppsApprovePayment($msg, $salesPaymentId, 'Y');

									if ( defined('IS_SHOPPING_CART_INSTALLED') && IS_SHOPPING_CART_INSTALLED == 1 && $cartOrderId > 0 )
										cartOrderPaymentStatusUpdate($msg, $cartOrderId, 'A');
								}
								else 
									$msg = 'OrderId is empty. Cannot automatically approve order';
							}
							
							// Get out of this loop
							break;						
						}
						else if (strcmp ($res, "INVALID") == 0)
						{
							$msg = 'Paypal did not confirm the order when posted back for verification';
						}
					}
					fclose ($fp);
				}
			}
			else 
				$msg = 'OrderId is empty. Cannot verify order.';
		}
		else 
		{
			$msg = 'Paypal receiver email did not match with the paypal owner email [O:'.$prefs['PAYPAL_EMAIL'].'][R:'.$receiver_email.'].';
		}

//*************************************************************************************************

		sendMail(SCRIPT_WEBMASTER, SCRIPT_WEBMASTER, 'Paypal# '.$pcsOrderId. ' ['.$orderStatus.']', "Following data was sent from PAYPAL in response to payment:\n\n".$out."\n\n[Msg:".$msg."]\n\nPostBack response: ".$res."\n", 0);

//*************************************************************************************************
?>