<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

require("path.php");
require(PATH . "include/include.php");

//*************************************************************************************************

$langFilename2 = 'final_category.php';
include(PATH . "member_session.php");

//*************************************************************************************************

$name = getVar('name', '', '', array('maxlen' => 100));

//*************************************************************************************************

// Render template
renderTemplate('member_productlist', [
    'memberPageHeading' => VIEW_SAVED_PRODUCT_LIST,
    'name' => $name,
]);

//*************************************************************************************************

function getUserProductLink($productId, $storeCount, $pLink, $showStore = 1)
{
    global $langFolder;

    $productId = (int)$productId;

    if (IS_BUDGETLIST_INSTALLED == 1) {
        ?>
        <button class="btn btn-xs btn-dark2"
                onclick="addToBudgetList(<?php echo $productId; ?>);"><?php echo BUDGET_LIST; ?></button>
        <br><br>
        <?php
    }

    if (REDIRECT_ON_ONE_STORE != 1 || $storeCount != 1) {
        ?>
        <a href="<?php echo $pLink; ?>" class="link">
            <button class="btn btn-dark2"><?php echo COMPARE; ?></button>
        </a><br>
        <font style="font-size:10px; color:#4C4C4C;"><?php echo PRICES_FROM . $storeCount . ' ' . STORES; ?></font>
        <?php
    } else {
        if ($productId > 0) {
            ?>
            <a href="<?php echo getSeoUrl('redirect', 'prod_id=' . $productId . '&amp;isBuy=Y&amp;isProduct=Y'); ?>"
               class="link" target="_blank">
                <button class="btn btn-sm btn-dark2"><?php echo GO_TO_STORE; ?></button>
            </a>
            <?php
        }
    }

    if ($showStore == 1 && $storeCount > 0 && $storeCount <= 2) {
        $count = 0;
        $res = preparedQuery("SELECT USERID FROM " . PREFIX . "USER_PRODUCT WHERE PRODUCT_ID = ? AND ISVALID='Y'", array($productId));
        while (($row = getRow($res))) {
            if (!file_exists(PATH . "upload/merchant/" . $row['USERID'] . ".jpg"))
                continue;

            if ($count++ >= 2)
                break;
            ?>
            <div style="height:5px;"></div>
            <img src="<?php echo getMerchantLogoThumbUrl($row['USERID'], 80, 25); ?>" border="0"
                 alt="<?php echo $row['USERID']; ?>" title="<?php echo $row['USERID']; ?>">
            <?php
        }
    }

} // getUserProductLink()

//*************************************************************************************************
