<?php 
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

		require ("path.php");
		require (PATH."include/include.php"); 

//*************************************************************************************************
//		AIM (Advanced Integration Method) PHP Script For Authorize.net 
//*************************************************************************************************

		$merchantId			= postVar('merchantId');
		$amount				= postVar('amount', 'float');

		$ccFirstname		= postVar('ccFirstname');
		$ccLastname			= postVar('ccLastname');
		$ccAddress			= postVar('ccAddress');
		$ccCity				= postVar('ccCity');
		$ccState			= postVar('ccState');
		$ccCountry			= postVar('ccCountry');
		$ccZip				= postVar('ccZip');
		$ccEmail			= postVar('ccEmail');
		
		$packagePaymentId	= postVar('packagePaymentId', 'int');
		$clickPaymentId		= postVar('clickPaymentId', 'int');
		
		if ( $packagePaymentId > 0 )
			$ccDetail		= "Payment for PackageID : ".$packagePaymentId;
		else
			$ccDetail		= "Payment for ClickID : ".$clickPaymentId;
		
		$ccCardnum			= postVar('ccCardnum');
		$ccCardexpiryM		= postVar('ccValiduptoMonth', '[^0-9]', '', array('maxlen'=>2));
		$ccCardexpiryY		= postVar('ccValiduptoYear', '[^0-9]', '', array('maxlen'=>4));
		$ccCardexpiry		= $ccCardexpiryM.$ccCardexpiryY;
		$ccCardcode			= postVar('ccCardcode');

		// Save the settings in db
		$resCC = preparedQuery("SELECT ID FROM ".PREFIX."USER_CREDITCARD WHERE USERID = ? AND CARD_NO = ?", array($merchantId, $ccCardnum));
		if ( ($rowCC = getRow($resCC)) )
		{
			tableUpdate('USER_CREDITCARD', $rowCC['ID'], array(
																	'FIRST_NAME'		=> $ccFirstname,
																	'LAST_NAME'			=> $ccLastname,
																	'ADDRESS'			=> $ccAddress,
																	'CITY'				=> $ccCity,
																	'STATE'				=> $ccState,
																	'COUNTRY'			=> $ccCountry,
																	'ZIP'				=> $ccZip,
																	'EMAIL'				=> $ccEmail,
																	'VALID_UPTO_MONTH'	=> $ccCardexpiryM,
																	'VALID_UPTO_YEAR'	=> $ccCardexpiryY,
																	'CVV_CODE'			=> $ccCardcode
																));
		}
		else
		{
			tableInsert('USER_CREDITCARD', array(
													'ID'				=> getNextId('USER_CREDITCARD'),
													'USERID'			=> $merchantId,
													'FIRST_NAME'		=> $ccFirstname,
													'LAST_NAME'			=> $ccLastname,
													'ADDRESS'			=> $ccAddress,
													'CITY'				=> $ccCity,
													'STATE'				=> $ccState,
													'COUNTRY'			=> $ccCountry,
													'ZIP'				=> $ccZip,
													'EMAIL'				=> $ccEmail,
													'CARD_TYPE'			=> '',
													'CARD_NO'			=> $ccCardnum,
													'VALID_UPTO_MONTH'	=> $ccCardexpiryM,
													'VALID_UPTO_YEAR'	=> $ccCardexpiryY,
													'CVV_CODE'			=> $ccCardcode
												));
		}

//*************************************************************************************************

		$details = authorizeProcessPayment($msg, $merchantId, $packagePaymentId, $amount, $ccCardnum, $ccCardexpiry, $ccCardcode, $ccDetail, $ccFirstname, $ccLastname, $ccAddress, $ccCity, $ccState, $ccCountry, $ccZip, $ccEmail);

		if ( $details == 0 )
		{
			echo $msg;
			die;
		}

//*************************************************************************************************

		// Payment successful
		if ( $details[0] == '1' )
		{
			$msg1 = '';
			if ( $packagePaymentId > 0 )
				approveUserPackagePayment($msg1, $packagePaymentId, 'Y');

			$msg2 = '';
			if ( $clickPaymentId > 0 )
				approveUserClickthroughPayment($msg2, $clickPaymentId, 'Y');	
		}

//*************************************************************************************************

		echo " 
			<html>
				<head>
					<title>Please wait....</title>
				</head>

				<body onLoad=\"frmRedirect();\">
					<center>

						<form name='F' action='authorize_result.php' method='GET'>
							<input type='hidden' name='isApproved'			value='$details[0]'>
							<input type='hidden' name='results'				value='$details[3]'>

							<input type='hidden' name='packagePaymentId'	value='$packagePaymentId'>
							<input type='hidden' name='clickPaymentId'		value='$clickPaymentId'>

							<input type='hidden' name='amount'				value='$amount'>
							<input type='hidden' name='amountEx'			value='$details[9]'>
							<input type='hidden' name='merchantId'			value='$merchantId'>

							<input type='hidden' name='firstname'			value='$ccFirstname'>
							<input type='hidden' name='lastname'			value='$ccLastname'>
							<input type='hidden' name='ccNum'				value='"."**** **** **** ".substr($ccCardnum, -4)."'>
							<input type='hidden' name='ccExpiry'			value='$ccCardexpiry'>
							<input type='hidden' name='authCode'			value='$details[4]'>
							
							<input type='submit' name='btnSubmit'			value='Continue->' style='font-family:verdana'><br>
							
							<font size='1' face='Verdana'>Click button if not redirected in 5 seconds</font>
						</form>	
						
						<script>
							function frmRedirect()
							{
								setTimeout(\"document.F.submit();\", 5000);
							}
						</script>

					</center>

				</body>
				
			</html>";

		echo "<!-- \n";
		print_r($details);
		echo " \n-->";

//*************************************************************************************************
?>