<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

require("path.php");
require(PATH . "include/include.php");
require(PATH . 'include/include_RSA.php');

//*************************************************************************************************

include(PATH . "session.php");

//*************************************************************************************************

// Skip user valid redirection if making payment
$doUserValidRedirect = postVar('task') == 'Package' ? 'N' : 'Y';
$allowVisitorSeller2Page = in_array(postVar('task'), array('UserProduct', 'Payment')) ? 1 : 0;
include("merchant_session.php");

//*************************************************************************************************				

$task = postVar('task');
$action = postVar('action');
$return = postVar('return', 'urlpart');
$isAjax = postVar('isAjax');

//*************************************************************************************************

require(PATH . "include/security_check.php");

//*************************************************************************************************				
//			MERCHANT PASSWORD
//*************************************************************************************************
if ($task == "ChangePassword") {

    $oldPassword = postVar('oldPassword', PWD_ALLOWED_CHARS, '', array('maxlen' => MAX_CHARS_PWD));
    $newPassword = postVar('newPassword', PWD_ALLOWED_CHARS, '', array('maxlen' => MAX_CHARS_PWD));
    $confirmPassword = postVar('confirmPassword', PWD_ALLOWED_CHARS, '', array('maxlen' => MAX_CHARS_PWD));


    if ($oldPassword == "" || $newPassword == "" || $confirmPassword == "") {
        header("Location: " . $return . "info=1");
    }


    if ($action == "Update") {
        if ($newPassword == $confirmPassword) {
            $result = preparedQuery("SELECT PASSWORD FROM " . PREFIX . "USER WHERE USERID = ?", array($merchantId));

            if (($rows = getRow($result))) {
                if (passwordVerify($oldPassword, $rows['PASSWORD'])) {
                    $res = tableUpdate('USER', $merchantId, array('PASSWORD' => passwordHash($newPassword)), 'USERID');
                    if ($res > 0)
                        header("Location: " . $return . "info=3");
                } else
                    header("Location: " . $return . "info=8");
            } else
                header("Location: " . $return . "info=7");
        } else
            header("Location: " . $return . "info=9");
    }
}

//*************************************************************************************************
//			USER TAX RATE
//*************************************************************************************************
elseif ($task == "UserTax") {
    if ($action == "Update") {
        preparedUpdate("DELETE FROM " . PREFIX . "USER_TAX WHERE USERID = ?", array($merchantId));
        $res = executeQuery("SELECT CODE FROM " . PREFIX . "STATE ORDER BY NAME");
        while (($row = getRow($res))) {
            $rate = postVar('tax_' . $row['CODE'], 'float');
            tableInsert('USER_TAX', array('USERID' => $merchantId, 'STATE' => $row['CODE'], 'TAX' => $rate));
        }

        header("Location: " . $return . "info=3");
        die;
    }
}

//*************************************************************************************************
//			CSV UPLOAD
//*************************************************************************************************
elseif ($task == "UserCSVUpload") {
    if ($action == "UserCSVUpload") {
        if (trim($_FILES["csv"]["name"]) != "") {
            $fileName = "upload/csvfiles/" . $merchantId . ".csv";
            $filePath = PATH . $fileName;

            $msg = '';
            if (isRedUpload($msg, $_FILES["csv"], $fileName)) {
                header("Location: " . $return . "info=" . urlencode($msg));
                die;
            }

            if (copyFile($_FILES["csv"]["tmp_name"], $filePath))
                header("Location: merchant_user_product_import_csv_prompt.php?info=10");
            else
                header("Location: " . $return . "info=6");
        }
        die;
    }
}

//*************************************************************************************************
//			XML UPLOAD
//*************************************************************************************************
elseif ($task == "UserXMLUpload") {
    if ($action == "UserXMLUpload") {
        if (trim($_FILES["xml"]["name"]) != "") {
            $fileName = "upload/xmlfiles/" . $merchantId . ".xml";
            $filePath = PATH . $fileName;

            $msg = '';
            if (isRedUpload($msg, $_FILES["xml"], $fileName)) {
                header("Location: " . $return . "info=" . urlencode($msg));
                die;
            }

            if (copyFile($_FILES["xml"]["tmp_name"], $filePath))
                header("Location: " . $return . "info=10&name=" . $_FILES["xml"]["name"]);
            else
                header("Location: " . $return . "info=6");
        }
        die;
    }
}

//*************************************************************************************************
//			MERCHANT
//*************************************************************************************************
elseif ($task == "Merchant") {
    if ($action == "Profile") {
        $name = postVar('name');
        $personName = postVar('personName');
        $address = postVar('address');
        $city = postVar('city');
        $state = postVar('state');
        $country = postVar('country');
        $zip = postVar('zip');
        $phone = postVar('phone');
        $mobile = postVar('mobile');
        $email = postVar('email');
        $url = postVar('url', 'urlpart');
        $profile = postVar('profile', '', '', array('maxlen' => 255));
        $shortDescription = postVar('shortDescription', '', '', array('maxlen' => 255));
        $deliveryCosts = postVar('deliveryCosts');
        $shippingDetails = postVar('shippingDetails');
        $paymentMethods = postVar('paymentMethods', '', array(), array('array' => 1));
        $verifiers = postVar('verifiers', '', array(), array('array' => 1));
        $languages = postVar('languages', '', array(), array('array' => 1));
        $userField1 = postVar('userField1');
        $monthlyBudget = postVar('monthlyBudget', 'float');
        $spider_products = $_POST['spider_products'] == 'Y' ? 'Y' : 'N';

        if (trim($name) == '' || trim($email) == '' || trim($url) == '') {
            header("Location: " . $return . "info=1");
            die;
        }

        $ret = tableUpdate('USERINFO', $merchantId, array(
            'NAME' => $name,
            'PERSON_NAME' => $personName,
            'ADDRESS' => $address,
            'CITY' => $city,
            'STATE' => $state,
            'COUNTRY' => $country,
            'ZIP' => $zip,
            'PHONE' => $phone,
            'MOBILE' => $mobile,
            'EMAIL' => $email,
            'URL' => $url,
            'SPIDER_PRODUCTS' => $spider_products
        ), 'USERID');
        if ($ret > 0) {
            $arrVals = array();
            if (IS_BUDGETLIST_INSTALLED == 1)
                $arrVals['USER_FIELD_1'] = $userField1;

            updateUserProfileInfo($msg, $merchantId, $profile, $shortDescription, $deliveryCosts, $shippingDetails, $paymentMethods, $verifiers, $languages);

            $arrVals['MONTHLY_BUDGET'] = $monthlyBudget;
            tableUpdate('USER', $merchantId, $arrVals, 'USERID');

            header("Location: " . $return . "info=3");
        } else
            header("Location: " . $return . "info=6");
        die;
    } elseif ($action == "ProfileInfo") {
        $profile = postVar('profile', '', '', array('maxlen' => 255));

        tableUpdate('USERINFO', $merchantId, array('PROFILE' => $profile), 'USERID');

        header("Location: " . $return . "info=3");
    } elseif ($action == "SpiderTags") {
        $product_prefix = postVar('product_prefix');
        $product_suffix = postVar('product_suffix');
        $product_id_prefix = postVar('product_id_prefix');
        $product_id_suffix = postVar('product_id_suffix');
        $product_title_prefix = postVar('product_title_prefix');
        $product_title_suffix = postVar('product_title_suffix');
        $user_product_price_prefix = postVar('user_product_price_prefix');
        $user_product_price_suffix = postVar('user_product_price_suffix');
        $user_product_comment_prefix = postVar('user_product_comment_prefix');
        $user_product_comment_suffix = postVar('user_product_comment_suffix');
        $user_product_brand_prefix = postVar('user_product_brand_prefix');
        $user_product_brand_suffix = postVar('user_product_brand_suffix');
        $user_product_detail_url_prefix = postVar('user_product_detail_url_prefix');
        $user_product_detail_url_suffix = postVar('user_product_detail_url_suffix');
        $user_product_buy_url_prefix = postVar('user_product_buy_url_prefix');
        $user_product_buy_url_suffix = postVar('user_product_buy_url_suffix');
        $user_product_shipping_prefix = postVar('user_product_shipping_prefix');
        $user_product_shipping_suffix = postVar('user_product_shipping_suffix');
        $user_product_partno_prefix = postVar('user_product_partno_prefix');
        $user_product_partno_suffix = postVar('user_product_partno_suffix');
        $user_product_available_prefix = postVar('user_product_available_prefix');
        $user_product_available_suffix = postVar('user_product_available_suffix');

        if (trim($product_prefix) == "" || trim($product_suffix) == "" || trim($product_id_prefix) == "" || trim($product_id_suffix) == "" || trim($product_title_prefix) == "" || trim($product_title_suffix) == "" || trim($user_product_price_prefix) == "" || trim($user_product_price_suffix) == "" || trim($user_product_comment_prefix) == "" || trim($user_product_comment_suffix) == "" || trim($user_product_brand_prefix) == "" || trim($user_product_brand_suffix) == "" || trim($user_product_detail_url_prefix) == "" || trim($user_product_detail_url_suffix) == "" || trim($user_product_buy_url_prefix) == "" || trim($user_product_buy_url_suffix) == "" || trim($user_product_shipping_prefix) == "" || trim($user_product_shipping_suffix) == "" || trim($user_product_partno_prefix) == "" || trim($user_product_partno_suffix) == "" || trim($user_product_available_prefix) == "" || trim($user_product_available_suffix) == "")
            header("Location: " . $return . "info=1");

        else {
            preparedUpdate("DELETE FROM " . PREFIX . "USER_SPIDER_TAGS WHERE USERID = ?", array($merchantId));
            tableInsert('USER_SPIDER_TAGS', array(
                'USERID' => $merchantId,
                'PRODUCT_PREFIX' => $product_prefix,
                'PRODUCT_SUFFIX' => $product_suffix,
                'PRODUCT_ID_PREFIX' => $product_id_prefix,
                'PRODUCT_ID_SUFFIX' => $product_id_suffix,
                'PRODUCT_TITLE_PREFIX' => $product_title_prefix,
                'PRODUCT_TITLE_SUFFIX' => $product_title_suffix,
                'USER_PRODUCT_PRICE_PREFIX' => $user_product_price_prefix,
                'USER_PRODUCT_PRICE_SUFFIX' => $user_product_price_suffix,
                'USER_PRODUCT_COMMENT_PREFIX' => $user_product_comment_prefix,
                'USER_PRODUCT_COMMENT_SUFFIX' => $user_product_comment_suffix,
                'USER_PRODUCT_BRAND_PREFIX' => $user_product_brand_prefix,
                'USER_PRODUCT_BRAND_SUFFIX' => $user_product_brand_suffix,
                'USER_PRODUCT_DETAIL_URL_PREFIX' => $user_product_detail_url_prefix,
                'USER_PRODUCT_DETAIL_URL_SUFFIX' => $user_product_detail_url_suffix,
                'USER_PRODUCT_BUY_URL_PREFIX' => $user_product_buy_url_prefix,
                'USER_PRODUCT_BUY_URL_SUFFIX' => $user_product_buy_url_suffix,
                'USER_PRODUCT_SHIPPING_PREFIX' => $user_product_shipping_prefix,
                'USER_PRODUCT_SHIPPING_SUFFIX' => $user_product_shipping_suffix,
                'USER_PRODUCT_PARTNO_PREFIX' => $user_product_partno_prefix,
                'USER_PRODUCT_PARTNO_SUFFIX' => $user_product_partno_suffix,
                'USER_PRODUCT_AVAILABLE_PREFIX' => $user_product_available_prefix,
                'USER_PRODUCT_AVAILABLE_SUFFIX' => $user_product_available_suffix
            ));
            header("Location: " . $return . "info=3");
        }
    } elseif ($action == "BecomeFeaturedPayment") {
        $paymentMethod = postVar('paymentMethod');

        //////////////////////////////////
        // Payment Method Cannot be Empty.
        if ($paymentMethod == '') {
            $msg = PAYMENT_OPTIONS_CONF_ERR;
            if ($return == '')
                $return = 'merchant_welcome.php?';

            echo getErrorForm($_POST, $return . "info=" . urlencode($msg));
            die;
        }
        //////////////////////////////////

        // Get Amount to be Paid
        $row = getRecord('PREFERENCES', 1000);
        $featuredFee = $row['FEATURED_MERCHANT_FEE'];

        $paymentId = getNextId("USER_FEATURED_PAYMENT");

        // Add a featured payment
        $ret = tableInsert('USER_FEATURED_PAYMENT', array(
            'ID' => $paymentId,
            'MERCHANTID' => $merchantId,
            'PAYMENT_TYPE' => $paymentMethod,
            'PAYMENT_DATETIME' => getTimezoneTime(),
            'AMOUNT' => $featuredFee,
            'ISVALID' => 'N',
            'FEATURED_DATE' => '0000-00-00'
        ));
        // Set is featured requested
        tableUpdate('USER', $merchantId, array('ISFEATURED_REQUESTED' => 'Y'), 'USERID');

        if ($ret <= 0) {
            echo getErrorForm($_POST, $return . "info=6");
            die;
        }

        makePayment($merchantId, $paymentMethod, $featuredFee, 0, 0, $paymentId);
    }
}

//*************************************************************************************************
//			USER URL
//*************************************************************************************************
else if ($task == "UserURL") {
    $url = postVar('url', 'url');
    $id = postVar('id', 'int');

    if ($action == "Add") {
        if (trim($url) == "")
            header("Location: " . $return . "info=1");

        else {
            $newUserURLId = getNextId("USER_URL", "ID");

            $res = tableInsert('USER_URL', array('ID' => $newUserURLId, 'USERID' => $merchantId, 'URL' => $url));
            if ($res > 0)
                header("Location: " . $return . "info=2");
            else
                header("Location: " . $return . "info=6");
        }
    } else if ($action == "Update") {
        if (trim($url) == "")
            header("Location: " . $return . "info=1");

        else {
            if (($row = getRecord('USER_URL', $id))) {
                $res = tableUpdate('USER_URL', $id, array('URL' => $url));
                if ($res > 0)
                    header("Location: " . $return . "info=3");
                else
                    header("Location: " . $return . "info=6");
            } else
                header("Location: " . $return . "info=5");
        }
    } else if ($action == "Delete") {
        if (trim($id) == "")
            header("Location: " . $return . "info=1");

        else {
            $res = preparedUpdate("DELETE FROM " . PREFIX . "USER_URL WHERE ID = ?", array($id));
            if ($res > 0)
                header("Location: " . $return . "info=4");
            else
                header("Location: " . $return . "info=6");
        }
    }
}

//*************************************************************************************************
//			UPDATE MERCHANT IMAGE
//*************************************************************************************************
elseif ($task == "UpdateImage") {
    if ($action == "UpdateImage") {
        if (trim($_FILES["image"]["name"]) != '') {
            $merchantId = postVar('merchantId', 'int');
            $file_name = PATH . "upload/merchant/" . $merchantId . ".jpg";

            $msg = '';
            if (isRedUpload($msg, $_FILES["image"], $file_name)) {
                header("Location: " . $return . "info=" . urlencode($msg));
                die;
            }

            if (copyFile($_FILES["image"]["tmp_name"], $file_name)) {
                header("Location: " . $return . "info=18");
            } else
                header("Location: " . $return . "info=6");
        }
        die;
    }
}

//*************************************************************************************************
//			PRODUCT
//*************************************************************************************************
else if ($task == "UserProduct") {
    $category = postVar('category');
    $product = postVar('product');
    $price = postVar('price', 'float');
    $currSymbol = postVar('currSymbol');
    $priceC = postVar('priceC', 'float');
    $quantity = postVar('quantity');
    $dimensionLength = postVar('dimensionLength');
    $dimensionWidth = postVar('dimensionWidth');
    $dimensionHeight = postVar('dimensionHeight');
    $dimensionUnit = postVar('dimensionUnit');
    $weight = postVar('weight');
    $weightUnit = postVar('weightUnit');
    $sellable = postVar('sellable');
    $comment = postVar('comment', '', '', array('maxlen' => 255));
    $brand = postVar('brand');
    $detail_url = postVar('detail_url');
    $buy_url = postVar('buy_url');
    $shipping = postVar('shipping');
    $partNo = postVar('partNo');
    $isAvailable = postVar('isAvailable');
    $contactSeller = postVar('contactSeller');
    $isValid = postVar('isValid');

    $userField1 = postVar('userField1');
    $userField2 = postVar('userField2');
    $userField3 = postVar('userField3');
    $userField4 = postVar('userField4');
    $userField5 = postVar('userField5');
    $userField6 = postVar('userField6');
    $userField7 = postVar('userField7');
    $userField8 = postVar('userField8');
    $userField9 = postVar('userField9');

    $id = postVar('id', 'int');

    if ($action == "Add") {
        $currId = $currSymbol == '' ? 0 : getColumn('CURRENCY', $currSymbol, 'ID', 'SYMBOL');
        $msg = '';
        $newUserProductId = addUserProduct($msg, $merchantId, array($category, $product), array($price, $currId, $priceC), $comment, $brand, $detail_url, $buy_url, $shipping, $partNo, $isAvailable, $isValid, $userField1, $userField2, $userField3, $userField4, $userField5, $userField6, $userField7, $userField8, $userField9, $quantity, $dimensionLength, $dimensionWidth, $dimensionHeight, $dimensionUnit, $weight, $weightUnit, $sellable, $contactSeller);
        echo getErrorForm($_POST, $return . "info=" . urlencode($msg));
        die;
    }

    elseif ($action == "Update") {
        $msg = '';
        $res = updateUserProduct($msg, $id, $merchantId, $product, $price, $comment, $brand, $detail_url, $buy_url, $shipping, $partNo, $isAvailable, $isValid, $userField1, $userField2, $userField3, $userField4, $userField5, $userField6, $userField7, $userField8, $userField9, 1, $quantity, $dimensionLength, $dimensionWidth, $dimensionHeight, $dimensionUnit, $weight, $weightUnit, $sellable, $contactSeller); // Update All
        echo getErrorForm($_POST, $return . "info=" . urlencode($msg));
    }

    elseif ($action == "Status") {
        $msg = "";
        $res = updateUserProduct($msg, $id, $merchantId, $product, $price, $comment, $brand, $detail_url, $buy_url, $shipping, $partNo, $isAvailable, $isValid);
        if ($res > 0)
            tableUpdate('USER_PRODUCT', $id, array('ISVALID_MANUAL' => $isValid));
        header("Location: " . $return . "info=" . urlencode($msg));
    }

    elseif ($action == "Delete") {
        $msg = "";
        $res = updateUserProduct($msg, $id, $merchantId, '', '', '', '', '', '', '', '', '', 'N');
        header("Location: " . $return . "info=4");
        /*
                    // 10/7/2009 Deleting will also delete the clickthroughs and other stats
                    $msg	= "";
                    $res	= deleteUserProduct($msg, $id);
                    header("Location: ".$return."info=".urlencode($msg));
        */
    }

    elseif ($action == "ImageUpload") {
        if (trim($_FILES["image"]["name"]) != '') {
            $productId = postVar('productId', 'int');

            if (IS_MERCHANT_PRODUCT_ADD_ALLOWED == 1)
                $file_name = PATH . makeProductImagePath($msg, $productId);
            else
                $file_name = PATH . "upload/products_temp/" . $productId . ".jpg";

            $msg = '';
            if (isRedUpload($msg, $_FILES["image"], $file_name)) {
                header("Location: " . $return . "info=" . urlencode($msg));
                die;
            }

            if (copyFile($_FILES["image"]["tmp_name"], $file_name))
                header("Location: " . $return . "info=10");
            else
                header("Location: " . $return . "info=6");
        } else
            header("Location: " . $return . "info=6");
        die;
    }
}

//*************************************************************************************************
//			PRODUCT
//*************************************************************************************************
else if ($task == "ProductTemp") {
    $category = postVar('category');
    $title = postVar('title');
    $detail = postVar('detail');
    $field1 = postVar('field1');
    $field2 = postVar('field2');
    $field3 = postVar('field3');
    $field4 = postVar('field4');
    $field5 = postVar('field5');
    $field6 = postVar('field6');
    $field7 = postVar('field7');
    $field8 = postVar('field8');
    $field9 = postVar('field9');
    $price = postVar('price', 'float');
    $comment = postVar('comment', '', '', array('maxlen' => 255));
    $brand = postVar('brand');
    $detail_url = postVar('detail_url');
    $buy_url = postVar('buy_url');
    $shipping = postVar('shipping');
    $partNo = postVar('partNo');
    $isAvailable = postVar('isAvailable');
    $id = postVar('id', 'int');

    /*
    // No need to validate product title in TEMP as when it is moved to
    // Product table filename is inserted there.
    if ( validateProductTitle($productName, $_POST, $return) == 0 )
        die;
    */

    if ($action == "Add") {
        if (trim($title) == "" || trim($category) == "" || trim($buy_url) == "" || trim($price) == "")
            echo getErrorForm($_POST, $return . "info=1");

        else {
            if (IS_MERCHANT_PRODUCT_ADD_ALLOWED == 1) {
                $max = addProduct($msg, $category, $title, $filename, $detail, $brand, $partNo, 'Y', 'N', $field1, $field2, $field3, $field4, $field5, $field6, $field7, $field8, $field9, $price, $price, 1);

                if ($max > 0) {
                    addUserProduct($msg, $merchantId, array($category, $max), $price, $comment, $brand, $detail_url, $buy_url, $shipping, $partNo, $isAvailable);

                    header("Location: merchant_proposed_product_upload_image.php?updtId=" . $max . "&info=2");
                } else
                    echo getErrorForm($_POST, $return . "info=" . urlencode($msg));
            } else {

                $max = getNextId("PRODUCT_TEMP", "ID");

                $res = tableInsert('PRODUCT_TEMP', array(
                    'PROPOSEDBY' => $merchantId,
                    'ID' => $max,
                    'CATEGORY_ID' => $category,
                    'TITLE' => $title,
                    'DETAIL' => $detail,
                    'DATE_ADDED' => getTimezoneTime(),
                    'FIELD_1' => $field1,
                    'FIELD_2' => $field2,
                    'FIELD_3' => $field3,
                    'FIELD_4' => $field4,
                    'FIELD_5' => $field5,
                    'FIELD_6' => $field6,
                    'FIELD_7' => $field7,
                    'FIELD_8' => $field8,
                    'FIELD_9' => $field9,
                    'PRICE' => $price,
                    'COMMENTS' => $comment,
                    'BRAND' => $brand,
                    'DETAIL_URL' => $detail_url,
                    'BUY_URL' => $buy_url,
                    'SHIPPING' => $shipping,
                    'PARTNO' => $partNo,
                    'ISAVAILABLE' => $isAvailable
                ));
                $_SESSION['scatId'] = $category;
                if ($result > 0) {
                    header("Location: merchant_proposed_product_upload_image.php?updtId=" . $max . "&info=2");
                } else
                    echo getErrorForm($_POST, $return . "info=6");
            }
        }
    } else if ($action == "Update") {
        if (trim($title) == "" || trim($category) == "" || trim($buy_url) == "" || trim($price) == "" || trim($id) == "")
            echo getErrorForm($_POST, $return . "info=1");

        else {
            $res = tableInsert('PRODUCT_TEMP', $id, array(
                'CATEGORY_ID' => $category,
                'TITLE' => $title,
                'DETAIL' => $detail,
                'FIELD_1' => $field1,
                'FIELD_2' => $field2,
                'FIELD_3' => $field3,
                'FIELD_4' => $field4,
                'FIELD_5' => $field5,
                'FIELD_6' => $field6,
                'FIELD_7' => $field7,
                'FIELD_8' => $field8,
                'FIELD_9' => $field9,
                'PRICE' => $price,
                'COMMENTS' => $comment,
                'BRAND' => $brand,
                'DETAIL_URL' => $detail_url,
                'BUY_URL' => $buy_url,
                'SHIPPING' => $shipping,
                'PARTNO' => $partNo,
                'ISAVAILABLE' => $isAvailable
            ));
            if ($res > 0)
                header("Location: " . $return . "info=3");
            else
                echo getErrorForm($_POST, $return . "info=6");
        }
    } else if ($action == "Delete") {
        if (trim($id) == "")
            header("Location: " . $return . "info=1");

        else {
            $res = preparedUpdate("DELETE FROM " . PREFIX . "PRODUCT_TEMP WHERE ID = ?", array($id));
            if ($res > 0) {
                unlinkSafe(PATH . "upload/products_temp/" . $id . ".jpg");
                header("Location: " . $return . "info=4");
            } else
                header("Location: " . $return . "info=6");
        }
    }
}

//*************************************************************************************************
//			PACKAGE
//*************************************************************************************************
elseif ($task == "Package") {
    $packageId = postVar('packageId', 'int');
    $optionId = postVar('optionId', 'int');

    if ($action == 'Select') {
        if ($packageId == 0) {
            header("Location: " . $return . "info=1");
            die;
        }

        if (!($pkgRec = getRecord('PACKAGE', $packageId))) {
            header("Location: " . $return . "info=5");
            die;
        }

        if ($pkgRec['ISHIDDEN'] == 'Y') {
            header("Location: " . $return . "info=30");
            die;
        }

        //////////////////////////////////
        // Payment Method Cannot be Empty.
        if ($optionId == '') {
            $msg = PAYMENT_OPTIONS_CONF_ERR;
            if ($return == '')
                $return = 'merchant_welcome.php?';

            echo getErrorForm($_POST, $return . "info=" . urlencode($msg));
            die;
        }
        //////////////////////////////////

        $_SESSION['packageId'] = $packageId;

// 5/12/2015: Mamda: use above already opened record
//			$newAmount = (float)getColumn('PACKAGE', $packageId,  'PRICE');
        $newAmount = (float)$pkgRec["PRICE"];

        $msg = '';
        $res = addUserPackage($msg, $merchantId, $packageId, $optionId);

        if ($res > 0) {
// 3/12/2015: Mamda: should not be sent when actually payment is not made
//				$msgEx = '';
//				sendPackagePaymentEmail($msgEx, $merchantId, $packageId);
            if ($newAmount > 0) {
                makePayment($merchantId, $optionId, $newAmount, $res);
                die;
            }

            $_SESSION['userValid'] = 'Y';
            header("Location: merchant_welcome.php?info=125");
        } else
            header("Location: " . $return . "info=" . $msg);
        die;
    }
}

//*************************************************************************************************
//			PAYMENT OPTION
//*************************************************************************************************
elseif ($task == "PaymentOption") {
    $optionId = postVar('optionId', 'int');

    if ($action == 'Select') {
        if (trim($optionId) == '') {
            header("Location: " . $return . "info=1");
            die;
        }

        $newAmount = getColumn('PAYMENT_OPTION', $optionId, 'CLICKTHROUGHS') * getColumn('PREFERENCES', 1000, 'CLICKTHROUGH_RATE');
        $_SESSION['optionId'] = $optionId;

        echo paypalDonation("PAYMENT UID:" . $merchantId . " OID:" . $optionId, $newAmount, "merchant_payment_success.php", "merchant_payment_cancel.php");
        die;
    }
}

//*************************************************************************************************
//			PAYMENT REQUEST
//*************************************************************************************************
elseif ($task == "Payment") {
    $amount = postVar('amount', 'float');
    $chkPP = postVar('chkPP', 'int');
    $chkCQ = postVar('chkCQ', 'int');
    $ppEml = postVar('ppEml');
    $cqNm = postVar('cqNm');

    $pMethd = ($chkPP == 1 ? 1 : 0) + ($chkCQ == 1 ? 2 : 0);

    if ($action == 'Request') {
        if ($amount == 0) {
            header("Location: " . $return . "info=1");
            die;
        }

        if ($chkPP == 1 && $ppEml == '') {
            header("Location: " . $return . "info=1");
            die;
        }
        if ($chkCQ == 1 && $cqNm == '') {
            header("Location: " . $return . "info=1");
            die;
        }

        $curBal = getUserBalance($merchantId);
        $crLim = getMerchantCreditLimit($merchantId);

        if ($curBal < $amount) {
            header("Location: " . $return . "info=318");
            die;
        }

        if ($curBal < $crLim) {
            header("Location: " . $return . "info=319");
            die;
        }

        $res = tableUpdate('USER', $merchantId, array('REQUEST_PAYMENT' => $amount), 'USERID');
        $res += tableUpdate('USERINFO', $merchantId, array('PAYMENT_RECEIVE_METHOD' => $pMethd, 'PAYPAL_EMAIL' => $ppEml, 'CHECKS_PAYABLE_TO' => $cqNm), 'USERID');
        if ($res > 0)
            header("Location: " . $return . "info=320");
        else
            header("Location: " . $return . "info=6");
        die;
    }
}

//*************************************************************************************************
//			NOTHING
//*************************************************************************************************
else
    header("Location: merchant_welcome.php?t=" . $task . "&a=" . $action);

?>