<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

require("path.php");
require(PATH . "include/include.php");

//*************************************************************************************************

include(PATH . "session.php");

//*************************************************************************************************

include("merchant_session.php");

//*************************************************************************************************

include("merchant_product_import_feed_constants.php");

//*************************************************************************************************

$userId = $merchantId;

//*************************************************************************************************

$total = getVar('total');
$delimiter = getVar('delimiter');
if ($total == '' || $delimiter == '') {
    header("Location: merchant_product_import_feed_prompt.php?userId=" . $userId . "&info=1");
    die;
}

//*************************************************************************************************

// Get File Path
$filepath = PATH . "upload/merchant/" . $userId . "/products-feed.csv";

if (!file_exists($filepath)) {
    header("Location:merchant_product_import_csv.php?info=" . CSV_FILE_NOT_FOUND);
    die;
}

//*************************************************************************************************

// Open File for Reading
if (!($fp = fopen($filepath, "r")))
    die ("<font color='red'><b>" . COULD_NOT_OPEN_FILE_FOR_READING . $filepath . "</b></font>");

// Read Lines and move ahead
$lines = array();
$linesize = 0;
$delimiter = $delimiter == 't' ? "\t" : $delimiter;

while (!feof($fp) && $linesize < 2) {
    $totLines++;

    if ($linesize == 0)
        $line1Arr = fgetcsv($fp, 65000, $delimiter, '"');
    else
        $line2Arr = fgetcsv($fp, 65000, $delimiter, '"');

    $linesize++;
}
fclose($fp);

//*************************************************************************************************

$colCount = count($line1Arr);

//*************************************************************************************************

for ($i = 0; $i < $colCount; $i++) {
    $line1Arr[$i] = strip_tags($line1Arr[$i]);
    $line1Arr[$i] = trim(str_replace('\n', '', str_replace('"', '', strlen($line1Arr[$i]) > 28 ? substr($line1Arr[$i], 0, 28) : $line1Arr[$i])));
}

//*************************************************************************************************

for ($i = 0; $i < $colCount; $i++) {
    $line2Arr[$i] = strip_tags($line2Arr[$i]);
    $line2Arr[$i] = trim(str_replace('\n', '', str_replace('"', '', strlen($line2Arr[$i]) > 28 ? substr($line2Arr[$i], 0, 28) : $line2Arr[$i])));
}

//*************************************************************************************************

$res = preparedQuery("SELECT * FROM " . PREFIX . "USER_FEED_PARAMETERS WHERE USERID = ?", array($userId));
if (($row = getRow($res))) {
    $isExactMatch = $row['EXACT_MATCH'];
    $isNewEntryAllowed = $row['ISNEWENTRY_ALLOWED'];
    $isColIdEntryPoint = $row['ISCOL_ENTRY_POINT'];
    $isImageUpdtAllowed = $row['ISUPDATE_IMAGE_ALLOWED'];

    $useCategoryMapping = $row['USE_CATEGORY_MAPPING'];
    $isOnlyCatMapping = $row['ISONLY_CAT_MAPPING'];
    $isMatchByName = $row['ISMATCH_BY_PRODUCTNAME'];

    $colMaincat = $row['COL_MAIN_CAT'];
    $colSubcat = $row['COL_SUB_CAT'];
    $colMicrocat = $row['COL_MICRO_CAT'];

    $colCatid = $row['COL_CAT_ID'];

    $colProduct = $row['COL_PRODUCT'];
    $colDetail = $row['COL_DETAIL'];
    $colImage = $row['COL_IMAGE'];

    $colPrice = $row['COL_PRICE'];
    $colComments = $row['COL_COMMENTS'];
    $colBrand = $row['COL_BRANDS'];
    $colDetailURL = $row['COL_DETAIL_URL'];
    $colBuyURL = $row['COL_BUY_URL'];
    $colShipping = $row['COL_SHIPPING'];
    $colPartNo = $row['COL_PARTNO'];
    $colEanUpc = $row['COL_EAN_UPC'];
    $colAvailability = $row['COL_AVAILABILITY'];
    $colUserProductId = $row['COL_USER_PRODUCT_ID'];
    $lastUpdated = $row['LAST_UPDATED'];

    // Setup UltaArray
    $ultaArray = array();
    foreach ($row as $key => $value) {
        $ultaArray[$value] = $key;
    }
} else {
    $isExactMatch = 'Y';
    $isNewEntryAllowed = 'Y';
    $isColIdEntryPoint = 'Y';
    $isImageUpdtAllowed = 'N';

    $useCategoryMapping = 'N';
    $isOnlyCatMapping = 'Y';
    $isMatchByName = 'Y';

    $colMaincat = '0';
    $colSubcat = '1';
    $colMicrocat = '2';

    $colCatid = '';

    $colProduct = '4';
    $colDetail = '5';
    $colImage = '6';

    $colPrice = '7';
    $colComments = '8';
    $colBrand = '9';
    $colDetailURL = '10';
    $colBuyURL = '11';
    $colShipping = '12';
    $colPartNo = '13';
    $colAvailability = '14';
    $colEanUpc = '15';
    $colUserProductId = '';
    $lastUpdated = 'N/A';

    // Setup UltaArray
    $ultaArray = array();
    $ultaArray[0] = 'COL_MAIN_CAT';
    $ultaArray[1] = 'COL_SUB_CAT';
    $ultaArray[2] = 'COL_MICRO_CAT';
    $ultaArray[3] = 'COL_CAT_ID';
    $ultaArray[4] = 'COL_PRODUCT';
    $ultaArray[5] = 'COL_DETAIL';
    $ultaArray[6] = 'COL_IMAGE';
    $ultaArray[7] = 'COL_PRICE';
    $ultaArray[8] = 'COL_COMMENTS';
    $ultaArray[9] = 'COL_BRANDS';
    $ultaArray[10] = 'COL_DETAIL_URL';
    $ultaArray[11] = 'COL_BUY_URL';
    $ultaArray[12] = 'COL_SHIPPING';
    $ultaArray[13] = 'COL_PARTNO';
    $ultaArray[14] = 'COL_AVAILABILITY';
    $ultaArray[15] = 'COL_EAN_UPC';
    $ultaArray[16] = '';
}


//*************************************************************************************************

$yOffset = 0;

//*************************************************************************************************

// Render template
renderTemplate('merchants/product-import-feed-prompt2', get_defined_vars());

//*************************************************************************************************
