<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

require("path.php");
require(PATH . "include/include.php");

//*************************************************************************************************

$langFilename = 'merchant_user_products.php';
include(PATH . "session.php");

//*************************************************************************************************

include("merchant_session.php");

//*************************************************************************************************

$updtId = getVar('updtId', 'int');
$showId = getVar('showId', 'int');

//*************************************************************************************************

$categoryId = getVar('categoryId', 'int', sessionVar('categoryId'));
$_SESSION['categoryId'] = $categoryId;

//*************************************************************************************************

if ( $updtId > 0 ) {

    if ( !($row = getRecord("PRODUCT_TEMP", $updtId)) ) {
        showMerchantErrorPage('', INFO_5);
    }

    // Render template
    renderTemplate('merchants/proposed-products-update', [
        'updtId' => $updtId,
        'row' => $row,
    ]);

}

//*************************************************************************************************

if ( $showId > 0 ) {

    if ( !($row = getRecord("PRODUCT_TEMP", $showId)) ) {
        showMerchantErrorPage('', INFO_5);
    }

    // Render template
    renderTemplate('merchants/proposed-products-show', [
        'showId' => $showId,
        'row' => $row,
    ]);

}

//*************************************************************************************************

$arrProposedProducts = [];

$subSql = '';
$args = array();
if ($categoryId > 0) {
    $subSql = "WHERE CATEGORY_ID = ?";
    $args[] = $categoryId;
}

$res = breakPages("SELECT * FROM " . PREFIX . "PRODUCT_TEMP " . $subSql . " ORDER BY TITLE", '', 0, $args);
$resTot = getTotalRows($res);

if (IS_MERCHANT_PRODUCT_ADD_ALLOWED == 1 && $resTot < 1) {
    $subSql = '';
    $args = array();
    if ($categoryId > 0) {
        $subSql = "P.CATEGORY_ID = ? AND ";
        $args[] = $categoryId;
    }
    $args[] = $merchantId;

    $res = breakPages("SELECT * FROM " . PREFIX . "PRODUCT P, " . PREFIX . "USER_PRODUCT UP WHERE " . $subSql . " P.ID = UP.PRODUCT_ID AND UP.USERID = ? ORDER BY TITLE", '', 0, $args);
}

while ( ($row = getRow($res)) ) {
    $arrProposedProducts[] = $row;
}

// Render template
renderTemplate('merchants/proposed-products', [
    'arrProposedProducts' => $arrProposedProducts,
    'categoryId' => $categoryId,
]);

//*************************************************************************************************
