<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

require("path.php");
require(PATH . "include/include.php");

//*************************************************************************************************

include(PATH . "session.php");

//*************************************************************************************************

include("merchant_session.php");

//*************************************************************************************************

$showId = getVar('showId', 'int');

//*************************************************************************************************

$avgRating = getColumn("USER_RATING", $merchantId, "IFNULL(AVG(RATING), 0)", "MERCHANTID");

//*************************************************************************************************

if ($showId > 0) {

    $res = preparedQuery("SELECT UI.USERID, UI.NAME AS UINAME, UPR.* FROM " . PREFIX . "VISITORINFO UI, " . PREFIX . "USER_RATING UPR WHERE UI.USERID=UPR.USERID AND UPR.ID = ?", array($showId));
    if (!($row = getRow($res))) {
        showMerchantErrorPage('', INFO_5);
    }

    $row['UIEMAIL'] = getColumn("VISITOR", $row['USERID'], "EMAIL", "USERID");

    renderTemplate('merchants/ratings-show', [
        'avgRating' => $avgRating,
        'showId' => $showId,
        'row' => $row,
    ]);

}

//*************************************************************************************************

$arrRatings = [];
$res = preparedQuery("SELECT UPR.* FROM " . PREFIX . "USER_RATING UPR WHERE UPR.MERCHANTID = ? ORDER BY RATING", array($merchantId));
$x = 0;
while (($row = getRow($res))) {
    $recMem = preparedQuery("SELECT VI.NAME AS VINAME, V.EMAIL AS VIEMAIL FROM " . PREFIX . "VISITOR V, " . PREFIX . "VISITORINFO VI WHERE V.USERID = ? AND V.USERID = VI.USERID", array($row['USERID']));
    if (($rowMem = getRow($recMem))) {
        $row['NAME'] = $rowMem['VINAME'];
        $row['EMAIL'] = $rowMem['VIEMAIL'];
    } else {
        $row['NAME'] = isset($row['NAME']) ? $row['NAME'] : '';
        $row['EMAIL'] = isset($row['EMAIL']) ? $row['EMAIL'] : '';
    }

    $arrRatings[] = $row;
}

// Render template
renderTemplate('merchants/ratings', [
    'avgRating' => $avgRating,
    'arrRatings' => $arrRatings,
]);

//*************************************************************************************************
