<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

	include("path.php");
	require(PATH."include/include.php");

//*************************************************************************************************

	session_start();

//*************************************************************************************************

	include (PATH."session.php");

//*************************************************************************************************

	include ("merchant_session.php");

//*************************************************************************************************

	// Get File Path
	$filepath	= PATH."upload/csvfiles/".$merchantId.".csv";

	// Log filename
	$logFileName = "upload/csvfiles/".$merchantId.".html";

//*************************************************************************************************


	if ( !file_exists($filepath) )
	{
		header("Location: merchant_user_product_import_csv.php?info=".CSV_FILE_NOT_FOUND);
		die;
	}

//*************************************************************************************************

	$delimiter			= getVar('delimiter');
	$delimiter			= $delimiter == 't' ? "\t" : $delimiter;
	
	$colProduct			= getVar('colProduct');
	
	$colPrice			= getVar('colPrice');
	$colComments		= getVar('colComments');
	$colBrand			= getVar('colBrand');
	$colDetailURL		= getVar('colDetailURL');
	$colBuyURL			= getVar('colBuyURL');
	$colShipping		= getVar('colShipping');
	$colPartNo			= getVar('colPartNo');
	$colAvailability	= getVar('colAvailability');
	$colUserProductId	= getVar('colUserProductId');


//*************************************************************************************************

	$lineno = getVar('lineno');
	if ( $lineno == "" )
		$lineno = 0;

	$success = getVar('success', 'int');
	if ( $success == "" )
		$success = 0;

	$failure = getVar('failure', 'int');
	if ( $failure == "" )
		$failure = 0;

	$notfound = getVar('notfound', 'int');
	if ( $notfound == "" )
		$notfound = 0;

//*************************************************************************************************
	
	$count		= 0;
	$MAX_LINES	= 500;

//*************************************************************************************************
	
	if ( $lineno == 0 )
	{
		$head = "
		<html>

			<head>
				<title>".PAGE_TITLE_DATAFEED_LOG_FILE."</title>
				<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1'>
				<link href='".getResourceUrl('public.min.css', 'style')."' rel='stylesheet' type='text/css' />
				<link href='".getResourceUrl('style.min.css', 'style', true)."' rel='stylesheet' type='text/css' />
			</head>

			<body bgcolor='#FFFFFF' text='#000000' leftmargin=20 marginheight=10 marginwidth=10 topmargin=20>
		";
		
		writeToFile($logFileName, $head);
		writeToFile("upload/csvfiles/".$merchantId.".progress", 0);

		appendToFile($logFileName, "<font class=normal>".PROCESSING." [$filepath]</font><br>");
	}

//*************************************************************************************************

	if ( !($fp = fopen($filepath, "r")) )
	{
		appendToFile($logFileName, "<font class=normal>".CANNOT_READ." [$filepath]</font><br>");
		echo ("<font style='color:red; font-family:Verdana; font-size:10px; font-weight:bold; text-align: center;'><b>".MSG_COULD_NOT_OPEN_FILE_FOR_READING." ".$filepath."</b></font>");
	}

//*************************************************************************************************

	if ( $delimiter == "" )
	{
		appendToFile($logFileName, "<font class=normal>".EMPTY_DELIMITER."</font><br>");
		echo ("<font style='color:red; font-family:Verdana; font-size:10px; font-weight:bold; text-align: center;'><b>".EMPTY_DELIMITER."</b></font>");
		die;
	}

//*************************************************************************************************

	if ( $lineno != 0 )
	{
		appendToFile($logFileName, "<br><font class=normal>*** <b>Hop</b> [".LINE.":$lineno]</font><br>");

		for ( $i=0; $i<$lineno; $i++)
			$data = @fgets($fp, 1024);
	}

//*************************************************************************************************

	//preparedUpdate("DELETE FROM ".PREFIX."USER_PRODUCT WHERE USERID = ?", array($merchantId));

//*************************************************************************************************

	while ( $count <= $MAX_LINES && !feof($fp) )
	{
		$arrCols = fgetcsv($fp, 10000, $delimiter, '"');


		if ( sizeof($arrCols) < 3 || $lineno < 1 )
			;//echo "Leaving Empty<br>";

		else
		{
			appendToFile($logFileName, "<br><font class=normal></font>");
			$err = "";
									
			// If required columns are missing.
			if ( $arrCols[$colProduct] == "" || $arrCols[$colBuyURL] == "" || $arrCols[$colPrice] == "" )
			{
				appendToFile($logFileName, "<font class=normal>- ".REQUIRED_COLUMNS_ARE_MISSING.". [".$arrCols[$colProduct].", ".$arrCols[$colBuyURL].", ".$arrCols[$colPrice]."]</font><br>");
			}
			else
			{
				// Get values
				$productName		= "";				
				$productPrice		= "";
				$productComments	= "";
				$productBrand		= "";
				$productDetailURL	= "";
				$productBuyURL		= "";
				$productShipping	= "";
				$productPartNo		= "";
				$productIsAvailable = "";
				$userProductId		= "";

				///////////////////////////////////////////////////////////////////////////////////
				if ( $colProduct != "" && is_numeric($colProduct) )
					$productName	= trimEnclosedComma($arrCols[$colProduct]);

				if ( $colPrice != "" && is_numeric($colPrice) )
					$productPrice	= number_format($arrCols[$colPrice], 2, '.', '');
				
				if ( $colComments != "" && is_numeric($colComments) )
					$productComments= trimEnclosedComma($arrCols[$colComments]);

				if ( $colBrand != "" && is_numeric($colBrand) )
					$productBrand	= trimEnclosedComma($arrCols[$colBrand]);
				
				if ( $colDetailURL != "" && is_numeric($colDetailURL) )
					$productDetailURL = trimEnclosedComma($arrCols[$colDetailURL]);

				if ( $colBuyURL != "" && is_numeric($colBuyURL) )
					$productBuyURL  = trimEnclosedComma($arrCols[$colBuyURL]);

				if ( $colShipping != "" && is_numeric($colShipping) )
					$productShipping  = trimEnclosedComma($arrCols[$colShipping]);

				if ( $colPartNo != "" && is_numeric($colPartNo) )
					$productPartNo  = trimEnclosedComma($arrCols[$colPartNo]);

				if ( $colAvailability != "" && is_numeric($colAvailability) )
					$productIsAvailable  = trimEnclosedComma($arrCols[$colAvailability]);				

				if ( $colUserProductId != "" && is_numeric($colUserProductId) )
					$userProductId	= $arrCols[$colUserProductId];

				///////////////////////////////////////////////////////////////////////////////////
								
				//print_r($arrCols); die;

				///////////////////////////////////////////////////////////////////////////////////

				// Check for categories only if USER_PRODUCT_ID is empty
				if ( $userProductId == "" )
				{
					// Check for product
					$productId		 = checkProduct($productName);
										// This check for product in db and inserts if not found and returns the ID of product
					appendToFile($logFileName, "<font class=normal>---- PRODUCT ID [$productId] -- > ($productName)</font><br>");
				
					///////////////////////////////////////////////////////////////////////////////////

					if ( $productId > 0 )
					{
						$ret = insertUserProduct($merchantId, $productId, 0, $productName, $productPrice, $productComments, $productBrand, $productDetailURL, $productBuyURL, $productShipping, $productPartNo, $productIsAvailable);

						if ( $ret > 0 )
							$success++;
						else
							$failure++;
					}
					else
						$notfound++;

					///////////////////////////////////////////////////////////////////////////////////

				}
				else
				{
					appendToFile($logFileName, "<font class=normal>---- USER_PRODUCT_ID ".SUPPLIED." [$userProductId]</font><br>");

					$ret = insertUserProduct($merchantId, 0, $userProductId, $productName, $productPrice, $productComments, $productBrand, $productDetailURL, $productBuyURL, $productShipping, $productPartNo, $productIsAvailable);

					if ( $ret > 0 )
						$success++;
					else
						$failure++;
				}

				///////////////////////////////////////////////////////////////////////////////////

			} // if of required columns ends here
			
		} // if of line length ends here 

		$lineno++;
		$count++;
	
	} // while loop ends here //

	writeToFile("upload/csvfiles/".$merchantId.".progress", $lineno-2);

//*************************************************************************************************

	if ( feof($fp) )
	{
		appendToFile($logFileName, "</body></html>");
        showMerchantErrorPage(MANAGE_PRODUCT_IMPORT, "<font class='info'>".FILE_EXECUTED_SUCCESSFULLY."<br>".MERCHANT." : $merchantId<br>".INSTRUCTIONS." : ".($lineno-2)."<br>".SUCCESS." : $success<br>".FAILURE." : $failure<br>".NOT_FOUND." : $notfound<br><br>| <a href='merchant_user_product_import_csv.php' class=link>".BACK."</a> |<br><br>| <a href='".SCRIPT_ROOT.'rf.php?f='.urlencode($logFileName)."' class=link target='_blank'>".LOG_FILE."</a> |</font>");
	}
	else
	{
		echo "<html><head><meta http-equiv='refresh' content='5; url=merchant_user_product_import_csv_process.php?lineno=".$lineno."&success=".$success."&failure=".$failure."&notfound=".$notfound."&delimiter=".getVar('delimiter')."&colProduct=".$colProduct."&colPrice=".$colPrice."&colComments=".$colComments."&colBrand=".$colBrand."&colDetailURL=".$colDetailURL."&colBuyURL=".$colBuyURL."&colShipping=".$colShipping."&colPartNo=".$colPartNo."&colAvailability=".$colAvailability."&colUserProductId=".$colUserProductId."'><title>".PROCESSING."...</title></head><body>".PROCESSING."...</body></html>";
		die;
	}

//*************************************************************************************************

	fclose($fp);

//*************************************************************************************************
//*************************************************************************************************
//*************************************************************************************************

	function checkProduct($productName)
	{
		global $logFileName;

		$productId = 0;

		if ( $productName != '' )
		{
			$resultMC	= preparedQuery("SELECT C.ID AS CID, C.TITLE AS CTITLE, P.ID AS PID, P.TITLE AS PTITLE FROM ".PREFIX."CATEGORY C, ".PREFIX."PRODUCT P WHERE P.CATEGORY_ID = C.ID AND P.TITLE LIKE ?", array($productName));
			$totRows	= getTotalRows($resultMC);

			if ( $totRows == 1 )
			{
				if ( $rowMC = getRow($resultMC) )
				{
					$productId = $rowMC["PID"];
					
					appendToFile($logFileName, "<font class=normal>---- ".PRODUCT_FOUND." {[CID : ".$rowMC["CID"]."][CTITLE : ".$rowMC["CTITLE"]."][PID : ".$rowMC["PID"]."][PTITLE : ".$rowMC["PTITLE"]."]}</font><br>");
				}
				else
					appendToFile($logFileName, "<font class=normal>---- ".PRODUCT_NOT_FOUND_IN_DB." [".NAME." : ".$productName."]</font><br>");				
			}
			else if ( $totRows > 1 )
				appendToFile($logFileName, "<font class=normal>---- ".PRODUCT_FOUND_MULTIPLE." [".NAME." : ".$productName."]</font><br>");

			else if ( $totRows < 1 )
				appendToFile($logFileName, "<font class=normal>---- ".PRODUCT_NOT_FOUND_IN_DB." [".NAME." : ".$productName."]</font><br>");
		}

		return $productId;
	}

//*************************************************************************************************

	function insertUserProduct($userId, $productId, $userProductId, $name, $price, $comments, $brand, $detailUrl, $buyUrl, $shipping, $partNo, $isAvailable)
	{
		global $logFileName;

		if ( $price != "" )
		{
			if ( ($userProductId == "" || $userProductId == 0) && $productId != "" && $productId != 0 )
			{									// UserProductID is empty but ProductId is present. Insert New UserProduct
				
				$res = preparedQuery("SELECT ID FROM ".PREFIX."USER_PRODUCT WHERE USERID = ? AND PRODUCT_ID = ?", array($userId, $productId));
				if ( ($row = getRow($res)) )
					$userProductId = $row["ID"];
				else
				{
					$userProductId	= getNextId("USER_PRODUCT");
					$temp			= tableInsert('USER_PRODUCT', array(
																			'ID'			=> $userProductId,
																			'USERID'		=> $userId,
																			'PRODUCT_ID'	=> $productId,
																			'ISVALID'		=> 'Y'
																		));
					if ( $temp <= 0 )
					{
						appendToFile($logFileName, "<font class=normal>----- ".PRODUCT_PRICE_INSERTION_FAILED." ($userId, $productId, $userProductId, $name, $price ....)</font><br>");
						return 0;
					}
				}
			}
			
			///////////////////////////////////////////////////////////////////////////////////////////

			if ( $userProductId != "" && $userProductId != 0 )
			{
					$values = array();
					
					if ( $comments != '' )				$values['COMMENT']		= $comments;
					if ( $brand != '' )					$values['BRAND']		= $brand;
					if ( $detailUrl != '' )				$values['DETAIL_URL']	= $detailUrl;
					if ( $buyUrl != '' )				$values['BUY_URL']		= $buyUrl;
					if ( $shipping != '' )				$values['SHIPPING']		= $shipping;
					if ( $partNo != '' )				$values['PARTNO']		= $partNo;
					if ( $isAvailable != '' )			$values['ISAVAILABLE']	= stristr($isAvailable, 'Y') ? 'Y' : 'N';

					$values['PRICE']		= str_replace(',', '', $price);
					$values['LAST_UPDATED']	= getTimezoneTime();
					
					$temp = tableUpdate('USER_PRODUCT', $userProductId, $values);

//					setPriceHistory($productId, $productPrice, $userId);
					
					appendToFile($logFileName, "<font class=normal>----- ".PRODUCT_PRICE." <b>".getFormattedPrice($price, SCRIPT_DOLLAR, 1)."</b> ".ADDED_FOR_PRODUCT." <b>".$name."</b></font><br>");
					
					if ( $temp > 0 )
						return 1;
					else
						return 0;
			}
			else
			{
				appendToFile($logFileName, "<font class=normal>----- ".PRODUCT_PRICE_ADD_FAILED_DUE_TO_EMPTY." <b>USER_PRODUCT_ID</b> ($userId, $productId, $userProductId, $price ....)</font><br>");
				return 0;
			}
		}
		else
		{
			appendToFile($logFileName, "<font class=normal>----- ".PRODUCT_PRICE_ADD_FAILED_DUE_TO_EMPTY." <b>PRICE</b> ($userId, $productId, $userProductId, $price ....)</font><br>");
			return 0;
		}
	}

//*************************************************************************************************

	function trimEnclosedComma($str)
	{
		$str = str_replace('""', '"', $str);
		
		if ( !stristr($str, "\\'") )
			$str = str_replace("'", "''", $str);

		if ( substr($str, 0, 1) == "\"" )
		{
			if ( substr($str, strlen($str)-1, 1) == "\"" )
			{
				return trim(substr($str, 1, strlen($str)-2));
			}
		}
		return trim($str);
	}
?>