<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

require("path.php");
require(PATH . "include/include.php");

//*************************************************************************************************

include(PATH . "session.php");

//*************************************************************************************************

$allowVisitorSeller2Page = 1;
include("merchant_session.php");

//*************************************************************************************************

$updtId = getVar('updtId', 'int');
$showId = getVar('showId', 'int');

$category = getVar('category', 'int');
$title = getVar('title');

//*************************************************************************************************

// Product details display
if ($showId != '') {
    // Load the record
    $res = preparedQuery("SELECT UP.*, C.TITLE AS CTITLE, P.TITLE AS PTITLE FROM ".PREFIX."PRODUCT P, ".PREFIX."USER_PRODUCT UP, ".PREFIX."CATEGORY C WHERE P.ID=UP.PRODUCT_ID AND C.ID=P.CATEGORY_ID AND UP.ID = ?", array($showId));

    // Show error if not found
    if ( !($row = getRow($res)) ) {
        showMerchantErrorPage('', INFO_5);
    }

    // Show error if not user's data
    if ( $row['USERID'] != $merchantId ) {
        showMerchantErrorPage(AUTHENTICATION_FAILED, INFO_5);
    }

    // Show record details
    renderTemplate('merchants/user-products-show', [
        'row' => $row,
    ]);
    die;
}

//*************************************************************************************************

// Product update page
if ($updtId != '') {
    // Load the record
    $res = preparedQuery("SELECT UP.*, C.ID AS CID, C.TITLE AS CTITLE, P.ID AS PID, P.TITLE AS PTITLE FROM ".PREFIX."PRODUCT P, ".PREFIX."USER_PRODUCT UP, ".PREFIX."CATEGORY C WHERE P.ID=UP.PRODUCT_ID AND C.ID=P.CATEGORY_ID AND UP.ID = ?", array($updtId));

    // Show error if not found
    if ( !($row = getRow($res)) ) {
        showMerchantErrorPage('', INFO_5);
    }

    // Show error if not user's data
    if ( $row['USERID'] != $merchantId ) {
        showMerchantErrorPage(AUTHENTICATION_FAILED, INFO_5);
    }

    // Show record for updating
    renderTemplate('merchants/user-products-update', [
        'row' => $row,
    ]);
    die;
}

//*************************************************************************************************

// Show product listing template
$arrUserProducts = [];

$args = array($merchantId);
$subSql = '';

// [2009/12/18] Salman: Removed the link to USER_PRODUCT, PRODUCT so that the stats are not deleted
// 						Due to this CATEGORY_ID search is not possible.
//						New field of CATEGORY_TITLE added to the table.
// [11/25/2013] Mamda:	We now bring it back, because we do delete price and product both if cat is deleted
if ($category > 0) {
    $args[] = $category;
    $subSql .= " AND P.CATEGORY_ID = ?";
}

if ($title != '') {
    $args[] = '%' . $title . '%';
    $subSql .= " AND P.TITLE LIKE ?";
}

$args[] = (int)BASE_URL_REDIRECT_PRODUCT_ID;

$result = breakPages("SELECT C.ID AS CID,P.ID AS PID, C.TITLE AS CTITLE, P.TITLE AS PTITLE, UP.* FROM " . PREFIX . "CATEGORY C, " . PREFIX . "PRODUCT P, " . PREFIX . "USER_PRODUCT UP WHERE P.ID = UP.PRODUCT_ID AND C.ID = P.CATEGORY_ID AND UP.USERID = ? " . $subSql . " AND P.ID <> ? ORDER BY C.TITLE, P.TITLE", '', 0, $args);
$count = 0;

while ( ($row = getRow($result)) ) {
    $arrUserProducts[] = $row;
}

renderTemplate('merchants/user-products', [
    'arrUserProducts' => $arrUserProducts,
]);

//*************************************************************************************************
