<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

		require ("path.php");
		require (PATH."include/include.php");

//*************************************************************************************************

		include (PATH."session.php");

//*************************************************************************************************
		
		$userId	= getVar('uId', 'int');
		$fn		= getVar('fn', '', '', array('maxlen'=>50));

		if ( $userId == 0 && $fn != '' )
			$userId = (int)getColumn('USERINFO', $fn, 'USERID', 'FILENAME');

		if ( $userId == 0 )
		{
			header("Location: ".getSeoUrl('/')."?info=1");
			die;
		}

//*************************************************************************************************

		$sql	= "SELECT USERID, NAME, ADDRESS, CITY, STATE, COUNTRY, ZIP, PHONE, MOBILE, URL, PROFILE, SHORT_DESCRIPTION, DELIVERY_COSTS, SHIPPING_DETAILS, PAGE_TITLE, PAGE_KEYWORDS, PAGE_DESCRIPTION FROM ".PREFIX."USERINFO WHERE USERID = ?";
		$res 	= preparedQuery($sql, array($userId));
		$uiRec	= array();
		
		if ( !($uiRec = getRow($res)) )
		{
			echo INFO_5;
			die;
		}

//*************************************************************************************************

		$arrMerchatAccepts	= array();
		$res = preparedQuery("SELECT UT.ID, UT.TITLE, UT.DETAIL FROM ".PREFIX."USER_ASSOC_PAYMENT_METHODS UA, ".PREFIX."USER_PAYMENT_METHODS UT WHERE UA.USERID = ? AND UA.PAYMENT_METHOD_ID=UT.ID", array($userId));
		while ( ($row = getRow($res)) )
			$arrMerchatAccepts[] = $row;

		$arrVerifiedBy		= array();
		$res = preparedQuery("SELECT UT.ID, UT.TITLE, UT.DETAIL FROM ".PREFIX."USER_ASSOC_VERIFIERS UA, ".PREFIX."USER_VERIFIERS UT WHERE UA.USERID = ? AND UA.VERIFIER_ID=UT.ID", array($userId));
		while ( ($row = getRow($res)) )
			$arrVerifiedBy[] = $row;

		$arrLanguages		= array();
		$res = preparedQuery("SELECT UT.ID, UT.TITLE FROM ".PREFIX."USER_ASSOC_LANGUAGES UA, ".PREFIX."USER_LANGUAGES UT WHERE UA.USERID = ? AND UA.LANGUAGE_ID=UT.ID", array($userId));
		while ( ($row = getRow($res)) )
			$arrLanguages[] = $row;

//*************************************************************************************************

		$pageTitle		= $uiRec['PAGE_TITLE'] == '' ? $uiRec['NAME'].' '.PROFILE : $uiRec['PAGE_TITLE'];
		$pageKeywords	= $uiRec['PAGE_KEYWORDS'] == '' ? $uiRec['NAME'].' '.PROFILE : $uiRec['PAGE_KEYWORDS'];
		$pageDescription= $uiRec['PAGE_DESCRIPTION'] == '' ? $uiRec['NAME'].' '.PROFILE : $uiRec['PAGE_DESCRIPTION'];

//*************************************************************************************************

		$merchantImageExists = file_exists(PATH."upload/merchant/".$userId.".jpg");
			
//*************************************************************************************************

		$res		= preparedQuery("SELECT AVG(RATING) AS AVG, COUNT(ID) AS TOT FROM ".PREFIX."USER_RATING WHERE MERCHANTID = ? AND ISVALID = 'Y'", array($userId));
		$row		= getRow($res);
		$avgRating	= (int)$row['AVG'];
		$totReviews	= (int)$row['TOT'];

		$ratingUrl	= getMerchantPath($userId, 'Reviews', '', $uiRec['FILENAME']);

//*************************************************************************************************

        // Render template
        renderTemplate('merchant_detail', [
            'userId' => $userId,
            'uiRec' => $uiRec,
            'merchantImageExists' => $merchantImageExists,
            'avgRating' => $avgRating,
            'totReviews' => $totReviews,
            'ratingUrl' => $ratingUrl,
            'arrMerchatAccepts' => $arrMerchatAccepts,
            'arrVerifiedBy' => $arrVerifiedBy,
            'arrLanguages' => $arrLanguages,
        ]);

//*************************************************************************************************
