<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

		require ("path.php");
		require (PATH."include/include.php");

//*************************************************************************************************

		include (PATH."session.php");

//*************************************************************************************************

		$curArch	= '';//date('Y-m');
		$archive	= getVar('archive', '', $curArch);
		$newsId		= getVar('news', 'int');

		if ( $newsId > 0 )
		{
			$newsRec = getRecord('NEWS', $newsId);

			$pageTitle		= $newsRec['PAGE_TITLE'];
			$pageKeywords	= $newsRec['PAGE_KEYWORDS'];
			$pageDescription= $newsRec['PAGE_DESCRIPTION'];
		}

//*************************************************************************************************

		$args	= array();
		$sql	= "SELECT ID, NEWS_DATE, HEADLINE, DESCRIPTION FROM ".PREFIX."NEWS WHERE ISVALID = 'Y'";
		if ( $newsId == 0 && $archive == '' )
		{
			// do nothing
		}
		elseif ( $newsId == 0 )
		{
			$args[]	= $archive;
			$sql	.= " AND DATE_FORMAT(NEWS_DATE, '%Y-%m') = ?";
		}
		else
		{
			$args[]	= $newsId;
			$sql	.= " AND ID = ?";
		}
		$sql	.= " ORDER BY NEWS_DATE DESC, HEADLINE";

		$resWNewsPg	= breakPages($sql, '', 0, $args);

//*************************************************************************************************

		$archOpts	= '';
		$res		= executeQuery("SELECT DISTINCT(DATE_FORMAT(NEWS_DATE, '%Y-%m')) AS ARCHIVE FROM ".PREFIX."NEWS WHERE ISVALID = 'Y' ORDER BY NEWS_DATE DESC");
		$count		= 0;
		while ( $row = getRow($res) )
		{
			if ( $count++ == 0 )
			{
				if ( $row['ARCHIVE'] != $curArch )
				{
					if ( $curArch != '' )
					{
						$archYear	= substr($curArch, 0, 4);
						$archMonth	= substr($curArch, 5, 2);
						$archTitle	= formatDate($curArch.'-01', 'F, Y');

						$archOpts .= '<option value="'.$curArch.'">'.$archTitle.'</option>';
					}
					else
						$archOpts .= '<option value="">'.SELECT_ANY.'</option>';
				}
			}

			$archYear	= substr($row['ARCHIVE'], 0, 4);
			$archMonth	= substr($row['ARCHIVE'], 5, 2);
			$archTitle	= formatDate($row['ARCHIVE'].'-01', 'F, Y');
//			$archTitle	= date('F, Y', mktime(0, 0, 0, $archMonth, 1, $archYear));
			
			$archOpts .= '<option value="'.$row['ARCHIVE'].'" '.($archive==$row['ARCHIVE']?'selected':'').'>'.$archTitle.'</option>';
		}

//*************************************************************************************************

		$arrComments	= array();
		$commentRow		= array('USER_NAME'=>'', 'USER_CITY'=>'', 'USER_STATE'=>'', 'USER_COUNTRY'=>'', 'REVIEW'=>'');
		if ( $newsId != '' )
		{
			$sql = "SELECT USERID, USER_NAME, USER_CITY, USER_STATE, DATE_ADDED, REVIEW FROM ".PREFIX."NEWS_COMMENTS WHERE NEWS_ID = ? AND ISVALID = 'Y' ORDER BY DATE_ADDED DESC";
			$res = preparedQuery($sql, array($newsId));
			while ( ($row = getRow($res)) )
			{
				if ( DO_WRITE_NEWS_COMMENTS_WITHOUT_LOGIN == 1 )
				{
					$name		= $row['USER_NAME'];
					$location 	= ($row['USER_CITY']!='' && $row['USER_STATE']!='') ? $row['USER_CITY'].', '.$row['USER_STATE'] : $row['USER_CITY'].$row['USER_STATE'];
				}
				else
				{
					$name		= $row['USERID'];
					$location	= '';
					
					$sql2		= "SELECT NAME, CITY, STATE FROM ".PREFIX."VISITORINFO WHERE USERID = ?";
					$res2 		= preparedQuery($sql2, array($row['USERID']));
					if ( ($row2 = getRow($res2)) )
					{
						$name 	  	= $row2['NAME'];
						$location 	= ($row2['CITY']!='' && $row2['STATE']!='') ? $row2['CITY'].', '.$row2['STATE'] : $row2['CITY'].$row2['STATE'];
					}
				}
				
				$row['NAME']	= $name;
				$row['LOCATION']= $location;

				$arrComments[]	= $row;
			}
			
			// Get comment entered by this user
			if ( defined('DO_WRITE_NEWS_COMMENTS_WITHOUT_LOGIN') && DO_WRITE_NEWS_COMMENTS_WITHOUT_LOGIN != 1 && $visitorId != '' )
			{
				$sql = "SELECT USER_NAME, USER_CITY, USER_STATE, USER_COUNTRY, REVIEW FROM ".PREFIX."NEWS_COMMENTS WHERE USERID = ? AND NEWS_ID = ?";
				$res = preparedQuery($sql, array($visitorId, $newsId));
				$commentRow = getRow($res);
			}
		}

//*************************************************************************************************

		$return			= 'news.php?archive='.$archive.'&news='.$newsId.'&';

//*************************************************************************************************
		
        // Render template
        renderTemplate('news', [
            'newsId' => $newsId,
            'curArch' => $curArch,
            'archive' => $archive,
            'archOpts' => $archOpts,
            'newsRec' => $newsRec,
            'resWNewsPg' => $resWNewsPg,
            'arrComments' => $arrComments,
            'commentRow' => $commentRow,
            'return' => $return,
        ]);

//*************************************************************************************************

		free($resWNewsPg);

//*************************************************************************************************
