<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

//		error_reporting(0);
//		ini_set('display_errors',	'Off');

//*************************************************************************************************

// Change it to 1 if you want to see error instead of no-image.gif
define( 'SHOW_DETAILED_ERROR', 0 );

//*************************************************************************************************

require( "path.php" );
require( PATH . "include/include.php" );
require( PATH . "include/include_thumbnail.php" );

//*************************************************************************************************

include( PATH . "session.php" );

//*************************************************************************************************

$productId = getVar( 'p', 'int' );
$imageId   = getVar( 'pi', 'int' );

//*************************************************************************************************

// Check for empty product Id
if ( $productId == 0 ) {
	exitWithHeaderMsg( 'There is no productId provided.' );
}

//*************************************************************************************************

if ( IS_MULTIPLE_IMAGES_INSTALLED == 1 ) {
	if ( $imageId == 0 ) {
		$imageId = defaultProductImageId( $productId );
	}
}

// Get the filename
if ( ! ( $prodImg = getRecord( 'PRODUCT_IMAGE', $imageId ) ) ) {
	exitWithHeaderMsg( 'Image record cannot be loaded ' . $imageId );
}
$filename = $prodImg['FILENAME'];

//*************************************************************************************************

// Find local image path in the harddisk
// Remember to use this field instead of PRODUCT_IMAGE column LOCAL_IMAGE
// Because product can be moved
$categoryId = getColumn( 'PRODUCT', $productId, 'CATEGORY_ID', 'ID' );
$imgName    = getProductImagePath( $productId, '', $filename );
$imgPath    = PATH_SUBD . $imgName;

//		echo "\nLocal Image Path: [$imgPath] \n";

//*************************************************************************************************

// Remote Image URL
$imgRemote = $prodImg['REMOTE_IMAGE'];

//*************************************************************************************************

// If we use separate server for images AND image is not downloaded (or attempted for download) AND its a remote image, then attempt to create product folders
if ( defined( 'IS_THIS_STATIC_SERVER' ) && IS_THIS_STATIC_SERVER == 1 && $prodImg['IS_DOWNLOADED'] == 0 && $prodImg['REMOTE_IMAGE'] != 'upload' ) {
	$msgEx = '';
	makeProductImagePath( $msgEx, $productId, $categoryId, $filename );
}

//*************************************************************************************************

// Image is manually uploaded from admin panel
if ( $imgRemote == 'upload' ) {
	if ( file_exists( $imgPath ) ) {
		showLocalFile( $imgName );
		die;
	} else {
		if ( SHOW_DETAILED_ERROR == 1 ) {
			exitWithHeaderMsg( 'Product image is not properly uploaded from admin panel [' . $imgRemote . '] [' . $productId . '].' );
		} else {
			header( "Location: " . SCRIPT_ROOT . "images/" . $langFolder . "/no-image.gif" );
		}
		die;
	}
} // Images are downloaded on server at runtime, when page is displayed for the first time
elseif ( PRODUCT_IMAGE_DISPLAY_METHOD == 1 ) {
	// If cache file did not exist, then we check if the large file exists or not, if no then download it
	if ( ! file_exists( $imgPath ) ) {
		if ( ! isValidRemoteUrl( $imgRemote ) ) {
			if ( SHOW_DETAILED_ERROR == 1 ) {
				exitWithHeaderMsg( 'Product image record does not contain remote image url. [' . $imgRemote . ']' );
			} else {
				header( "Location: " . SCRIPT_ROOT . "images/" . $langFolder . "/no-image.gif" );
			}
		}

		$msg = '';
		$ret = saveProductImageFromUrl( $msg, $imgName, $imgRemote );

		// File download failed
		if ( $ret == 0 ) {
			if ( SHOW_DETAILED_ERROR == 1 ) {
				exitWithHeaderMsg( 'Error download remote image [' . $msg . '] [' . $imgRemote . '].' );
			} else {
				header( "Location: " . SCRIPT_ROOT . "images/" . $langFolder . "/no-image.gif" );
			}
			die;
		}
	} else {
		$imgModTimezone = gmdate( "Y-m-d H:i:s", filemtime( $imgPath ) );

		$year  = substr( $imgModTimezone, 0, 4 );
		$month = substr( $imgModTimezone, 5, 2 );
		$day   = substr( $imgModTimezone, 8, 2 );

		$hour = @substr( $imgModTimezone, 11, 2 );
		$min  = @substr( $imgModTimezone, 14, 2 );
		$sec  = @substr( $imgModTimezone, 17, 4 );

		$imgModTimeServer = date( "Y-m-d H:i:s", mktime( $hour + SCRIPT_TIMEZONE, $min, $sec, $month, $day, $year ) );

		// Download New Copy
		if ( $imgModTimeServer < $prodImg['ADDED_ON'] ) {
			if ( ! isValidRemoteUrl( $imgRemote ) ) {
				if ( SHOW_DETAILED_ERROR == 1 ) {
					exitWithHeaderMsg( 'Product image record does not contain remote image url [' . $imgRemote . '].' );
				} else {
					header( "Location: " . SCRIPT_ROOT . "images/" . $langFolder . "/no-image.gif" );
				}
				die;
			}

			$msg = '';
			$ret = saveProductImageFromUrl( $msg, $imgName, $imgRemote );

			// File download failed
			if ( $ret == 0 ) {
				if ( SHOW_DETAILED_ERROR == 1 ) {
					exitWithHeaderMsg( 'Error download remote image [' . $msg . '] [' . $imgRemote . '].' );
				} else {
					header( "Location: " . SCRIPT_ROOT . "images/" . $langFolder . "/no-image.gif" );
				}
				die;
			}
		}

	}

	showLocalFile( $imgName );
	die;
}

//*************************************************************************************************

// Images are displayed from merchant website, only thumbnails are stored on server when page is displayed for the first time
elseif ( PRODUCT_IMAGE_DISPLAY_METHOD == 2 ) {
	if ( ! isValidRemoteUrl( $imgRemote ) ) {
		exitWithHeaderMsg( 'Product image record does not contain remote image url.' );
	}

	header( "Location: " . $imgRemote );
	die;
}

//*************************************************************************************************

// Default settings (Images are downloaded on server during datafeed import)
else {
	showLocalFile( $imgName );
	die;
}

//*************************************************************************************************
?>