<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

//		error_reporting(0);
//		ini_set('display_errors',	'Off');

//*************************************************************************************************

// Change it to 1 if you want to see error instead of no-image.gif
define( 'SHOW_DETAILED_ERROR', isset( $_GET['debug'] ) ? (int) $_GET['debug'] : 0 );

//*************************************************************************************************

require( "path.php" );
require( PATH . "include/include.php" );
require( PATH . "include/include_thumbnail.php" );

//*************************************************************************************************

include( PATH . "session.php" );

//*************************************************************************************************

$pFilename = getVar( 'pf', '', '', [ 'maxlen' => 255 ] );
$productId = getVar( 'p', 'int' );
$imageId   = getVar( 'pi', 'int' );
$imgWidth  = getVar( 'w', 'int' );
$imgHeight = getVar( 'h', 'int' );

if ( $imgWidth == 0 && $imgHeight == 0 ) {
	$imgWidth = 120;
}

//*************************************************************************************************

if ( $productId == 0 && $pFilename != '' ) {
	$productId = (int) getColumn( 'PRODUCT', $pFilename, 'ID', 'FILENAME' );
}

//*************************************************************************************************

// Check for empty product Id
if ( $productId == 0 ) {
	exitWithHeaderMsg( 'There is no productId provided.' );
}

//*************************************************************************************************

if ( IS_MULTIPLE_IMAGES_INSTALLED == 1 ) {
	if ( $imageId == 0 ) {
		$imageId = defaultProductImageId( $productId );
	}
}

// Get the filename
if ( ! ( $prodImg = getRecord( 'PRODUCT_IMAGE', $imageId ) ) ) {
	exitWithHeaderMsg( 'Image record cannot be loaded ' . $imageId );
}
$filename = $prodImg['FILENAME'];

//*************************************************************************************************

// Find local image path in the harddisk
// Remember to use this field instead of PRODUCT_IMAGE column LOCAL_IMAGE
// Because product can be moved
$categoryId = getColumn( 'PRODUCT', $productId, 'CATEGORY_ID', 'ID' );
$imgName    = getProductImagePath( $productId, '', $filename );
$imgPath    = PATH_SUBD . $imgName;

if ( SHOW_DETAILED_ERROR > 0 ) {
	echo "\nLocal Image Path: [$imgPath]<br>\n";
}

//*************************************************************************************************

if ( SHOW_DETAILED_ERROR > 1 ) {
	echo "Product Image [$imgName]<br><br>\n\n";
}

// 17-Oct-15: Last time it was tried to be downloaded but failed. So dont download again
if ( $prodImg['IS_DOWNLOADED'] == '2' ) {
	if ( SHOW_DETAILED_ERROR > 0 ) {
		exitWithHeaderMsg( 'Tried to download product image but failed previously [' . $productId . '].' );
	} else {
		redirectToNoImage( $imgWidth );
	}
	die;
}

if ( SHOW_DETAILED_ERROR > 0 ) {
	echo "<pre>";
	print_r( $prodImg );
	echo "</pre>";
}

//*************************************************************************************************

// 21/9/2012: SALMAN: An extra check for the addon
if ( IS_MULTIPLE_IMAGES_INSTALLED == 1 ) {
	// The local image name in database is not same as in the generated link
	if ( $prodImg['LOCAL_IMAGE'] != $imgName ) {
		$prodImg['LOCAL_IMAGE'] = $imgName;
	}
}

//*************************************************************************************************

// Remote Image URL
$imgRemote = $prodImg['REMOTE_IMAGE'];

// Get cache file path
$imgCachePath = PATH_SUBD . getProductThumbPath( $imgName, $imgWidth, $imgHeight );

//*************************************************************************************************

// If we use separate server for images AND image is not downloaded (or attempted for download) AND its a remote image, then attempt to create product folders
if ( defined( 'IS_THIS_STATIC_SERVER' ) && IS_THIS_STATIC_SERVER == 1 && $prodImg['IS_DOWNLOADED'] == 0 && $prodImg['REMOTE_IMAGE'] != 'upload' ) {
	$msgEx = '';
	makeProductImagePath( $msgEx, $productId, $categoryId, $filename );
}

//*************************************************************************************************


// Images are downloaded on server at runtime, when page is displayed for the first time
//  - OR -
// Images are displayed from merchant website, only thumbnails are stored on server when page is displayed for the first time
if ( PRODUCT_IMAGE_DISPLAY_METHOD == 1 || PRODUCT_IMAGE_DISPLAY_METHOD == 2 ) {

	if ( SHOW_DETAILED_ERROR > 1 ) {
		echo "Cache Path [$imgCachePath]<br><br>\n\n";
	}

	// If cache file exists and is greater than 0 bytes
	if ( file_exists( $imgCachePath ) && filesize( $imgCachePath ) > 0 ) {
		/*
		// Original file exists and Thumb is newer than it
		if ( file_exists($imgPath) && filemtime($imgCachePath) > filemtime($imgPath) )
		{
			if ( SHOW_DETAILED_ERROR > 1 )
				echo "Cache Image is NEW<br><br>\n\n";

			getCacheThumbnail($imgCachePath);
			die;
		}
		*/
		$imgCacheModTimezone = gmdate( "Y-m-d H:i:s", filemtime( $imgCachePath ) );

		$year  = substr( $imgCacheModTimezone, 0, 4 );
		$month = substr( $imgCacheModTimezone, 5, 2 );
		$day   = substr( $imgCacheModTimezone, 8, 2 );

		$hour = @substr( $imgCacheModTimezone, 11, 2 );
		$min  = @substr( $imgCacheModTimezone, 14, 2 );
		$sec  = @substr( $imgCacheModTimezone, 17, 4 );

		$imgCacheModTimeServer = date( "Y-m-d H:i:s", mktime( $hour + SCRIPT_TIMEZONE, $min, $sec, $month, $day, $year ) );

		// Original thumb exists and Thumb is newer than PRODUCT_IMAGE date-added
		if ( $imgCacheModTimeServer > $prodImg['ADDED_ON'] ) {
			if ( SHOW_DETAILED_ERROR > 1 ) {
				echo "Cache Image is NEW than record added in database<br><br>\n\n";
			}

			getCacheThumbnail( $imgCachePath );
			die;
		}
	}


	// If Large file exists and greater than 0 bytes
	if ( $imgRemote != 'upload' && file_exists( $imgPath ) && filesize( $imgPath ) > 0 ) {
		$imgModTimezone = gmdate( "Y-m-d H:i:s", filemtime( $imgPath ) );

		$year  = substr( $imgModTimezone, 0, 4 );
		$month = substr( $imgModTimezone, 5, 2 );
		$day   = substr( $imgModTimezone, 8, 2 );

		$hour = @substr( $imgModTimezone, 11, 2 );
		$min  = @substr( $imgModTimezone, 14, 2 );
		$sec  = @substr( $imgModTimezone, 17, 4 );

		$imgModTimeServer = date( "Y-m-d H:i:s", mktime( $hour + SCRIPT_TIMEZONE, $min, $sec, $month, $day, $year ) );


		// Original Large File DOES NOT exists and Thumb is newer than PRODUCT_IMAGE date-added
		if ( $imgModTimeServer > $prodImg['ADDED_ON'] ) {
			// Do nothing so that image is displayed from this large file on line# 192
		} else {
			// Delete this incorrect file so that new file is downloaded in next if check
			@unlink( $imgPath );
		}
	}


	// If cache file did not exist, then we check if the large file exists or not, if no then download it, or even if yes but is 0 bytes then try to download it
	if ( ! file_exists( $imgPath ) || filesize( $imgPath ) == 0 ) {
		// Large file do not exists
		// BUT image was manually uploaded
		if ( $imgRemote == 'upload' ) {
			if ( SHOW_DETAILED_ERROR > 0 ) {
				exitWithHeaderMsg( 'Product image is not properly uploaded from admin panel [' . $imgRemote . '] [' . $productId . '].' );
			} else {
				redirectToNoImage( $imgWidth );
			}
			die;
		}

		if ( SHOW_DETAILED_ERROR > 1 ) {
			echo "Image does not exists and now will download it [$imgRemote]<br><br>\n\n";
		}

		if ( ! isValidRemoteUrl( $imgRemote ) ) {
			if ( SHOW_DETAILED_ERROR > 0 ) {
				exitWithHeaderMsg( 'Product image record does not contain remote image url [' . $imgRemote . '].' );
			} else {
				redirectToNoImage( $imgWidth );
			}
			die;
		}

		$msg = '';
		$ret = saveProductImageFromUrl( $msg, $imgName, $imgRemote );
		if ( SHOW_DETAILED_ERROR > 0 ) {
			echo "Image downloaded [Result:$ret] [$imgName]<br>\n";
		}

		// 17-Oct-15: SALMAN: We should mark the PRODUCT_IMAGE is attempt to be DOWNLOADED so that it is not done again.
		executeUpdate( "UPDATE " . PREFIX . "PRODUCT_IMAGE SET IS_DOWNLOADED = " . ( $ret == 0 ? '2' : '1' ) . " WHERE PRODUCT_ID = " . $productId );


		// File download failed
		if ( $ret == 0 ) {
			if ( SHOW_DETAILED_ERROR > 0 ) {
				die( 'Error download remote image [' . $msg . '].' );
			} else {
				redirectToNoImage( $imgWidth );
			}
			die;
		}
	}

	// By now the product image must have been saved on its location, so now we can get thumb from that image
	// Now check if we can write on cache directory
	$imgCacheDir = dirname( $imgCachePath );
	if ( file_exists( $imgCacheDir ) ) {
		if ( SHOW_DETAILED_ERROR > 1 ) {
			echo "Now make cache [$imgCachePath]<br><br>\n\n";
		}


		if ( is_writable( $imgCacheDir ) ) {
			getThumbnail( $imgPath, $imgCachePath, $imgWidth, $imgHeight );
			getCacheThumbnail( $imgCachePath );
		} else {
			if ( SHOW_DETAILED_ERROR > 0 ) {
				exitWithHeaderMsg( 'Cache directory not writeable. [' . $imgCacheDir . ']' );
			} else {
				redirectToNoImage( $imgWidth );
			}
			die;
		}
	} else {
		if ( SHOW_DETAILED_ERROR > 0 ) {
			exitWithHeaderMsg( 'Cache directory does not exist. [' . $imgCacheDir . ']' );
		} else {
			redirectToNoImage( $imgWidth );
		}
		die;
	}

	// For this type of display, we donot keep the large image on our server, so we delete it after cache is shown
	if ( $imgRemote != 'upload' && PRODUCT_IMAGE_DISPLAY_METHOD == 2 ) {
		if ( SHOW_DETAILED_ERROR > 1 ) {
			echo "Now DELETE source image as setting is '2' [$imgPath]<br><br>\n\n";
		}

		if ( file_exists( $imgPath ) ) {
			@unlink( $imgPath );
		}
	}

	die;
}

//*************************************************************************************************

// Default settings (Images are downloaded on server during datafeed import)
else {
	header( "Location: " . SCRIPT_ROOT . "thumbnail.php?f=" . urlencode( $imgName ) . "&w=" . $imgWidth . "&h=" . $imgHeight . "&" );
	die;
}

//*************************************************************************************************
?>