<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

	if ( $apiType != API_TYPE_AMAZON )
		require (PATH."include/include_amazon_product_prices.php");

	// Only run this on mysql products
	if ( $apiType != API_TYPE_AMAZON && $AMZ_PRICES_SETTINGS_FOUND )
	{

//*************************************************************************************************

		$pricesAdded	= false;

		$amzCat = 'Electronics';
		if ( $cat['AMAZON_SEARCH_INDEX'] != '' )
			$amzCat = $cat['AMAZON_SEARCH_INDEX'];
		elseif ( $cat['AMAZON_CATEGORY'] != '' )
			$amzCat = $cat['AMAZON_CATEGORY'];

//*************************************************************************************************

		if ( $apiType == API_TYPE_MYSQL )
		{
			$aId		= $prod['AMAZON_ID'];
			if ( $aId != '' && $aId != '0' )
			{
				$amzPrices			= getAmazonPricesForASIN($aId, $productId, $sp);
				$pricesAdded		= count($amzPrices) > 0;
				$noOfRecords	   += count($amzPrices);
				$arrPrices			= array_merge($arrPrices, $amzPrices);
			}

//*************************************************************************************************

			// If (amazon asin was not mapped OR price was not added) AND category is mapped with amazon
			if ( ($aId == '' || $aId == '0' || !$pricesAdded) && $amzCat != '' )
			{
				// Find product with EAN if it is set
				if ( $prod['EAN_UPC'] != '' )
				{
					$resAmzProds = amazon_getProducts($amzCat, $prod['EAN_UPC'], '', 1);
					if ( is_array($resAmzProds) && isset($resAmzProds['ITEM']) && is_array($resAmzProds['ITEM']) )
					{
						$arrAmzPrices = array();
						foreach ( $resAmzProds['ITEM'] as $rowAmzProd )
						{
							$aId	= $rowAmzProd['ASIN'][0];
							$title	= $rowAmzProd['ITEMATTRIBUTES'][0]['TITLE'][0];

							if ( is_numeric($title) )
								continue;

							$arrAmzPrices[] = array(
														'ASIN'		=> $rowAmzProd['ASIN'][0],
														'TITLE'		=> $title,
														'PRICE'		=> $rowAmzProd['ITEMATTRIBUTES'][0]['LISTPRICE'][0]['AMOUNT'][0]/100
													);
						}

						$aId = findBestAmazonPrice($arrAmzPrices, $prod);
						if ( $aId != '' )
						{
							$amzPrices			= getAmazonPricesForASIN($aId, $productId, $sp);
							$pricesAdded		= count($amzPrices) > 0;
							$noOfRecords	   += count($amzPrices);
							$arrPrices			= array_merge($arrPrices, $amzPrices);
						}
					}
				}

				// Find product with title clean and mapped search index
				if ( !$pricesAdded )
				{
					$resAmzProds = amazon_getProducts($amzCat, trim($prod['TITLE_CLEAN'])==''?doStripSpecialChars($prod['TITLE']):$prod['TITLE_CLEAN'], '', 1);
					if ( is_array($resAmzProds) && isset($resAmzProds['ITEM']) && is_array($resAmzProds['ITEM']) )
					{
						$arrAmzPrices = array();
						foreach ( $resAmzProds['ITEM'] as $rowAmzProd )
						{
							$aId	= $rowAmzProd['ASIN'][0];
							$title	= $rowAmzProd['ITEMATTRIBUTES'][0]['TITLE'][0];

							if ( is_numeric($title) )
								continue;

							$arrAmzPrices[] = array(
														'ASIN'		=> $rowAmzProd['ASIN'][0],
														'TITLE'		=> $title,
														'PRICE'		=> $rowAmzProd['ITEMATTRIBUTES'][0]['LISTPRICE'][0]['AMOUNT'][0]/100
													);
						}

						$aId = findBestAmazonPrice($arrAmzPrices, $prod);
						if ( $aId != '' )
						{
							$amzPrices			= getAmazonPricesForASIN($aId, $productId, $sp);
							$pricesAdded		= count($amzPrices) > 0;
							$noOfRecords	   += count($amzPrices);
							$arrPrices			= array_merge($arrPrices, $amzPrices);
						}
					}
				}
			}

		} // end-if of Mysql

		else
		{
			$resAmzProds = amazon_getProducts($amzCat, doStripSpecialChars($prod['TITLE']), '', 1);
			if ( is_array($resAmzProds) && isset($resAmzProds['ITEM']) && is_array($resAmzProds['ITEM']) )
			{
				$arrAmzPrices = array();
				foreach ( $resAmzProds['ITEM'] as $rowAmzProd )
				{
					$title	= $rowAmzProd['ITEMATTRIBUTES'][0]['TITLE'][0];

					if ( is_numeric($title) )
						continue;

					$arrAmzPrices[] = array(
												'ASIN'		=> $rowAmzProd['ASIN'][0],
												'TITLE'		=> $title,
												'PRICE'		=> $rowAmzProd['ITEMATTRIBUTES'][0]['LISTPRICE'][0]['AMOUNT'][0]/100
											);
				}

				$aId = findBestAmazonPrice($arrAmzPrices, $prod);
				if ( $aId != '' )
				{
					$amzPrices			= getAmazonPricesForASIN($aId, $productId, $sp);
					$pricesAdded		= count($amzPrices) > 0;
					$noOfRecords	   += count($amzPrices);
					$arrPrices			= array_merge($arrPrices, $amzPrices);
				}
			}
		}

//*************************************************************************************************

	} // end-if of $AMZ_PRICES_SETTINGS_FOUND

//*************************************************************************************************
?>