<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

require("path.php");
require(PATH . "include/include.php");

//*************************************************************************************************

$langFilename2 = 'products.php';
include(PATH . "session.php");

//*************************************************************************************************

include(PATH . "products_top.php");

//*************************************************************************************************

// Load here so that langauges are loaded as well
require(PATH . "include/include_ebay.php");

//*************************************************************************************************

$exceptionMsg = '';

$noOfRecords = 0;
$noOfPages = 0;
$arrPrices = array();

$start = (int)$_GET['start'];
$res = ebayGetSearch($prod['TITLE'], '', $start / 10 + 1, 10, ''); //$prod['EBAYID']
//		echo '<pre>';print_r($res);die;

if (isset($res['FINDITEMSBYKEYWORDSRESPONSE'][0]['SEARCHRESULT'][0])) {
    $res = $res['FINDITEMSBYKEYWORDSRESPONSE'][0];

    if ($res['ACK'][0] == 'Success') {
        $resSize = $res['SEARCHRESULT'][0]['__ATTRIBUTES']['COUNT'] > 10 ? 10 : $res['SEARCHRESULT'][0]['__ATTRIBUTES']['COUNT'];
        $noOfPages = ceil($resSize / 10);
        $noOfRecords = $resSize;

        if ($resSize > 0) {
            for ($j = 0; $j < $resSize; $j++) {
                $count++;
                $row = $res['SEARCHRESULT'][0]['ITEM'][$j];

                $detailUrl = $row['VIEWITEMURL'][0];
                $price = $row['SELLINGSTATUS'][0]['CURRENTPRICE'][0][0];
                $pageUrl = SCRIPT_ROOT . 'redirect_ebay.php?id=' . $productId . '&price=' . $price . '&url=' . base64_encode($detailUrl);

                $arrPrices[$j]['TITLE'] = $row['TITLE'][0];
                $arrPrices[$j]['BUYURL'] = $pageUrl;

                if ($row['GALLERYURL'][0] != '')
                    $arrPrices[$j]['IMAGE'] = "<img src=\"" . fixMixedContentUrl($row['GALLERYURL'][0]) . "\" border='0'>";

                $arrPrices[$j]['STARTTIME'] = formatDateTime($row['LISTINGINFO'][0]['STARTTIME'][0]);
                $arrPrices[$j]['ENDTIME'] = formatDateTime($row['LISTINGINFO'][0]['ENDTIME'][0]);
                $arrPrices[$j]['BIDCOUNT'] = number_format($row['SELLINGSTATUS'][0]['BIDCOUNT'][0]);
                $arrPrices[$j]['PRICE'] = $row['SELLINGSTATUS'][0]['CURRENTPRICE'][0]['__ATTRIBUTES']['CURRENCYID'] . $price;
            }
        }

        if ($noOfRecords == 0)
            $exceptionMsg = NO_MERCHANTS_FOUND;

    } else {
        $exceptionMsg = '<b>' . $res['SHORTMESSAGE'][0] . ' : </b>' . $res['LONGMESSAGE'][0];
    }
} else {
    $exceptionMsg = 'Error, see source for details<!-- ' . print_r($res, 1) . ' -->';
}


//*************************************************************************************************

// Render template
renderTemplate('products_ebay', [
    'apiType' => $apiType,
    'exceptionMsg' => $exceptionMsg,
    'arrPrices' => $arrPrices,
]);

//*************************************************************************************************
