<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

		defined('PATH') or die('direct access not allowed!');

//*************************************************************************************************

		function pcsProductsListing(&$msg, $isSearch, $categoryId='', $searchText='', $searchType='', $searchProductIn='', $advanceSearch='', $manuText='', $manufacturer='', $merchant='', $fId='', $srhcats='', $minPrice='', $maxPrice='', $childList='', $categoryTitle='', $categoryRec='')
		{
			global $loadFromProdSrc, $isAjaxProdSrc;

			// If this is an ajax call, then filters should be cleared because they will not work with this api, instead they can mess
			if ( $isAjaxProdSrc )
				$fId = array();
			
			// Check search string if we are in search mode
			if ( $isSearch )
			{
				if ( function_exists('isRedInput') )
				{
					if ( isRedInput($searchText) || isRedInput($searchType) )
					{
						$msg = UNSAFE_SEARCH_QUERY;
						return 0;
					}
				}

				if ( strlen($searchText) < 3 && $manuText == '' && (!is_array($merchant) || count($merchant) == 0) )
				{
					$msg = SEARCH_QUERY_TOO_SHORT;
					return 0;
				}
			}

			// Set return array here
			$ret	= array();

			// Check if shopzilla listing is enabled
			if ( $loadFromProdSrc == API_TYPE_SHOPZILLA )
			{
				require_once (PATH."include/include_shopzilla.php");

				return pcsShopzillaSearch($msg, $isSearch, isset($categoryRec['SHOPZILLA_ID']) ? $categoryRec['SHOPZILLA_ID'] : 0, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice);
			}

			// Check if amazon listing is enabled
			elseif ( $loadFromProdSrc == API_TYPE_AMAZON )
			{
				require_once (PATH."include/include_amazon_ecs.php");

				return pcsAmazonSearch($msg, $isSearch, isset($categoryRec['AMAZON_SEARCH_INDEX']) ? $categoryRec['AMAZON_SEARCH_INDEX'] : '', isset($categoryRec['AMAZON_BROWSE_NODE']) ? $categoryRec['AMAZON_BROWSE_NODE'] : '', $isSearch ? $searchText : $categoryRec['AMAZON_SEARCH_KEYWORDS'], $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice);
			}

			// Check if kelkoo listing is enabled
			elseif ( $loadFromProdSrc == API_TYPE_KELKOO )
			{
				require_once (PATH."include/include_kelkoo.php");

				return pcsKelkooSearch($msg, $isSearch, isset($categoryRec['KELKOO_ID']) ? $categoryRec['KELKOO_ID'] : 0, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice);
			}

			// Check if SDC listing is enabled
			elseif ( $loadFromProdSrc == API_TYPE_SDC )
			{
				require_once (PATH."include/include_sdc.php");

				return pcsSDCSearch($msg, $isSearch, isset($categoryRec['SDC_ID']) && !$isSearch ? $categoryRec['SDC_ID'] : 0, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice);
			}

			// Check if AffWin listing is enabled
			elseif ( $loadFromProdSrc == API_TYPE_AFFWIN )
			{
				require_once (PATH."include/include_affwin.php");

				return pcsAffWinSearch($msg, $isSearch, isset($categoryRec['AFFWIN_ID']) && !$isSearch ? $categoryRec['AFFWIN_ID'] : 0, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice, $categoryTitle);
			}

			// Check if NexTag listing is enabled
			elseif ( $loadFromProdSrc == API_TYPE_NEXTAG )
			{
				require_once (PATH."include/include_nextag.php");

				return pcsNexTagSearch($msg, $isSearch, isset($categoryRec['NEXTAG_ID']) && !$isSearch ? $categoryRec['NEXTAG_ID'] : 0, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice);
			}

			// Check if PriceGrabber listing is enabled
			elseif ( $loadFromProdSrc == API_TYPE_PRICEGRABBER )
			{
				require_once (PATH."include/include_pricegrabber.php");

				return pcsPriceGrabberSearch($msg, $isSearch, isset($categoryRec['PRICEGRABBER_ID']) && !$isSearch ? $categoryRec['PRICEGRABBER_ID'] : 0, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice);
			}

			// Check if PopShops listing is enabled
			elseif ( $loadFromProdSrc == API_TYPE_POPSHOPS )
			{
				require_once (PATH."include/include_popshops.php");

				return pcsPopShopsSearch($msg, $isSearch, isset($categoryRec['POPSHOPS_ID']) && !$isSearch ? $categoryRec['POPSHOPS_ID'] : 0, $searchText, $merchant, $fId, $srhcats, $minPrice, $maxPrice);
			}

			// Check if Affilinet listing is enabled
			elseif ( $loadFromProdSrc == API_TYPE_AFFILINET )
			{
				require_once (PATH."include/include_affilinet.php");

				return pcsAffilinetSearch($msg, $isSearch, isset($categoryRec['AFFILINET_ID']) && !$isSearch ? $categoryRec['AFFILINET_ID'] : 0, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice);
			}

			// Check if Connexity listing is enabled
			elseif ( $loadFromProdSrc == API_TYPE_CONNEXITY )
			{
				require_once (PATH."include/include_connexity.php");

				return pcsConnexitySearch($msg, $isSearch, isset($categoryRec['CONNEXITY_ID']) && !$isSearch ? $categoryRec['CONNEXITY_ID'] : 0, $searchText, $merchant, $fId, $srhcats, $minPrice, $maxPrice);
			}

			// Check if Elasticsearch is enabled
			elseif ( defined('IS_ELASTICSEARCH_INSTALLED') && IS_ELASTICSEARCH_INSTALLED == 1 && $loadFromProdSrc == API_TYPE_ELASTICSEARCH )
			{
				return pcsElasticsearchSearch($msg, $isSearch, $categoryId, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice);
			}

			// Check if Zanox listing is enabled
			elseif ( $loadFromProdSrc == API_TYPE_ZANOX )
			{
				require_once (PATH."include/include_zanox.php");

				return pcsZanoxSearch($msg, $isSearch, isset($categoryRec['ZANOX_ID']) && !$isSearch ? $categoryRec['ZANOX_ID'] : 0, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice);
			}

			// Search via sphinx if installed and could be searched
			// 9/4/2013: Mamda: Removed [ $manuText == '' && ] because we now handled brand search in sphinx using a new index
			// 6/30/2016: Mamda: Removed [ getVar('mpp') != 1 && count($fId) == 0 && ] because we now them in sphinx using sphinxql
			if ( IS_SPHINX_SEARCH_INSTALLED == 1 && $_GET['noSphinx'] == '' && $advanceSearch == '' )
				return pcsSphinxSearch($msg, $isSearch, $categoryId, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice, $categoryRec);


			// Search via mysql
			return pcsMysqlList($msg, $isSearch, $categoryId, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice, $childList, $categoryTitle, $categoryRec);
				
		}

//*************************************************************************************************

		function pcsSphinxSearch(&$msg, $isSearch, $categoryId='', $searchText='', $searchType='', $searchProductIn='', $advanceSearch='', $manuText='', $manufacturer='', $merchant='', $fId='', $srhcats='', $minPrice='', $maxPrice='', $categoryRec='', $cleanSearch=0)
		{
			global $pageSize, $x, $t;
			global $priceBoundSql;
			global $isAjaxProdSrc;

			$x				= getVar('x', 'int');
			$pageSize		= (int)$pageSize;
			$pageSize		= $pageSize == 0 ? 20 : $pageSize;
			$sk				= getVar('sk');
			$so				= getVar('so');
			$minPrice		= getVar('minPrice', 'int');
			$maxPrice		= getVar('maxPrice', 'int');

			$sphinxSKs		= array(
										'TITLE'			=> 'TITLE_SORT',
										'RATING'		=> 'PRODUCT_RATING',
										'PRICE_MIN'		=> 'MIN_PRICE'
									);

			$sphinxQuery	= '';
			$sphinxIndex	= '';
			$sphinxOptions	= '';
			$arrSphinxPIDs	= array();
			$totSphinxProds	= 0;

			$isBrandSearch	= $searchText == '' && $manuText != '';
			$isMPPSearch	= $searchText == '' && $merchant[0] != '' && getVar('mpp') == 1;

			if ( $isBrandSearch )
				$sphinxQuery = $manuText;
			elseif ( $isMPPSearch )
				$sphinxQuery = $merchant[0];
			else
				$sphinxQuery = $searchText;

			$sphinxQuery	= str_replace("-", "\\-", $sphinxQuery);
			$sphinxQuery	= str_replace("/", " ", $sphinxQuery);
			$sphinxQuery	= str_replace('(', '', $sphinxQuery);
			$sphinxQuery	= str_replace(')', '', $sphinxQuery);

			if ( $cleanSearch > 0 )
			{
				$sphinxQuery = str_replace('-', '', $sphinxQuery);
				$sphinxQuery = str_replace('.', '', $sphinxQuery);
				$sphinxQuery = str_replace('\\', '', $sphinxQuery);
				$sphinxQuery = str_replace('@', '', $sphinxQuery);
				$sphinxQuery = str_replace('#', '', $sphinxQuery);
				$sphinxQuery = str_replace('*', '', $sphinxQuery);
				$sphinxQuery = str_replace('(', '', $sphinxQuery);
				$sphinxQuery = str_replace(')', '', $sphinxQuery);
				$sphinxQuery = str_replace('%', '', $sphinxQuery);
				if ( $cleanSearch > 1 )
					$sphinxQuery = str_replace(' ', '', $sphinxQuery);
			}

			// Search by partial words if setup in constants
			//	must enable use of min_infix_len setting in sphinx.conf if want to use partial word search
			if ( IS_SEARCH_BY_WORD == 0 )
				$sphinxQuery = '*'.str_replace(' ', '* *', $sphinxQuery).'*';

			if ( $isSearch )
			{
				if ( $isBrandSearch )
					$sphinxIndex	= SPHINX_PREFIX.'IDX_pcs_search_brand';
				elseif ( $isMPPSearch )
					$sphinxIndex	= SPHINX_PREFIX.'IDX_pcs_search_mpp';
				elseif ( $searchProductIn == 'C' )
					$sphinxIndex	= SPHINX_PREFIX.'IDX_pcs_search_prodcode';
				elseif ( $searchProductIn == 'T' )
					$sphinxIndex	= SPHINX_PREFIX.'IDX_pcs_search_title';
				else
					$sphinxIndex	= SPHINX_PREFIX.'IDX_pcs_search_title, '.SPHINX_PREFIX.'IDX_pcs_search_prodcode';
			}
			else
			{
				$sphinxQuery	= $categoryId;//implode(' ', getChildCategoryList($categoryId));
				$sphinxQuery	= str_replace(' ', ' | ', $sphinxQuery);	// To make it search in MATCH_ANY mode
//				$sphinxOptions	.= 'OPTION ranker=matchany ';				// To get compatible ranking by match any
				// this above is not working right now, have to check in details later if it matters
				$sphinxIndex	= SPHINX_PREFIX.'IDX_pcs_category_id';
			}


			// Generate filters sql
			$filterSql	= '';
			if ( count($srhcats) > 0 )						$filterSql .= ' AND CATEGORY_ID IN ('.implode(',', $srhcats).')';
			if ( count($manufacturer) > 0 )					$filterSql .= ' AND MANUFACTURER_ID IN ('.implode(',', $manufacturer).')';
			if ( !$isMPPSearch && count($merchant) > 0 )	$filterSql .= ' AND FILTER_USERID IN ('.implode(',', $merchant).')';
			if ( count($fId) > 0 )							$filterSql .= ' AND VALUE_ID IN ('.implode(',', $fId).')';


			// Generate price sql
			$priceSql		= '';
			if ( $maxPrice != 0 )
				$priceSql	= "AND MIN_PRICE >= ".$minPrice." AND MIN_PRICE <= ".$maxPrice."";


			// Generate store count sql
			$storeCountSql	= '';
			if ( defined('DO_HIDE_PRODUCT_WITH_0_STORES') && DO_HIDE_PRODUCT_WITH_0_STORES == 1 )
				$storeCountSql	= "AND STORE_COUNT>0";


			// Generate order by
			$orderBy	= 'WEIGHT() DESC';
			if ( isset($sphinxSKs[$sk]) )
				$orderBy	= $sphinxSKs[$sk].' '.($so=='DESC'?'DESC':'ASC');


			// Now create the sphinxQL sql
			$sphinxSql	=
								// Main query
								"SELECT ID FROM ".$sphinxIndex
										." WHERE MATCH('".handleSingleQuote($sphinxQuery)."')" .$filterSql. ' ' .$priceSql. ' ' .$storeCountSql
										." ORDER BY ".$orderBy
										." LIMIT ".$x.",".$pageSize
										." FACET CATEGORY_ID LIMIT 500"
										." FACET MANUFACTURER_ID LIMIT 100"
										." FACET FILTER_USERID LIMIT 100"
										." FACET VALUE_ID LIMIT 500"
										." ".$sphinxOptions

								// Query for price min/max bounds
								.";SELECT MIN(MIN_PRICE), MAX(MIN_PRICE) FROM ".$sphinxIndex
										." WHERE MATCH('".handleSingleQuote($sphinxQuery)."')" .$filterSql. ' ' .$storeCountSql
										." ".$sphinxOptions

								// Query for meta (totals etc)
								.";SHOW META";


			if ( $_GET['debug'] == 1 )
				echo "\n<!-- \n SPHINX SQL:".$sphinxSql."\n -->\n";

			// Call sphinxQL with the sql
			$msg = '';
			$ret = sphinxQLQuery($msg, $sphinxSql);

			if ( $_GET['debug'] == 1 )
				echo "\n<!-- \n MSG:".$msg."\n RESULT:".print_r($ret, 1)."\n -->\n";

			// Quit if search failed. It must be an array with 7 sub-arrays (matches, cat-filters, manu-filters, merchant-filters, general-filters, price-bounds, totals)
			if ( $ret == null || !is_array($ret) || count($ret) != 7 )
				return 0;

			$matches	= $ret[0];
			$catFilters	= $ret[1];
			$manFilters	= $isBrandSearch ? array() : $ret[2];
			$merFilters	= $isMPPSearch ? array() : $ret[3];
			$valFilters	= $ret[4];
			$priceBnds	= $ret[5];
			$totals		= $ret[6];

			$ret		= '';

			$totSphinxProds	= (int)$totals[1]['Value'];

			if ( is_array($matches) )
			{
				foreach ( $matches as $temp )
				{
					if ( isset($temp['id']) )
						$arrSphinxPIDs[] = (int)$temp['id'];
				}
			}
			$arrSphinxPIDs		= array_unique($arrSphinxPIDs);

			if ( count($arrSphinxPIDs) < 1 )
			{
				if ( $cleanSearch == 0 )
					return pcsSphinxSearch($msg, $isSearch, $categoryId, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice, $categoryRec, 1);

				if ( $cleanSearch == 1 )
					return pcsSphinxSearch($msg, $isSearch, $categoryId, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice, $categoryRec, 2);

				$msg = NO_PRODUCTS_FOUND;
				return 0;
			}

			$filterArrCats		= $isAjaxProdSrc ? array() : getFilterArrayFromSphinxAttrs($catFilters, 'category_id', 'CATEGORY');
			$filterArrCats		= count($filterArrCats) < 2 ? array() : $filterArrCats;	// Only show category filter if more than 1
			$filterArrBrands	= $isAjaxProdSrc ? array() : getFilterArrayFromSphinxAttrs($manFilters, 'manufacturer_id', 'BRAND', 'ID', 'TITLE', 'MANUFACTURER_ID', 'MANUFACTURER');
			$filterArrStores	= $isAjaxProdSrc ? array() : getFilterArrayFromSphinxAttrs($merFilters, 'filter_userid', 'USERINFO', 'USERID', 'NAME', 'USERID', 'NAME');
			$filterArr			= $isAjaxProdSrc ? array() : getFilterArrayFromSphinxAttrs4Features($valFilters);

			$productTableName	= PREFIX."PRODUCT";
			if ( USE_PRODUCT_FEATURE_VIEW_TABLE != 1 )
			{
				if ( DO_ENABLE_SEARCH_BY_MATCH == 1 && $_GET['advanceSearch'] != '' )
					$productTableName	= PREFIX."PRODUCT_MYISAM";
			}
			else
				$productTableName	= PREFIX."PRODUCT_FEATURE_VIEW";


			// Now generate sql
			$sql			= "SELECT IFNULL(P.MIN_PRICE, 0) AS PRICE_MIN, IFNULL(P.MAX_PRICE, 0) AS PRICE_MAX, IFNULL(P.STORE_COUNT, 0) AS STORE_COUNT, P.ID AS ID, P.TITLE AS TITLE, P.MANUFACTURER, P.MANUFACTURER_CODE, P.FIELD_1 AS ARTICLE_CODE, '' AS DETAIL, P.FILENAME AS PFILENAME, P.PRODUCT_RATING AS RATING, C.ID AS CID, C.FILENAME AS CFILENAME, C.TITLE AS CATEGORY ".(IS_MERCHANTBID_INSTALLED!=0 ? ', P.MAX_BID':'')." FROM ".PREFIX."CATEGORY C, ".$productTableName." P WHERE P.ID IN (".implode(',', $arrSphinxPIDs).") AND C.ID = P.CATEGORY_ID AND C.ISVALID='Y' ORDER BY ".($sk==''?'':$sk.' '.$so.', ')." ".(IS_MERCHANTBID_INSTALLED!=0 ? 'MAX_BID DESC,':'')." STORE_COUNT DESC";
			$sqlTotal		= "SELECT ".$totSphinxProds." AS TOTAL";
			$_GET['t']		= $totSphinxProds;
			$t				= $totSphinxProds;

			// Query for calculating min/max price bounds
			$pmin = isset($priceBnds[0]['min(min_price)']) ? (float)$priceBnds[0]['min(min_price)'] : 0;
			$pmax = isset($priceBnds[0]['max(min_price)']) ? (float)$priceBnds[0]['max(min_price)'] : 0;
			$priceBoundSql	= "SELECT ".$pmin." AS MINP, ".$pmax." AS MAXP";

			//print_r($filterArrCats);print_r($filterArrBrands);print_r($filterArrStores);die("\n".$sql."\n".$priceBoundSql);

			if ( DO_TIME_EACH_QUERY == 1 )
				echo "\n\n<!-- \nSQL generated in pcsSphinxSearch()\n$sql\n\n -->\n\n";


			// Now run the mysql query
			$mySqlStart = getMicroTime();
			$res	= executeQuery($sql);
			$mySqlEnd	= getMicroTime();
			
			$noOfRecords= getTotalRows($res);

			$listingArr	= array();
			while ( ($row = getRow($res)) )
				$listingArr[]	= $row;

			loadProductDetailInArray($listingArr);

			free($res);

			$mySqlDiff = $mySqlEnd - $mySqlStart;
//			printf("<!-- <center><font size='1' face='verdana' color='#DDDDDD'>Query generated in %0.6f seconds</font></center> -->", $mySqlDiff);


			// Create sort options array
			$sortOptsArr		= array();
			$sortOptsArr[]		= array('sk'=>'RATING',		'so'=>'DESC',	'title'=>RATING_HIGH_TO_LOW);
			$sortOptsArr[]		= array('sk'=>'RATING',		'so'=>'ASC',	'title'=>RATING_LOW_TO_HIGH);
			$sortOptsArr[]		= array('sk'=>'TITLE',		'so'=>'ASC',	'title'=>TITLE);
			$sortOptsArr[]		= array('sk'=>'PRICE_MIN',	'so'=>'ASC',	'title'=>PRICE_LOW_TO_HIGH);
			$sortOptsArr[]		= array('sk'=>'PRICE_MIN',	'so'=>'DESC',	'title'=>PRICE_HIGH_TO_LOW);

			// Now return the data
			return array(
							'SORT_OPTIONS'	=> $sortOptsArr,
							'RESULTS'		=> $listingArr,
							'RETURNED'		=> $noOfRecords,
							'TOTAL'			=> $t,
							'FILTER_CATS'	=> $filterArrCats,
							'FILTER_BRANDS'	=> $filterArrBrands,
							'FILTER_STORES'	=> $filterArrStores,
							'FILTER_OTHERS'	=> $filterArr
						);
		}

//*************************************************************************************************

		function sphinxQLQuery(&$msg, $qry)
		{
			// must use IP instead of localhost or wont work
			// 9306 is the sphinxql port
			$mysqli = new mysqli('127.0.0.1', '', '', '', 9306);

			// initialize array for output
			$ret = array();

			// run query
			if ( $mysqli->multi_query($qry) )
			{
				// get all results sets returned by the query
				$dex = 0;
				do {
					if ( ($result = $mysqli->store_result()) )
					{
						$ret[$dex] = array();

						while ( ($row = $result->fetch_assoc()) )
							$ret[$dex][] = $row;

						$result->free();

						$dex++;
					}
				} while ($mysqli->more_results() && $mysqli->next_result());
			}
			else
			{
				$msg = $mysqli->error;
				return null;
			}

			return $ret;
		}

//*************************************************************************************************

		function pcsMysqlList(&$msg, $isSearch, $categoryId='', $searchText='', $searchType='', $searchProductIn='', $advanceSearch='', $manuText='', $manufacturer='', $merchant='', $fId='', $srhcats='', $minPrice='', $maxPrice='', $childList='', $categoryTitle='', $categoryRec='')
		{
			global $sessionId, $searchId, $sqlWhere, $sql, $sqlTotal, $pageSize, $tmpSearchTable, $t;
			global $minPriceBound, $maxPriceBound, $priceBoundSql, $isAjaxProdSrc;


			$productTableName	= PREFIX."PRODUCT";
			if ( USE_PRODUCT_FEATURE_VIEW_TABLE == 1 && count($fId) > 0 )
			{
				$productTableName		= PREFIX."PRODUCT_FEATURE_VIEW";
			}
			elseif ( $isSearch )
			{
				if ( DO_ENABLE_SEARCH_BY_MATCH == 1 )
					$productTableName	= PREFIX."PRODUCT_MYISAM";
			}

			// Initialize the SQL variables
			$catWhere					= '';
			$whereManu					= '';
			$priceSql					= '';
			$merSql						= '';
			$manuSql					= '';
			$catSql						= '';
			$filterIDs					= '';
			$extraTables				= '';
			
			$storeCountSql	= '';
			if ( defined('DO_HIDE_PRODUCT_WITH_0_STORES') && DO_HIDE_PRODUCT_WITH_0_STORES == 1 )
				$storeCountSql	= "AND P.STORE_COUNT>0";

			// The child line list
			$catChildList				= $childList;

			if ( $catChildList == '' && $categoryId > 0 )
			{
				// 8-8-2012: Salman: Print Debug info if SQL is being logged
				if ( DO_TIME_EACH_QUERY == 1 )
					echo "\n<!-- getChildCategoryList() starts in pcsMysqlList() -->\n";
				$catChildArr = SHOW_PRODUCTS_ON_MID_LEVEL_CATEGORIES == 1 ? getChildCategoryList($categoryId, $categoryTitle) : getLastLevelChildList($categoryId, $categoryTitle);
				if ( DO_TIME_EACH_QUERY == 1 )
					echo "\n<!-- getChildCategoryList() ends in pcsMysqlList() -->\n";
				
				$catChildList = !is_array($catChildArr) || count($catChildArr) == 0 ? '' : implode(',', $catChildArr);
				
				// 8-8-2012: Salman: Print Debug info if SQL is being logged
				if ( DO_TIME_EACH_QUERY == 1 )
					echo "<br><br>Child List: ".$catChildList." [$categoryId]<br><br>";
			}

			if ( IS_PRODUCTFILTERS_INSTALLED == 1 )
			{
				if ( $categoryId > 0 && trim($catChildList) != '' )
					$catWhere = " AND P.CATEGORY_ID IN (".$catChildList.")";

				///////////////////////////////////////////////////////////////////////////////////////
				$manuSubSql		= "";
				if ( is_array($manufacturer) )
				{
					foreach ( $manufacturer as $mx )
						$manuSubSql	.= " OR P.MANUFACTURER = '".((int)$mx)."'";
				}
				if ( $manuSubSql != "" )
					$manuSql	= " AND (".substr($manuSubSql, 4).")";

				///////////////////////////////////////////////////////////////////////////////////////		
				if ( count($merchant) > 0 )
				{
					$extraTables .= ", ".PREFIX."USER_PRODUCT UP";
					$merSql	= "AND UP.USERID IN ('".implode("', '", $merchant)."') AND UP.ISVALID='Y' AND P.ID=UP.PRODUCT_ID";
				}

				///////////////////////////////////////////////////////////////////////////////////////		
				$catSubSqlArr	= array();
				if ( is_array($srhcats) )
				{
					foreach ( $srhcats as $mx )
						$catSubSqlArr = array_merge($catSubSqlArr, getChildCategoryList((int)$mx));
				}

				if ( count($catSubSqlArr) > 0 )
				{
					$catWhere	= '';
					$catSql		= " AND P.CATEGORY_ID IN (".implode(',', $catSubSqlArr).")";
				}

				///////////////////////////////////////////////////////////////////////////////////////
				$filterIDs 	= getFilterProductIds($fId, 'P.ID');
				
				
				///////////////////////////////////////////////////////////////////////////////////////
				// Build Price SQL based on min and max price
				if ( $maxPrice != 0 )
					$priceSql	= "AND (P.MIN_PRICE >= ".$minPrice." AND P.MIN_PRICE <= ".$maxPrice.")";
			}

			
			// If it is a search
			if ( $isSearch )
			{
				///////////////////////////////////////////////////////////////////////////////////////
				$whereTitle		= '';
				$colTitleRel	= '';
				$sorTitleRel	= '';
				$sqlCS 			= '';
				$codeAliasIds 	= '';

				if ( $searchText != '' || $manuText != '' || $merSql != '' )
				{
					/////////////////////////////////////////////////
					// BUILD TEMPORARY Search Table
					$tmpSearchTable	= "SEARCH_RESULTS_".preg_replace('/[^a-zA-Z0-9]/', '', $sessionId);

					// Create temp search table name
					$retTemp		= executeUpdate("CREATE TEMPORARY TABLE ".$tmpSearchTable."
							(
							ID int(11) unsigned NOT NULL DEFAULT '0',
							PRICE_MIN decimal(9,2) DEFAULT '0.00',
							PRICE_MAX decimal(9,2) DEFAULT '0.00',
							STORE_COUNT int(11) unsigned DEFAULT '0',
							TITLE varchar(255) NOT NULL DEFAULT ' ',
							MANUFACTURER int(11) unsigned NOT NULL DEFAULT '0',
							PFILENAME varchar(255) DEFAULT ' ',
							RATING tinyint(3) NOT NULL DEFAULT '-1',
							CID  int(11) unsigned NOT NULL DEFAULT '0',
							CFILENAME varchar(100) NOT NULL DEFAULT ' ',
							CATEGORY varchar(100) NOT NULL DEFAULT ' ',
							TITLE_REL TINYint(3),
							".(IS_MERCHANTBID_INSTALLED!=0 ? 'MAX_BID decimal(9,2) NOT NULL default 0.0,':'')."
							PRIMARY KEY (ID)
							)
							".DEFINE_DEFAULT_CHARSET);
					
					/////////////////////////////////////////////////
					// Search category name based on the SearchText
					if ( $searchText != '' )
					{
						$arrCS = array();
						$resCS = executeQuery("SELECT ID FROM ".PREFIX."CATEGORY WHERE (".getSearchColumn('TITLE', $searchText).") AND ISVALID='Y'");
						while ( ($rowCS = getRow($resCS)) )
							$arrCS[] = (int)$rowCS['ID'];
							
						// Make SQL for the category names searched
						if ( count($arrCS) > 0 )
							$sqlCS = " OR P.CATEGORY_ID IN (".implode(",", $arrCS).")";
					}
					
					////////////////////////////////////////////////
					// Build Manufacturer SQL
					if ( $manuText != '' )
					{
						$msg		= '';
						$manuId		= getBrand($msg, $manuText, 0);
						$whereManu	= "AND P.MANUFACTURER = '".$manuId."' ";
					}

					/////////////////////////////////////////////////
					// To avoid sub query, load the product id of manufacturer code from code alias first
					if ( $searchText != '' && ($searchProductIn == 'A' || $searchProductIn == 'B') )
					{
						$resCodeAlias = preparedQuery("SELECT PRODUCT_ID FROM ".PREFIX."PRODUCT_CODE_ALIAS WHERE MANUFACTURER_CODE = ?", array($searchText));
						while ( ($rowCodeAlias = getRow($resCodeAlias)))
							$codeAliasIds .= ($codeAliasIds==''?'':',').$rowCodeAlias['PRODUCT_ID'];

						$resEanAlias = preparedQuery("SELECT PRODUCT_ID FROM ".PREFIX."PRODUCT_EAN_ALIAS WHERE EAN = ?", array($searchText));
						while ( ($rowEanAlias = getRow($resEanAlias)))
							$codeAliasIds .= ($codeAliasIds==''?'':',').$rowEanAlias['PRODUCT_ID'];
					}
					
					/////////////////////////////////////////////////
					// If MYISAM engine is being used
					if ( DO_ENABLE_SEARCH_BY_MATCH == 1 )
					{
						$colTitleRel	= "";
						
						if ( $searchText != '' )
						{
							if ( $searchProductIn == 'A' )
								$whereTitle	= " AND ((MATCH (P.TITLE) AGAINST ('".$searchText."')) OR (P.MANUFACTURER_CODE LIKE '".$searchText."' ".($codeAliasIds!="" ? "OR P.ID IN (".$codeAliasIds.")":"")."))";
							elseif ( $searchProductIn == 'T' )
								$whereTitle	= " AND ( MATCH (P.TITLE) AGAINST ('".$searchText."') )";
							else
								$whereTitle	= " AND ((P.MANUFACTURER_CODE LIKE '".$searchText."' ".($codeAliasIds!="" ? "OR P.ID IN (".$codeAliasIds.")":"")."))";
						}
						else
							$whereTitle = '';
						
						// Make the search SQL
						$whereSql	= trim($whereTitle." ".$whereManu." ".$catWhere." ".$priceSql." ".$manuSql." ".$merSql." ".$catSql." ".$filterIDs." ".$storeCountSql);
						$whereSql	= substr($whereSql, 4); // remove the "AND " from the start
						$sql		= "SELECT '0.0', '0.0', 0, P.ID AS ID, P.TITLE AS TITLE, 0, '', 0, 0, '', '', (MATCH (P.TITLE) AGAINST ('".$searchText."')) AS TITLE_REL FROM ".PREFIX."PRODUCT_MYISAM P ".$extraTables." WHERE ".$whereSql;
						
						$retTemp2	= executeUpdate("INSERT INTO ".$tmpSearchTable." ".$sql);
						
						// Now update SEARCH table with products
						executeUpdate("UPDATE ".$tmpSearchTable." S, ".PREFIX."PRODUCT P SET
										S.PRICE_MIN = P.MIN_PRICE,
										S.PRICE_MAX = P.MAX_PRICE,
										S.STORE_COUNT = P.STORE_COUNT,
										S.MANUFACTURER = P.MANUFACTURER,
										S.PFILENAME = P.FILENAME,
										S.RATING = P.PRODUCT_RATING,
										S.CID = P.CATEGORY_ID
										WHERE S.ID = P.ID");
						
						// Now update SEARCH table with category
						executeUpdate("UPDATE ".$tmpSearchTable." S, ".PREFIX."CATEGORY C SET
										S.CFILENAME = C.FILENAME,
										S.CATEGORY = C.TITLE
										WHERE S.CID = C.ID");
						
						$sql		= "SELECT PRICE_MIN, PRICE_MAX, STORE_COUNT, ID, TITLE, PFILENAME, RATING, CID, CFILENAME, CATEGORY FROM ".$tmpSearchTable;
						$sqlTotal	= "SELECT COUNT(*) AS TOTAL, MIN(PRICE_MIN) AS MINP, MAX(PRICE_MIN) AS MAXP FROM ".$tmpSearchTable;

						// Query for calculating min/max price bounds
						$priceBoundSql	= "SELECT MIN(PRICE_MIN) AS MINP, MAX(PRICE_MIN) AS MAXP FROM ".$tmpSearchTable;
					}
					
					// If NORMAL engine is being used
					else
					{
						/////////////////////////////////////////////////
						if ( $searchText != '' )
						{
							$sorTitleRel	= "TITLE_REL DESC, ";

							if ( $searchProductIn == 'A' )
							{
								$colTitleRel	= ", (IF (INSTR(P.TITLE, '".$searchText."')>0, 1, 0)) + (IF (P.MANUFACTURER_CODE LIKE '".$searchText."', 10, 0)) AS TITLE_REL";
								$whereTitle		= "AND (((".getSearchColumn('P.TITLE', $searchText).")".$sqlCS.") OR (P.MANUFACTURER_CODE LIKE '".$searchText."' ".($codeAliasIds==''?'':"OR P.ID IN (".$codeAliasIds.")")."))";
							}
							elseif ( $searchProductIn == 'T' )
							{
								$colTitleRel	= ", (IF (INSTR(P.TITLE, '".$searchText."')>0, 1, 0)) AS TITLE_REL";
								$whereTitle		= "AND ((".getSearchColumn('P.TITLE', $searchText).")".$sqlCS.")";
							}
							else
							{
								$colTitleRel	= ", (IF (P.MANUFACTURER_CODE LIKE '".$searchText."', 10, 0)) AS TITLE_REL";
								$whereTitle		= "AND ((P.MANUFACTURER_CODE LIKE '".$searchText."' ".($codeAliasIds==''?'':"OR P.ID IN (".$codeAliasIds.")")."))";
							}
						}
						
						
						// Make the search SQL
						$sql		= "SELECT DISTINCT(P.ID) AS ID, IFNULL(P.MIN_PRICE, 0) AS PRICE_MIN, IFNULL(P.MAX_PRICE, 0) AS PRICE_MAX, IFNULL(P.STORE_COUNT, 0) AS STORE_COUNT, P.TITLE AS TITLE, P.MANUFACTURER AS MANUFACTURER, P.FILENAME AS PFILENAME, P.PRODUCT_RATING AS RATING, P.CATEGORY_ID AS CID, '', '' ".($colTitleRel==''?', 0':$colTitleRel)." ".(IS_MERCHANTBID_INSTALLED!=0 ? ', MAX_BID':'')." FROM ".$productTableName." P ".$extraTables." WHERE P.ISVALID='Y' ".$catWhere." ".$whereTitle." ".$whereManu." ".$priceSql." ".$manuSql." ".$merSql." ".$catSql." ".$filterIDs." ".$storeCountSql."";

						//if ( $_GET['debug'] != 0 ) die("[$sql]");
						
						$retTemp2	= executeUpdate("INSERT INTO ".$tmpSearchTable." ".$sql);
						
						$sql		= "SELECT PRICE_MIN, PRICE_MAX, STORE_COUNT, ID, TITLE, PFILENAME, RATING, CID FROM ".$tmpSearchTable." ORDER BY ".(IS_MERCHANTBID_INSTALLED!=0 ? 'MAX_BID DESC,':'')." ".$sorTitleRel." STORE_COUNT DESC";
						$sqlTotal	= "SELECT COUNT(*) AS TOTAL, MIN(PRICE_MIN) AS MINP, MAX(PRICE_MIN) AS MAXP FROM ".$tmpSearchTable;						

						// Query for calculating min/max price bounds
						$priceBoundSql	= "SELECT MIN(PRICE_MIN) AS MINP, MAX(PRICE_MIN) AS MAXP FROM ".$tmpSearchTable;
					}
					
				} // Search Block

				else
				{
					$msg = SEARCH_QUERY_TOO_SHORT;
					return 0;
				}
				
			}
			
			// It is NOT search
			else
			{
				////////////////////////////////////////////////
				// Build manufacturer sql to support brand filtering seo urls with category listing
				// for e.g. http://demo.kaonsoftwares.com/pc8.5/camcorders.1398/brand/canon
				if ( $manuText != '' )
				{
					$msg		= '';
					$manuId		= getBrand($msg, $manuText, 0);
					$whereManu	= "AND P.MANUFACTURER = '".$manuId."' ";
				}

				$sql			= "SELECT DISTINCT(P.ID) AS ID, IFNULL(P.MIN_PRICE, 0) AS PRICE_MIN, IFNULL(P.MAX_PRICE, 0) AS PRICE_MAX, IFNULL(P.STORE_COUNT, 0) AS STORE_COUNT, P.TITLE AS TITLE, '' AS DETAIL, P.MANUFACTURER, P.FILENAME AS PFILENAME, P.PRODUCT_RATING AS RATING, P.CATEGORY_ID AS CID, '' AS CFILENAME, '' AS CATEGORY ".($colTitleRel==''?', 0':$colTitleRel)." FROM ".$productTableName." P ".$extraTables." ".($extraTables==''&&$productTableName==PREFIX.'PRODUCT'?"USE INDEX (IndexORDER_BY)":"")." WHERE P.ISVALID='Y' ".$catWhere." ".$whereManu." ".$priceSql." ".$manuSql." ".$merSql." ".$catSql." ".$filterIDs." ".$storeCountSql." ORDER BY ".(IS_MERCHANTBID_INSTALLED!=0 ? 'MAX_BID DESC,':'')." ".$sorTitleRel." STORE_COUNT DESC";
				$sqlTotal		= "SELECT COUNT(DISTINCT(P.ID)) AS TOTAL, MIN(P.MIN_PRICE) AS MINP, MAX(P.MIN_PRICE) AS MAXP FROM ".$productTableName." P ".$extraTables."".($extraTables==''&&$productTableName==PREFIX.'PRODUCT'?"USE INDEX (IndexTOTAL)":"")." WHERE P.ISVALID='Y' ".$catWhere." ".$whereManu." ".$priceSql." ".$manuSql." ".$merSql." ".$catSql." ".$filterIDs." ".$storeCountSql."";

				// Query for calculating min/max price bounds
				$priceBoundSql	= "SELECT MIN(P.MIN_PRICE) AS MINP, MAX(P.MIN_PRICE) AS MAXP FROM ".$productTableName." P ".$extraTables."".($extraTables==''&&$productTableName==PREFIX.'PRODUCT'?"USE INDEX (IndexTOTAL)":"")." WHERE P.ISVALID='Y' ".$catWhere." ".$whereManu." ".$priceSql." ".$manuSql." ".$merSql." ".$catSql." ".$filterIDs." ".$storeCountSql."";
			}

			// 8-8-2012: Salman: Print Debug info if SQL is being logged
			if ( DO_TIME_EACH_QUERY == 1 )
				echo "\n<!-- pcsMysqlList() PRODUCT starts-->\n";
			
			if ( $sql != '' )
			{
				// 2/2/2016: Mamda: if an api sort order comes, it gives sql error
				$tSK = $_GET['sk'];
				if ( !in_array($_GET['sk'], array('RATING', 'TITLE', 'PRICE_MIN', 'PRICE_MAX')) )
					$_GET['sk'] = '';

				// Now run the mysql query
				$mySqlStart = getMicroTime();
				$res		= breakPages($sql, $sqlTotal);
				$mySqlEnd	= getMicroTime();

				// Restore back from above saved
				$_GET['sk'] = $tSK;
			}
			else
			{
				$msg = ' --- unknown error --- ';
				return 0;
			}
			
			// Get number of records returned
			$noOfRecords= getTotalRows($res);

			// Load in the array
			$listingArr	= array();
			while ( ($row = getRow($res)) )
				$listingArr[]	= $row;

			// 8-8-2012: Salman
			//echo "\n<!-- pcsMysqlList() PRODUCT DETAIL starts-->\n";
			
			// Load PRODUCT DETAIL for the products of page 1
			loadProductDetailInArray($listingArr, 'ID', 'DETAIL', true, array($categoryId=>$categoryRec));

			// FREE resultset
			free($res);

			$mySqlDiff = $mySqlEnd - $mySqlStart;
			
			// 8-8-2012: Salman: Print Debug info if SQL is being logged
			if ( DO_TIME_EACH_QUERY == 1 )
				printf("<!-- Query generated in %0.6f seconds -->", $mySqlDiff);


			// Now handle filters
			// 8-8-2012: Salman: Print Debug info if SQL is being logged
			if ( DO_TIME_EACH_QUERY == 1 )
				echo "\n<!-- pcsMysqlList() FILTERS starts-->\n";
			$sqlWhere			= '';
			$filterArr			= $isAjaxProdSrc ? array() : pcsMysqlFilters($msg, $sqlWhere, $isSearch, $categoryId, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice, $childList, $categoryTitle, $categoryRec);
//			print_r($filterArr);die;

			// 8-8-2012: Salman: Print Debug info if SQL is being logged
			if ( DO_TIME_EACH_QUERY == 1 )
				echo "\n<!-- pcsMysqlList() FILTERS BRAND starts-->\n";
			$filterArrBrands	= $isAjaxProdSrc ? array() : getProductFiltersBrands($categoryId, $categoryTitle, $sqlWhere, $searchId);
			
			// 8-8-2012: Salman: Print Debug info if SQL is being logged
			if ( DO_TIME_EACH_QUERY == 1 )
				echo "\n<!-- pcsMysqlList() FILTERS MERCHANT starts-->\n";
			$filterArrStores	= $isAjaxProdSrc ? array() : getProductFiltersStores($categoryId, $categoryTitle, $sqlWhere);

			// 8-8-2012: Salman: Print Debug info if SQL is being logged
			if ( DO_TIME_EACH_QUERY == 1 )
				echo "\n<!-- pcsMysqlList() FILTERS CATEGORY starts-->\n";
			
			$filterArrCats		= array();
			if ( $isSearch )
				$filterArrCats	= $isAjaxProdSrc ? array() : getProductFiltersCats($sqlWhere);
			else
				$filterArrCats	= $isAjaxProdSrc ? array() : getProductFiltersSubCats($categoryId);

			// 8-8-2012: Salman: Print Debug info if SQL is being logged
			if ( DO_TIME_EACH_QUERY == 1 )
				echo "\n<!-- pcsMysqlList() end -->\n";
		
			
			// Create sort options array
			$sortOptsArr		= array();
			$sortOptsArr[]		= array('sk'=>'RATING',		'so'=>'DESC',	'title'=>RATING_HIGH_TO_LOW);
			$sortOptsArr[]		= array('sk'=>'RATING',		'so'=>'',		'title'=>RATING_LOW_TO_HIGH);
			$sortOptsArr[]		= array('sk'=>'TITLE',		'so'=>'',		'title'=>TITLE);
			$sortOptsArr[]		= array('sk'=>'PRICE_MIN',	'so'=>'',		'title'=>PRICE_LOW_TO_HIGH);
			$sortOptsArr[]		= array('sk'=>'PRICE_MIN',	'so'=>'DESC',	'title'=>PRICE_HIGH_TO_LOW);

			// Now return the data
			return array(
							'SORT_OPTIONS'	=> $sortOptsArr,
							'RESULTS'		=> $listingArr,
							'RETURNED'		=> $noOfRecords,
							'TOTAL'			=> $t,
							'FILTER_CATS'	=> $filterArrCats,
							'FILTER_BRANDS'	=> $filterArrBrands,
							'FILTER_STORES'	=> $filterArrStores,
							'FILTER_OTHERS'	=> $filterArr
						);
		}

//*************************************************************************************************

		function pcsMysqlFilters(&$msg, &$sqlWhere, $isSearch, $categoryId='', $searchText='', $searchType='', $searchProductIn='', $advanceSearch='', $manuText='', $manufacturer='', $merchant='', $fId='', $srhcats='', $minPrice='', $maxPrice='', $childList='', $categoryTitle='', $categoryRec='', $productIDs='')
		{
			global $sessionId, $sql, $sqlTotal, $pageSize, $t;

			$productIDs	= is_array($productIDs) ? $productIDs : array();

			// Now handle filters
			$sqlWhere	= '';
			$filterSqlF	= '';

			if ( $isSearch || ( is_array($fId) && count($fId) > 0 ) )
			{
				$pos	= strpos($sql, 'WHERE')+5;
				$posOr	= strpos($sql, 'ORDER BY');
				
				if ( $posOr === false )
					$sqlWhere	= substr($sql, $pos);
				else
					$sqlWhere	= substr($sql, $pos, $posOr - $pos);

				$pos	= strpos($sql, 'FROM');
				$posOr	= strpos($sql, 'ORDER BY');

				$idCol	= strstr($sql, 'P.ID') ? 'P.ID' : 'ID';
				
				if ( $posOr === false )
					$filterSqlF	= "SELECT ".$idCol." AS PRODUCT_ID ".substr($sql, $pos);
				else
					$filterSqlF	= "SELECT ".$idCol." AS PRODUCT_ID ".substr($sql, $pos, $posOr - $pos);
			}

			$filterArr			= array();

			if ( $isSearch || ( is_array($fId) && count($fId) > 0 ) )
			{
				$filterArrSub	= array();
				$filterArrVal	= array();
				$rowSub			= array();
				$lastId			= 0;

				$strFilterPIDs	= '';

				if ( count($productIDs) == 0 )
				{
					$dexFilterPIDs	= 0;
					$resFilterPIDs	= executeQuery($filterSqlF);
					while ( ($rowFilterPIDs = getRow($resFilterPIDs)) )
					{
						if ( $dexFilterPIDs++ > 5000 )
							break;

						$strFilterPIDs .= ','.$rowFilterPIDs['PRODUCT_ID'];
					}
					$strFilterPIDs = substr($strFilterPIDs, 1);
				}
				else
					$strFilterPIDs = implode(',', $productIDs);
				
				$filterSql		= "SELECT V.ID, V.FEATURE_ID AS FEATURE_ID, FEATURE, VALUE, V.MERGED_TO, V.MERGED_IDS, V.MERGED_LABEL, COUNT(*) AS TOT FROM ".PREFIX."PRODUCT_FEATURE_CATEGORY FC, ".PREFIX."PRODUCT_FEATURE_VALUE V, ".PREFIX."PRODUCT_FEATURE PF WHERE FC.ID = V.FEATURE_ID AND V.ID = PF.VALUE_ID  AND FC.ISVALID = 'Y' AND FC.DISPLAY_AS_FILTER = 'Y' AND PRODUCT_ID IN (".($strFilterPIDs==''?'0':$strFilterPIDs).") GROUP BY V.ID ORDER BY FC.SORT_ORDER, FEATURE, V.SORT_ORDER, VALUE";
				$resSub			= executeQuery($filterSql);

                $mergedTo	= array();

                while ( ($rowEx = getRow($resSub)) )
				{
					if ( $lastId == 0 )
					{
						$lastId				= $rowEx['FEATURE_ID'];
						$rowSub['ID']		= $rowEx['FEATURE_ID'];
						$rowSub['FEATURE']	= $rowEx['FEATURE'];
					}
					elseif ( $lastId != $rowEx['FEATURE_ID'] )
					{
						$rowSub['CHILDS']	= $filterArrVal;
						$filterArrSub[]		= $rowSub;
						$filterArrVal		= array();
						$rowSub				= array();

						$lastId				= $rowEx['FEATURE_ID'];
						$rowSub['ID']		= $rowEx['FEATURE_ID'];
						$rowSub['FEATURE']	= $rowEx['FEATURE'];
					}

                    if ( $rowEx['MERGED_TO'] > 0 )
                    {
                        if ( isset($filterArrVal[$rowEx['MERGED_TO']]) )
                            $filterArrVal[$rowEx['MERGED_TO']]['TOT'] += $rowEx['TOT'];
                        elseif ( isset($mergedTo[$rowEx['MERGED_TO']]) )
                            $mergedTo[$rowEx['MERGED_TO']] += $rowEx['TOT'];
                        else
                            $mergedTo[$rowEx['MERGED_TO']] = $rowEx['TOT'];

                        continue;
                    }

                    elseif ( $rowEx['MERGED_IDS'] != '' && $rowEx['MERGED_LABEL'] != '' )
                    {
                        if ( isset($mergedTo[$rowEx['ID']]) )
                        {
                            $rowEx['TOT'] += $mergedTo[$rowEx['ID']];
                            unset($mergedTo[$rowEx['ID']]);
                        }
                        $rowEx['VALUE'] = $rowEx['MERGED_LABEL'];
                    }

                    $rowVal				= array();
					$rowVal['ID']		= $rowEx['ID'];
					$rowVal['VALUE']	= $rowEx['VALUE'];
					$rowVal['TOT']	    = $rowEx['TOT'];
					$filterArrVal[$rowEx['ID']]		= $rowVal;
				}

				if ( $lastId > 0 ) // If records where there
				{
					$rowSub['CHILDS']	= $filterArrVal;
					$filterArrSub[]	= $rowSub;

					$row			= array();
					$row['ID']		= 0;
					$row['FEATURE']	= 'Default';
					$row['CHILDS']	= $filterArrSub;
					$filterArr[]	= $row;
				}

                // Get the merged to values if there are some values not settled
                // details: https://www.kaonsoftwares.com/mantis/view.php?id=307
                if ( count($mergedTo) > 0 ) {
                    // Load them all
                    $sqlM2 = '';
                    foreach ( $mergedTo as $idM2 => $totM2 ) {
                        $sqlM2 .= "OR CONCAT(',', MERGED_IDS, ',') LIKE '%,".$idM2.",%'";
                    }
                    $sqlM2 = "SELECT FEATURE_ID, ID, VALUE, MERGED_IDS FROM ".PREFIX."PRODUCT_FEATURE_VALUE WHERE ".substr($sqlM2, 3);
//					echo "\n\n<!-- MERGED TO SQL \n".print_r($sqlM2, 1)."\n -->\n\n";
                    $resM2 = executeQuery($sqlM2);
                    while ( ($rowM2 = getRow($resM2)) ) {
                        // Walk through all features
                        foreach ( $filterArr as $key1 => $val1 ) {
//							echo "\n\n<!-- [".$key1."] \n".print_r($val1, 1)."\n -->\n\n";
                            if ( is_array($val1['CHILDS']) ) {
                                foreach ( $val1['CHILDS'] as $key => $val ) {
                                    // If feature dont match then skip
                                    if ( $val['ID'] != $rowM2['FEATURE_ID'] ) {
                                        continue;
                                    }
                                    // Get total
                                    $totM2 = 0;
                                    $arrM2 = explode(',', $rowM2['MERGED_IDS']);
                                    foreach ( $arrM2 as $idM2 ) {
                                        $totM2 += $mergedTo[$idM2];
                                    }
                                    // Add value to childs
                                    $filterArr[$key1]['CHILDS'][$key]['CHILDS'][$rowM2['ID']] = [
                                        'ID'	=> $rowM2['ID'],
                                        'VALUE'	=> $rowM2['VALUE'],
                                        'TOT'	=> $totM2
                                    ];
                                }
                            }
                        }
                    }
                }
			}
			else
			{
				$linkCatId 	= (int)isset($categoryRec['LINK_CAT_ID']) ? $categoryRec['LINK_CAT_ID'] : 0;
				$clSql		= $childList . ($linkCatId>0 ? ",'".$linkCatId."'":'');

				if ( $clSql != '' )
				{
					$filterSql = "SELECT F.ID, F.FEATURE FROM ".PREFIX."PRODUCT_FEATURE_CATEGORY F, ".PREFIX."PRODUCT_FEATURE_IN_CATEGORY FC WHERE FC.CATEGORY_ID IN (".$clSql.") AND F.ID = FC.FEATURE_ID AND F.PARENT_ID = 0 AND F.ISVALID = 'Y' AND F.DISPLAY_AS_FILTER = 'Y' GROUP BY F.ID ORDER BY F.SORT_ORDER, F.FEATURE";
					$res = executeQuery($filterSql);
					while ( ($row = getRow($res)) )
					{
						$filterArrSub	= array();
						$resSub			= preparedQuery("SELECT F.ID, F.FEATURE FROM ".PREFIX."PRODUCT_FEATURE_CATEGORY F, ".PREFIX."PRODUCT_FEATURE_IN_CATEGORY FC WHERE FC.CATEGORY_ID IN (".$clSql.") AND F.ID = FC.FEATURE_ID AND F.PARENT_ID = ? AND F.ISVALID = 'Y' AND F.DISPLAY_AS_FILTER = 'Y' GROUP BY F.ID ORDER BY F.SORT_ORDER, F.FEATURE", array($row['ID']));
						while ( ($rowSub = getRow($resSub)) )
						{
							$filterArrVal		= array();
							$resVal				= preparedQuery("SELECT ID, VALUE, MERGED_TO, MERGED_LABEL FROM ".PREFIX."PRODUCT_FEATURE_VALUE WHERE FEATURE_ID = ? ORDER BY SORT_ORDER, VALUE", array($rowSub['ID']));
							
							while ( ($rowVal = getRow($resVal)) )
							{
                                if ( $rowVal['MERGED_TO'] > 0 )
                                    continue;

                                elseif ( $rowVal['MERGED_LABEL'] != '' )
                                    $rowVal['VALUE'] = $rowVal['MERGED_LABEL'];

                                $filterArrVal[] = $rowVal;
							}

							$rowSub['CHILDS']	= $filterArrVal;
							$filterArrSub[]		= $rowSub;
						}

						$row['CHILDS']	= $filterArrSub;
						$filterArr[]	= $row;
					}
				}
			}

//			print_r($filterArr);die;

/* 5/12/2016: Mamda: no need to merge now as its already merged

			// Keep counts saved as they are disturbed in Feature Merging and then we get erros in Value merging
			$fcCount = array();

			// Merge Features
			for ( $i1=0; $i1<count($filterArr); $i1++ )
			{
				if ( !is_array($filterArr[$i1]['CHILDS']) )	continue;

				$fcCount[$i1] = count($filterArr[$i1]['CHILDS']);

				for ( $i2=0; $i2<$fcCount[$i1]; $i2++ ) // Match all records
				{
					for ( $i3=0; $i3<$fcCount[$i1]; $i3++ ) // Check them with all records
					{
						if ( $i2 == $i3 )	continue; // Skip matching same record

						if ( !is_array($filterArr[$i1]['CHILDS'][$i2]) || !is_array($filterArr[$i1]['CHILDS'][$i3]) )
							continue; // Skip unset records

						if ( $filterArr[$i1]['CHILDS'][$i2]['FEATURE'] == $filterArr[$i1]['CHILDS'][$i3]['FEATURE'] )
						{
							$filterArr[$i1]['CHILDS'][$i2]['ID'] = array_merge(
																					is_array($filterArr[$i1]['CHILDS'][$i2]['ID'])?$filterArr[$i1]['CHILDS'][$i2]['ID']:array(0=>$filterArr[$i1]['CHILDS'][$i2]['ID']),
																					is_array($filterArr[$i1]['CHILDS'][$i3]['ID'])?$filterArr[$i1]['CHILDS'][$i3]['ID']:array(0=>$filterArr[$i1]['CHILDS'][$i3]['ID'])
																				);
							$filterArr[$i1]['CHILDS'][$i2]['CHILDS'] = array_merge(
																					is_array($filterArr[$i1]['CHILDS'][$i2]['CHILDS'])?$filterArr[$i1]['CHILDS'][$i2]['CHILDS']:array(),
																					is_array($filterArr[$i1]['CHILDS'][$i3]['CHILDS'])?$filterArr[$i1]['CHILDS'][$i3]['CHILDS']:array()
																				);
							unset($filterArr[$i1]['CHILDS'][$i3]);
							$i2 = 0; // Reset all checking
							break; // Break i3 loop and start i2 loop from 0
						}
					}
				}
			}

			// Merge Values
			for ( $i1=0; $i1<count($filterArr); $i1++ )
			{
				if ( !is_array($filterArr[$i1]['CHILDS']) )	continue;

				for ( $i2=0; $i2<$fcCount[$i1]; $i2++ ) // Go through all features
				{
					if ( !is_array($filterArr[$i1]['CHILDS'][$i2]['CHILDS']) )	continue;

					$c3 = count($filterArr[$i1]['CHILDS'][$i2]['CHILDS']);

					for ( $i3=0; $i3<$c3; $i3++ ) // Check all value records
					{
						for ( $i4=0; $i4<$c3; $i4++ ) // Check with all records
						{
							if ( $i3 == $i4 )	continue; // Skip matching same record

							if ( !isset($filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i3]) || !isset($filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i4]) )
								continue;

							if ( $filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i3]['VALUE'] == $filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i4]['VALUE'] )
							{
								$filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i3]['ID'] = array_merge(
																						is_array($filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i3]['ID'])?$filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i3]['ID']:array(0=>$filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i3]['ID']),
																						is_array($filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i4]['ID'])?$filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i4]['ID']:array(0=>$filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i4]['ID'])
																					);
								$filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i3]['TOT'] += $filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i4]['TOT'];
								unset($filterArr[$i1]['CHILDS'][$i2]['CHILDS'][$i4]);
								$i3 = 0; // Reset all checking
								break; // Break i3 loop and start i2 loop from 0
							}
						}
					}
				}
			}
*/
			if ( !$isSearch )
				$sqlWhere	= '';

			return $filterArr;
		}

//*************************************************************************************************

		function getFilterArrayFromSphinxAttrs($arr, $key, $tableName, $idField='ID', $titleField='TITLE', $outIdField='ID', $outTitleField='TITLE')
		{
			$output		= array();
			$tempIds	= array();

			if ( !is_array($arr) || $key == '' )	return array();

			// Load the ids and corresponding counts in $tempIds array (only if id and count both are > 0)
			foreach ( $arr as $temp )
			{
				if ( isset($temp[$key]) && $temp['count(*)'] )
				{
					$k = (int)$temp[$key];
					$v = (int)$temp['count(*)'];
					if ( $k > 0 && $v > 0 )
						$tempIds[$k] = $v;
				}
			}

			if ( count($tempIds) == 0 )				return array();

			$sql = "SELECT ".$idField." AS ".$outIdField.", ".$titleField." AS ".$outTitleField." FROM ".PREFIX.$tableName." WHERE ".$idField." IN (".implode(',', array_keys($tempIds)).")";
			$res = executeQuery($sql);
			while ( ($row = getRow($res)) )
			{
				$row['TOT']	= $tempIds[$row[$outIdField]];
				array_unshift($row, $row['TOT'] );
				$output[]	= $row;
			}

			rsort($output);

			return $output;
		}

//*************************************************************************************************

		function getFilterArrayFromSphinxAttrs4Features($arr)
		{
			$tempIds	= array();

			if ( !is_array($arr) )	return array();

			// Load the ids and corresponding counts in $tempIds array (only if id and count both are > 0)
			foreach ( $arr as $temp )
			{
				if ( isset($temp['value_id']) && $temp['count(*)'] )
				{
					$k = (int)$temp['value_id'];
					$v = (int)$temp['count(*)'];
					if ( $k > 0 && $v > 0 )
						$tempIds[$k] = $v;
				}
			}

			if ( count($tempIds) == 0 )				return array();

			$filterArr			= array();

			$filterArrSub	= array();
			$filterArrVal	= array();
			$rowSub			= array();
			$lastId			= 0;

			$filterSql		= "SELECT V.ID, V.FEATURE_ID, FEATURE, VALUE, FC.PARENT_ID FROM ".PREFIX."PRODUCT_FEATURE_CATEGORY FC, ".PREFIX."PRODUCT_FEATURE_VALUE V WHERE V.ID IN (".implode(',', array_keys($tempIds)).") AND FC.ID = V.FEATURE_ID AND FC.ISVALID = 'Y' AND FC.DISPLAY_AS_FILTER = 'Y' ORDER BY FC.SORT_ORDER, FEATURE, V.SORT_ORDER, VALUE";
			$resSub			= executeQuery($filterSql);
			while ( ($rowEx = getRow($resSub)) )
			{
				if ( $lastId == 0 )
				{
					$lastId				= $rowEx['FEATURE_ID'];
					$rowSub['ID']		= $rowEx['FEATURE_ID'];
					$rowSub['PARENT_ID']= $rowEx['PARENT_ID'];
					$rowSub['FEATURE']	= $rowEx['FEATURE'];
				}
				elseif ( $lastId != $rowEx['FEATURE_ID'] )
				{
					$rowSub['CHILDS']	= $filterArrVal;
					if ( !isset($filterArrSub[$rowSub['PARENT_ID']]) )
						$filterArrSub[$rowSub['PARENT_ID']] = array();
					$filterArrSub[$rowSub['PARENT_ID']][] = $rowSub;
					$filterArrVal		= array();
					$rowSub				= array();

					$lastId				= $rowEx['FEATURE_ID'];
					$rowSub['ID']		= $rowEx['FEATURE_ID'];
					$rowSub['PARENT_ID']= $rowEx['PARENT_ID'];
					$rowSub['FEATURE']	= $rowEx['FEATURE'];
				}
				
				$rowVal				= array();
				$rowVal['ID']		= $rowEx['ID'];
				$rowVal['VALUE']	= $rowEx['VALUE'];
				$rowVal['TOT']		= $tempIds[$rowEx['ID']];
				$filterArrVal[]		= $rowVal;
			}

			if ( $lastId > 0 ) // If records where there
			{
				$rowSub['CHILDS']	= $filterArrVal;
				if ( !isset($filterArrSub[$rowSub['PARENT_ID']]) )
					$filterArrSub[$rowSub['PARENT_ID']] = array();
				$filterArrSub[$rowSub['PARENT_ID']][] = $rowSub;
			}

			// Get the parent ids
			$pIds = array_keys($filterArrSub);

			// Load as single parent filter if there is only 1 parent
			if ( count($pIds) == 1 )
			{
				$row			= array();
				$row['ID']		= 0;
				$row['FEATURE']	= 'Default';
				$row['CHILDS']	= $filterArrSub[$pIds[0]];
				$filterArr[]	= $row;
			}
			// Load parents if there are multiple
			else
			{
				$temp = $pIds;
				$pIds = array();
				foreach ( $temp as $t )
					$pIds[] = (int)$t;

				if ( count($pIds) > 0 )
				{
					$res = executeQuery("SELECT ID, FEATURE FROM ".PREFIX."PRODUCT_FEATURE_CATEGORY WHERE ID IN (".implode(',', $pIds).") ORDER BY SORT_ORDER, FEATURE");
					while ( ($row = getRow($res)) )
					{
						$row['CHILDS']	= $filterArrSub[$row['ID']];
						$filterArr[]	= $row;
					}
				}
			}

			if ( $_GET['debug'] == 1 )
				echo "\n\n<!-- \nSPHINX FILTERS:\n".print_r($filterArr, 1)."\n -->\n\n";

			return $filterArr;
		}

//*************************************************************************************************

		$pcsCachedCategoryRecs = array();
		function pcsGetCategoryRec($apiType, $categoryId, $doCache=0, $defaultCatTitle='', $defaultCatFilename='')
		{
			global $pcsCachedCategoryRecs;

			if ( $doCache == 1 && isset($pcsCachedCategoryRecs[$categoryId]) )
				return $pcsCachedCategoryRecs[$categoryId];

			if ( $apiType == API_TYPE_MYSQL )			$cRec = getRecord("CATEGORY", $categoryId);
			elseif ( $apiType == API_TYPE_SHOPZILLA )	$cRec = getRecord("CATEGORY", $categoryId, "SHOPZILLA_ID");
			elseif ( $apiType == API_TYPE_AMAZON )		$cRec = getRecord("CATEGORY", $categoryId, "AMAZON_CATEGORY");
			elseif ( $apiType == API_TYPE_KELKOO )		$cRec = getRecord("CATEGORY", $categoryId, "KELKOO_ID");
			elseif ( $apiType == API_TYPE_SDC )			$cRec = getRecord("CATEGORY", $categoryId, "SDC_ID");
			elseif ( $apiType == API_TYPE_AFFWIN )		$cRec = getRecord("CATEGORY", $categoryId, "AFFWIN_ID");
			elseif ( $apiType == API_TYPE_NEXTAG )		$cRec = getRecord("CATEGORY", $categoryId, "NEXTAG_ID");
			elseif ( $apiType == API_TYPE_PRICEGRABBER )$cRec = getRecord("CATEGORY", $categoryId, "PRICEGRABBER_ID");
			elseif ( $apiType == API_TYPE_AFFILINET )	$cRec = getRecord("CATEGORY", $categoryId, "AFFILINET_ID");
			elseif ( $apiType == API_TYPE_CONNEXITY )	$cRec = getRecord("CATEGORY", $categoryId, "CONNEXITY_ID");
			elseif ( $apiType == API_TYPE_ZANOX )		$cRec = getRecord("CATEGORY", $categoryId, "ZANOX_ID");

			if ( !is_array($cRec) )
			{
				$arrRec = array($categoryId, $defaultCatTitle, $defaultCatFilename);

				if ( $doCache == 1 )
					$pcsCachedCategoryRecs[$categoryId] = $arrRec;

				return $arrRec;
			}

			$cRec['FILENAME']	= $cRec['FILENAME'] == '' ? replaceFilenameChars($cRec['TITLE']) : $cRec['FILENAME'];

			$arrRec = array($cRec['ID'], $cRec['TITLE'], $cRec['FILENAME']);

			if ( $doCache == 1 )
				$pcsCachedCategoryRecs[$categoryId] = $arrRec;

			return $arrRec;
		}

//*************************************************************************************************

		function pcsFillCategoryRec($apiType, &$prods, $doCache=0)
		{
			$tot = count($prods);

			$arr = array();
			$str = '';
			if ( is_array($prods) )
			{
				foreach ( $prods as $prod )
				{
					$arr[] = $prod['CATEGORY_ID'];
					$str .= ', ?';
				}
			}

			$tot = count($arr);

			if ( $tot == 0 )
				return;

			$str = substr($str, 2);

			$idField	= 'ID';
			if ( $apiType == API_TYPE_SHOPZILLA )		$idField	= 'SHOPZILLA_ID';
			elseif ( $apiType == API_TYPE_AMAZON )		$idField	= 'AMAZON_CATEGORY';
			elseif ( $apiType == API_TYPE_KELKOO )		$idField	= 'KELKOO_ID';
			elseif ( $apiType == API_TYPE_SDC )			$idField	= 'SDC_ID';
			elseif ( $apiType == API_TYPE_AFFWIN )		$idField	= 'AFFWIN_ID';
			elseif ( $apiType == API_TYPE_NEXTAG )		$idField	= 'NEXTAG_ID';
			elseif ( $apiType == API_TYPE_PRICEGRABBER )$idField	= 'PRICEGRABBER_ID';
			elseif ( $apiType == API_TYPE_AFFILINET )	$idField	= 'AFFILINET_ID';
			elseif ( $apiType == API_TYPE_CONNEXITY )	$idField	= 'CONNEXITY_ID';
			elseif ( $apiType == API_TYPE_ZANOX )		$idField	= 'ZANOX_ID';

			$cats = array();
			$res = preparedQuery("SELECT ID, TITLE, FILENAME FROM ".PREFIX."CATEGORY WHERE ".$idField." IN (".$str.")", $arr);
			while ( ($row = getRow($res)) )
				$cats[$row['ID']] = $row;

			for ( $i=0; $i<$tot; $i++ )
			{
				$prods[$i]['CTITLE']	= $cats[$prods[$i]['CATEGORY_ID']]['TITLE'] == '' ? $prods[$i]['CATEGORY']: $cats[$prods[$i]['CATEGORY_ID']]['TITLE'];
				$prods[$i]['CFILENAME']	= $cats[$prods[$i]['CATEGORY_ID']]['FILENAME'] == '' ? $prods[$i]['CFILENAME'] : $cats[$prods[$i]['CATEGORY_ID']]['FILENAME'];
				
				// we need to do this to avoid getProductPath() try to run getRecord() because PFILENAME is not found
				if ( !isset($prods[$i]['PFILENAME']) || $prods[$i]['PFILENAME'] == '' )
					$prods[$i]['PFILENAME']	= isset($prods[$i]['FILENAME']) ? $prods[$i]['FILENAME'] : '';
			}
		}

//*************************************************************************************************

		function pcsGetSortOptsFromApi($apiSK, $apiSO)
		{
			$sk = '';
			$so = '';

			if ( stristr($spiSK, 'price') || stristr($spiSO, 'price') )				$sk = 'PRICE';
			elseif ( stristr($spiSK, 'title') || stristr($spiSO, 'title') )			$sk = 'TITLE';
			elseif ( stristr($spiSK, 'name') || stristr($spiSO, 'name') )			$sk = 'TITLE';
			elseif ( stristr($spiSK, 'rating') || stristr($spiSO, 'rating') )		$sk = 'PRODUCT_RATING';

			if ( stristr($spiSK, 'desc') || stristr($spiSO, 'desc') )				$so = 'DESC';

			return array($sk, $so);
		}

//*************************************************************************************************
?>