<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

if ( $productId < 1 ) {
	return [];
}

//*************************************************************************************************

$min  = 0;
$max  = 0;
$step = 1;

$values = [];

$arr = [];
$res = executeQuery( "SELECT MAX_PRICE AS MAXP, MIN_PRICE AS MINP, ((MAX_PRICE+MIN_PRICE)/2) AS AVGP, CHANGE_DATE FROM " . PREFIX . "PRODUCT_PRICE_HISTORY WHERE PRODUCT_ID = " . $productId . " GROUP BY CHANGE_DATE ORDER BY CHANGE_DATE DESC LIMIT 6" );
while ( ( $row = getRow( $res ) ) ) {
	array_unshift( $arr, $row );
}

$tot = count( $arr );
$dif = floor( $tot / 7 );
$dex = 0;
foreach ( $arr as $row ) {
	$dex ++;

	if (                                   // Skip the loop if
		$dex != 1 &&                       // its not first record						AND
		$dex != $tot &&                    // its not last record						AND
		$dif > 0 &&                        // skipping difference is something			AND
		( $dex - 1 ) % $dif != 0           // this is an intermediate record to skip
	) {
		continue;
	}

	$min = $min == 0 || $row['MINP'] < $min ? $row['MINP'] : $min;
	$max = $row['MAXP'] > $max ? $row['MAXP'] : $max;

	$values[ formatDate( $row['CHANGE_DATE'], 'd/M' ) ] = [
		(float) $row['MINP'],
		(float) $row['MAXP'],
		(float) $row['AVGP'],
	];
}
free( $res );

$step = floor( ( $max - $min ) / 2 );
$step = $step <= 0 ? 1 : $step;

return $values;

//*************************************************************************************************
