<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

		define('API_WORD_MATCH_THRESHOLD',	65);

		$ajaxCall	= getVar('ajax', 'int');

        $isPreview	= getVar('preview', 'int') == 1;

		$apiType	= getVar('apiType');
		$apiType	= $apiType == '' ? API_TYPE_MYSQL : $apiType;

		$productId	= $apiType == API_TYPE_MYSQL ? getVar('productId', 'int') : getVar('productId', '[^a-zA-Z0-9-]', '', array('maxlen'=>50));

		$prodName	= getVar('prodName', '', '', array('maxlen'=>250));
		$prodCat	= getVar('prodCat', 'int');
		$prodUPC	= getVar('prodUPC', '[^a-zA-Z0-9-]', '', array('maxlen'=>50));
		$prodPrice	= getVar('prodPrice', 'float');

		$nextAjaxCalls				= array();
		if ( $ajaxCall == 0 )
		{
			if ( $productId == '' )
				showErrorPageAndDie(404, 'Product id is empty');

			if ( is_array($prefPrdSrc) )
			{
				foreach ( $prefPrdSrc as $key => $val )
				{
					if ( !strstr($key, 'SHOW_PRODUCTS_FROM_') || $val != 1 )
						continue;

					$apiNm = str_replace('SHOW_PRODUCTS_FROM_', '', $key);

					if ( isset($ARR_API_TYPE_NAME_VALS[$apiNm]) && $ARR_API_TYPE_NAME_VALS[$apiNm] != $apiType )
						$nextAjaxCalls[] = $ARR_API_TYPE_NAME_VALS[$apiNm];
				}
			}
		}
		else
		{
			if ( $prodName == '' && $prodUPC == '' )
				die('{"ERR":"no name or ean/upc to search"}');
		}

//*************************************************************************************************

		$doHideLeftPanel			= IS_PRODUCTFILTERS_INSTALLED == 1 || IS_PRICEHISTORYGRAPH_INSTALLED == 1 ? 1 : 0;

//*************************************************************************************************

		$prod					= array();
		$cat					= array();
		$categoryId				= getVar('categoryId', 'int');
		$tabCategoryId			= 0;
		$productThumbUrl		= '';
		$productImageUrl		= '';

		$apiProdSKU				= '';
		$apiProdUPC				= '';

//*************************************************************************************************

		if ( $apiType == API_TYPE_MYSQL )
		{
			if ( $ajaxCall == 0 )
			{
				if ( !( $prod = getRecord('PRODUCT', $productId) ) )
					showErrorPageAndDie(404, 'Product not found for ID '.$productId);
			}
			else
			{
				$prodId = 0;
				if ( $prodUPC != '' )
					$prodId = (int)getColumn('PRODUCT_EAN_ALIAS', $prodUPC, 'PRODUCT_ID', 'EAN');

				if ( $prodId == 0 && $prodName != '' )
				{
					$prodWords = getCleanedWordsFromString($prodName);
					$sqlProdNam = "SELECT ID FROM ".PREFIX."PRODUCT WHERE ".getSearchColumn('TITLE', implode(' ', $prodWords), ' ')." AND ISVALID='Y' LIMIT 1";
					if ( isset($_GET['debug']) )
						echo "\n\n<!-- \n\n$sqlProdNam\n\n -->\n\n";
					$resPNM = executeQuery($sqlProdNam);
					if ( ($rowPNM = getRow($resPNM)) )
						$prodId = (int)$rowPNM['ID'];
				}

				if ( $prodId == 0 )
					die('{"ERR":"Mysql product not found by EAN or Name"}');

				if ( !( $prod = getRecord('PRODUCT', $prodId) ) )
					die('{"ERR":"product not found by id: '.$prodId.'"}');

				$productId = $prodId;
			}

			$prod['DETAIL'] = getColumn('PRODUCT_DETAIL', $productId, 'DETAIL', 'PRODUCT_ID');

			if ( $prod['MANUFACTURER'] != '' )
			{
				$prod['MANUFACTURERID'] = $prod['MANUFACTURER'];
				$prod['MANUFACTURER'] = $prod['MANUFACTURERID'] == '0' ? 'N/A' : getColumn('BRAND', $prod['MANUFACTURERID']);
			}

			// 12/23/2016: Mamda: this is to ensure that if category id is passed in url and it is not matching
			//				the products original category id, then we go to 404
			if ( $categoryId > 0 && $prod['CATEGORY_ID'] != $categoryId )
				showErrorPageAndDie(404, 'Category id does not match product\'s category record');

			$categoryId			= (int)$prod['CATEGORY_ID'];
			$cat				= getRecord('CATEGORY', $categoryId);
			$tabCategoryId		= getRootCategory($cat['PARENT_ID']);
			$productImageUrl	= getProductImageUrl($productId);
		}

		// Load elasticsearch product information
		elseif ( defined('IS_ELASTICSEARCH_INSTALLED') && IS_ELASTICSEARCH_INSTALLED == 1 && $apiType == API_TYPE_ELASTICSEARCH )
		{
			if ( $ajaxCall == 0 )
			{
				$esRes = elasticsearch_getDocumentById(ELASTICSEARCH_PRODUCT_INDEX, $productId);
				if ( !is_object($esRes) || !is_object($esRes->_source) )
				{
					header('Location: '.getSeoUrl('/', 'info=6'));
					die;
				}
			}
			else
				die('{"ERR":"skipping Elastic Search"}');


			$esRes = $esRes->_source;

//			echo '<pre>';print_r($esRes);die;

			$prod	= array(
								'API_TYPE'			=> API_TYPE_ELASTICSEARCH,
								'MIN_PRICE'			=> isset($esRes->min_price) ? $esRes->min_price : 0,
								'MAX_PRICE'			=> isset($esRes->max_price) ? $esRes->max_price : 0,
								'FORMATTED_PRICE_MIN'=> isset($esRes->min_price) ? getFormattedPrice($esRes->min_price, $currencySymbol, $currencyRate) : 0,
								'FORMATTED_PRICE_MAX'=> isset($esRes->max_price) ? getFormattedPrice($esRes->max_price, $currencySymbol, $currencyRate) : 0,
								'STORE_COUNT'		=> isset($esRes->store_count) ? $esRes->store_count : 0,
								'ID'				=> $esResuctId,
								'LINK_ID'			=> $esResuctId,
								'TITLE'				=> isset($esRes->title) ? $esRes->title : '',
								'DETAIL'			=> isset($esRes->description) ? $esRes->description : '',
								'FILENAME'			=> isset($esRes->filename) ? $esRes->filename : '',
								'MANUFACTURER'		=> isset($esRes->manufacturer) ? $esRes->manufacturer : '',
								'MANUFACTURER_ID'	=> isset($esRes->manufacturer_id) ? $esRes->manufacturer_id : 0,
								'MANUFACTURER_CODE'	=> isset($esRes->codes[0]) ? $esRes->codes[0] : '',
								'EAN_UPC'			=> isset($esRes->codes[0]) ? $esRes->eans[0] : '',
								'RATING'			=> isset($esRes->rating) ? $esRes->rating : -1,
								'CATEGORY_ID'		=> isset($esRes->category_id) ? $esRes->category_id : 0
							);

//			echo '<pre>';print_r($prod);die;

			if ( is_array($esRes->prices) )
			{
				$arrMers = array();
				$arrMerRs = array();
				foreach ( $esRes->prices as $objPrice )
				{
					if ( !is_object($objPrice) )
						continue;

					$noOfRecords++;

					$hasAvailability	= $objPrice->availability == '' ? $hasAvailability : true;
					$hasComments		= $objPrice->comments == '' ? $hasComments : true;

					if ( !isset($arrMers[$objPrice->user_id]) )
						$arrMers[$objPrice->user_id] = getRecord('USERINFO', $objPrice->user_id, 'USERID');

					if ( !isset($arrMerRs[$objPrice->user_id]) )
					{
						$resTmrX1 = executeQuery("SELECT AVG(RATING) AS R, COUNT(ID) AS C FROM ".PREFIX."USER_RATING WHERE MERCHANTID='".$objPrice->user_id."' AND ISVALID='Y'");
						$arrMerRs[$objPrice->user_id] = getRow($resTmrX1);
					}

					$arrPrice	= array(
											'USERID'			=> $objPrice->user_id,
											'NAME'				=> $arrMers[$objPrice->user_id]['NAME'],
											'FILENAME'			=> $arrMers[$objPrice->user_id]['FILENAME'],
											'PARTNO'			=> $objPrice->part_no,
											'PRICE'				=> $objPrice->price,
											'FORMATTED_PRICE'	=> getFormattedPrice($objPrice->price, $currencySymbol, $currencyRate),
											'TOTAL'				=> $objPrice->price,
											'FORMATTED_TOTAL'	=> getFormattedPrice($objPrice->price, $currencySymbol, $currencyRate),
											'SHIPPING'			=> $objPrice->shipping,
											'COMMENT'			=> $objPrice->comments,
											'BUY_URL'			=> $objPrice->buy_url,
											'RATING'			=> $arrMerRs[$objPrice->user_id]['R'],
											'REVIEWS'			=> $arrMerRs[$objPrice->user_id]['C'],
											'ISAVAILABLE'		=> $objPrice->availability,
											'BRAND'				=> $objPrice->brand,
										);

					$arrPrice['RATING_URL'] = getMerchantPath($arrPrice['USERID'], 'Reviews', '', $arrPrice['FILENAME']);
					$mLink					= getMerchantPath($arrPrice['USERID'], '', '', $arrPrice['FILENAME']);

					if ( file_exists(PATH_SUBD."upload/merchant/".$arrPrice["USERID"].".jpg") )
						$arrPrice['IMAGE'] 	= "<a href='".$mLink."'><img src=\"".getMerchantLogoThumbUrl($arrPrice['USERID'], 120, 50, $arrPrice['NAME'])."\" class='img-responsive center-block' border='0' alt='".$arrPrice['NAME']."' title='".$arrPrice['NAME']."'></a>";
					else
						$arrPrice['IMAGE'] 	= "<a href='".$mLink."' class='link'><b>".$arrPrice['NAME']."</b></a>";			

					$arrPrices[] = $arrPrice;

					array_unshift($arrPrice, $arrPrice['TOTAL'] );
					$arrBest[] = $arrPrice;
				}
			}

			$apiProdSKU			= isset($esRes->codes[0]) ? $esRes->codes[0] : '';
			$apiProdUPC			= isset($esRes->eans[0]) ? $esRes->eans[0] : '';

			$esRes->category_id	= (int)$esRes->category_id;
			if ( $esRes->category_id > 0 )
			{
				if ( ($temp = getRecord('CATEGORY', $esRes->category_id)) )
				{
					$categoryId	= $esRes->category_id;
					$cat		= $temp;
				}
			}

			$productThumbUrl	= isset($esRes->images[0]) ? $esRes->images[0] : '';
			$productImageUrl	= isset($esRes->images[0]) ? $esRes->images[0] : '';

			$linkReviews		= getProductPath($productId, $productFilename, $categoryId, $categoryFilename, 'review', '', $apiType);
			$totReviews			= $prod['REVIEWS'];
		}

		// Load shopzilla product information
		elseif ( $apiType == API_TYPE_SHOPZILLA )
		{
			require_once (PATH."include/include_shopzilla.php");

			if ( $ajaxCall == 0 )
			{
				$msg = '';
				$szRes = pcsShopzillaProductInfo($msg, $productId);
				if ( !is_array($szRes) ) { header('Location: '.getSeoUrl('/', 'info=6')); die; }
			}
			else
			{
				// clean the name for search
				$prodName = preg_replace('/[^a-zA-Z0-9 ]/', '', $prodName);

				// find by name on SZ
				$szRes = shopzilla_getProducts(0, $prodName);
				if ( !is_array($szRes) || !isset($szRes['PRODUCTS'][0]['PRODUCT'][0]['__ATTRIBUTES']['ID']) )
					die('{"ERR":"Shopzilla not found by name: '.$prodName.'"}');

				// load the product from SZ if got the SZ-ID
				$szID = 'SZPID-'.$szRes['PRODUCTS'][0]['PRODUCT'][0]['__ATTRIBUTES']['ID'];
				$szRes = pcsShopzillaProductInfo($msg, $szID);
				if ( !is_array($szRes) )
					die('{"ERR":"Shopzilla not found by id ['.$prodName.']['.$szID.']"}');

				// get the prod array to test word threashold
				list($tcat, $prod, $arrPrices) = $szRes;

				// get matching threshold
				$mth = wordsMatchThreshold($prodName, $prod['TITLE']);

				if ( $mth < API_WORD_MATCH_THRESHOLD )
					die('{"ERR":"Shopzilla found but word match failed ['.$prodName.']['.$prod['TITLE'].']['.$mth.']"}');
			}

//			echo '<pre>';print_r($szRes);die;

			list($tcat, $prod, $arrPrices) = $szRes;
			// 12/28/2015: Mamda: $cat loaded from api does problems as script thinks it is script category while actually it is api category, so try to load it below

			if ( is_array($arrPrices) )
			{
				foreach ( $arrPrices as $arrPrice )
				{
					$noOfRecords++;

					$hasAvailability	= $arrPrice['ISAVAILABLE'] == '' ? $hasAvailability : true;
					$hasComments		= $arrPrice['COMMENT'] == '' ? $hasComments : true;

					if ( $arrPrice['LOGO_URL'] != '' )
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#'><img src=\"".$arrPrice['LOGO_URL']."\" border='0' alt='".$arrPrice['NAME']."' class='img-responsive center-block' title='".$arrPrice['NAME']."'></a>";
					else
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#' class='link'><b>".$arrPrice['NAME']."</b></a>";

					$arrPrice['REDIRECT_URL'] 	= getSeoUrl('redirect', 'apiType='.$apiType.'&amp;url='.urlencode($arrPrice['BUY_URL']));

					array_unshift($arrPrice, $arrPrice['TOTAL'] );
					$arrBest[] = $arrPrice;
				}
			}

			$apiProdSKU			= $prod['SKU'];
			$apiProdUPC			= $prod['UPC'];

			if ( $prod['CATEGORY_ID'] > 0 )
			{
				if ( ($temp = getRecord('CATEGORY', $prod['CATEGORY_ID'], 'SHOPZILLA_ID')) )
				{
					$categoryId	= (int)$temp['ID'];
					$cat		= $temp;
				}
			}

			$productThumbUrl	= str_replace('{WIDTH}', 150, str_replace('{HEIGHT}', 150, $prod['IMAGE_URL']));
			$productImageUrl	= str_replace('{WIDTH}', 550, str_replace('{HEIGHT}', 550, $prod['IMAGE_URL']));

			list($szType,$szId) = explode('-', $productId, 2);
			$linkReviews		= getProductPath($productId, $productFilename, $categoryId, $categoryFilename, 'review', '', $apiType);
			// 9/4/2013: Mamda: Incase of shopzilla, we use default reviews page as there we do handle reviews from SZ
//			$linkReviews		= $szType == 'SZPID' ? 'http://www.shopzilla.com/'.$prod['FILENAME'].'/'.$szId.'/review' : '#';
			$totReviews			= $prod['REVIEWS'];
		}

		// Load amazon product information
		elseif ( $apiType == API_TYPE_AMAZON )
		{
			require_once (PATH."include/include_amazon_ecs.php");

			if ( $ajaxCall == 0 )
			{
				$msg = '';
				$amzRes = pcsAmazonProductInfo($msg, $productId);
				if ( !is_array($amzRes) ) { header('Location: '.getSeoUrl('/', 'info=6&msg='.urlencode($msg))); die; }
			}
			else
			{
				$msg = '';
				$amzRes = amazon_getProducts('', $prodName);
				if ( !is_array($amzRes) || !isset($amzRes['ITEM'][0]['ASIN'][0]) )
					die('{"ERR":"'.urlencode($msg.'['.$prodName.']').'"}');
				$amzRes = pcsAmazonProductInfo($msg, $amzRes['ITEM'][0]['ASIN'][0]);
				if ( !is_array($amzRes) )
					die('{"ERR":"'.urlencode($msg.'['.$prodName.']').'"}');

				// get the prod array to test word threashold
				list($tcat, $prod, $arrPrices) = $amzRes;

				// get matching threshold
				$mth = wordsMatchThreshold($prodName, $prod['TITLE']);

				if ( $mth < API_WORD_MATCH_THRESHOLD )
					die('{"ERR":"Amazon found but word match failed ['.$prodName.']['.$prod['TITLE'].']['.$mth.']"}');
			}

//			echo '<pre>';print_r($amzRes);die;

			list($tcat, $prod, $arrPrices) = $amzRes;
			// 12/28/2015: Mamda: $cat loaded from api does problems as script thinks it is script category while actually it is api category, so try to load it below

			$hideUserReviews = true;
			if ( is_array($arrPrices) )
			{
				foreach ( $arrPrices as $arrPrice )
				{
					$noOfRecords++;

					// If store does not have logo, then show Amazon logo and Amazon as store name
					if ( $arrPrice['LOGO_URL'] == '' )
					{
						$arrPrice['NAME']				    = 'Amazon';
						$arrPrices[$noOfRecords-1]['NAME']	= 'Amazon';
					}

					$hasAvailability	= $arrPrice['ISAVAILABLE'] == '' ? $hasAvailability : true;
					$hasComments		= $arrPrice['COMMENT'] == '' ? $hasComments : true;
					$hideUserReviews	= $arrPrice['RATING'] == 0 ? $hideUserReviews : true;

					if ( $arrPrice['LOGO_URL'] != '' )
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#'><img src=\"".$arrPrice['LOGO_URL']."\" border='0' alt='".$arrPrice['NAME']."' class='img-responsive center-block' title='".$arrPrice['NAME']."'></a>";
					else
	//					$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#' class='link'><b>".$arrPrice['NAME']."</b></a>";
	// 10/5/2016: Mamda: asked to show Amazon logo instead if no logo from api
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#' class='link'><img src=\"".getMerchantLogoThumbUrl(PCS_AMAZON_USERID, 100, 30, $arrPrice['NAME'])."\" border='0' alt='".$arrPrice['NAME']."' class='img-responsive center-block' title='".$arrPrice['NAME']."'></a>";

					$arrPrice['REDIRECT_URL'] 	= getSeoUrl('redirect', 'apiType='.$apiType.'&amp;url='.urlencode($arrPrice['BUY_URL']));

					array_unshift($arrPrice, $arrPrice['TOTAL'] );
					$arrBest[] = $arrPrice;
				}
			}

			$apiProdSKU			= $prod['SKU'];
			$apiProdUPC			= $prod['EAN'];

			if ( $tcat['ID'] != '' )
			{
				if ( ($temp = getRecord('CATEGORY', $tcat['ID'], 'AMAZON_BROWSE_NODE')) )
				{
					$categoryId	= (int)$temp['ID'];
					$cat		= $temp;
				}
			}

			$productThumbUrl	= str_replace('{WIDTH}', 150, str_replace('{HEIGHT}', 150, $prod['IMAGE_URL']));
			$productImageUrl	= str_replace('{WIDTH}', 550, str_replace('{HEIGHT}', 550, $prod['IMAGE_URL']));
		}

		// Load kelkoo product information
		elseif ( $apiType == API_TYPE_KELKOO )
		{
			require_once (PATH."include/include_kelkoo.php");

			$cat = getRecord('CATEGORY', $categoryId);

			if ( $ajaxCall == 0 )
			{
				$msg = '';
				$kkRes = pcsKelkooProductInfo($msg, getVar('categoryId'), $productId, $cat['KELKOO_ID']);
				if ( !is_array($kkRes) ) { header('Location: '.getSeoUrl('/', 'info=6')); die; }
			}
			else
			{
				$msg = '';
				if ( $prodUPC != '' )
					$kkRes = pcsKelkooProductInfo($msg, '', '', '', $prodUPC);
				if ( !is_array($kkRes) )
					die('{"ERR":"Kelkoo - '.urlencode($msg.'['.$prodUPC.']').'"}');
			}

//			echo '<pre>';print_r($kkRes);die;

			list($tcat, $prod, $arrPrices) = $kkRes;
			// 12/28/2015: Mamda: $cat loaded from api does problems as script thinks it is script category while actually it is api category, so try to load it below

			if ( is_array($arrPrices) )
			{
				foreach ( $arrPrices as $arrPrice )
				{
					$noOfRecords++;

					$hasAvailability	= $arrPrice['ISAVAILABLE'] == '' ? $hasAvailability : true;
					$hasComments		= $arrPrice['COMMENT'] == '' ? $hasComments : true;

					if ( $arrPrice['LOGO_URL'] != '' )
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#'><img src=\"".$arrPrice['LOGO_URL']."\" border='0' alt='".$arrPrice['NAME']."' class='img-responsive center-block' title='".$arrPrice['NAME']."'></a>";
					else
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#' class='link'><b>".$arrPrice['NAME']."</b></a>";

					$arrPrice['REDIRECT_URL'] 	= getSeoUrl('redirect', 'apiType='.$apiType.'&amp;url='.urlencode($arrPrice['BUY_URL']));

					array_unshift($arrPrice, $arrPrice['TOTAL'] );
					$arrBest[] = $arrPrice;
				}
			}

			$apiProdSKU			= $prod['SKU'];
			$apiProdUPC			= $prod['EAN'];

			if ( $tcat['ID'] != '' )
			{
				if ( ($temp = getRecord('CATEGORY', $tcat['ID'], 'KELKOO_ID')) )
				{
					$categoryId	= (int)$temp['ID'];
					$cat		= $temp;
				}
			}

			$productThumbUrl	= str_replace('{WIDTH}', 150, str_replace('{HEIGHT}', 150, $prod['IMAGE_URL']));
			$productImageUrl	= str_replace('{WIDTH}', 550, str_replace('{HEIGHT}', 550, $prod['IMAGE_URL']));
			$tempParts			= explode('/http', $productImageUrl);
			$productImageUrl	= $tempParts[0] . '/http' . urlencode($tempParts[1]);
		}

		// Load sdc product information
		elseif ( $apiType == API_TYPE_SDC )
		{
			require_once (PATH."include/include_sdc.php");

			if ( $ajaxCall == 0 )
			{
				$msg = '';
				$sdcRes = pcsSDCProductInfo($msg, getVar('categoryId'), $productId);

				if ( !is_array($sdcRes) )
				{
					header('Location: '.getSeoUrl('/', 'info=6'));
					die;
				}
			}
			else
			{
				$msg = '';
				$sdcRes = sdc_getSearchResults($prodName);

				if ( isset($_GET['debug']) ) { print_r($sdcRes);die; }

				if ( !is_array($sdcRes) || !isset($sdcRes['ITEMS'][0]['OFFER'][0]['__ATTRIBUTES']['ID']) )
					die('{"ERR":" SDC product not found by name"}');

				// find most suitable price from sdc
				$lastTH = 0;
				$sdcOffer = '';
				if ( is_array($sdcRes['ITEMS'][0]['OFFER']) )
				{
					foreach ( $sdcRes['ITEMS'][0]['OFFER'] as $tsdcOffer )
					{
						// compare price first if product price and sdc price both are present
						$sdcPrice = (float)$tsdcOffer['BASEPRICE'][0][0];
						if ( $prodPrice > 0 && $sdcPrice > 0 )
						{
							// get proportion of price by dividing the larger one with smaller one
							$prop = $sdcPrice > $prodPrice ? $sdcPrice / $prodPrice : $prodPrice / $sdcPrice;
							// if proportion is more than double, then skip
							if ( $prop > 2 )
								continue;
						}

						$mth = wordsMatchThreshold($prodName, $tsdcOffer['NAME'][0]);
						if ( $mth > API_WORD_MATCH_THRESHOLD - 5 && $mth > $lastTH )
						{
							$lastTH = $mth;
							$sdcOffer = $tsdcOffer;
						}
					}
				}

				if ( !is_array($sdcOffer) )
					die('{"ERR":"SDC matching product not found"}');

				$sdcID = str_replace('=', '', 'OFFER-'.$sdcOffer['__ATTRIBUTES']['ID']);
				$sdcRes = pcsSDCProductInfo($msg, 0, $sdcID);
				if ( !is_array($sdcRes) )
					die('{"ERR":"SDC product not found by id ['.$sdcID.']"}');

				list($tcat, $prod, $arrPrices) = $sdcRes;
			}

//			echo '<pre>';print_r($sdcRes);die;

			list($cat, $prod, $arrPrices) = $sdcRes;
			// 12/28/2015: Mamda: $cat in include_sdc is evaluated from script, so no need to eval again here

			if ( is_array($arrPrices) )
			{
				foreach ( $arrPrices as $arrPrice )
				{
					$noOfRecords++;

					$hasAvailability	= $arrPrice['ISAVAILABLE'] == '' ? $hasAvailability : true;
					$hasComments		= $arrPrice['COMMENT'] == '' ? $hasComments : true;

					if ( $arrPrice['LOGO_URL'] != '' )
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#'><img src=\"".$arrPrice['LOGO_URL']."\" border='0' alt='".$arrPrice['NAME']."' class='img-responsive center-block' title='".$arrPrice['NAME']."'></a>";
					else
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#' class='link'><b>".$arrPrice['NAME']."</b></a>";

					$arrPrice['REDIRECT_URL'] 	= getSeoUrl('redirect', 'apiType='.$apiType.'&amp;url='.urlencode($arrPrice['BUY_URL']));

					array_unshift($arrPrice, $arrPrice['TOTAL'] );
					$arrBest[] = $arrPrice;
				}
			}

			$apiProdSKU			= $prod['MANUFACTURER_CODE'] == '' ? $prod['SKU'] : $prod['MANUFACTURER_CODE'];
			$apiProdUPC			= $prod['EAN'] == '' ? $prod['UPC'] : $prod['EAN'];

			$categoryId			= $cat['ID'] > 0 ? $cat['ID'] : $categoryId;

			$productThumbUrl	= str_replace('{WIDTH}', 150, str_replace('{HEIGHT}', 150, $prod['IMAGE_URL']));
			$productImageUrl	= str_replace('{WIDTH}', 550, str_replace('{HEIGHT}', 550, $prod['IMAGE_URL']));
		}

		// Load affwin product information
		elseif ( $apiType == API_TYPE_AFFWIN )
		{
			require_once (PATH."include/include_affwin.php");

			if ( $ajaxCall == 0 )
			{
				$msg = '';
				$apiRes = pcsAffWinProductInfo($msg, $productId);

				if ( !is_array($apiRes) )
				{
					header('Location: '.getSeoUrl('/', 'info=6'));
					die;
				}
			}
			else
				die('{"ERR":"Skipping Affiliate Window"}');

//			echo '<pre>';print_r($apiRes);die;

			list($cat, $prod, $arrPrices) = $apiRes;
			// 12/28/2015: Mamda: $cat in include_affwin is evaluated from script already

			if ( is_array($arrPrices) )
			{
				foreach ( $arrPrices as $arrPrice )
				{
					$noOfRecords++;

					$hasAvailability	= $arrPrice['ISAVAILABLE'] == '' ? $hasAvailability : true;
					$hasComments		= $arrPrice['COMMENT'] == '' ? $hasComments : true;

					if ( $arrPrice['LOGO_URL'] != '' )
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#'><img src=\"".$arrPrice['LOGO_URL']."\" border='0' alt='".$arrPrice['NAME']."' class='img-responsive center-block' title='".$arrPrice['NAME']."'></a>";
					else
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#' class='link'><b>".$arrPrice['NAME']."</b></a>";

					$arrPrice['REDIRECT_URL'] 	= getSeoUrl('redirect', 'apiType='.$apiType.'&amp;url='.urlencode($arrPrice['BUY_URL']));

					array_unshift($arrPrice, $arrPrice['TOTAL'] );
					$arrBest[] = $arrPrice;
				}
			}

			$apiProdSKU			= $prod['SKU'];

			$categoryId			= $cat['ID'] > 0 ? $cat['ID'] : $categoryId;

			$productThumbUrl	= $prod['THUMB_URL'];
			$productImageUrl	= $prod['IMAGE_URL'];
		}

		// Load nextag product information
		elseif ( $apiType == API_TYPE_NEXTAG )
		{
			require_once (PATH."include/include_nextag.php");

			if ( $ajaxCall == 0 )
			{
				$msg = '';
				$nextagRes = pcsNexTagProductInfo($msg, $productId);

				if ( !is_array($nextagRes) )
				{
					header('Location: '.getSeoUrl('/', 'info=6'));
					die;
				}
			}
			else
				die('{"ERR":"Skipping NexTAG"}');

//			echo '<pre>';print_r($nextagRes);die;

			list($tcat, $prod, $arrPrices) = $nextagRes;
			// 12/28/2015: Mamda: $cat loaded from api does problems as script thinks it is script category while actually it is api category, so try to load it below

			if ( is_array($arrPrices) )
			{
				foreach ( $arrPrices as $arrPrice )
				{
					$noOfRecords++;

					$hasAvailability	= $arrPrice['ISAVAILABLE'] == '' ? $hasAvailability : true;
					$hasComments		= $arrPrice['COMMENT'] == '' ? $hasComments : true;

					if ( $arrPrice['LOGO_URL'] != '' )
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#'><img src=\"".$arrPrice['LOGO_URL']."\" border='0' alt='".$arrPrice['NAME']."' class='img-responsive center-block' title='".$arrPrice['NAME']."'></a>";
					else
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#' class='link'><b>".$arrPrice['NAME']."</b></a>";

					$arrPrice['REDIRECT_URL'] 	= getSeoUrl('redirect', 'apiType='.$apiType.'&amp;url='.urlencode($arrPrice['BUY_URL']));

					array_unshift($arrPrice, $arrPrice['TOTAL'] );
					$arrBest[] = $arrPrice;
				}
			}

			$apiProdSKU			= $prod['SKU'];
			$apiProdUPC			= $prod['UPC'];

			if ( $tcat['ID'] != '' )
			{
				if ( ($temp = getRecord('CATEGORY', $tcat['ID'], 'NEXTAG_ID')) )
				{
					$categoryId	= (int)$temp['ID'];
					$cat		= $temp;
				}
			}

			$productThumbUrl	= str_replace('{WIDTH}', 150, str_replace('{HEIGHT}', 150, $prod['IMAGE_URL']));
			$productImageUrl	= str_replace('{WIDTH}', 550, str_replace('{HEIGHT}', 550, $prod['IMAGE_URL']));
		}

		// Load Affilinet product information
		elseif ( $apiType == API_TYPE_AFFILINET )
		{
			require_once (PATH."include/include_affilinet.php");

			if ( $ajaxCall == 0 )
			{
				$msg = '';
				$json = pcsAffilinetProductInfo($msg, $productId);

				if ( !is_array($json) ) { header('Location: '.getSeoUrl('index', 'info=6')); die; }
			}
			else
				die('{"ERR":"Skipping Affilinet"}');

//			echo '<pre>';print_r($json);die;

			list($tcat, $prod, $arrPrices) = $json;
			// 12/28/2015: Mamda: $cat loaded from api does problems as script thinks it is script category while actually it is api category, so try to load it below

			if ( is_array($arrPrices) )
			{
				foreach ( $arrPrices as $arrPrice )
				{
					$noOfRecords++;

					$hasAvailability	= $arrPrice['ISAVAILABLE'] == '' ? $hasAvailability : true;
					$hasComments		= $arrPrice['COMMENT'] == '' ? $hasComments : true;

					if ( $arrPrice['LOGO_URL'] != '' )
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#'><img src=\"".$arrPrice['LOGO_URL']."\" border='0' alt='".$arrPrice['NAME']."' class='img-responsive center-block' title='".$arrPrice['NAME']."'></a>";
					else
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#' class='link'><b>".$arrPrice['NAME']."</b></a>";

					$arrPrice['REDIRECT_URL'] 	= getSeoUrl('redirect', 'apiType='.$apiType.'&amp;url='.urlencode($arrPrice['BUY_URL']));

					array_unshift($arrPrice, $arrPrice['TOTAL'] );
					$arrBest[] = $arrPrice;
				}
			}

			if ( $tcat['ID'] != '' )
			{
				if ( ($temp = getRecord('CATEGORY', $tcat['ID'], 'AFFILINET_ID')) )
				{
					$categoryId	= (int)$temp['ID'];
					$cat		= $temp;
				}
			}

			$productThumbUrl	= $prod['IMAGE_URL'];
			$productImageUrl	= $prod['IMAGE_URL_L'];
		}

		// Load Connexity product information
		elseif ( $apiType == API_TYPE_CONNEXITY )
		{
			require_once (PATH."include/include_connexity.php");

			if ( $ajaxCall == 0 )
			{
				$msg = '';
				$res = pcsConnexityProductInfo($msg, $productId);

	//			echo '<pre>';print_r($res);die;

				if ( !is_array($res) ) { header('Location: '.getSeoUrl('index', 'info=6')); die; }
			}
			else
				die('{"ERR":"Skipping Connexity"}');

			list($tcat, $prod, $arrPrices) = $res;

			if ( is_array($arrPrices) )
			{
				foreach ( $arrPrices as $arrPrice )
				{
					$noOfRecords++;

					$hasAvailability	= $arrPrice['ISAVAILABLE'] == '' ? $hasAvailability : true;
					$hasComments		= $arrPrice['COMMENT'] == '' ? $hasComments : true;

					if ( $arrPrice['LOGO_URL'] != '' )
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#'><img src=\"".$arrPrice['LOGO_URL']."\" border='0' alt='".$arrPrice['NAME']."' class='img-responsive center-block' title='".$arrPrice['NAME']."'></a>";
					else
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#' class='link'><b>".$arrPrice['NAME']."</b></a>";

					$arrPrice['REDIRECT_URL'] 	= getSeoUrl('redirect', 'apiType='.$apiType.'&amp;url='.urlencode($arrPrice['BUY_URL']));

					array_unshift($arrPrice, $arrPrice['TOTAL'] );
					$arrBest[] = $arrPrice;
				}
			}

			if ( $tcat['ID'] != '' )
			{
				if ( ($temp = getRecord('CATEGORY', $tcat['ID'], 'CONNEXITY_ID')) )
				{
					$categoryId	= (int)$temp['ID'];
					$cat		= $temp;
				}
			}

			$productThumbUrl	= $prod['THUMB_URL'];
			$productImageUrl	= $prod['IMAGE_URL'];
		}

		// Load PriceGrabber product information
		elseif ( $apiType == API_TYPE_PRICEGRABBER )
		{
			require_once (PATH."include/include_pricegrabber.php");

			if ( $ajaxCall == 0 )
			{
				$msg = '';
				$pgRes = pcsPriceGrabberProductInfo($msg, $productId);

				if ( !is_array($pgRes) )
				{
					header('Location: '.getSeoUrl('index', 'info=6'));
					die;
				}
			}
			else
				die('{"ERR":"Skipping PriceGrabber"}');

//			echo '<pre>';print_r($pgRes);die;

			list($tcat, $prod, $arrPrices) = $pgRes;
			// 12/28/2015: Mamda: $cat loaded from api does problems as script thinks it is script category while actually it is api category, so try to load it below

			if ( is_array($arrPrices) )
			{
				foreach ( $arrPrices as $arrPrice )
				{
					$noOfRecords++;

					$hasAvailability	= $arrPrice['ISAVAILABLE'] == '' ? $hasAvailability : true;
					$hasComments		= $arrPrice['COMMENT'] == '' ? $hasComments : true;

					if ( $arrPrice['LOGO_URL'] != '' )
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#'><img src=\"".$arrPrice['LOGO_URL']."\" border='0' alt='".$arrPrice['NAME']."' class='img-responsive center-block' title='".$arrPrice['NAME']."'></a>";
					else
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#' class='link'><b>".$arrPrice['NAME']."</b></a>";

					$arrPrice['REDIRECT_URL'] 	= getSeoUrl('redirect', 'apiType='.$apiType.'&amp;url='.urlencode($arrPrice['BUY_URL']));

					array_unshift($arrPrice, $arrPrice['TOTAL'] );
					$arrBest[] = $arrPrice;
				}
			}

			if ( $tcat['ID'] != '' )
			{
				if ( ($temp = getRecord('CATEGORY', $tcat['ID'], 'PRICEGRABBER_ID')) )
				{
					$categoryId	= (int)$temp['ID'];
					$cat		= $temp;
				}
			}

			$productThumbUrl	= $prod['IMAGE_URL'];
			$productImageUrl	= $prod['IMAGE_URL_L'];
		}

		// Load zanox product information
		elseif ( $apiType == API_TYPE_ZANOX )
		{
			require_once (PATH."include/include_zanox.php");

			if ( $ajaxCall == 0 )
			{
				$msg = '';
				$zanoxRes = pcsZanoxProductInfo($msg, $productId);

				if ( !is_array($zanoxRes) )
				{
					header('Location: '.getSeoUrl('index', 'info=6'));
					die;
				}
			}
			else
				die('{"ERR":"Skipping Zanox"}');

//			echo '<pre>';print_r($zanoxRes);die;

			list($tcat, $prod, $arrPrices) = $zanoxRes;
			// 12/28/2015: Mamda: $cat loaded from api does problems as script thinks it is script category while actually it is api category, so try to load it below

			if ( is_array($arrPrices) )
			{
				foreach ( $arrPrices as $arrPrice )
				{
					$noOfRecords++;

					$hasAvailability	= $arrPrice['ISAVAILABLE'] == '' ? $hasAvailability : true;
					$hasComments		= $arrPrice['COMMENT'] == '' ? $hasComments : true;

					if ( $arrPrice['LOGO_URL'] != '' )
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#'><img src=\"".$arrPrice['LOGO_URL']."\" border='0' alt='".$arrPrice['NAME']."' class='img-responsive center-block' title='".$arrPrice['NAME']."'></a>";
					else
						$arrPrices[$noOfRecords-1]['IMAGE'] 	= "<a href='#' class='link'><b>".$arrPrice['NAME']."</b></a>";

					$arrPrice['REDIRECT_URL'] 	= getSeoUrl('redirect', 'apiType='.$apiType.'&amp;url='.urlencode($arrPrice['BUY_URL']));

					array_unshift($arrPrice, $arrPrice['TOTAL'] );
					$arrBest[] = $arrPrice;
				}
			}

			if ( $tcat['ID'] != '' )
			{
				if ( ($temp = getRecord('CATEGORY', $tcat['ID'], 'ZANOX_ID')) )
				{
					$categoryId	= (int)$temp['ID'];
					$cat		= $temp;
				}
			}

			$productThumbUrl	= $prod['IMAGE_URL'];
			$productImageUrl	= $prod['IMAGE_URL_L'];
		}

		// Load price from ebay
		elseif ( $apiType == 'ebay' )
		{
			require_once (PATH."include/include_ebay.php");

			if ( $ajaxCall == 0 )
			{
				header('Location: '.getSeoUrl('/', 'info=30&msg=ebay+nonajax+call'));
				die;
			}
			else
			{
				$msg = '';
				$res = ebayGetSearch($prodName, '');

				if ( !is_array($res) || !isset($res['FINDITEMSBYKEYWORDSRESPONSE'][0]['SEARCHRESULT'][0]) )
					die('{"ERR":"eBay err-1"}');

				$res = $res['FINDITEMSBYKEYWORDSRESPONSE'][0];
				if ( $res['ACK'][0] != 'Success' )
					die('{"ERR":"eBay err-2 ['.$res['SHORTMESSAGE'][0].']"}');

				$resSize = $res['SEARCHRESULT'][0]['__ATTRIBUTES']['COUNT']>10 ? 10:$res['SEARCHRESULT'][0]['__ATTRIBUTES']['COUNT'];
				if ( $resSize > 0 )
				{
					for ($j=0; $j<$resSize; $j++)
					{
						$row		= $res['SEARCHRESULT'][0]['ITEM'][$j];

						$ebayTitle	= $row['TITLE'][0];

						$mth = wordsMatchThreshold($prodName, $ebayTitle);
						if ( $mth < API_WORD_MATCH_THRESHOLD )
							continue;

						$detailUrl	= $row['VIEWITEMURL'][0];
						$price		= $row['SELLINGSTATUS'][0]['CURRENTPRICE'][0][0];
						$pageUrl	= SCRIPT_ROOT.'redirect_ebay.php?id='.EBAY_PRODUCT_ID.'&price='.$price.'&url='.base64_encode($detailUrl);

						$arrPrice	= array();

						$arrPrice['API_TYPE']	= 'ebay';
						$arrPrice['COMMENT']	= $ebayTitle;
						$arrPrice['BUY_URL']	= $pageUrl;
						$arrPrice['IMAGE']		= '<img src="'.getReadfileLink('upload/merchant/ebay.jpg').'" height="33" border="0" class="img-responsive center-block" alt="'.TAB_PRODUCT_EBAY.'">';
						$arrPrice['ISAVAILABLE']= formatDateTime($row['LISTINGINFO'][0]['STARTTIME'][0]).' - '.formatDateTime($row['LISTINGINFO'][0]['ENDTIME'][0]);
						$arrPrice['BIDCOUNT']	= number_format($row['SELLINGSTATUS'][0]['BIDCOUNT'][0]);
						$arrPrice['PRICE']		= $price;
						$arrPrice['FORMATTED_PRICE']= $row['SELLINGSTATUS'][0]['CURRENTPRICE'][0]['__ATTRIBUTES']['CURRENCYID'].$price;
						$arrPrice['TOTAL']		= $arrPrice['PRICE'];
						$arrPrice['FORMATTED_TOTAL']= $arrPrice['FORMATTED_PRICE'];

						$noOfRecords++;
						$arrPrices[] = $arrPrice;

						array_unshift($arrPrice, $arrPrice['PRICE'] );
					}

					if ( count($arrPrices) == 0 )
						die('{"ERR":"eBay err-4 [no prices extracted]"}');
				}
				else
					die('{"ERR":"eBay err-3 [empty res]"}');
			}
		}

//*************************************************************************************************

		$productFilename	= $prod['FILENAME'];
		
		$categoryId			= $categoryId == 0 ? 1 : $categoryId;

		$cat				= isset($cat['ID']) ? $cat : getRecord('CATEGORY', $categoryId);
		$tabCategoryId		= $tabCategoryId > 0 ? $tabCategoryId : getRootCategory($cat['PARENT_ID']);

		$categoryTitle		= $cat['TITLE'];
		$categoryFilename	= $cat['FILENAME'];

		$productLink		= getProductPath($productId, $productFilename, $categoryId, $categoryFilename, '', '', $apiType);
		$categoryLink		= getCategoryPath($categoryId, $categoryFilename);

//*************************************************************************************************

		$langFilename2 = 'products.php';

//*************************************************************************************************

		if ( $ajaxCall == 0 && defined('SHOW_MYSQL_PRICES_ON_API_PRODUCTS') && SHOW_MYSQL_PRICES_ON_API_PRODUCTS == 1 )
		{
			require (PATH."products_db_prices_on_api.php");
		}

//*************************************************************************************************
?>