<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

		require ("path.php");
		require (PATH."include/include.php");

//*************************************************************************************************

		include (PATH."session.php");

//*************************************************************************************************				

		$task	= postVar('task');
		$action = postVar('action');
		$return = postVar('return', 'url');
		$isAjax = postVar('isAjax', 'int');

//*************************************************************************************************

		require (PATH."include/security_check.php");

//*************************************************************************************************
//			USER PRODUCT REVIEW
//*************************************************************************************************
if ( $task == "UserReview" )
{
		$productId		= postVar('productId', 'int');
		$rating			= postVar('rating', 'int');
		$review			= postVar('review', '', '', array('maxlen'=>255));
		$visitorName	= postVar('visitorName');
		$visitorCity	= postVar('visitorCity');
		$visitorState	= postVar('visitorState');
		$visitorCountry	= postVar('visitorCountry');
		$captchaAnswer	= postVar('captchaAnswer', '', '', array('maxlen'=>10));
		$captchaDex		= postVar('captchaDex', 'int');

		if ( $action == "Add" )
		{
			if ( DO_WRITE_REVIEW_WITHOUT_LOGIN == 0 && $visitorId == 0 )
				die(strip_tags(getInfo(17)));

            $msg = '';
            if ( !verifyCaptcha($msg) )
				die(strip_tags(getInfo($msg)));

			if ( $productId == ''  || $rating == '' || $review == '' || ( $visitorId == 0 && $visitorName == '' ) ) 
				die(strip_tags(getInfo(1)));

			if ( $visitorId > 0 )
			{
				if ( ($visitorRec = getRecord('VISITORINFO', $visitorId, 'USERID')) )
				{
					$visitorName	= $visitorRec['NAME'];
					$visitorCity	= $visitorRec['CITY'];
					$visitorState	= $visitorRec['STATE'];
					$visitorCountry	= $visitorRec['COUNTRY'];
				}

				$visitorName	= handleSingleQuote($visitorName);
				$visitorCity	= handleSingleQuote($visitorCity);
				$visitorState	= handleSingleQuote($visitorState);
				$visitorCountry	= handleSingleQuote($visitorCountry);
				$review			= handleSingleQuote($review);

				$sql = "SELECT ID FROM ".PREFIX."PRODUCT_RATING WHERE USERID = ? AND PRODUCT_ID = ?";
				$res = preparedQuery($sql, array($visitorId, $productId));

				if ( ($row = getRow($res)) )
				{
					$ret = tableUpdate('PRODUCT_RATING', $row['ID'], array(
																			'USER_NAME'		=> $visitorName,
																			'USER_CITY'		=> $visitorCity,
																			'USER_STATE'	=> $visitorState,
																			'USER_COUNTRY'	=> $visitorCountry,
																			'RATING'		=> $rating,
																			'REVIEW'		=> $review,
																			'ISVALID'		=> 'N'
																		));
					if( $ret > 0 )
						die(strip_tags(getInfo(216)));
					else
						die(strip_tags(getInfo(6)));
				}
				else
				{
					$newId = getNextId('PRODUCT_RATING');
					$ret = tableInsert('PRODUCT_RATING', array(
																'ID'			=> $newId,
																'PRODUCT_ID'	=> $productId,
																'USERID'		=> $visitorId,
																'USER_NAME'		=> $visitorName,
																'USER_CITY'		=> $visitorCity,
																'USER_STATE'	=> $visitorState,
																'USER_COUNTRY'	=> $visitorCountry,
																'RATING'		=> $rating,
																'REVIEW'		=> $review,
																'DATE_ADDED'	=> getTimezoneTime('Y-m-d'),
																'ISVALID'		=> 'N'
															));
					if ( $ret > 0 )
						die(strip_tags(getInfo(216)));
					else
						die(strip_tags(getInfo(6)));
				}
			}
			else
			{
				$visitorName	= handleSingleQuote($visitorName);
				$visitorCity	= handleSingleQuote($visitorCity);
				$visitorState	= handleSingleQuote($visitorState);
				$visitorCountry	= handleSingleQuote($visitorCountry);
				$review			= handleSingleQuote($review);

				$newId = getNextId('PRODUCT_RATING');
				$ret = tableInsert('PRODUCT_RATING', array(
															'ID'			=> $newId,
															'PRODUCT_ID'	=> $productId,
															'USERID'		=> $visitorId,
															'USER_NAME'		=> $visitorName,
															'USER_CITY'		=> $visitorCity,
															'USER_STATE'	=> $visitorState,
															'USER_COUNTRY'	=> $visitorCountry,
															'RATING'		=> $rating,
															'REVIEW'		=> $review,
															'DATE_ADDED'	=> getTimezoneTime('Y-m-d'),
															'ISVALID'		=> 'N'
														));
				if ( $ret > 0 )
					die(strip_tags(getInfo(216)));
				else
					die(strip_tags(getInfo(6)));
			}
		}
		
}

//*************************************************************************************************
//			USER REVIEW
//*************************************************************************************************
elseif ( $task == "UserMerchantReview" )
{
		$userId			= postVar('userId', 'int');
		$orderId		= postVar('orderId', 'int');
		$rating			= postVar('rating', 'int');
		$review			= postVar('review', '', '', array('maxlen'=>255));
		$visitorName	= postVar('visitorName');
		$visitorCity	= postVar('visitorCity');
		$visitorState	= postVar('visitorState');
		$visitorCountry	= postVar('visitorCountry');
		$captchaAnswer	= postVar('captchaAnswer', '', '', array('maxlen'=>10));
		$captchaDex		= postVar('captchaDex', 'int');

		if ( $action == "Add" )
		{
			if ( DO_WRITE_REVIEW_WITHOUT_LOGIN == 0 && $visitorId == 0 )
				die(strip_tags(getInfo(17)));

            $msg = '';
            if ( !verifyCaptcha($msg) )
				die(strip_tags(getInfo($msg)));

			if ( $userId == ''  || $rating == '' || $review == '' || ( $visitorId == 0 && $visitorName == '' ) ) 
				die(strip_tags(getInfo(1)));

			$arrXF = array();
			if ( IS_MERCHANT_EX_RATING_INSTALLED == 1 )
			{
				$resXF	= executeQuery("SELECT FIELD_NAME FROM ".PREFIX."USER_RATING_EX_FIELDS ORDER BY FIELD_NAME");
				while ( ($rowXF = getRow($resXF)) )
					$arrXF[$rowXF['FIELD_NAME']] = postVar($rowXF['FIELD_NAME'], 'int');
			}

			if ( $visitorId > 0 )
			{
				if ( $visitorRec = getRecord('VISITORINFO', $visitorId, 'USERID') )
				{
					$visitorName	= $visitorRec['NAME'];
					$visitorCity	= $visitorRec['CITY'];
					$visitorState	= $visitorRec['STATE'];
					$visitorCountry	= $visitorRec['COUNTRY'];
				}

				$visitorName	= handleSingleQuote($visitorName);
				$visitorCity	= handleSingleQuote($visitorCity);
				$visitorState	= handleSingleQuote($visitorState);
				$visitorCountry	= handleSingleQuote($visitorCountry);
				$review			= handleSingleQuote($review);

				if ( $orderId > 0 )
				{
					if ( !($orderRec = getRecord('ORDER', $orderId)) )
						die(strip_tags(getInfo(5)));

					if ( $orderRec['USERID'] != $visitorId )
						die(strip_tags(getInfo(30)));
				}

				if ( $orderId == 0 )
					$res = preparedQuery("SELECT ID FROM ".PREFIX."USER_RATING WHERE USERID = ? AND MERCHANTID = ?", array($visitorId, $userId));
				else
					$res = preparedQuery("SELECT ID FROM ".PREFIX."USER_RATING WHERE USERID = ? AND MERCHANTID = ? AND ORDER_ID = ?", array($visitorId, $userId, $orderId));
				
				if ( ($row = getRow($res)) )
				{
					$ret = tableUpdate('USER_RATING', $row['ID'], array_merge($arrXF, array(
																		'USER_NAME'		=> $visitorName,
																		'USER_CITY'		=> $visitorCity,
																		'USER_STATE'	=> $visitorState,
																		'USER_COUNTRY'	=> $visitorCountry,
																		'RATING'		=> $rating,
																		'REVIEW'		=> $review,
																		'ISVALID'		=> 'N'
																	)));
					if( $ret > 0 )
						die(strip_tags(getInfo(217)));
					else
						die(strip_tags(getInfo(6)));
				}
				else
				{
					$newId = getNextId('USER_RATING');
					$ret = tableInsert('USER_RATING', array_merge($arrXF, array(
															'ID'			=> $newId,
															'MERCHANTID'	=> $userId,
															'USERID'		=> $visitorId,
															'ORDER_ID'		=> $orderId,
															'USER_NAME'		=> $visitorName,
															'USER_CITY'		=> $visitorCity,
															'USER_STATE'	=> $visitorState,
															'USER_COUNTRY'	=> $visitorCountry,
															'RATING'		=> $rating,
															'REVIEW'		=> $review,
															'DATE_ADDED'	=> getTimezoneTime('Y-m-d'),
															'ISVALID'		=> 'N'
														)));
					if ( $ret > 0 )
						die(strip_tags(getInfo(217)));
					else
						die(strip_tags(getInfo(6)));
				}
			}
			else
			{
				$visitorName	= handleSingleQuote($visitorName);
				$visitorCity	= handleSingleQuote($visitorCity);
				$visitorState	= handleSingleQuote($visitorState);
				$visitorCountry	= handleSingleQuote($visitorCountry);
				$review			= handleSingleQuote($review);

				$newId = getNextId('USER_RATING');
				$ret = tableInsert('USER_RATING', array_merge($arrXF, array(
														'ID'			=> $newId,
														'MERCHANTID'	=> $userId,
														'USERID'		=> $visitorId,
														'USER_NAME'		=> $visitorName,
														'USER_CITY'		=> $visitorCity,
														'USER_STATE'	=> $visitorState,
														'USER_COUNTRY'	=> $visitorCountry,
														'RATING'		=> $rating,
														'REVIEW'		=> $review,
														'DATE_ADDED'	=> getTimezoneTime('Y-m-d'),
														'ISVALID'		=> 'N'
													)));
				if ( $ret > 0 )
					die(strip_tags(getInfo(217)));
				else
					die(strip_tags(getInfo(6)));
			}
		}
		
}

//*************************************************************************************************
//			NOTHING
//*************************************************************************************************
else	
	header("Location: ".getSeoUrl('/')."?p=index&t=".$task."&a=".$action);

//*************************************************************************************************

exit(); // To make sure session is working //
?>