<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************
//die;
		require ("path.php");
		require (PATH."include/include.php");

//*************************************************************************************************

		include (PATH."session.php");

//*************************************************************************************************

		define('ALLOWED_TO_READ_IN', 'upload/');

//*************************************************************************************************
		
		$f = getVar('f', 'urlpart');

		// If filename was not provided in query string
		if ( $f == '' )
		{
			// Check if we got here from "501 - Method not implemented" error
			if ( $_SERVER['REDIRECT_STATUS'] == 501 )
			{
				// If it was not for rf.php, then show that error and exit
				if ( $_SERVER['REDIRECT_URL'] != '/rf.php' )
				{
					header('HTTP/1.1 501');
					echo "<h1>Method not implemented</h1>".$_SERVER['REQUEST_METHOD']." to ".$_SERVER['REDIRECT_URL']." not supported!";
					die;
				}

				// Get the filename from any appropriate source
				if ( $_SERVER['REDIRECT_QUERY_STRING'] != '' && substr($_SERVER['REDIRECT_QUERY_STRING'], 0, 2) == 'f=' )
					$f = urldecode(substr($_SERVER['REDIRECT_QUERY_STRING'], 2));
				elseif ( $_SERVER['REQUEST_URI'] != '' && strstr($_SERVER['REQUEST_URI'], '/rf.php?f=') )
					$f = urldecode(str_replace('/rf.php?f=', '', $_SERVER['REQUEST_URI']));
			}
		}

		// Check for empty filename
		if ( $f == '' )
		{
			header('HTTP/1.1 403');
			echo "<font face='verdana' color='red'>".INFO_159."</font>";
			die;
		}

		// Trying to use relative path
		if ( stristr($f, '..') )
		{
			header('HTTP/1.1 403');
			echo "<font face='verdana' color='red'>".INFO_30." [..]</font>";
			die;
		}

		// Check for the file existance
		if ( !file_exists(PATH_SUBD.$f) )
		{
			header('HTTP/1.1 404');
			echo "<font face='verdana' color='red'>".FILE_DONOT_EXIST."</font>";
			die;
		}

		// Last Check. It should only be reading the 'upload/' folder
		if ( substr($f, 0, strlen(ALLOWED_TO_READ_IN)) != ALLOWED_TO_READ_IN )
		{
			header('HTTP/1.1 404');
			echo "<font face='verdana' color='red'>".NOT_ALLOWED_IN_THIS_FOLDER."</font>";
			die;
		}

		// Check for file parts
		$fileParts = pathinfo($f);
//		print_r($fileParts); die;

		if ( !is_array($fileParts) )
		{
			header('HTTP/1.1 403');
			echo "<font face='verdana' color='red'>".INCORRECT_FILE."</font>";
			die;
		}

		$filename = PATH_SUBD.$f;
		$fileParts['extension'] = strtolower($fileParts['extension']);
		
		// Check for file extension
		if ( $fileParts['extension'] == 'jpg' || $fileParts['extension'] == 'jpeg' || $fileParts['extension'] == 'gif' || $fileParts['extension'] == 'png' )
		{
			$imgInfo		= @getimagesize($filename);
			$lastModified	= gmdate('D, d M Y H:i:s', filemtime($filename)).' GMT';

			// did the browser send an if-modified-since request?
			if (isset($_SERVER['HTTP_IF_MODIFIED_SINCE'])) 
			{
				// parse header
				$ifModifiedSince = kregexpReplace(';.*$', '', '', $_SERVER['HTTP_IF_MODIFIED_SINCE']);

				if ( $ifModifiedSince == $lastModified ) 
				{
					// the browser's cache is still up to date
					header("HTTP/1.0 304 Not Modified");
					header("Cache-Control: max-age=86400, must-revalidate");
					exit;
				}
			}

			// send other headers
			header('Content-Type: '.($imgInfo[2]==1?'image/gif':($imgInfo[2]==2?'image/jpeg':'image/png')) );
			header('Cache-Control: max-age=86400, must-revalidate');
			header('Content-Length: '.filesize($filename));
			header('Last-Modified: '.$lastModified);
			@readfile($filename);
			die;
		}
		elseif ( $fileParts['extension'] == 'html' || $fileParts['extension'] == 'htm' || $fileParts['extension'] == 'csv' || $fileParts['extension'] == 'txt' || $fileParts['extension'] == 'xml' || $fileParts['extension'] == 'log' )
		{
			header('HTTP/1.1 200 OK');	// This line gives error on some servers so can be commented.

			header('Status: 200 OK');
			header('Content-type: '.getContentTypeFromDocType($fileParts['extension']));
			header('Content-Disposition: inline; filename="'.basename($filename).'"');
			header('Last-Modified: '.date('r', filemtime($filename)) );
			header('Content-Length: '.filesize($filename));
			header('Cache-control: private');
			
			// Open pointer
			if ( !($fp = fopen($filename, "r")) )
				die ("Could not open file for Reading, Filepath : ".$filename);
			
			// Read From File			
			$data = "";
			while ( !feof($fp) ) 
			{
				$data = fgets($fp, 51200);
				echo $data;
				flush();
			}
			fclose($fp);
			die;
		}
		elseif ( $fileParts['extension'] == 'swf' )
		{
			header('Content-Type: application/x-shockwave-flash');
			header('Cache-Control: max-age=86400, must-revalidate');
			header('Content-Length: '.filesize($filename));
			header('Last-Modified: '.$lastModified);
			@readfile($filename);
			die;
		}
		elseif ( $fileParts['extension'] == 'gz' )
		{
			header('Content-Type: application/x-gzip');
			header('Content-Disposition: inline; filename="'.basename($filename).'"');
			header('Cache-Control: max-age=86400, must-revalidate');
			header('Content-Length: '.filesize($filename));
			header('Last-Modified: '.$lastModified);
			@readfile($filename);
			die;
		}
		elseif ( $fileParts['extension'] == 'zip' )
        {
            header('Content-Type: application/x-compressed');
            header('Content-Disposition: inline; filename="'.basename($filename).'"');
            header('Cache-Control: max-age=86400, must-revalidate');
            header('Content-Length: '.filesize($filename));
            header('Last-Modified: '.$lastModified);
            @readfile($filename);
            die;
        }
		else
		{
			header('HTTP/1.1 403');
			echo "<font face='verdana' color='red'>".THIS_FILETYPE_IS_NOT_SUPPORTED."</font>";
			die;
		}

//*************************************************************************************************

	function getContentTypeFromDocType($ext)
	{
		$docType = $ext;

		if ( $docType == 'doc' )
			return 'application/doc';
		
		elseif ( $docType == 'pdf' )
			return 'application/pdf';
		
		elseif ( $docType == 'html' || $docType == 'htm' || $docType == 'php' )
			return 'text/html';
		
		elseif ( $docType == 'xml' )
			return 'text/xml';
		
		elseif ( $docType == 'lic' )
			return 'text';
		
		elseif ( $docType == 'txt' || $docType == 'csv' || $docType == 'log' )
			return 'text';
		
		elseif ( $docType == 'zip' )
			return 'application/zip';

		else
			return 'image/jpeg';
	}

//*************************************************************************************************
?>