<?php
//*************************************************************************************************
		
		require ("path.php");
		require (PATH."include/include.php");
		require (PATH."include/rss.genesis.php");
		require (PATH.ADMIN_FOLDER_NAME."/product_import_xml_functions.php");

//*************************************************************************************************

		include (PATH."session.php");

//*************************************************************************************************

		$productId		= getVar('productId', 'int');

//*************************************************************************************************

		if ( $productId <= 0 )
		{
			header("Location: ".getSeoUrl('/')."?info=105");
			die;
		}

//*************************************************************************************************

		if ( !($prod = getRecord('PRODUCT', $productId)) )
		{
			header("Location: ".getSeoUrl('/')."?info=5");
			die;
		}

		$prod['DETAIL']	= getColumn('PRODUCT_DETAIL', $productId, 'DETAIL', 'PRODUCT_ID');

//*************************************************************************************************

		// Make data XML safe
		$prod['TITLE']	= translateXml($prod['TITLE']);
		$prod['DETAIL'] = translateXml($prod['DETAIL']);

//*************************************************************************************************

		$categoryId		= (int)$prod['CATEGORY_ID'];

		if ( !($cat = getRecord('CATEGORY', $categoryId)) )
		{
			header("Location: index.php?info=211");
			die;
		}

//*************************************************************************************************

		$pLink	= getProductPath($productId, $prod['FILENAME'], $categoryId, $cat['FILENAME']);

//*************************************************************************************************

		$sql	= "SELECT ID, USERID, PRICE, COMMENT FROM ".PREFIX."USER_PRODUCT WHERE PRODUCT_ID = ? AND ISVALID = 'Y' ORDER BY PRICE DESC";
		$res	= preparedQuery($sql, array($productId));

//*************************************************************************************************

		// STARTS
		$rss = new rssGenesis();

		// CHANNEL
		$rss->setChannel (
							SCRIPT_COMPANY_NAME.' - '.PRICES.' '._FOR.' '.$prod['TITLE'], // Title
							$pLink,					// Link
							$prod['DETAIL'],		// Description
							null,					// Language
							null,					// Copyright
							null,					// Managing Editor
							null,					// WebMaster
							$prod['PRODUCT_RATING'],// Rating
							"auto",					// PubDate
							"auto",					// Last Build Date
							null,					// Docs
							null,					// Skip Days
							null					// Skip Hours
						);
									
		// IMAGE
		$rss->setImage (
							$prod['TITLE'],			// Title
							getProductThumbnail($productId, $pLink, $prod['TITLE'], $categoryId, 120, 120, '', '', '', '', $prod['FILENAME']), // Source
							$pLink,					// Link
							"auto",					// Width
							"auto",					// Height
							$prod['DETAIL']			// Description
						);

		while ( ($row = getRow($res)) )
		{
			// ITEM
            $rss->addItem(
                getFormattedPrice($row['PRICE'], SCRIPT_DOLLAR, 1) . ' at ' . getColumn('USERINFO', $row['USERID'], 'NAME', 'USERID'), // Title
                getSeoUrl('redirect', 'prod_id=' . $row['ID'] . '&amp;isBuy=Y'), // Link
                $row['COMMENT'] // Description
            );

        }

		// FINISH
		$rss->outputRSS ();

//*************************************************************************************************
