<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

require("path.php");
require(PATH . "include/include.php");

//*************************************************************************************************

include(PATH . "session.php");

//*************************************************************************************************

$imgDivWidth = 50;
$otherDivWidth = (defined('AJAX_SEARCH_AUTOCOMPLETE_WIDTH') ? AJAX_SEARCH_AUTOCOMPLETE_WIDTH : 400) - $imgDivWidth - 35;

//*************************************************************************************************

$query = getVar('q');
if ($query == '')
    die;

$max = 10;
$tot = 0;
$arr = array();

//*************************************************************************************************

if (defined('IS_SPHINX_SEARCH_INSTALLED') && IS_SPHINX_SEARCH_INSTALLED == 1) {
    $sphinxQuery = str_replace("-", "\\-", $query);
    $sphinxQuery = str_replace("/", " ", $sphinxQuery);

    // Search by partial words if setup in constants
    //	must enable use of min_infix_len setting in sphinx.conf if want to use partial word search
    if (IS_SEARCH_BY_WORD == 0)
        $sphinxQuery = '*' . str_replace(' ', '* *', $sphinxQuery) . '*';

    $arrSphinxPIDs = callSphinxSearch($sphinxQuery, SPHINX_PREFIX . 'IDX_pcs_search_title', $max);

    if (count($arrSphinxPIDs) > 0) {
        $res = executeQuery("SELECT ID, FILENAME, CATEGORY_ID, TITLE, MIN_PRICE, STORE_COUNT FROM " . PREFIX . "PRODUCT WHERE ISVALID = 'Y' AND ID IN (" . implode(',', $arrSphinxPIDs) . ") LIMIT " . $max);
        while (($row = getRow($res)))
            $arr[] = $row;
    }
} else {
    $res = executeQuery("SELECT ID, FILENAME, CATEGORY_ID, TITLE, MIN_PRICE, STORE_COUNT FROM " . PREFIX . "PRODUCT WHERE ISVALID = 'Y' AND (TITLE LIKE '%" . handleSingleQuote($query) . "%' OR MANUFACTURER_CODE LIKE '%" . handleSingleQuote($query) . "%') LIMIT " . $max);
    while (($row = getRow($res)))
        $arr[] = $row;

    if (count($arr) > 0) {
        $res = executeQuery("SELECT COUNT(*) AS T FROM " . PREFIX . "PRODUCT WHERE ISVALID = 'Y' AND (TITLE LIKE '%" . handleSingleQuote($query) . "%' OR MANUFACTURER_CODE LIKE '%" . handleSingleQuote($query) . "%')");
        $row = getRow($res);
        $tot = (int)$row['T'];
    }
}

//*************************************************************************************************

if (count($arr) < $max) {
    $res = executeQuery("SELECT P.ID, P.FILENAME, P.CATEGORY_ID, P.TITLE, P.MIN_PRICE, P.STORE_COUNT FROM " . PREFIX . "PRODUCT P, " . PREFIX . "CATEGORY C WHERE C.ISVALID = 'Y' AND C.TITLE LIKE '%" . handleSingleQuote($query) . "%' AND P.CATEGORY_ID=C.ID AND P.ISVALID='Y' LIMIT " . $max);
    while (($row = getRow($res)))
        $arr[] = $row;
}

//*************************************************************************************************

if (count($arr) < $max) {
    $res = executeQuery("SELECT P.ID, P.FILENAME, P.CATEGORY_ID, P.TITLE, P.MIN_PRICE, P.STORE_COUNT FROM " . PREFIX . "PRODUCT P, " . PREFIX . "USER_PRODUCT UP WHERE UP.ISVALID = 'Y' AND UP.USERID LIKE '%" . handleSingleQuote($query) . "%' AND P.ID=UP.PRODUCT_ID AND P.ISVALID='Y' LIMIT " . $max);
    while (($row = getRow($res)))
        $arr[] = $row;
}

//*************************************************************************************************

if (count($arr) < 1)
    die;

//*************************************************************************************************

// Render template
renderTemplate('search-suggestions-' . AJAX_SEARCH_AUTOCOMPLETE_THEME, [
    'arr' => $arr,
    'tot' => $tot,
    'query' => $query,
]);

//*************************************************************************************************

function callSphinxSearch($sphinxQuery, $sphinxIndex, $max = 10)
{
    global $tot;

    // Generate store count sql
    $storeCountSql = '';
    if (defined('DO_HIDE_PRODUCT_WITH_0_STORES') && DO_HIDE_PRODUCT_WITH_0_STORES == 1)
        $storeCountSql = "AND STORE_COUNT>0";

    // Now create the sphinxQL sql
    $sphinxSql =
        // Main query
        "SELECT ID FROM " . $sphinxIndex
        . " WHERE MATCH('" . handleSingleQuote($sphinxQuery) . "') " . $storeCountSql
        . " LIMIT 0," . $max

        // Query for meta (totals etc)
        . ";SHOW META";

    // Call sphinxQL with the sql
    $msg = '';
    $ret = sphinxQLQuery($msg, $sphinxSql);

    // Quit if search failed. It must be an array with 2 sub-arrays (matches, totals)
    if ($ret == null || !is_array($ret) || count($ret) != 2)
        return array();

    $matches = $ret[0];
    $totals = $ret[1];

    $ret = '';

    $tot = (int)$totals[1]['Value'];
    $arrSphinxPIDs = array();

    if (is_array($matches)) {
        foreach ($matches as $temp) {
            if (isset($temp['id']))
                $arrSphinxPIDs[] = (int)$temp['id'];
        }
    }
    $arrSphinxPIDs = array_unique($arrSphinxPIDs);

    return $arrSphinxPIDs;
}

//*************************************************************************************************

function sphinxQLQuery(&$msg, $qry)
{
    // must use IP instead of localhost or wont work
    // 9306 is the sphinxql port
    $mysqli = new mysqli('127.0.0.1', '', '', '', 9306);

    // initialize array for output
    $ret = array();

    // run query
    if ($mysqli->multi_query($qry)) {
        // get all results sets returned by the query
        $dex = 0;
        do {
            if (($result = $mysqli->store_result())) {
                $ret[$dex] = array();

                while (($row = $result->fetch_assoc()))
                    $ret[$dex][] = $row;

                $result->free();

                $dex++;
            }
        } while ($mysqli->more_results() && $mysqli->next_result());
    } else {
        $msg = $mysqli->error;
        return null;
    }

    return $ret;
}

//*************************************************************************************************
