<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

		// LOG SQL and Build Time stamp
		if ( !isset($pageStart) || $pageStart == 0 )
		{
			//define('DO_TIME_EACH_QUERY',	1);
			$pageStart = microtime(); 
			$pageStart = explode(" ", $pageStart); 
			$pageStart = $pageStart[1] + $pageStart[0]; 
		}

//*************************************************************************************************

        // Declare global variables so that they can be accessed every where
        global $manufacturer, $merchant;

//*************************************************************************************************

		// If search flag is already set, then use its value, other wise set it to true because we are in the search file
		$isSearch		= isset($isSearch) ? $isSearch : true;

//*************************************************************************************************

		// Include path if not defined already
		if (!defined('PATH')) {
			require("path.php");
		}

		// Load includes if not loaded already
		if (!defined('INCLUDES_LOADED')) {
			require(PATH . "include/include.php");
		}

//*************************************************************************************************

		// Set the cache sub-key for header / footer
		$cacheHFSubKey = !isset($cacheHFSubKey) || $cacheHFSubKey == '' ? 'search' : $cacheHFSubKey;

//*************************************************************************************************

		// Out Buffer Open
		ob_start();

//*************************************************************************************************

		if ( $isSearch )
			include (PATH."session.php");

		// 8-8-2012: Salman: Print Debug info if SQL is being logged
		if ( DO_TIME_EACH_QUERY == 1 )
			echo "\n<!-- \n- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n\n search page starts \n\n -->\n";

//*************************************************************************************************

		// Make sure that the sort order are valid, to avoid sql error
		limitGetVar('so', array('ASC', 'DESC'));
		// Sort key (sk) will already be taken care of in listing function in case of mysql, we cannot
		//	restrict here, otherwise the api sortings will fail

//*************************************************************************************************
// Product source mixing setup

		// Initialize vars
		$isAjaxProdSrc		= false;

		// Load sorted list of enabled product sources
		$sortedCheckedSrcs	= getSortedCheckedApis($prefPrdSrc);

		// See if this is an ajax call for mixing next product source
		$nextAjaxProdSrc	= getVar('ajaxNPS');
		if ( $nextAjaxProdSrc != '' && $nextAjaxProdSrc != $prefPrdSrc['BASE_PRODUCT_SOURCE'] )
			$isAjaxProdSrc	= true;

		// If next ajax call is made but not supported then quit
		if ( $isAjaxProdSrc && !in_array($nextAjaxProdSrc, array_keys($sortedCheckedSrcs)) )
			die(UNSUPPORTED_PRODUCT_SOURCE.' ['.$nextAjaxProdSrc.']');

		// Set the loading product source
		$loadFromProdSrc	= $isAjaxProdSrc ? $nextAjaxProdSrc : $prefPrdSrc['BASE_PRODUCT_SOURCE'];

//*************************************************************************************************

		// Check search restriction by ip address
		if ( !$isAjaxProdSrc && $isSearch && defined('APPLY_IP_SEARCH_RESTRICTION') && APPLY_IP_SEARCH_RESTRICTION == 1 )
		{
			if ( !isset($_SESSION['bypassSearchOnce']) )
			{
				$doRestrict		= false;
				$IP_ADDRESS_INT	= getCurrentIntIP();

				$resIpSecurity  = preparedQuery("SELECT IP_ADDRESS FROM ".PREFIX."SEARCH_CAPTCHA_LOCKED_IPS WHERE IP_ADDRESS = ?", array($IP_ADDRESS_INT));
				if ( ($rowIpSecurity = getRow($resIpSecurity)) )
				{
					$doRestrict	= true;
				}
				else
				{
					$resIpSecurity  = preparedQuery("SELECT SUM(SEARCH_COUNT) AS TOTAL FROM ".PREFIX."SEARCH USE INDEX (IndexCOMPS1) WHERE IP_ADDRESS = ? AND LAST_SEARCH_ON > ?", array($IP_ADDRESS_INT, time()-IP_SEARCH_CHECK_LAST_X_SECS));
					if ( ($rowIpSecurity = getRow($resIpSecurity)) )
					{
						if ( $rowIpSecurity['TOTAL'] > IP_SEARCH_CHECK_MAX_LIMIT )
						{
							$doRestrict	= true;
							if ( defined('IP_SEARCH_CHECK_SHOW_CAPTCHA') && IP_SEARCH_CHECK_SHOW_CAPTCHA == 1 )
								tableInsert('SEARCH_CAPTCHA_LOCKED_IPS', array('IP_ADDRESS'=>$IP_ADDRESS_INT));
						}
					}
				}

				if ( $doRestrict )
				{
					$pageTitle		= SEARCH_RESTRICT_PAGE_TITLE;
					ob_start();
					echo '<div class="text-center">';
					echo '<h1>'.$pageTitle.'</h1>';
                    echo '<div class="alert alert-danger">' . SEARCH_RESTRICT_PAGE_WRITEUP . '</div>';
					if ( defined('IP_SEARCH_CHECK_SHOW_CAPTCHA') && IP_SEARCH_CHECK_SHOW_CAPTCHA == 1 )
					{
?>
			<h2><?php echo SEARCH_RESTRICT_CAPTCHA_HEADING; ?></h2>
			<?php echo $info; ?>
			<form method="post" action="<?= SCRIPT_ROOT ?>search_captcha_verify.php">
				<input type="hidden" name="url" value="<?= $_SERVER['REQUEST_URI'] ?>">
				<div style="width:300px;margin:20px auto"><?php showCaptcha() ?></div>
				<input type="submit" name="btn" value="<?= SUBMIT ?>" class="btn btn-success">
			</form>
<?php
					}
                    echo '</div>';
                    $contentHtml = ob_get_contents();
                    ob_end_clean();

                    renderTemplate('basic', ['contentHtml' => $contentHtml]);

					// Close mysql immediately
					forceCloseMysql();
					die;
				}
			}
			else
				unset($_SESSION['bypassSearchOnce']);
		}

//*************************************************************************************************

		if ( !$isSearch && $categoryId > 0 && $childList == '0' )
			$info = str_replace('{CONTACT_URL}', getSeoUrl('contactus', 'sub=MSG_ERROR_ON_CAT_URL_1&url='.urlencode(str_replace('&amp;', '&', $categoryLink))), getInfo(327)).'<br>';

//*************************************************************************************************

		if ( !$isSearch )
			loadLanguageForPage($lang, 'final_category');

//*************************************************************************************************

		// Needed in filters-ajax.tpl.php to get total brand filters count
		$searchId			= $isSearch ? getNextSearchId() : 0;

//*************************************************************************************************

		// Handle the merge of filters only in mysql filters
		if ( $apiType == API_TYPE_MYSQL && isset($_GET['fId']) && is_array($_GET['fId']) )
		{
			$_GET['oldfId'] = $_GET['fId'];
			$_GET['fId'] = getMergedFilterIds($_GET['fId']);
		}

//*************************************************************************************************

		// Handle the merchant's products public page case
		$merFN				= getVar('merFN', '', '', array('maxlen'=>50));
		$merPPPage			= getVar('mpp', 'int') == 1; // true / false
		$merchantName		= '';
		if ( $merFN != '' )
		{
			if ( ($tUIRow = getRecord('USERINFO', $merFN, 'FILENAME')) )
			{
				$merPPPage = true;
				$merchantName = $tUIRow['NAME'];
				$_GET['mer'] = array(0=>(int)$tUIRow['USERID']);
			}
		}

		// If its merchant's public products page
		if ( $merPPPage )
		{
			// Then show only from database (no apis)
			$loadFromProdSrc = API_TYPE_MYSQL;

			// If merchant name is not picked, then pick
			if ( $merchantName == '' && is_array($_GET['mer']) && isset($_GET['mer'][0]) && $_GET['mer'][0] != '' )
				$merchantName = getColumn('USERINFO', handleSingleQuote($_GET['mer'][0]), 'NAME', 'USERID');

			// If bad merchant name then show "unknown"
			$merchantName = $merchantName == '0' || $merchantName == '' ? UNKNOWN : $merchantName;
		}

		list($searchProductIn, $searchText) = getSearchParameters();

		$searchWithin		= getVar('searchWithin');

		$searchText			= trim($searchWithin.' '.$searchText);
		$searchText			= str_replace("\\'", "'", $searchText);

		$searchType			= getVar('searchType');
		$manuText			= brandUrlDecode(getVar('manuText'));
		$manufacturer		= getVar('manufacturer');
		$advanceSearch		= getVar('advanceSearch');
		$title				= getVar('title');
		$priceRange			= getVar('priceRange');
		$catId				= getVar('catId', 'int');

		// Initialize category parameters if they were not initialized already
		$categoryId			= isset($categoryId) ? $categoryId : $catId;
		$categoryRec		= isset($categoryRec) ? $categoryRec : array();
		$categoryTitle		= isset($categoryTitle) ? $categoryTitle : '';
		$categoryFilename	= isset($categoryFilename) ? $categoryFilename : '';
		$childList			= isset($childList) ? $childList : '';

		// 8/24/2012: Mamda: General fix for all types of searches (Sphinx + APIs)
		// 9/4/2013: Mamda: Removed below check as we now handle search by brand in sphinx as well
		//					|| IS_SPHINX_SEARCH_INSTALLED == 1 
		if ( $prefPrdSrc['BASE_PRODUCT_SOURCE'] != API_TYPE_MYSQL )
		{
			if ( $isSearch && $searchText == '' && $manuText != '' )
				$searchText		= $manuText;
		}

		$minPriceBound		= getVar('minPriceBound', 'int');
		$maxPriceBound		= getVar('maxPriceBound', 'int');
		$priceBoundSql		= '';

//*************************************************************************************************

		if ( $isSearch )
		{
			$pageHeading	= SEARCH.': '.($searchText==''&&$manuText!=''?$manuText:$searchText);
			$pageBreadcrumb	= ' &gt; '.SEARCH.': '.($searchText==''&&$manuText!=''?$manuText:$searchText).' &gt; <a href="javascript:doSearchWithin();">'.SEARCH_WITHIN_RESULTS.'</a>';

			if ( $advanceSearch != '' )
				$searchText = $title;

			$_SESSION['visitorLastSearches']	= uniquePush(sessionVar('visitorLastSearches'), $searchText);
			$visitorLastSearches				= $_SESSION['visitorLastSearches'];

			include(PATH."search_products_replace.php");
		}

//*************************************************************************************************

		$doHideLeftPanel			= IS_PRODUCTFILTERS_INSTALLED == 1 ? 1 : 0;
		$doHideFilters				= 0;	// In case of some apis that do not support filters, this will hide them and show banners instead

//*************************************************************************************************

		$searchTextEx 	= stripslashes($searchText);
		$searchText		= handleSingleQuote($searchText);

//*************************************************************************************************
//*************************************************************************************************

		// The main products listing engine
		// On successfull call sets these variables
		//		$sortOptsArr			= holds sorting options to show
		//		$listingArr				= holds product records
		//		$noOfRecords			= # of records returned
		//		$listingTotal			= # of total records
		//		$filterArrCats			= category filters
		//		$filterArrBrands		= manufacturer filters
		//		$filterArrStores		= merchant filters
		//		$filterArr				= other filters
		//   On failure prints error page and dies here
		//require (PATH."products_listing_engine.php");
		require (PATH."products_listing_functions.php");

//*************************************************************************************************

// 10/3/2012: We are now setting this from admin preferences
//		$pageSize		= 20;
		$sql			= '';
		$sqlTotal		= '';

		$manufacturer	= array();
		$merchant		= array();
		$fId			= array();
		$srhcats		= array();

		$tmpSearchTable	= '';

//*************************************************************************************************

		// Build GET variables
		$minPrice		= getVar('minPrice', 'float');
		$maxPrice		= getVar('maxPrice', 'float');
		$manufacturer	= getVar('manu', '', array(), array('array'=>1));
		$merchant		= getVar('mer', '', array(), array('array'=>1));
		$srhcats		= getVar('scat', 'int', array(), array('array'=>1));

		$temp			= getVar('fId', 'a-zA-Z0-9:@_,\-\. ', array(), array('array'=>1));
		$fId			= array();
		if ( is_array($temp) )
		{
			foreach ( $temp as $t )
				$fId = array_merge($fId, $apiType == API_TYPE_MYSQL ? explode('_', $t) : array($t));
		}

		///////////////////////////////////////////////////////////////////////////////////////
		// Build ARRAY of GET variables
		for ($a=0; $a<count($fId); $a++)
			$fId[$a] = doCleanInput($fId[$a]);

		for ($a=0; $a<count($manufacturer); $a++)
			$manufacturer[$a] = doCleanInput(doStripString($manufacturer[$a]));

		for ($a=0; $a<count($merchant); $a++)
			$merchant[$a] = doCleanInput(doStripString($merchant[$a]));

		for ($a=0; $a<count($srhcats); $a++)
			$srhcats[$a] = doCleanInput(doStripString($srhcats[$a]));


//*************************************************************************************************

		// 8-8-2012: Salman: Print Debug info if SQL is being logged
		if ( DO_TIME_EACH_QUERY == 1 )
			echo "\n<!-- \n- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n\n pcsProductsListing() starts \n\n -->\n";

		// This function below will load search results from any suitable engine (mysql, sphinx, apis (if configured)... )
		$msg = '';
		$ret = pcsProductsListing($msg, $isSearch, $categoryId, $searchText, $searchType, $searchProductIn, $advanceSearch, $manuText, $manufacturer, $merchant, $fId, $srhcats, $minPrice, $maxPrice, $childList, $categoryTitle, $categoryRec);

		// 8-8-2012: Salman: Print Debug info if SQL is being logged
		if ( DO_TIME_EACH_QUERY == 1 )
			echo "\n<!-- \n- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n\n pcsProductsListing() ends \n\n -->\n";

//*************************************************************************************************

		// Returned value is not an array : ERROR
		if ( !is_array($ret) )
		{
			$errMsg = is_array($msg) ? $msg['ERROR'] : $msg;
			if ( !$isAjaxProdSrc )
			{
				$ret = array(
							'SORT_OPTIONS'	=> array(),
							'RESULTS'		=> array(),
							'RETURNED'		=> 0,
							'TOTAL'			=> 0,
							'FILTER_CATS'	=> array(),
							'FILTER_BRANDS'	=> array(),
							'FILTER_STORES'	=> array(),
							'FILTER_OTHERS'	=> array()
						);

				if ( isset($_GET['debug']) )
					echo "\n\n<!-- ".$errMsg." -->\n\n";
			}
			else
			{
				echo "\n\n<!-- ".$errMsg." -->\n\n";
				die;
			}
		}

//*************************************************************************************************

		// Assign Array returned's elements to variables
		$sortOptsArr			= $ret['SORT_OPTIONS'];
		$listingArr				= $ret['RESULTS'];
		$noOfRecords			= $ret['RETURNED'];
		$listingTotal			= $ret['TOTAL'];
		$filterArrCats			= $ret['FILTER_CATS'];
		$filterArrBrands		= $ret['FILTER_BRANDS'];
		$filterArrStores		= $merPPPage ? array() : $ret['FILTER_STORES'];
		$filterArr				= $ret['FILTER_OTHERS'];
		$apiLinkBack			= isset($ret['LINK_BACK']) ? $ret['LINK_BACK'] : '';

		// Reset array to save memory
		$ret					= array();				

//*************************************************************************************************

		if ( $minPriceBound == 0 && $maxPriceBound == 0 && $priceBoundSql != '' )
		{
			$resPB = executeQuery($priceBoundSql);
			if ( ($rowPB = getRow($resPB)) )
			{
				if ( isset($rowPB['MINP']) )	$minPriceBound	= (float)$rowPB['MINP'];
				if ( isset($rowPB['MAXP']) )	$maxPriceBound	= (float)$rowPB['MAXP'];
			}
		}

//*************************************************************************************************

		$searchText				= $searchTextEx;

//*************************************************************************************************

		// Build the ARRAY of Related Categories to be displayed on top of listing
		if ( !$isAjaxProdSrc )
		{
			// 8-8-2012: Salman: Print Debug info if SQL is being logged
			if ( DO_TIME_EACH_QUERY == 1 )
				echo "\n<!-- \n- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n\n Build related category listing starts [".date('Y-m-d H:i:s')."] \n\n -->\n";
			
			$cacheRelatedCatFilename	= 'cache/html/related-cat-'.(isset($categoryRec['PARENT_ID'])?$categoryRec['PARENT_ID']:'na').'.html';
			if ( !($_GET['reCache'] == '' && file_exists(PATH.$cacheRelatedCatFilename) && filemtime(PATH.$cacheRelatedCatFilename)+(CACHE_LIFE_IN_HRS*60*60) > time()) )
			{
				if ( DO_TIME_EACH_QUERY == 1 )
					echo "\n\n				<!-- Related categories sqls executed [".date('Y-m-d H:i:s')."] -->\n\n";

				$relatedCats	= array();
				if ( !$isSearch && SHOW_RELATED_CATEGORIES_ON_LISTING )
				{
					// 8-8-2012: Salman: Print Debug info if SQL is being logged
					if ( DO_TIME_EACH_QUERY == 1 )
						echo "\n<!-- getLastLevelChildList() starts in related categories -->\n";
					$childCatsArr = SHOW_PRODUCTS_ON_MID_LEVEL_CATEGORIES == 1 ? getChildCategoryList($categoryRec['PARENT_ID']) : getLastLevelChildList($categoryRec['PARENT_ID']);
					$childCats = implode(',', $childCatsArr);
					if ( DO_TIME_EACH_QUERY == 1 )
						echo "\n<!-- getLastLevelChildList() ends in related categories -->\n";

					$searchRC	= $categoryTitle;
					$searchRC	= str_replace(' & ', ' ', $categoryTitle);
					$subSqlRC	= getSearchColumnByWord('TITLE', $searchRC);
					$subSqlRC	= "(".str_replace(' AND ', ' OR ', $subSqlRC).")";

					$tempIds	= trimUniqueCsvVals($childCats, 'int', 1);
					$argsArr	= array();
					$argsStr	= prepareArgs4Query($argsArr, explode(',', $tempIds));

					$argsArr[]	= $categoryId;

					if ( !($argsStr == '?' && $argsArr[0] == '') )
					{
						$sqlRC = "SELECT ID, TITLE, FILENAME FROM ".PREFIX."CATEGORY WHERE ID IN (".$argsStr.") AND PRODUCTS > 0 AND ".$subSqlRC." AND ISVALID='Y' AND ID <> ?";
						$resRC = preparedQuery($sqlRC, $argsArr);
						while ( ($rowRC = getRow($resRC)) )
							$relatedCats[] = $rowRC;
					}

					if ( count($relatedCats) == 0 )
					{
						$sqlRC = "SELECT ID, TITLE, FILENAME FROM ".PREFIX."CATEGORY WHERE ".$subSqlRC." AND PRODUCTS > 0 AND ISVALID='Y' AND ID <> ?";
						$resRC = preparedQuery($sqlRC, array($categoryId));
						while ( ($rowRC = getRow($resRC)) )
							$relatedCats[] = $rowRC;
					}
				}

			} // cache file exists and is valid
			else
			{
				// 8-8-2012: Salman: Print Debug info if SQL is being logged
				if ( DO_TIME_EACH_QUERY == 1 )
					echo "\n\n				<!-- Related categories no sqls executed [".date('Y-m-d H:i:s')."] -->\n\n";
			}

			// 8-8-2012: Salman: Print Debug info if SQL is being logged
			if ( DO_TIME_EACH_QUERY == 1 )
				echo "\n<!-- \n- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n\n Build related category listing ends [".date('Y-m-d H:i:s')."] \n\n -->\n";
		}

//*************************************************************************************************

		// Load META TAGs of the page based on search and category
		if ( $isSearch )
		{
			if ( $merPPPage )
			{
				$pageTitle		= str_replace("{MERCHANT_NAME}", $merchantName, MPP_PAGE_TITLE);
				$pageKeywords	= str_replace("{MERCHANT_NAME}", $merchantName, MPP_PAGE_KEYWORDS);
				$pageDescription= str_replace("{MERCHANT_NAME}", $merchantName, MPP_PAGE_DESCRIPTION);
				$pageBreadcrumb	= ' &gt; '.$pageTitle;
			}
			else
			{
				$pageTitle		= str_replace("{SEARCH_KEYWORDS}", $searchText, PAGE_TITLE);
				$pageKeywords	= str_replace("{SEARCH_KEYWORDS}", $searchText, PAGE_KEYWORDS);
				$pageDescription= str_replace("{SEARCH_KEYWORDS}", $searchText, PAGE_DESCRIPTION);
			}
		}
		else
		{
			// Make title of page 2 and higher different
			$pageNumber					= getVar('x', 'int');
			$pageNumber					= ($pageNumber / ($pageSize==0 ? 1:$pageSize))+1;
			$pageNumberText				= $pageNumber > 1 ? (PAGE.' '.$pageNumber.' '.OF.' '):'';

			$pageTitle					= $pageNumberText.$pageTitle;
			$pageKeywords				= $pageNumberText.$pageKeywords;
			$pageDescription			= $pageNumberText.$pageDescription;

			$canonicalLink				= $x == 0 ? $categoryLink : getCategoryPath($categoryId, $categoryFilename, $t, $x);
			$prevPageLink				= $x - $pageSize < 0 ? '' : getCategoryPath($categoryId, $categoryFilename, $t, $x - $pageSize);
			$nextPageLink				= $x + $pageSize >= $t ? '' : getCategoryPath($categoryId, $categoryFilename, $t, $x + $pageSize);
		}

		$ogTitle				= $pageTitle;
		$ogDescription			= $pageDescription;
		$ogUrl					= $pageUrl;

//*************************************************************************************************

		$doCallJScrolPage	= true;

//*************************************************************************************************

		// Call template
		// 8-8-2012: Salman: Print Debug info if SQL is being logged
		if ( DO_TIME_EACH_QUERY == 1 )
			echo "\n<!-- Template starts-->\n";

		if ( $isAjaxProdSrc ) {
			include(PATH . 'products_listing.php');
		}
		else {
			// Render template
			renderTemplate('search_products', $GLOBALS);
		}

//*************************************************************************************************

		// Out Buffer Closed and Flushed
		ob_end_flush();

		if ( DO_TIME_EACH_QUERY == 1 )
			printf("\n\n<font size=1 color=gray face=verdana>PAGE LOADED IN <b>%0.6f</b> SECONDS</font><br><br>\n\n", (getMicroTime()-$pageStart));

//*************************************************************************************************
