<?php
//*************************************************************************************************
//		Price Comparison Script copyright Kaon Softwares ( http://www.kaonsoftwares.com )
//=================================================================================================
//		NOTICE: Do NOT remove the copyright and/or license information from this file.
//				doing so will automatically terminate your rights to use this program.
//-------------------------------------------------------------------------------------------------
//		This file comes with the license agreement. You must abide by the agreement. Any violation
//		will automatically result in termination of your rights to use this program.
//		See license agreement at www.kaonsoftwares.com/license.html
//-------------------------------------------------------------------------------------------------
//		You may modify the source code but this copyright notice MUST remain on all
//		PriceComparison Script's files.
//*************************************************************************************************

defined('PATH') or die('direct access not allowed!');

//*************************************************************************************************

startSession();

//*************************************************************************************************

header("Content-Type: text/html; charset=" . DEFAULT_CHARSET . "");

//*************************************************************************************************

$sessionId = session_id();

//*************************************************************************************************

// Pre-Load Categories
preloadCategories();

//*************************************************************************************************

// This variable is set to true if this page is directly called. It can be used to identify bots.
$directHit = isset($_SESSION['hitDetected']) && $_SESSION['hitDetected'] == 1 ? false : true;
$_SESSION['hitDetected'] = 1;

//*************************************************************************************************

// Initialize so that it is only shown on homepage
$showCookieNotice = false;
$showNewsletterPop = false;

// We cannot use the $isIndexPage var as it is not set yet
if (strstr($_SERVER["PHP_SELF"], 'index.php')) {
    // Show the cookie message if not shown on this computer ever and not shown in this session as well
    $showCookieNotice = !isset($_SESSION['sessCookieNotice']) && !isset($_COOKIE['shownCookieNotice']);

    // If cookie is set, renew it to next 1 year
    if (isset($_COOKIE['shownCookieNotice']))
        setcookie('shownCookieNotice', 1, time() + 60 * 60 * 24 * 365);

    // Mark in session that the notice is shown, so that it does not appear again in this session
    $_SESSION['sessCookieNotice'] = 1;


    // Show the newsletter pop if not shown on this computer ever and not shown in this session as well
    $showNewsletterPop = !isset($_SESSION['showNewsletterPop']) && !isset($_COOKIE['showNewsletterPop']);

    // If cookie is set, renew it to next 1 year
    if (isset($_COOKIE['showNewsletterPop']))
        setcookie('showNewsletterPop', 1, time() + 60 * 60 * 24 * 365);

    // Mark in session that the pop is shown, so that it does not appear again in this session
    $_SESSION['showNewsletterPop'] = 1;
}

//*************************************************************************************************

$visitorId = (int)sessionVar('visitorId');
$visitorEmail = sessionVar('visitorEmail');
$visitorName = sessionVar('visitorName');

$merchantId = sessionVar('merchantId');

//*************************************************************************************************

$IP_ADDRESS = getClientIP();

$locCity = '';    // We dont set these two values but initialized them for future as
$locZip = '';    // they are used in member login/register and contactus forms.
$locCountry = sessionVar('sessLocCountry');
if ($locCountry == '') {
    $locCountry = getLocationFromIP($IP_ADDRESS);
    if (defined('IS_MULTI_DOMAIN_REDIRECT_INSTALLED') && IS_MULTI_DOMAIN_REDIRECT_INSTALLED == 1) {
        $redirectUrl = getColumn('COUNTRY', $locCountry, 'REDIRECT_URL', 'TITLE');
        if (!isValidURL($redirectUrl))
            $redirectUrl = DEFAULT_MULTI_DOMAIN_REDIRECT_URL;

        if (
            isValidURL($redirectUrl) &&                                                // Check if redirect url is valid
            stristr(DEFAULT_MULTI_DOMAIN_REDIRECT_URL, $_SERVER['HTTP_HOST']) &&    // Check if current url is the default url (eg: www.domain.com)
            $redirectUrl != DEFAULT_MULTI_DOMAIN_REDIRECT_URL &&                    // Check if redirect url is not the default url (to avoid loop)
            $_SERVER['PHP_SELF'] == '/index.php'                                    // Only run this on homepage
        ) {
            header("Location: " . $redirectUrl);
            die;
        }
    }

    $_SESSION['sessLocCountry'] = $locCountry;
}

//*************************************************************************************************

$lang       = (int)sessionVar('lang');
$langFolder = sessionVar('langFolder');
$langRec    = isset($_SESSION['langRec']) ? $_SESSION['langRec'] : [];

if ($lang == 0 || $langFolder == '') {
    $lang       = (int)SCRIPT_DEFAULT_LANGUAGE;
    $langRec    = getRecord('LANGUAGE', $lang);
    $langFolder = $langRec ? $langRec['FOLDER'] : 0;

    // Folder not found
    if ($langRec == 0) {
        $langRec = getRecordEx('LANGUAGE', ' 1=1 LIMIT 1');
        if ($langRec != 0) {
            $lang       = $langRec['ID'];
            $langFolder = $langRec['FOLDER'];
        }
    }

    // Save in session if lang folder is not empty
    if ($langFolder != '') {
        $_SESSION['lang']       = $lang;
        $_SESSION['langFolder'] = $langFolder;
        $_SESSION['langRec']    = $langRec;
    }
    else {
        echo "<!-- Error: Language folder not found in database [".$langRec."] -->\n";
    }
}

//*************************************************************************************************

// Remove any character accept alphabets
$langFolder = kregexpReplace('[^A-Z\-]*', 'i', '', $langFolder);

$langISOCode = isset($COUNTRY_ALPHA2_TO_LANG_CODES[ $langFolder ]) ? substr($COUNTRY_ALPHA2_TO_LANG_CODES[ $langFolder ], 0, 2) : 'en';

//*************************************************************************************************

$langFilesToLoad = [];

$currentFilename = $_SERVER["PHP_SELF"];
if ($currentFilename == '')
    $currentFilename = $_SERVER["SCRIPT_FILENAME"] != "" ? $_SERVER["SCRIPT_FILENAME"] : $_SERVER["SCRIPT_NAME"];

$currentPagename = substr($currentFilename, strrpos($currentFilename, '/') + 1);

if (isset($langFilename) && $langFilename != '')
    $langFilesToLoad[] = str_replace('.php', '', $langFilename);

if (isset($langFilename2) && $langFilename2 != '')
    $langFilesToLoad[] = str_replace('.php', '', $langFilename2);

if (isset($currentPagename) && $currentPagename != '')
    $langFilesToLoad[] = str_replace('.php', '', $currentPagename);

$langLoadArray = ['constants', 'constants-commons', 'constants-messages', 'constants-info', 'constants-js'];
foreach ($langLoadArray as $langFilename)
    $langFilesToLoad[] = $langFilename;

loadLanguageForPage($lang, $langFilesToLoad);

//*************************************************************************************************

$currencySymbol = sessionVar('currencySymbol');
$currencyRate = sessionVar('currencyRate', 'float') * (getVar('exvat', 'float') == '' ? 1 : 0.825);

if ($currencySymbol == '' || $currencyRate == '') {
    $currencySymbol = SCRIPT_DOLLAR;
    $currencyRate = 1 * (getVar('exvat') == '' ? 1 : 0.825);
    $_SESSION['currencySymbol'] = $currencySymbol;
    $_SESSION['currencyRate'] = $currencyRate;
}

//*************************************************************************************************

// Security Checks
$_GET['t'] = getVar('t', 'int');
$_GET['x'] = getVar('x', 'int');

$_GET['so'] = getVar('so');
$_GET['sp'] = getVar('sp');
$_GET['sk'] = getVar('sk');

$_GET['info'] = getVar('info');

//*************************************************************************************************

$info = '';
if ($_GET['info'] != '')
    $info = getInfo(getVar('info'));

//*************************************************************************************************

$visitorProdsVisited = is_array(sessionVar('visitorProdsVisited')) ? sessionVar('visitorProdsVisited') : [];
$visitorLastSearches = is_array(sessionVar('visitorLastSearches')) ? sessionVar('visitorLastSearches') : [];

//*************************************************************************************************

$pageSize = isset($prefs['PUBLIC_PAGE_SIZE']) ? (int)$prefs['PUBLIC_PAGE_SIZE'] : 15;

//*************************************************************************************************

$pageTitle = str_replace('"', "&quot;", str_replace("{COMPANY_NAME}", SCRIPT_COMPANY_NAME, defined('PAGE_TITLE') ? PAGE_TITLE : SCRIPT_COMPANY_NAME));
$pageKeywords = str_replace('"', "&quot;", str_replace("{COMPANY_NAME}", SCRIPT_COMPANY_NAME, defined('PAGE_KEYWORDS') ? PAGE_KEYWORDS : SCRIPT_COMPANY_NAME));
$pageDescription = str_replace('"', "&quot;", str_replace("{COMPANY_NAME}", SCRIPT_COMPANY_NAME, defined('PAGE_DESCRIPTION') ? PAGE_DESCRIPTION : SCRIPT_COMPANY_NAME));
$pageHeading = defined('PAGE_HEADING') ? PAGE_HEADING : $pageTitle;
$pageUrl = ($_SERVER['SERVER_PORT'] == 443 ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];

$ogTitle = $pageTitle;
$ogDescription = $pageDescription;
$ogUrl = $pageUrl;
$ogImage = '';
$ogAudio = '';
$ogVideo = '';

$isContentPage = 0;

//*************************************************************************************************

$showDesktopSiteOnly = getVar('__dt', 'int');
if ($showDesktopSiteOnly == 0)
    $showDesktopSiteOnly = (int)sessionVar('__dt');
$_SESSION['__dt'] = $showDesktopSiteOnly;

if (isset($_GET['iOS']) || isset($_SESSION['iOS'])) {
    $_SESSION['iOS'] = 1;
    $browserType = 'iphone';
}

$templateSubFolder = '';
if (
    defined('IS_MOBILE_SITE_INSTALLED') && IS_MOBILE_SITE_INSTALLED == 1 && $showDesktopSiteOnly == 0 &&
//				in_array($browserType, array('android', 'iphone', 'symbian', 'mobile'))
// 12/18/2015: Mamda: only send to mobile if its mobile, because and android tablet also says "android"
    $browserType == 'mobile'
)
    $templateSubFolder = 'mobile/';

//*************************************************************************************************

if (IS_AFFILIATES_INSTALLED == 1)
    saveAffiliateId(getVar('aff'));

//*************************************************************************************************

$templateName = defined('CURRENT_TEMPLATE') && CURRENT_TEMPLATE != '' ? CURRENT_TEMPLATE : 'default';
$themeName = defined('CURRENT_THEME') && CURRENT_THEME != '' ? CURRENT_THEME : 'default';

// 10/27/2015: Mamda: Only load from session if its a demo site
if (defined('IS_IN_DEMO_MODE') && IS_IN_DEMO_MODE == 1 && is_array($DEMO_INSTALLED_TEMPLATES) && sessionVar('sessTemplateName') != '' && sessionVar('sessThemeName') != '') {
    $tt = $_SESSION['sessTemplateName'] . '~' . $_SESSION['sessThemeName'];
    $arr = array_keys($DEMO_INSTALLED_TEMPLATES);
    if (in_array($tt, $arr)) {
        $templateName = $_SESSION['sessTemplateName'];
        $themeName = $_SESSION['sessThemeName'];
    }
}

if (!defined('ACTIVE_TEMPLATE')) {
    define( 'ACTIVE_TEMPLATE', $templateName );
}
if (!defined('ACTIVE_THEME')) {
    define( 'ACTIVE_THEME', $themeName );
}

//*************************************************************************************************

if (DO_SHUTDOWN_WEBSITE == 1 && !stristr($_SERVER['PHP_SELF'], '.js.php')) {
    loadLanguageForPage($lang, 'shutdown');

    include PATH . 'shutdown.php';
    die;
}

//*************************************************************************************************

// Session not created for this visitor
if (defined('APPLY_IP_VISIT_RESTRICTION') && APPLY_IP_VISIT_RESTRICTION == 1 && !isset($skipVisitLogCheck) && !strstr($_SERVER['PHP_SELF'], '.js.php') && !strstr($_SERVER['PHP_SELF'], '/product-thumb.php') && !strstr($_SERVER['PHP_SELF'], '/product-image.php') && !strstr($_SERVER['PHP_SELF'], '/rf.php') && !strstr($_SERVER['PHP_SELF'], '/thumbnail.php') && !strstr($_SERVER['PHP_SELF'], '/404.php') && !strstr($_SERVER['PHP_SELF'], '/brand_panel.php') && !strstr($_SERVER['PHP_SELF'], '/403.php')) {
    $IP_ADDRESS_INT = getCurrentIntIP();

	$isBanned = 0;
	$resIpBan = preparedQuery("SELECT ID FROM " . PREFIX . "VISIT_LOG USE INDEX (IndexCOMPS2) WHERE IP_ADDRESS = ? AND IS_BANNED = 1", [$IP_ADDRESS_INT]);
	if (($rowIpBan = getRow($resIpBan))) {
		$isBanned = 1;
	}

	$ipVisitTotal = 0;
	if ( $isBanned == 0 ) {
		$resIpSecurity = preparedQuery("SELECT COUNT(ID) AS TOTAL FROM " . PREFIX . "VISIT_LOG USE INDEX (IndexCOMPS1) WHERE IP_ADDRESS = ? AND TS_VISITED_ON > ?", [$IP_ADDRESS_INT, time() - IP_VISIT_CHECK_LAST_X_SECS]);
		if ( ($rowIpSecurity = getRow($resIpSecurity)) ) {
			$ipVisitTotal = $rowIpSecurity['TOTAL'];
		}
	}

    if ( $isBanned || $ipVisitTotal > IP_VISIT_CHECK_MAX_LIMIT) {

    	// Limit has exceeded but not banned yet = Ban him
	    if ( $isBanned == 0 ) {
	    	preparedUpdate("INSERT INTO " . PREFIX . "VISIT_LOG(IP_ADDRESS, TS_VISITED_ON, IS_BANNED, URL) VALUES(?, ?, 1, ?)", [$IP_ADDRESS_INT, time(), $_SERVER['PHP_SELF']]);
	    }

	    // Show recaptcha
        $pageTitle = VISIT_RESTRICT_PAGE_TITLE;
        ob_start();
        echo '<div class="text-center">';
        echo '<h1>' . $pageTitle . '</h1>';
        echo '<div class="alert alert-danger">' . VISIT_RESTRICT_PAGE_WRITEUP . '</div>';
        if (defined('IP_VISIT_CHECK_SHOW_CAPTCHA') && IP_VISIT_CHECK_SHOW_CAPTCHA == 1) {
            ?>
            <h2><?= VISIT_RESTRICT_CAPTCHA_HEADING; ?></h2>
            <?= $info; ?>
            <form method="post" action="<?= SCRIPT_ROOT ?>visit_captcha_verify.php">
                <input type="hidden" name="url" value="<?= $_SERVER['REQUEST_URI'] ?>">
                <div style="width:300px;margin:20px auto"><?php showCaptcha() ?></div>
                <input type="submit" name="btn" value="<?= SUBMIT ?>" class="btn btn-success">
            </form>
            <?php
        }
        echo '</div>';
        $contentHtml = ob_get_contents();
        ob_end_clean();

        renderTemplate('basic', ['contentHtml' => $contentHtml]);

        // Close mysql immediately
        forceCloseMysql();
        die;
    }
    // All good, just log as normal
	preparedUpdate("INSERT INTO " . PREFIX . "VISIT_LOG(IP_ADDRESS, TS_VISITED_ON, IS_BANNED, URL) VALUES(?, ?, 0, ?)", [$IP_ADDRESS_INT, time(), $_SERVER['PHP_SELF']]);
}

//*************************************************************************************************

$MyCartID = '';
$showCartLink = false;
$cartSummary = '';
if (defined('IS_SHOPPING_CART_INSTALLED') && IS_SHOPPING_CART_INSTALLED == 1) {
    $MyCartID = getCartSessionID();
    $res = preparedQuery("SELECT COUNT(ID) AS C, SUM(PRICE) AS T FROM " . PREFIX . "MYCART WHERE SESSION_ID = ?", [$MyCartID]);
    $row = getRow($res);
    $showCartLink = $row['C'] > 0;
    $cartSummary = $row['C'] > 0 ? $row['C'] . ' ' . ITEMS . ' @ ' . getFormattedPrice($row['T'], $currencySymbol, $currencyRate) : '';
}

//*************************************************************************************************

// Declare cache variables
$cacheEnabled = false;                    // Is caching enabled
$cacheAvailable = false;                    // Is cache available for this page
$cacheFilename = '';                        // Location of cached file
$cacheContents = '';                        // Contents of cache file
$cacheStartTime = 0;                        // Just to log the time taken
$cacheHFLiveParts = [];                    // These are header/footer live parts, initialized in cache init function

// Initialize the header/footer live parts into $cacheHFLiveParts
if (!strstr($_SERVER['REQUEST_URI'], '.js.php') && !strstr($_SERVER['REQUEST_URI'], '/rf.php?') && !strstr($_SERVER['REQUEST_URI'], '/brand_panel.php?')) {
    require(PATH . 'header_footer_live_parts.php');
}

//*************************************************************************************************
