@extends('base')

{{-- uncomment this section if want to override mobile menu
@section('mobile-menu')
    template specific mobile menu
@endsection
--}}

@section('template-content')

    <div class="container">
        <div class="full-container" style="min-height:70vh">

            {{-- Top Logo Bar --}}
            <div class="top-logo-bar">
                <div class="indented-container">
                    <div class="row">
                        <div class="col-xs-2 hidden-md hidden-lg">
                            <button type="button" class="m-menu">
                                <span class="icon-bar"></span>
                                <span class="icon-bar"></span>
                                <span class="icon-bar"></span>
                            </button>
                        </div>
                        <div class="col-xs-8 col-md-6">
                            <a href="{{ getSeoUrl('/') }}"><img src="{{ getResourceUrl('logo.png', 'images', true) }}"
                                                                class="img-responsive top-logo"
                                                                alt="{{ SCRIPT_COMPANY_NAME }}"
                                                                title="{{ SCRIPT_COMPANY_NAME }}"></a>
                        </div>
                        <div class="hidden-xs hidden-sm col-md-6 account-links">
                            {!! $currencyString !!}
                            {!! $languageString !!}
                            @if( $currencyString != '' || $languageString != '' )
                                @push('footer-scripts')
                                <script type="text/javascript">
                                    try {
                                        $("select[rel=relJQDDR]").msDropDown();
                                    } catch (e) {
                                        alert(e.message);
                                    }
                                </script>
                                @endpush
                            @endif
                            <a href="javascript:loadLoginBox();">{{ '' == $visitorName ? LOGIN.' / '.REGISTER : WELCOME.' '.$visitorName }}</a>
                        </div>
                    </div>
                </div>
            </div>

            {{-- Top Links Bar --}}
            <div class="top-links-bar hidden-xs hidden-sm">
                <div class="indented-container">
                    <div class="row">
                        <div class="col-md-7 plain-links">
                            <a href="{{ getSeoUrl('category_taxonomy') }}"><i
                                        class="fa fa-th-large"></i> {{ CATEGORIES }}</a>
                            <a href="{{ getSeoUrl('aboutus') }}">{{ ABOUT_US }}</a>
                            <a href="{{ getSeoUrl('contactus') }}">{{ CONTACT_US }}</a>
                            <a href="{{ getSeoUrl('faq') }}">{{ FAQS }}</a>
                        </div>
                        <div class="col-md-5 button-links">
                            <a href="{{ getSeoUrl('all-stores') }}" class="bg-light-green"><i
                                        class="fa fa-shopping-bag"></i> {{ MERCHANTS }}</a>
                            @if ( defined('IS_COUPONS_INSTALLED') && IS_COUPONS_INSTALLED == 1 )
                                <a href="{{ getSeoUrl('coupons_category') }}" class="bg-light-blue"><i
                                            class="fa fa-map-o"></i> {{ COUPONS }}</a>
                            @endif
                            <a href="{{ getSeoUrl('brands') }}" class="bg-orange"><i
                                        class="fa fa-flag"></i> {{ BRANDS }}</a>
                        </div>
                    </div>
                </div>
            </div>

            {{-- Center Area --}}
            <div class="center-area">
                <div class="indented-container">

                    <div class="BreadcrumbBar">

                            <div class="hidden-xs">
                                <a href="{{ getSeoUrl('/') }}">{{ HOME }}</a>
                                {!! cacheLivePart('header-page-breadcrumb') !!}
                            </div>
                            @if( $lastUrl != '' && $lastTitle != '' )
                                <div class="visible-xs">
                                    <a class="BreadCrumbLinkM" href="{{ $lastUrl }}"><span
                                                class="glyphicon glyphicon-chevron-left"></span> {{ BACK_TO }} {{ $lastTitle }}
                                    </a>
                                </div>
                            @endif
                    </div>


                        {!! $info !!}

                        @yield('content')

                </div>

            </div>
        </div>

        {{-- Footer Bar --}}
        <div class="footer-area align-left"></div>

        {{-- Copyright Bar --}}
        <div class="copyright-bar">
            {!! date('Y') . ' ' . COPY_RIGHT !!}
        </div>

    </div>

@endsection
