@extends('base')

{{-- uncomment this section if want to override mobile menu
@section('mobile-menu')
    template specific mobile menu
@endsection
--}}

@push('meta-tags')
<meta name="theme-color" content="#2d3e50"/>
@endpush

@section('template-content')

    <div class="container">
        <div class="full-container">

            {{-- Top Logo Bar --}}
            <div class="top-logo-bar">
                <div class="indented-container">
                    <div class="row">
                        <div class="col-xs-2 hidden-md hidden-lg">
                            <button type="button" class="m-menu" aria-label="{{ NAVIGATION }}">
                                <span class="icon-bar"></span>
                                <span class="icon-bar"></span>
                                <span class="icon-bar"></span>
                            </button>
                        </div>
                        <div class="col-xs-8 col-md-6">
                            <a href="{{ getSeoUrl('/') }}"><img src="{{ getResourceUrl('logo.png', 'images', true) }}"
                                                                class="img-responsive top-logo"
                                                                alt="{{ SCRIPT_COMPANY_NAME }}"
                                                                title="{{ SCRIPT_COMPANY_NAME }}"></a>
                        </div>
                        <div class="hidden-xs hidden-sm col-md-6 account-links">
                            {!! $currencyString !!}
                            {!! $languageString !!}
                            @if( $currencyString != '' || $languageString != '' )
                                @push('footer-scripts')
                                <script type="text/javascript">
                                    try {
                                        $("select[rel=relJQDDR]").msDropDown();
                                    } catch (e) {
                                        alert(e.message);
                                    }
                                </script>
                                @endpush
                            @endif
                            <a href="javascript:loadLoginBox();">{{ '' == $visitorName ? LOGIN.' / '.REGISTER : WELCOME.' '.$visitorName }}</a>
                        </div>
                    </div>
                </div>
            </div>

            {{-- Top Links Bar --}}
            <div class="top-links-bar hidden-xs hidden-sm">
                <div class="indented-container">
                    <div class="row">
                        <div class="col-md-6 plain-links">
                            <a href="{{ getSeoUrl('category_taxonomy') }}"><i
                                        class="fa fa-th-large"></i> {{ CATEGORIES }}</a>
                            <a href="{{ getSeoUrl('aboutus') }}">{{ ABOUT_US }}</a>
                            <a href="{{ getSeoUrl('contactus') }}">{{ CONTACT_US }}</a>
                            <a href="{{ getSeoUrl('faq') }}">{{ FAQS }}</a>
                        </div>
                        <div class="col-md-6 button-links">
                            <a href="{{ getSeoUrl('all-stores') }}" class="bg-light-green animate"><i
                                        class="fa fa-shopping-bag"></i> {{ MERCHANTS }}</a>
                            @if ( defined('IS_COUPONS_INSTALLED') && IS_COUPONS_INSTALLED == 1 )
                                <a href="{{ getSeoUrl('coupons_category') }}" class="bg-light-blue animate"><i
                                            class="fa fa-map-o"></i> {{ COUPONS }}</a>
                            @endif
                            <a href="{{ getSeoUrl('brands') }}" class="bg-orange animate"><i
                                        class="fa fa-flag"></i> {{ BRANDS }}</a>
                        </div>
                    </div>
                </div>
            </div>

            {{-- Top Search Banner --}}
            @if( $isIndexPage )
                <div class="top-search-banner-full">
                    <div class="top-search-form">
                        <form action="{{ getSeoUrl('search_products') }}" method="GET" name="formSearch" id="formSearch"
                              class="form-inline">
                            <input type="hidden" name="searchWithin" value="">
                            <h2 class="hidden-xs hidden-sm">{{ SEARCH_PRODUCTS }}</h2>
                            <div class="input-group" style="width:100%" dir="ltr">
                                <input type="text" name="searchText" class="input-lg form-control"
                                       value="{{ cacheLivePart('header-search-text-ex') }}" title="{{ SEARCH_PRODUCTS }}"
                                       placeholder="{{ SEARCH_PRODUCTS }}" aria-label="{{ SEARCH_PRODUCTS }}">
                                <span class="input-group-addon animate"
                                      onclick="$('#formSearch').submit();">{{ SEARCH }}</span>
                            </div>
                            <div class="ac_wrapper"></div>
                        </form>
                        @if ( is_array($searchCloudArr) )
                            <div class="hidden-xs hidden-sm">
                            <h5 class="align-left">{{ RECENT_SEARCHES }}</h5>
                            <div class="row">
                                <?php $slicedArr = array_slice($searchCloudArr, 0, 12) ?>
                                @foreach ( $slicedArr as $rec )
                                    <div class="col-xs-4 col-sm-3 col-md-2">
                                        <a href="{{ getSearchUrl($rec['T']) }}"
                                           class="top-search-tag animate" title="{{ handleDoubleQuote($rec['T']) }}"
                                        >{{ getPartialString($rec['T'], 10, '', true, 2) }}</a>
                                    </div>
                                @endforeach
                            </div>
                            </div>
                        @endif
                    </div>
                </div>
            @else
                <div class="top-search-banner">
                    <form action="{{ getSeoUrl('search_products') }}" method="GET" name="formSearch" id="formSearch"
                          class="form-inline top-search-form">
                        <input type="hidden" name="searchWithin" value="">
                        <h2 class="hidden-xs hidden-sm">{{ SEARCH_PRODUCTS }}</h2>
                        <div class="input-group" style="width:100%" dir="ltr">
                            <input type="text" name="searchText" class="input-lg form-control"
                                   value="{{ cacheLivePart('header-search-text-ex') }}" title="{{ SEARCH_PRODUCTS }}"
                                   placeholder="{{ SEARCH_PRODUCTS }}">
                            <span class="input-group-addon" onclick="$('#formSearch').submit();">{{ SEARCH }}</span>
                        </div>
                        <div class="ac_wrapper"></div>
                    </form>
                </div>
            @endif

            {{-- Center Area --}}
            <div class="center-area">
                <div class="indented-container">

                    @if( ! $isIndexPage )
                        <div class="BreadcrumbBar">
                            <div class="hidden-xs"><a
                                        href="{{ getSeoUrl('/') }}">{{ HOME }}</a> {!! cacheLivePart('header-page-breadcrumb') !!}
                            </div>
                            @if( $lastUrl != '' && $lastTitle != '' )
                                <div class="visible-xs">
                                    <a class="BreadCrumbLinkM" href="{{ $lastUrl }}"><span
                                                class="glyphicon glyphicon-chevron-left"></span> {{ BACK_TO }} {{ $lastTitle }}
                                    </a>
                                </div>
                            @endif
                        </div>
                    @endif

                    {!! $info !!}

                    @if( $isContentPage )
                        <div class="row">
                            <div class="col-xs-12 col-md-8 align-left">
                                <h1>{{ cacheLivePart('header-page-heading') }}</h1>
                                @endif

                                @yield('content')

                                @if( $isContentPage )
                            </div>
                            <div class="hidden-xs hidden-sm col-md-4 align-right">

                                @if( FACEBOOK_PAGE_LINK != '#' )
                                    <iframe src="//www.facebook.com/plugins/likebox.php?href={{ urlencode(FACEBOOK_PAGE_LINK) }}&amp;width=300&amp;height=270&amp;colorscheme=light&amp;show_faces=true&amp;border_color&amp;stream=false&amp;header=true"
                                            scrolling="no" frameborder="0"
                                            style="border:none; overflow:hidden; width:300px; height:270px;"
                                            allowTransparency="true"></iframe>
                                    <div style="clear:both; height:10px;"></div>
                                @endif

                                {!! getBanner(1000, 'R1') !!}

                            </div>
                        </div>
                    @endif

                </div>
            </div>

            {{-- Footer Bar --}}
            <div class="footer-area align-left">
                <div class="indented-container">

                    <div class="row">
                        <div class="col-xs-12 col-sm-6 col-md-5">
                            <h2>{{ SIGN_UP_FOR_NEWSLETTER }}</h2>
                            <p>&nbsp;</p>
                            <div class="input-group">
                                <input type="text" name="email" placeholder="{{ EMAIL_ADDRESS }}" aria-label="{{ EMAIL_ADDRESS }}"
                                       onfocus="popNewsletter()" autocomplete="off" class="form-control">
                                <span class="input-group-addon input-group-addon-nl" onclick="popNewsletter()"><i
                                            class="fa fa-send"></i></span>
                            </div>
                            @include('newsletter-popwin')
                            <p>&nbsp;</p>
                            <p>&nbsp;</p>
                            @if( defined('FACEBOOK_PAGE_LINK') && FACEBOOK_PAGE_LINK != '#' && FACEBOOK_PAGE_LINK != '' )
                                <a href="{{ FACEBOOK_PAGE_LINK }}" class="social-icon" aria-label="Facebook"><i class="fa fa-facebook-f"></i></a>
                            @endif
                            @if( defined('GOOGLEPLUS_PAGE_LINK') && GOOGLEPLUS_PAGE_LINK != '#' && GOOGLEPLUS_PAGE_LINK != '' )
                                <a href="{{ GOOGLEPLUS_PAGE_LINK }}" class="social-icon" aria-label="Google+"><i
                                            class="fa fa-google-plus"></i></a>
                            @endif
                            @if( defined('TWITTER_PAGE_LINK') && TWITTER_PAGE_LINK != '#' && TWITTER_PAGE_LINK != '' )
                                <a href="{{ TWITTER_PAGE_LINK }}" class="social-icon" aria-label="Twitter"><i class="fa fa-twitter"></i></a>
                            @endif
                            @if( defined('YOUTUBE_PAGE_LINK') && YOUTUBE_PAGE_LINK != '#' && YOUTUBE_PAGE_LINK != '' )
                                <a href="{{ YOUTUBE_PAGE_LINK }}" class="social-icon" aria-label="Youtube"><i class="fa fa-youtube"></i></a>
                            @endif
                        </div>
                    </div>

                </div>
            </div>

            {{-- Footer Links Bar --}}
            <div class="footer-links-bar">
                <div class="row">
                    <div class="hidden-xs hidden-sm col-md-offset-2 col-md-2">
                        <a href="{{ getSeoUrl('/') }}"><b>{{ HOME }}</b></a><br>
                        <a id="linkLoginBox" href="javascript:loadLoginBox();">{{ VISITOR_AREA }}</a><br>
                        <span id="idFooterMemberLogout" {!! cacheLivePart('footer-logout-display') !!}><a
                                    href="javascript:performLogout()">{{ VISITOR_LOGOUT }}</a><br></span>
                        @if( cacheLivePart('show-shopping-cart-link') )
                            <a href="{{ getSeoUrl('merchant_store_cart_view') }}">{{ SHOPPING_CART }}</a><br>
                        @endif
                        <a href="{{ SCRIPT_ROOT }}affiliates/">{{ AFFILIATE_AREA }}</a><br>
                    </div>
                    <div class="hidden-xs hidden-sm col-md-2">
                        <a href="{{ SCRIPT_ROOT }}merchant/merchant_welcome.{{ EXTENSION }}"><b>{{ MERCHANT_AREA }}</b></a><br>
                        <a href="{{ getSeoUrl('merchant_ranking') }}">{{ TOP_MERCHANTS }}</a><br>
                        <a href="{{ getSeoUrl('all-stores') }}">{{ ALL_STORES }}</a><br>
                    </div>
                    <div class="hidden-xs hidden-sm col-md-2">
                        <a href="{{ getSeoUrl('aboutus') }}"><b>{{ ABOUT_US }}</b></a><br>
                        <a href="{{ getSeoUrl('contactus') }}">{{ CONTACT_US }}</a><br>
                        <a href="{{ getSeoUrl('faq') }}">{{ FAQ }}</a><br>
                    </div>
                    <div class="hidden-xs hidden-sm col-md-2">
                        <a href="{{ getSeoUrl('sitemap') }}"><b>{{ SITEMAP }}</b></a><br>
                        <a href="{{ getSeoUrl('termsofuse') }}">{{ TERMS_OF_USE }}</a><br>
                        <a href="{{ getSeoUrl('recent_searches') }}">{{ RECENT_SEARCHES }}</a><br>
                    </div>

                    <div class="col-xs-12 col-sm-12 hidden-md hidden-lg" style="position:relative;text-align:center;">
                        <select class="BotNav" onchange="location.href = this.value;" aria-label="{{ NAVIGATION }}">
                            <option value="">{{ NAVIGATION }}</option>
                            <option value="{{ getSeoUrl('/') }}">{{ HOME }}</option>
                            <option value="{{ SCRIPT_ROOT }}member_welcome.{{ EXTENSION }}">{{ VISITOR_AREA }}</option>
                        <!-- <option value="{{ SCRIPT_ROOT }}merchant/merchant_welcome.{{ EXTENSION }}">{{ MERCHANT_AREA }}</option> -->
                            @if( cacheLivePart('show-shopping-cart-link') )
                                <option value="{{ getSeoUrl('merchant_store_cart_view') }}">{{ SHOPPING_CART }}</option>
                            @endif
                            <option value="{{ getSeoUrl('merchant_ranking') }}">{{ TOP_MERCHANTS }}</option>
                            <option value="{{ getSeoUrl('all-stores') }}">{{ ALL_STORES }}</option>
                            <option value="{{ getSeoUrl('aboutus') }}">{{ ABOUT_US }}</option>
                            <option value="{{ getSeoUrl('contactus') }}">{{ CONTACT_US }}</option>
                            <option value="{{ getSeoUrl('faq') }}">{{ FAQ }}</option>
                            <option value="{{ getSeoUrl('sitemap') }}">{{ SITEMAP }}</option>
                            <option value="{{ getSeoUrl('termsofuse') }}">{{ TERMS_OF_USE }}</option>
                            <option value="{{ getSeoUrl('recent_searches') }}">{{ RECENT_SEARCHES }}</option>
                        </select>
                    </div>
                </div>
            </div>

            {{-- Copyright Bar --}}
            <div class="copyright-bar">
                {!! date('Y') . ' ' . COPY_RIGHT !!}
            </div>

        </div>
    </div>

@endsection
