@extends(ACTIVE_TEMPLATE.'.base')

@section('content')

    {{-- Add a gap --}}
    <p>&nbsp;</p>

    {{-- Show comparison link --}}
    <div style="position:relative;">
        <div style="position:absolute; left:auto; right:0; {{ is_array($_SESSION['sessCompareIds']) && count($_SESSION['sessCompareIds']) > 0 ? '' : 'display:none;' }}"
             id="idCompListLink"><a href="<?= getSeoUrl('compare_products') ?>"
                                    class="btn btn-dark1"><span
                        class="glyphicon glyphicon-list"></span> <?= COMPARISON_LIST ?></a></div>
    </div>

    {{-- Featured/Popular/Day Products Tabs --}}
    <ul class="nav nav-tabs nav-dex-products" role="tablist">
        <li role="presentation" class="active"><a href="#featured" aria-controls="featured" role="tab"
                                                  data-toggle="tab" onclick="unveilImages()">{{ FEATURED_PRODUCTS }}</a>
        </li>
        <li role="presentation"><a href="#popular" aria-controls="popular" role="tab"
                                   data-toggle="tab" onclick="unveilImages()">{{ POPULAR_PRODUCTS }}</a></li>
        <li role="presentation"><a href="#pod" aria-controls="pod" role="tab"
                                   data-toggle="tab" onclick="unveilImages()">{{ PRODUCT_OF_THE_DAY }}</a></li>
    </ul>

    {{-- Featured/Popular/Day Products Pages --}}
    <div class="tab-content">
        <div role="tabpanel" class="tab-pane active" id="featured">
            @include(ACTIVE_TEMPLATE.'.prod-boxes', [ 'sectionCode' => 'FP', 'arrProds' => $prodArr ])
        </div>
        <div role="tabpanel" class="tab-pane" id="popular">
            @include(ACTIVE_TEMPLATE.'.prod-boxes', [ 'sectionCode' => 'PP', 'arrProds' => $prodPOP ])
        </div>
        <div role="tabpanel" class="tab-pane" id="pod">
            @include(ACTIVE_TEMPLATE.'.prod-boxes', [ 'sectionCode' => 'TP', 'arrProds' => $prodPOD ])
        </div>
    </div>

    @push('footer-scripts')
    <script type="text/javascript" src="{{ getResourceUrl('products_listing.js.php', 'js', false, false) }}"></script>
    <script type="text/javascript" src="{{ getResourceUrl('products.js.php', 'js', false, false) }}"></script>
    @endpush

    @if( is_array($arrLeftCat) && count($arrLeftCat) > 3 )
        {{-- Category Boxes --}}
        <div class="dex-cats-container">
            <div class="row">
                <?php $arrCats = array_slice($arrLeftCat, 0, 4) ?>
                @foreach( $arrCats as $count => $cat )
                    <?php $categoryImagePath = getCategoryImageUrl($cat['ID']); ?>
                    <div class="col-xs-12 col-sm-6 col-md-3">
                        <a href="{{ getCategoryPath($cat['ID'], $cat['FILENAME']) }}" class="dex-cat-box">
                            <div class="dex-cat-box-inner dex-cat-box-inner-{{ ++$count }}"></div>
                            <span>{{ $cat['TITLE'] }}</span>
                            {!!
                                $categoryImagePath == '' ? '' :
                                    getImgTag([
                                        'src'   => getReadFileLink($categoryImagePath),
                                        'alt'	=> escAttr($cat['TITLE']),
									    'title'	=> escAttr($cat['TITLE'])
                                    ])
                            !!}
                        </a>
                    </div>
                @endforeach
            </div>
        </div>
    @endif

    @if( defined('IS_COUPONS_INSTALLED') && IS_COUPONS_INSTALLED == 1 )
        <?php include(PATH.'coupons_index_featured.php'); ?>
    @endif

@endsection
