@extends('base')

{{-- uncomment this section if want to override mobile menu
@section('mobile-menu')
    template specific mobile menu
@endsection
--}}

@section('template-content')

    <header>
        <div class="header-top">
            <div class="container">
                <div class="row">
                    <div class="hidden-xs col-sm-4">
                        <div class="row">
                            <div class="col-sm-4">
                                <a href="{{ getSeoUrl('aboutus') }}" class="icon"><i
                                            class="fa fa-info-circle"></i>{{ ABOUT_US }}</a>
                            </div>
                            <div class="col-sm-4">
                                <a href="{{ getSeoUrl('contactus') }}" class="icon"><i
                                            class="fa fa-envelope"></i>{{ CONTACT_US }}</a>
                            </div>
                            <div class="col-sm-4">
                                <a href="{{ getSeoUrl('faq') }}" class="icon"><i
                                            class="fa fa-question-circle"></i>{{ FAQ }}</a>
                            </div>
                        </div>
                    </div>
                    <div class="col-xs-2 hidden-sm hidden-md hidden-lg">
                        <button type="button" class="m-menu" aria-label="{{ NAVIGATION }}">
                            <span class="icon-bar"></span>
                            <span class="icon-bar"></span>
                            <span class="icon-bar"></span>
                        </button>
                    </div>
                    <div class="col-xs-8 col-sm-4">
                        <a href="{{ getSeoUrl('/') }}"><img src="{{ getResourceUrl('logo.png', 'images', true) }}"
                                                            class="img-responsive logo"
                                                            alt="{{ SCRIPT_COMPANY_NAME }}"
                                                            title="{{ SCRIPT_COMPANY_NAME }}"></a>
                        <div class="slogan">{{ SCRIPT_COMPANY_SLOGAN }}</div>
                    </div>
                    <div class="hidden-xs col-sm-4">
                        <div class="row">
                            <div class="col-sm-4">
                                <a href="{{ getSeoUrl('all-stores') }}" class="icon"><i
                                            class="fa fa-shopping-bag"></i>{{ MERCHANTS }}</a>
                            </div>
                            <div class="col-sm-4">
                                <a href="{{ getSeoUrl('brands') }}" class="icon"><i class="fa fa-flag"></i>{{ BRANDS }}
                                </a>
                            </div>
                            <div class="col-sm-4">
                                <a href="javascript:loadLoginBox();" class="icon"><i
                                            class="fa fa-dashboard"></i>{{ VISITOR_AREA }}</a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="header-search">
            <div class="container">
                <div class="row">
                    <div class="hidden-xs col-sm-3">
                        <a href="{{ getSeoUrl('category_taxonomy') }}" class="links"><i
                                    class="fa fa-sitemap"></i> {{ ALL_CATEGORIES }}</a>
                    </div>
                    <div class="col-xs-12 col-sm-6">
                        <form action="{{ getSeoUrl('search_products') }}" method="GET" name="formSearch" id="formSearch"
                              class="form-inline">
                            <input type="hidden" name="searchWithin" value="">
                            <div class="input-group">
                                <input type="text" name="searchText" class="input-lg form-control"
                                       value="{{ cacheLivePart('header-search-text-ex') }}"
                                       placeholder="{{ SEARCH_PRODUCTS }}" aria-label="{{ SEARCH_PRODUCTS }}">
                                <span class="input-group-addon"
                                      onclick="$('#formSearch').submit();">{{ SEARCH }}</span>
                            </div>
                            <div class="ac_wrapper"></div>
                        </form>
                    </div>
                    <div class="hidden-xs col-sm-3">
                        @if ( defined('IS_COUPONS_INSTALLED') && IS_COUPONS_INSTALLED == 1 )
                            <a href="{{ getSeoUrl('coupons_category') }}" class="links"><i
                                        class="fa fa-map-o"></i> {{ COUPONS }}</a>
                        @endif
                    </div>
                </div>
            </div>
        </div>
    </header>

    <main>

        <div class="container">

            <div class="BreadcrumbBar">
                <div class="hidden-xs"><a
                            href="{{ getSeoUrl('/') }}">{{ HOME }}</a> {!! cacheLivePart('header-page-breadcrumb') !!}
                </div>
                @if( $lastUrl != '' && $lastTitle != '' )
                    <div class="visible-xs">
                        <a class="BreadCrumbLinkM" href="{{ $lastUrl }}"><span
                                    class="glyphicon glyphicon-chevron-left"></span> {{ BACK_TO }} {{ $lastTitle }}
                        </a>
                    </div>
                @endif
            </div>

            {!! $info !!}

            @yield('content')

        </div>

    </main>

    <footer>

        <div class="footer-top">
            <div class="container">
                <div class="row">
                    <div class="hidden-xs hidden-sm col-md-offset-2 col-md-2">
                        <a href="{{ getSeoUrl('/') }}"><b>{{ HOME }}</b></a><br>
                        <a id="linkLoginBox" href="javascript:loadLoginBox();">{{ VISITOR_AREA }}</a><br>
                        <span id="idFooterMemberLogout" {!! cacheLivePart('footer-logout-display') !!}><a
                                    href="javascript:performLogout()">{{ VISITOR_LOGOUT }}</a><br></span>
                        @if( cacheLivePart('show-shopping-cart-link') )
                            <a href="{{ getSeoUrl('merchant_store_cart_view') }}">{{ SHOPPING_CART }}</a><br>
                        @endif
                        <a href="{{ SCRIPT_ROOT }}affiliates/">{{ AFFILIATE_AREA }}</a><br>
                    </div>
                    <div class="hidden-xs hidden-sm col-md-2">
                        <a href="{{ SCRIPT_ROOT }}merchant/merchant_welcome.{{ EXTENSION }}"><b>{{ MERCHANT_AREA }}</b></a><br>
                        <a href="{{ getSeoUrl('merchant_ranking') }}">{{ TOP_MERCHANTS }}</a><br>
                        <a href="{{ getSeoUrl('all-stores') }}">{{ ALL_STORES }}</a><br>
                    </div>
                    <div class="hidden-xs hidden-sm col-md-2">
                        <a href="{{ getSeoUrl('aboutus') }}"><b>{{ ABOUT_US }}</b></a><br>
                        <a href="{{ getSeoUrl('contactus') }}">{{ CONTACT_US }}</a><br>
                        <a href="{{ getSeoUrl('faq') }}">{{ FAQ }}</a><br>
                    </div>
                    <div class="hidden-xs hidden-sm col-md-2">
                        <a href="{{ getSeoUrl('sitemap') }}"><b>{{ SITEMAP }}</b></a><br>
                        <a href="{{ getSeoUrl('termsofuse') }}">{{ TERMS_OF_USE }}</a><br>
                        <a href="{{ getSeoUrl('recent_searches') }}">{{ RECENT_SEARCHES }}</a><br>
                    </div>

                    <div class="col-xs-12 col-sm-12 hidden-md hidden-lg" style="position:relative;text-align:center;">
                        <select class="BotNav" onchange="location.href = this.value;" aria-label="{{ NAVIGATION }}">
                            <option value="">{{ NAVIGATION }}</option>
                            <option value="{{ getSeoUrl('/') }}">{{ HOME }}</option>
                            <option value="{{ SCRIPT_ROOT }}member_welcome.{{ EXTENSION }}">{{ VISITOR_AREA }}</option>
                        <!-- <option value="{{ SCRIPT_ROOT }}merchant/merchant_welcome.{{ EXTENSION }}">{{ MERCHANT_AREA }}</option> -->
                            @if( cacheLivePart('show-shopping-cart-link') )
                                <option value="{{ getSeoUrl('merchant_store_cart_view') }}">{{ SHOPPING_CART }}</option>
                            @endif
                            <option value="{{ getSeoUrl('merchant_ranking') }}">{{ TOP_MERCHANTS }}</option>
                            <option value="{{ getSeoUrl('all-stores') }}">{{ ALL_STORES }}</option>
                            <option value="{{ getSeoUrl('aboutus') }}">{{ ABOUT_US }}</option>
                            <option value="{{ getSeoUrl('contactus') }}">{{ CONTACT_US }}</option>
                            <option value="{{ getSeoUrl('faq') }}">{{ FAQ }}</option>
                            <option value="{{ getSeoUrl('sitemap') }}">{{ SITEMAP }}</option>
                            <option value="{{ getSeoUrl('termsofuse') }}">{{ TERMS_OF_USE }}</option>
                            <option value="{{ getSeoUrl('recent_searches') }}">{{ RECENT_SEARCHES }}</option>
                        </select>
                    </div>
                </div>
            </div>
        </div>

        <div class="footer-bottom">
            <div class="container">

                @if( (defined('ANDROID_APP_ID') && ANDROID_APP_ID != '') || (defined('IOS_APP_ID') && IOS_APP_ID != '') )
                    <b>{{ str_replace('SCRIPT_COMPANY_NAME', SCRIPT_COMPANY_NAME, SMARTPHONE_APPS_HEADING) }}</b>
                    @if( defined('IOS_APP_ID') && IOS_APP_ID != '' )
                        <a href="https://itunes.apple.com/gb/app/{{ IOS_APP_ID }}" target="_blank"><img
                                    src="{{ getResourceUrl('logo-appstore.png', 'images', true) }}"
                                    class="img-responsive app-logo" alt="{{ APP_FOR_IOS }}"
                                    title="{{ APP_FOR_IOS }}"></a>
                    @endif
                    @if( defined('ANDROID_APP_ID') && ANDROID_APP_ID != '' )
                        <a href="https://play.google.com/store/apps/details?id={{ ANDROID_APP_ID }}"
                           target="_blank"><img
                                    src="{{ getResourceUrl('logo-playstore.png', 'images', true) }}"
                                    class="img-responsive app-logo" alt="{{ APP_FOR_ANDROID }}"
                                    title="{{ APP_FOR_ANDROID }}"></a>
                    @endif
                    <hr/>
                @endif

                @if((defined('FACEBOOK_PAGE_LINK') && FACEBOOK_PAGE_LINK != '#') ||
                    (defined('TWITTER_PAGE_LINK') && TWITTER_PAGE_LINK != '#') ||
                    (defined('GOOGLEPLUS_PAGE_LINK') && GOOGLEPLUS_PAGE_LINK != '#') ||
                    (defined('YOUTUBE_PAGE_LINK') && YOUTUBE_PAGE_LINK != '#'))
                    <b>{{ SOCIAL_MEDIA_CONNECT_HEADING }}</b>
                    @if(defined('FACEBOOK_PAGE_LINK') && FACEBOOK_PAGE_LINK != '#')
                        <a href="{{ FACEBOOK_PAGE_LINK }}" target="_blank"><i class="fa fa-facebook-square"></i></a>
                    @endif
                    @if(defined('TWITTER_PAGE_LINK') && TWITTER_PAGE_LINK != '#')
                        <a href="{{ TWITTER_PAGE_LINK }}" target="_blank"><i class="fa fa-twitter-square"></i></a>
                    @endif
                    @if(defined('GOOGLEPLUS_PAGE_LINK') && GOOGLEPLUS_PAGE_LINK != '#')
                        <a href="{{ GOOGLEPLUS_PAGE_LINK }}" target="_blank"><i
                                    class="fa fa-google-plus-square"></i></a>
                    @endif
                    @if(defined('YOUTUBE_PAGE_LINK') && YOUTUBE_PAGE_LINK != '#')
                        <a href="{{ YOUTUBE_PAGE_LINK }}" target="_blank"><i class="fa fa-youtube-square"></i></a>
                    @endif
                    <hr/>
                @endif

                <b>{{ SIGN_UP_FOR_NEWSLETTER }}</b>
                <div class="input-group">
                    <input type="text" name="email" placeholder="{{ EMAIL_ADDRESS }}" aria-label="{{ EMAIL_ADDRESS }}"
                           onfocus="popNewsletter()" autocomplete="off" class="form-control">
                    <span class="input-group-addon" onclick="popNewsletter()"><i
                                class="fa fa-send"></i></span>
                </div>
                @include('newsletter-popwin')

            </div>
        </div>

        <div class="copyright-bar">
            {!! date('Y') . ' ' . COPY_RIGHT !!}
        </div>

    </footer>

    <div class="scroll-to-top-button" onclick="scrollToTop()"><i class="fa fa-arrow-up"></i></div>

@endsection
