@extends('base')

{{-- uncomment this section if want to override mobile menu
@section('mobile-menu')
    template specific mobile menu
@endsection
--}}

@section('template-content')

    <header>
        <div class="header">
            <div class="container">
                <div class="row">
                    <div class="col-xs-10 col-md-4">
                        <a href="{{ getSeoUrl('/') }}"><img src="{{ getResourceUrl('logo.png', 'images', true) }}"
                                                            class="img-responsive logo" alt="{{ SCRIPT_COMPANY_NAME }}"
                                                            title="{{ SCRIPT_COMPANY_NAME }}"></a>
                    </div>
                    <div class="col-xs-2 hidden-md hidden-lg">
                        <button type="button" class="m-menu" aria-label="{{ NAVIGATION }}">
                            <span class="icon-bar"></span>
                            <span class="icon-bar"></span>
                            <span class="icon-bar"></span>
                        </button>
                    </div>
                    <div class="col-xs-12 col-md-4">
                        <form action="{{ getSeoUrl('search_products') }}" method="GET" name="formSearch" id="formSearch"
                              class="form-inline search-form">
                            <input type="hidden" name="searchWithin" value="">
                            <div class="input-group">
                                <input type="text" name="searchText" class="input-lg form-control"
                                       value="{{ cacheLivePart('header-search-text-ex') }}"
                                       placeholder="{{ SEARCH_PRODUCTS }}" aria-label="{{ SEARCH_PRODUCTS }}">
                                <span class="input-group-addon" onclick="$('#formSearch').submit();"><i
                                            class="fa fa-search"></i></span>
                            </div>
                            <div class="ac_wrapper"></div>
                        </form>
                    </div>
                    <div class="hidden-xs hidden-sm col-md-4">
                        <div class="links">
                            <a href="javascript:loadLoginBox();"><i
                                        class="fa fa-dashboard"></i>{{ '' == $visitorName ? VISITOR_AREA : WELCOME.' '.$visitorName }}
                            </a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </header>


    <main>

        <div class="main">
            <div class="container">

                <div class="breadcrumb">
                    <div class="hidden-xs"><a
                                href="{{ getSeoUrl('/') }}">{{ HOME }}</a> {!! cacheLivePart('header-page-breadcrumb') !!}
                    </div>
                    @if( $lastUrl != '' && $lastTitle != '' )
                        <div class="visible-xs">
                            <a class="BreadCrumbLinkM" href="{{ $lastUrl }}"><span
                                        class="glyphicon glyphicon-chevron-left"></span> {{ BACK_TO }} {{ $lastTitle }}
                            </a>
                        </div>
                    @endif
                </div>

                {!! $info !!}

                @yield('content')

            </div>
        </div>

    </main>


    <footer>

        <div class="footer">
            <div class="container">
                <div class="row">
                    <div class="hidden-xs hidden-sm col-md-3">
                        <a href="{{ getSeoUrl('/') }}"><img src="{{ getResourceUrl('logo-sm.png', 'images', true) }}"
                                                            class="img-responsive logo" alt="{{ SCRIPT_COMPANY_NAME }}"
                                                            title="{{ SCRIPT_COMPANY_NAME }}"></a>
                    </div>
                    <div class="col-xs-12 col-md-7">
                        <div class="row hidden-xs hidden-sm links">
                            <div class="col-sm-4">
                                <a href="{{ getSeoUrl('/') }}"><b>{{ HOME }}</b></a><br>
                                <a id="linkLoginBox" href="javascript:loadLoginBox();">{{ VISITOR_AREA }}</a><br>
                                <span id="idFooterMemberLogout" {{ cacheLivePart('footer-logout-display') }}><a
                                            href="javascript:performLogout()">{{ VISITOR_LOGOUT }}</a><br></span>
                                @if((cacheLivePart('show-shopping-cart-link')))
                                    <a href="{{ getSeoUrl('merchant_store_cart_view') }}">{{ SHOPPING_CART }}</a>
                                    <br>
                                @endif
                                <a href="{{ SCRIPT_ROOT }}affiliates/">{{ AFFILIATE_AREA }}</a><br>
                            </div>
                            <div class="col-sm-4">
                                <a href="{{ SCRIPT_ROOT }}merchant/merchant_welcome.{{ EXTENSION }}"><b>{{ MERCHANT_AREA }}</b></a><br>
                                <a href="{{ getSeoUrl('merchant_ranking') }}">{{ TOP_MERCHANTS }}</a><br>
                                <a href="{{ getSeoUrl('all-stores') }}">{{ ALL_STORES }}</a><br>
                                <a href="{{ getSeoUrl('recent_searches') }}">{{ RECENT_SEARCHES }}</a><br>
                                <a href="{{ getSeoUrl('faq') }}">{{ FAQ }}</a><br>
                            </div>
                            <div class="col-sm-4">
                                <a href="{{ getSeoUrl('aboutus') }}"><b>{{ ABOUT_US }}</b></a><br>
                                <a href="{{ getSeoUrl('contactus') }}">{{ CONTACT_US }}</a><br>
                                <a href="{{ getSeoUrl('privacy') }}">{{ PRIVACY_POLICY }}</a><br>
                                <a href="{{ getSeoUrl('termsofuse') }}">{{ TERMS_OF_USE }}</a><br>
                                <a href="{{ getSeoUrl('sitemap') }}">{{ SITEMAP }}</a><br>
                            </div>
                        </div>
                        <div class="visible-xs visible-sm">
                            <select class="BotNav" onchange="location.href = this.value;" aria-label="{{ NAVIGATION }}">
                                <option value="">{{ NAVIGATION }}</option>
                                <option value="{{ getSeoUrl('/') }}">{{ HOME }}</option>
                                <option value="{{ SCRIPT_ROOT }}member_welcome.{{ EXTENSION }}">{{ VISITOR_AREA }}</option>
                            <!-- <option value="{{ SCRIPT_ROOT }}merchant/merchant_welcome.{{ EXTENSION }}">{{ MERCHANT_AREA }}</option> -->
                                @if( cacheLivePart('show-shopping-cart-link') )
                                    <option value="{{ getSeoUrl('merchant_store_cart_view') }}">{{ SHOPPING_CART }}</option>
                                @endif
                                <option value="{{ getSeoUrl('merchant_ranking') }}">{{ TOP_MERCHANTS }}</option>
                                <option value="{{ getSeoUrl('all-stores') }}">{{ ALL_STORES }}</option>
                                <option value="{{ getSeoUrl('aboutus') }}">{{ ABOUT_US }}</option>
                                <option value="{{ getSeoUrl('contactus') }}">{{ CONTACT_US }}</option>
                                <option value="{{ getSeoUrl('faq') }}">{{ FAQ }}</option>
                                <option value="{{ getSeoUrl('sitemap') }}">{{ SITEMAP }}</option>
                                <option value="{{ getSeoUrl('termsofuse') }}">{{ TERMS_OF_USE }}</option>
                                <option value="{{ getSeoUrl('recent_searches') }}">{{ RECENT_SEARCHES }}</option>
                            </select>
                        </div>
                    </div>
                    <div class="col-xs-12 col-md-2">
                        <div class="social">
                            @if(defined('FACEBOOK_PAGE_LINK') && FACEBOOK_PAGE_LINK != '#')
                                <a href="{{ FACEBOOK_PAGE_LINK }}" target="_blank"><i class="fa fa-facebook-f"></i>
                                    Facebook</a>
                            @endif
                            @if(defined('TWITTER_PAGE_LINK') && TWITTER_PAGE_LINK != '#')
                                <a href="{{ TWITTER_PAGE_LINK }}" target="_blank"><i class="fa fa-twitter"></i> Twitter</a>
                            @endif
                            @if(defined('GOOGLEPLUS_PAGE_LINK') && GOOGLEPLUS_PAGE_LINK != '#')
                                <a href="{{ GOOGLEPLUS_PAGE_LINK }}" target="_blank"><i class="fa fa-google-plus"></i>
                                    Google+</a>
                            @endif
                            @if(defined('YOUTUBE_PAGE_LINK') && YOUTUBE_PAGE_LINK != '#')
                                <a href="{{ YOUTUBE_PAGE_LINK }}" target="_blank"><i class="fa fa-youtube-play"></i>
                                    YouTube</a>
                            @endif
                        </div>
                    </div>
                </div>
            </div>
        </div>

    </footer>

@endsection
