@extends(ACTIVE_TEMPLATE.'.base')

@section('content')

    <div class="container">

        @if( isset($arrLeftCat) && is_array($arrLeftCat) && count($arrLeftCat) > 6 )
            <div class="row">
                <div class="col-xs-12">

                    <div class="heading">
                        <div class="line"></div>
                        <div class="text">{{ POPULAR }} <b>{{ CATEGORIES }}</b></div>
                    </div>

                </div>
            </div>

            @php( $arrCats = array_splice($arrLeftCat, 0, 12) )
            @foreach( $arrCats as $count => $cat )
                <div class="col-xs-6 col-sm-3 col-md-2">
                    <a href="{{ getCategoryPath($cat['ID'], $cat['FILENAME']) }}" class="popular-cat">
                        <div class="icon"><i class="{{ $cat['ICON_CSS_CLASS'] }}"></i></div>
                        <div>{{ $cat['TITLE'] }}</div>
                    </a>
                </div>
            @endforeach
        @endif


        <img src="{{ getResourceUrl('sale-banner.png', 'images', true) }}" class="img-responsive sale-banner"
             alt="{{ SCRIPT_COMPANY_NAME }}"
             title="{{ SCRIPT_COMPANY_NAME }}">


        <div class="row">
            <div class="col-xs-12">

                <div class="heading">
                    <div class="line"></div>
                    <div class="text">{{ POPULAR }} <b>{{ PRODUCTS }}</b></div>
                </div>

            </div>
        </div>

        @include(ACTIVE_TEMPLATE.'.prod-boxes', [ 'sectionCode' => 'PP', 'arrProds' => $prodPOP ])


        <div class="row">
            <div class="col-xs-12">

                <div class="heading">
                    <div class="line"></div>
                    <div class="text">{{ FEATURED }} <b>{{ PRODUCTS }}</b></div>
                </div>

            </div>
        </div>

        @include(ACTIVE_TEMPLATE.'.prod-boxes', [ 'sectionCode' => 'FP', 'arrProds' => $prodArr ])


        <div class="clearfix">&nbsp;</div>
        <div class="row mb-2">
            <div class="col-xs-12 hidden-sm col-md-4">
                {!! getBanner(1000, 'R1') !!}
            </div>
            <div class="col-xs-12 col-md-8">
                <div class="box box-newsletter">
                    <h2>{{ NEWSLETTER }}</h2>
                    <p>{{ SIGN_UP_FOR_NEWSLETTER_AUTO_POP_WRITEUP }}</p>
                    <input type="text" name="email" placeholder="{{ EMAIL_ADDRESS }}" onfocus="popNewsletter();"
                           autocomplete="off" class="form-control">
                    <button type="button" class="btn btn-primary" onclick="popNewsletter();">{{ SIGNUP }}</button>
                </div>
            </div>
        </div>

        @include('newsletter-popwin')

    </div>

@endsection

@push('footer-scripts')
<script type="text/javascript" src="{{ getResourceUrl('products_listing.js.php', 'js', false, false) }}"></script>
<script type="text/javascript" src="{{ getResourceUrl('products.js.php', 'js', false, false) }}"></script>
@endpush
