<!DOCTYPE html>
<html {!! $htmlLangAttrib !!}>
<head>
    <title>{{ $pageMetaTitle }}</title>
    <meta name="keywords" content="{{ $pageMetaKeywords }}">
    <meta name="description" content="{{ $pageMetaDescription }}">
    <meta name="ROBOTS" content="ALL">
    <meta name="GOOGLEBOT" content="{{ $pageMetaGoogleIndex }}, FOLLOW">
    <meta name="revisit-after" content="2 weeks">
    <meta http-equiv="Content-Type" content="text/html; charset={{ $pageMetaCharset }}">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=5">

    <link rel="manifest" href="<?= SCRIPT_ROOT ?>_app-manifest.json.php">

    @stack('meta-tags')

    <meta property="og:type" content="website">
    <meta property="og:title" content="{{ $pageMetaOpenGraphTitle }}">
    <meta property="og:description" content="{{ $pageMetaOpenGraphDescription }}">
    <meta property="og:url" content="{{ $pageMetaOpenGraphUrl }}">
    {!! $pageMetaOpenGraphImageTag !!}
    {!! $pageMetaOpenGraphAudioTag !!}
    {!! $pageMetaOpenGraphVideoTag !!}

    @if( $facebookAppId != '' )
        <meta property="fb:app_id" content="{{ $facebookAppId }}"/>
    @endif

    {!! $pageCanonicalTag !!}

    <link href="{{ getResourceUrl('favicon.ico', 'images') }}" rel="shortcut icon">

    @if (defined('SENTRY_JS_DSN') && SENTRY_JS_DSN != '')
        <script src="https://browser.sentry-cdn.com/4.6.4/bundle.min.js" crossorigin="anonymous"></script>
        <script type="text/javascript">
            Sentry.init({dsn: '{{ SENTRY_JS_DSN }}'});
        </script>
    @endif

    <script type="text/javascript">
        <!--
        var jsScriptRoot = '{{ SCRIPT_ROOT }}';
        //-->
    </script>

    <link href="{{ getResourceUrl('public.min.css', 'style', false) }}" rel="stylesheet" type="text/css"/>

    @if( $isRTL )
        <link href="{{ getResourceUrl('basic_rtl.min.css', 'style', false) }}" rel="stylesheet" type="text/css"/>
    @endif

    @if( defined('SEPARATE_CSS_FOR_EACH_SCREEN_SIZE') && SEPARATE_CSS_FOR_EACH_SCREEN_SIZE == 1 )
        <link rel="stylesheet" href="{{ getResourceUrl('style-commons.css', 'style', true) }}" type="text/css"/>
        <link rel="stylesheet" media="(min-width:1200px)" href="{{ getResourceUrl('style-large.css', 'style', true) }}"
              type="text/css"/>
        <link rel="stylesheet" media="(min-width:992px) and (max-width:1199px)"
              href="{{ getResourceUrl('style-desktop.css', 'style', true) }}" type="text/css"/>
        <link rel="stylesheet" media="(min-width:768px) and (max-width:991px)"
              href="{{ getResourceUrl('style-tablet.css', 'style', true) }}" type="text/css"/>
        <link rel="stylesheet" media="(min-width:414px) and (max-width:767px)"
              href="{{ getResourceUrl('style-mobile.css', 'style', true) }}" type="text/css"/>
        <link rel="stylesheet" media="(max-width:413px)"
              href="{{ getResourceUrl('style-mobile-small.css', 'style', true) }}" type="text/css"/>
    @else
        <link href="{{ getResourceUrl('style.min.css', 'style', true) }}" rel="stylesheet" type="text/css"/>
        @if( $isRTL )
            <link href="{{ getResourceUrl('style_rtl.min.css', 'style', true) }}" rel="stylesheet" type="text/css"/>
        @endif
    @endif

    @if( defined('LOAD_CUSTOM_CSS_FILE') && 1 == LOAD_CUSTOM_CSS_FILE )
        <link rel="stylesheet" href="{{ getResourceUrl('custom.css', 'style') }}" type="text/css"/>
    @endif

<!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
    <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
    <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->

    @stack('styles')

    <script type="text/javascript"
            src="{{ getResourceUrl('main' . (AJAX_USES_IFRAME == 1 ? '_if' : '') . '.js', 'js', false) }}"></script>

    @if( $doCallMasonry )
        <script type="text/javascript" src="{{ getResourceUrl('jquery.masonry.js', 'js/jquery', false) }}"></script>
    @endif

    @if( $doCallJScrolPage )
        <link type="text/css" href="{{ getResourceUrl('jquery.jscrollpane.css', 'style', false) }}" rel="stylesheet"
              media="all"/>
        <script type="text/javascript"
                src="{{ getResourceUrl('jquery.jscrollpane.min.js', 'js/jquery', false) }}"></script>
    @endif

    @if( $doCallCalendar )
        <link href='{{ getResourceUrl('jquery-ui.min.css', 'style', false) }}' rel='stylesheet' type='text/css'>
        <script type="text/javascript" src="{{ getResourceUrl('jquery-ui.min.js', 'js/jquery', false) }}"></script>
        <script type="text/javascript"
                src="{{ getResourceUrl('jquery-ui-datepicker-langs.js', 'js/jquery', false) }}"></script>
    @endif

    @if( $doCallLightbox )
        <link rel="stylesheet" type="text/css"
              href="{{ getResourceUrl('jquery.lightbox.css', 'js/jquery/lightbox/themes/carbono', false) }}"/>
        <!--[if IE 6]>
        <link rel="stylesheet" type="text/css"
              href="{{ getResourceUrl('jquery.lightbox.ie6.css', 'js/jquery/lightbox/themes/carbono', false) }}"/>
        <![endif]-->
        <script type="text/javascript"
                src="{{ getResourceUrl('jquery.lightbox.min.js', 'js/jquery/lightbox', false) }}"></script>
        <!-- called combined in the page's specific js (products.js.php) -->
        <script type="text/javascript">
            $(document).ready(function () {
                $('.lightbox').lightbox();
            });
        </script>
    @endif

    @if( defined('USE_SMART_IMAGES_LOADING') && USE_SMART_IMAGES_LOADING == 1 )
        <script type="text/javascript">
            <!--
            $(document).ready(function () {
                $.ajaxSetup({cache: true});
                loadScript('{{ getResourceUrl('jquery.unveil.js', 'js/jquery', false) }}', function () {
                    $("img").unveil();
                    $.ajaxSetup({cache: false});
                });
            });
            //-->
        </script>
    @endif

    @stack('header-scripts')

    {!! $prefs['GOOGLE_ANALYTICS_CODE'] !!}

    @if( file_exists(PATH . BLADE_TEMPLATES_PATH . '/header-analytics-tracking.blade.php') )
        @include('header-analytics-tracking')
    @endif

</head>

<body class="{{ $isIndexPage ? 'innerpageBody' : ''  }}">

<div id="fb-root"></div>

<form id="idAjaxForm" action="{{ SCRIPT_ROOT }}" style="display:none;"></form>

<div id="divFullBody" class="FullBody">

@hasSection('mobile-menu') @yield('mobile-menu') @else @include('mobile-menu') @endif

<!-- ===============================  Header Commons Ends Here ===============================  -->

@yield('template-content')

<!-- ===============================  Footer Commons Starts Here ===============================  -->

</div>

<div id="divTempConent" style="display:none;"></div>

@if( AJAX_USES_IFRAME == 1 )
    <iframe id="ifAjax" name="ifAjax" src="" frameborder=0 width=0 height=0 onload="ifAjaxOnLoad()"
            style="display:none;"></iframe>
    <div id="divAjax" style="display:none;">
        <form id="frmAjax"></form>
    </div>
@endif

@if( defined('IS_IN_DEMO_MODE') && IS_IN_DEMO_MODE == 1 && defined('SHOW_THEME_BUILDER') && 1 == SHOW_THEME_BUILDER && count($DEMO_INSTALLED_TEMPLATES) > 1 )
    @include('demo-theme-builder')
@endif

<script type="text/javascript"
        src="{{ getResourceUrl('kCommons.js.php?isMemberPage=' . $isMemberPage, 'js', false) }}"></script>

@if( cacheLivePart('show-newsletter-pop') )
    <script type="text/javascript">
        <!--
        try {
            window.onload = function () {
                window.setTimeout(function () {
                    popNewsletterAuto();
                }, 15000);
            };
        } catch (e) {
        }
        //-->
    </script>
@endif

@if( cacheLivePart('show-cookie-notice') )
    <script type="text/javascript">
        <!--
        $(document).ready(function () {
            html = "<div id='idCookieMsg' class='alert alert-cookie alert-info'>";
            html += "<button type=button class=close data-dismiss=alert aria-hidden=true onclick=cookiesMsgAccept()>&times;</button>";
            html += "{!! $cookiePolicyHtml !!}";
            html += "</div>";
            $('body').append(html);
        });
        function cookiesMsgAccept() {
            $('#idCookieMsg').slideUp();
            getContentFromUrl("{{ SCRIPT_ROOT }}cookies-accepted-ajax.php", null, "GET", "", "hidePop();");
        }
        //-->
    </script>
@endif

@if( defined('LOAD_CUSTOM_JS_FILE') && 1 == LOAD_CUSTOM_JS_FILE )
    <script type="text/javascript" src="{{ getResourceUrl('custom.js', 'js') }}"></script>
@endif

@stack('footer-scripts')

</body>

</html>