<!DOCTYPE html>
<html {!! $htmlLangAttrib !!}>
<head>
    <title>{{ $pageMetaTitle }}</title>
    <meta name="keywords" content="{{ $pageMetaKeywords }}">
    <meta name="description" content="{{ $pageMetaDescription }}">
    <meta name="ROBOTS" content="ALL">
    <meta name="GOOGLEBOT" content="{{ $pageMetaGoogleIndex }}, FOLLOW">
    <meta name="revisit-after" content="2 weeks">
    <meta http-equiv="Content-Type" content="text/html; charset={{ $pageMetaCharset }}">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

    <meta property="og:type" content="website">
    <meta property="og:title" content="{{ $pageMetaOpenGraphTitle }}">
    <meta property="og:description" content="{{ $pageMetaOpenGraphDescription }}">
    <meta property="og:url" content="{{ $pageMetaOpenGraphUrl }}">
    {!! $pageMetaOpenGraphImageTag !!}
    {!! $pageMetaOpenGraphAudioTag !!}
    {!! $pageMetaOpenGraphVideoTag !!}

    {!! $pageCanonicalTag !!}

    <link href="{{ getResourceUrl('favicon.ico', 'images') }}" rel="shortcut icon">

    <script type="text/javascript">
        <!--
        var jsScriptRoot = '{{ SCRIPT_ROOT }}';
        //-->
    </script>

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
    <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
    <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->

    <link href="{{ getResourceUrl('public.min.css', 'style', false) }}" rel="stylesheet" type="text/css"/>

    {!! $prefs['GOOGLE_ANALYTICS_CODE'] !!}

</head>

<body>

<div class="container">
    <div class="row">
        <div class="col" style="padding-top: 20px">

            {!! $contentHtml !!}

        </div>
    </div>
</div>

</body>

</html>