@extends(ACTIVE_TEMPLATE.'.base')

@section('content')

    <?php if ( $isInDemo ) { ?>
    <div style="text-align:right;margin-bottom:20px;">
        <a href="http://www.kaonsoftwares.com/contact-us.html" target="_blank"><button class="btn btn-danger">Click here to redirect to the KAON SOFTWARES contact form <span class="glyphicon glyphicon-new-window"></span></button></a>
    </div>
    <div class="alert alert-danger" style="font:14px/20px Verdana"><b>Below is just a demo form to show how it looks!</b><br>Your installed script will have a working form like this where visitors can contact you.</div>
    <?php } else { ?>
    <div class="alert alert-success"><?php echo IF_ANY_COMMENTS?></div>
    <?php } ?>

    <form id="idFrmContact" action="<?php echo SCRIPT_ROOT; ?>contactus_process.php" method="POST" onsubmit="return validateFormEx(this)" class="form-horizontal" role="form">
        <div class="form-group">
            <label for="idName" class="col-sm-4 control-label"><?php echo PERSON_NAME?></label>
            <div class="col-sm-8">
                <input type="text" class="form-control" id="idName" name="Name" value="<?php echo postVar('Name')?>" placeholder="<?php echo JSMSG_PLEASE_PROVIDE_NAME?>" required>
            </div>
        </div>
        <div class="form-group">
            <label for="idAddress" class="col-sm-4 control-label"><?php echo ADDRESS; ?></label>
            <div class="col-sm-8">
                <input type="text" class="form-control" id="idAddress" name="Address" value="<?php echo postVar('Address')?>" placeholder="<?php echo ADDRESS; ?>">
            </div>
        </div>
        <div class="form-group">
            <label for="idCity" class="col-sm-4 control-label"><?php echo CITY; ?></label>
            <div class="col-sm-8">
                <input type="text" class="form-control" id="idCity" name="City" value="<?php echo postVar('City', '', $locCity)?>" placeholder="<?php echo CITY; ?>">
            </div>
        </div>
        <div class="form-group">
            <label for="idCountry" class="col-sm-4 control-label"><?php echo COUNTRY; ?></label>
            <div class="col-sm-8">
                <?php echo  str_replace("class='effect'", "class='form-control'", countryDropDown(postVar('country', '', $locCountry))) ?>
            </div>
        </div>
        <div class="form-group">
            <label for="idPhone" class="col-sm-4 control-label"><?php echo PHONE; ?></label>
            <div class="col-sm-8">
                <input type="text" class="form-control" id="idPhone" name="Phone" value="<?php echo postVar('Phone')?>" placeholder="<?php echo PHONE; ?>">
            </div>
        </div>
        <div class="form-group">
            <label for="idEmail" class="col-sm-4 control-label"><?php echo EMAIL; ?></label>
            <div class="col-sm-8">
                <input type="email" class="form-control" id="idEmail" name="Email" value="<?php echo postVar('Email')?>" placeholder="<?php echo JSMSG_PLEASE_PROVIDE_EMAIL_ADDRESS?>" required>
            </div>
        </div>
        <div class="form-group">
            <label for="idSubject" class="col-sm-4 control-label"><?php echo TOPIC?></label>
            <div class="col-sm-8">
                <input type="text" class="form-control" id="idSubject" name="Subject" value="<?php echo postVar('Subject', '', $getSubject)?>" placeholder="<?php echo TOPIC?>">
            </div>
        </div>
        <div class="form-group">
            <label for="idQuery" class="col-sm-4 control-label"><?php echo QUERY?></label>
            <div class="col-sm-8">
                <textarea id="idQuery" name="Query" maxlength="255" class="form-control" rows="3" placeholder="<?php echo QUERY?>" required><?php echo postVar('Query', '', $getQuery, array('maxlen'=>255))?></textarea>
            </div>
        </div>
        <div class="form-group">
            <div class="col-sm-4"></div>
            <div class="col-sm-6">
                <?php showCaptcha(); ?>
            </div>
        </div>
        <div class="form-group">
            <div class="col-sm-12" style="text-align:right;">
                <button type="reset" class="btn btn-default btn-lg"><?php echo _RESET; ?></button>
                <button type="submit" class="btn btn-primary btn-lg"><?php echo SUBMIT; ?></button>
            </div>
        </div>
    </form>

@endsection

@push('footer-scripts')
<script type="text/javascript">
    <!--
    <?php if ( $isInDemo ) { ?>
    $("#idFrmContact *").attr("disabled", true);
    <?php } ?>

    function validateFormEx(frm)
    {
        if ( frm.Name.value == '' )
        {
            alert('<?php echo JSMSG_PLEASE_PROVIDE_NAME?>');
            frm.Name.focus();
            return false;
        }

        else if ( frm.Email.value == '' )
        {
            alert('<?php echo JSMSG_PLEASE_PROVIDE_EMAIL_ADDRESS?>');
            frm.Email.focus();
            return false;
        }

        else if ( frm.Query.value == '' )
        {
            alert('<?php echo JSMSG_PLEASE_PROVIDE_YOUR_QUERY?>');
            frm.Query.focus();
            return false;
        }

        return true;
    }
    //-->
</script>
@endpush
