<div class="TopThemesSelContainer hidden-xs">
    <div class="TopThemesSelBox">
        <b style="line-height:18px;">Change Theme: <font size="1">(for demo only)</font></b><br>
        <select class="effect" onchange="location.href='{{ SCRIPT_ROOT }}_theme.php?tt='+this.value;" title="Select theme">
            @foreach( $DEMO_INSTALLED_TEMPLATES as $templateThemeCode => $templateThemeName )
                <option value="{{ $templateThemeCode }}" {{ $templateThemeCode == $templateName . '~' . $themeName ? 'selected' : '' }}>{{ $templateThemeName }}</option>
            @endforeach
        </select>
        <span class="glyphicon glyphicon-cog" title="Customize Theme"
              style="font-size:14px;cursor:pointer;display:none;" id="idCustomizeThemeButton"></span>
    </div>
    <div class="TopThemesSelIcon">
        <img src="{{ getResourceUrl('icon-themes.png', 'images') }}" width="32" height="32" border="0"
             alt="Change Theme" title="Change Theme" style="margin-top:-2px;">
    </div>
</div>

@push('footer-scripts')
<script type="text/javascript">
    <!--
    var themeSelShown = false;
    $('.TopThemesSelIcon,.TopThemesSelBox').mouseenter(function () {
        $('.TopThemesSelContainer').animate({top: '0px'}, 300, 'swing');
        themeSelShown = true;
    });
    $('.TopThemesSelContainer').mouseleave(function () {
        themeSelShown = false;
        window.setTimeout('hideThemesSelector();', 2000);
    });
    function hideThemesSelector() {
        if (!themeSelShown) $('.TopThemesSelContainer').animate({top: '-40px'}, 300, 'swing');
    }
    //-->
</script>
@endpush

@if( file_exists(PATH . 'themes/' . $themeName . '/theme_builder_constants.php') )
    @php( include_once (PATH . 'themes/' . $themeName . '/theme_builder_constants.php') )
@endif

@if( defined('IS_BUILD_YOUR_THEME_AVAILABLE') && IS_BUILD_YOUR_THEME_AVAILABLE == 1 && count($BUILD_YOUR_THEME_COMPONENTS) > 0 )

    @push('styles')
    <link rel='stylesheet' href='{{ getResourceUrl('spectrum.css', 'style') }}'/>
    @endpush

    @push('header-scripts')
    <script src='{{ getResourceUrl('spectrum.js', 'js') }}'></script>
    @endpush

    <div class="TopThemesCustomizeController">
        <div style="height:7px;"></div>
        <b style="float:left;">Customize Your Theme</b>
        <span class="glyphicon glyphicon-remove-circle" style="font-size:16px;float:right;cursor:pointer;"
              onclick="$('.TopThemesCustomizeController').animate({top:'-360px'}, 300, 'swing');" title="Cancel"></span>
        <div style="clear:both;"></div>
        <div style="height:275px;margin:7px 0px;overflow:auto;text-align:left;">
            @foreach( $BUILD_YOUR_THEME_COMPONENTS as $key => $arr )
                <div style="height:10px;"></div>
                <div style="width:200px;float:left;line-height:25px;">{{ $arr['LABEL'] }} :</div>
                <div style="width:60px;float:right;">
                    <input type='text' id="idCustomClr_{{ $key }}">
                </div>
                <div style="clear:both;"></div>
                <script type="text/javascript">
                    <!--
                    var themeCustomClr_{{ $key }} = '{{ $arr['COLOR'] }}';
                    $("#idCustomClr_{{ $key }}").spectrum({
                        color: "{{ $arr['COLOR'] }}",
                        change: function (color) {
                            themeCustomClr_{{ $key }} = color.toHexString();
                            invalidateCustomDisplay();
                        }
                    });
                    //-->
                </script>
            @endforeach
        </div>
        <div style="text-align:right;">
            <div style="font:10px Arial;color:#A01111;float:left;">(To keep your changes, DONOT refresh the page)</div>
            <span class="glyphicon glyphicon-arrow-down" style="font-size:16px;cursor:pointer;display:none;"
                  onclick="$('.TopThemesCustomizeController').animate({top:'-10px'}, 300, 'swing');$('[rel=relHideOnPreview]').show();$('[rel=relShowOnPreview]').hide();"
                  title="Customize Your Theme" rel="relShowOnPreview"></span>
            <span class="glyphicon glyphicon-eye-open" style="font-size:16px;cursor:pointer;"
                  onclick="$('.TopThemesCustomizeController').animate({top:'-325px'}, 300, 'swing');$('[rel=relHideOnPreview]').hide();$('[rel=relShowOnPreview]').show();"
                  title="Preview Your Theme" rel="relHideOnPreview"></span>
            <span class="glyphicon glyphicon-save" style="font-size:16px;cursor:pointer;"
                  onclick="downloadCustomizedTheme();" title="Download Your Customized Theme File"
                  rel="relHideOnPreview"></span>
        </div>
    </div>

    @push('header-scripts')
    <script type="text/javascript">
        <!--
        $('#idCustomizeThemeButton').show();
        $('#idCustomizeThemeButton').click(function () {
            $('.TopThemesCustomizeController').animate({top: '-10px'}, 300, 'swing');
        });

        function invalidateCustomDisplay() {
            $('#idCustExtCss').remove();
            $('head').append("<link rel='stylesheet' id='idCustExtCss' href='" + getCustomizedCssFile() + "' type='text/css' />");
        }

        function getCustomizedCssFile() {
            var cssFilename = '{{ SCRIPT_ROOT }}_theme_custom_css.php?';
            @foreach( $BUILD_YOUR_THEME_COMPONENTS as $key => $arr )
                    cssFilename = cssFilename + '{{ substr($arr['COLOR'], 1) }}=' + encodeURIComponent(themeCustomClr_{{ $key }}) + '&';
            @endforeach
                    return cssFilename;
        }

        function downloadCustomizedTheme() {
            window.open(getCustomizedCssFile(), '_blank');
            alert('Please save this custom css file on your script at /themes/{{ $themeName }}/style/style.min.css');
        }
        //-->
    </script>
    @endpush

@endif