@extends(ACTIVE_TEMPLATE.'.base')

@section('content')

    <div class="row">
        <div class="col-xs-12 col-md-offset-2 col-md-8">

            <form name="Visitor" action="controller.php" method="POST" onsubmit="return validateFormEx(this);" class="form-horizontal" role="form">
                <input type="hidden" name="task"   value="Visitor">
                <input type="hidden" name="refer"  value="<?php echo $return?>">
                <input type="hidden" name="action" value="Add">
                <input type="hidden" name="return" value="<?php echo getSeoUrl('member_register', 'return='.urlencode($return).'&')?>">

                <div class="panel panel-default panel-primary">
                    <div class="panel-heading"><h2><?php echo NEW_VISITOR_REGISTERATION_FORM?></h2></div>
                    <div class="panel-body">

                        <div class="form-group">
                            <label for="idEmail" class="col-sm-4 control-label"><?php echo EMAIL; ?></label>
                            <div class="col-sm-8">
                                <input type="email" class="form-control" id="idEmail" name="email" value="<?php echo postVar('email')?>" required>
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="idPassword" class="col-sm-4 control-label"><?php echo PASSWORD?></label>
                            <div class="col-sm-8">
                                <input type="password" class="form-control" id="idPassword" name="password" required>
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="idCfmPassword" class="col-sm-4 control-label"><?php echo CONFIRM_PASSWORD?></label>
                            <div class="col-sm-8">
                                <input type="password" class="form-control" id="idCfmPassword" name="confirmPassword" required>
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="idName" class="col-sm-4 control-label"><?php echo PERSON_NAME?></label>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="idName" name="name" value="<?php echo postVar('name')?>" required>
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="idAddress" class="col-sm-4 control-label"><?php echo ADDRESS; ?></label>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="idAddress" name="address" value="<?php echo postVar('address', '', '', array('maxlen'=>255))?>">
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="idCity" class="col-sm-4 control-label"><?php echo CITY; ?></label>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="idCity" name="city" value="<?php echo postVar('city', '', $locCity)?>">
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="idState" class="col-sm-4 control-label"><?php echo STATE; ?></label>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="idState" name="state" value="<?php echo postVar('state')?>">
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="idCountry" class="col-sm-4 control-label"><?php echo COUNTRY; ?></label>
                            <div class="col-sm-8">
                                <?php echo  str_replace("class='effect'", "class='form-control'", countryDropDown(postVar('country', '', $locCountry))) ?>
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="idZip" class="col-sm-4 control-label"><?php echo ZIP?></label>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="idZip" name="zip" value="<?php echo postVar('zip', '', $locZip, array('maxlen'=>255))?>">
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="idPhone" class="col-sm-4 control-label"><?php echo PHONE; ?></label>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="idPhone" name="phone" value="<?php echo postVar('phone')?>">
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="idMobile" class="col-sm-4 control-label"><?php echo MOBILE?></label>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="idMobile" name="mobile" value="<?php echo postVar('mobile')?>">
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-sm-6 col-sm-offset-4">
                                <?php showCaptcha() ?>
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-sm-12" style="text-align:center;">
                                <input type="checkbox" name="tosAgree" id="tosAgree" value="Y"> <label for="tosAgree"><?php echo str_replace('{A_HREF}', "<a href='".getSeoUrl('termsofuse')."' class='link' target='_blank'>", I_AGREE_TO_THE_TERMS_AND_CONDITIONS)?></label>
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-sm-12" style="text-align:right;">
                                <button type="reset" class="btn btn-default btn-lg"><?php echo _RESET; ?></button>
                                <button type="submit" class="btn btn-primary btn-lg"><?php echo REGISTER?></button>
                            </div>
                        </div>

                    </div>

                    <div class="panel-footer">
                        <div class="DivRow">
                            <div style="text-align:center;">
                                <b> |
                                    <a href="<?php echo getSeoUrl('member_login', 'return='.urlencode(getVar('return', 'url')))?>" class="link"><?php echo LOGIN?></a> |
                                    <a href="<?php echo getSeoUrl('member_forgot_pwd_form', 'return='.urlencode(getVar('return', 'url')))?>" class="link"><?php echo FORGOT_PASSWORD?></a> |
                                    <a href="<?php echo getSeoUrl('member_verify_email')?>" class="link"><?php echo VERIFY_EMAIL_ADDRESS?></a> |
                                </b>
                            </div>
                        </div>
                    </div>

                </div>

            </form>

        </div>
    </div>

@endsection

@push('footer-scripts')
<script type="text/javascript" language="JavaScript" src="<?php echo getResourceUrl('register.js.php', 'js', false, false)?>"></script>
@endpush
