@extends('member_base')

@section('member_page_content')

    <div class="row">
        <?php if ( defined('IS_SELL_YOURS_INSTALLED') && IS_SELL_YOURS_INSTALLED == 1 ) { ?>
        <div class="col-xs-12">
            <div style="text-align:center"><a
                        href="<?php echo SCRIPT_ROOT . 'merchant/merchant_welcome.' . EXTENSION; ?>" class="linkBold"
                        style="font:18px/30px Verdana;"><?php echo YOUR_SELLING_STORE_DASHBOARD; ?> &raquo;</a></div>
        </div>
        <div style="clear:both"></div>
        <?php } ?>

        <?php if ( defined('IS_SHOPPING_CART_INSTALLED') && IS_SHOPPING_CART_INSTALLED == 1 && $reviewOrderId > 0 && $reviewStoreId > 0 ) { ?>
        <div class="col-xs-12">
            <div style="text-align:center"><a
                        href="<?php echo SCRIPT_ROOT . 'user_rating.php?userId=' . $reviewStoreId . '&orderId=' . $reviewOrderId . '#write'; ?>"
                        class="linkBold"
                        style="font:18px/30px Verdana;"><?php echo str_replace('{merchantName}', getColumn('USERINFO', $reviewStoreId, 'NAME', 'USERID'), str_replace('{orderNo}', $reviewOrderId, REVIEW_MERCHANT_AFTER_ORDER)); ?> &raquo;</a>
            </div>
        </div>
        <div style="clear:both"></div>
        <?php } ?>

        <div class="col-xs-12 col-md-6">
            <div style="font:bold 18px Verdana; color:#4C4C4C; text-align:left"><?= WELCOME?> <?php echo sessionVar('visitorName')?></div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-6 col-ld-6">
            <div style="font:12px Verdana; color:#4C4C4C; text-align:right;"><?php echo LAST_LOGIN?>
                : <?php echo $lastLogin ?></div>
        </div>
        <div style="clear:both; height:10px;"></div>

        <div style="padding:0px 12px;">
            <div class="col-xs-12 col-sm-6 col-md-3 col-ld-3" style="padding:0px 15px;">
                <div class="MemberBox GradDark2">
                    <div class="Heading"><?php echo YOUR_PRODUCT_RATINGS?></div>
                    <?php
                    $tot = 0;
                    $res = preparedQuery("SELECT P.ID, P.CATEGORY_ID, P.TITLE, P.FILENAME, PR.RATING FROM " . PREFIX . "PRODUCT_RATING PR, " . PREFIX . "PRODUCT P WHERE PR.USERID = ? AND P.ID=PR.PRODUCT_ID AND P.ISVALID='Y' ORDER BY PR.DATE_ADDED DESC LIMIT 4", array($visitorId));
                    while ( ($row = getRow($res)) )
                    {
                    $tot++;
                    $prLink = SCRIPT_ROOT . 'product_rating.php?productId=' . $row['ID'];
                    ?>
                    <div class="MemberBoxItem" style="cursor:pointer;" onclick="location.href='<?php echo $prLink?>'">
                        <div style="width:40px; margin-top:4px; margin-left:10px; margin-right:10px; float:left;">
                            <?php echo getProductThumbnail($row['ID'], $prLink, $row['FILENAME'], $row['CATEGORY_ID'], 40, 40, '', '', '', '', $row['FILENAME'])?>
                        </div>
                        <div style="width:150px; padding-top:5px; line-height:18px; float:left;">
                            <div class='tiny TxtOverflowControl'
                                 style="height:18px;"><?php echo strip_tags($row['TITLE'])?></div>
                            <font class='tiny'><?php echo YOUR_RATING?>
                                : <?php echo getRatingStars($row['RATING'], 7, 13, 'Sm')?></font>
                        </div>
                        <div style="clear:both;"></div>
                    </div>
                    <?php
                    }

                    if ($tot == 0) {
                        $tot++;
                        echo '<div class="MemberBoxItem"><div style="padding:5px; text-align:center;">' . YOU_HAVE_NOT_REVIEWED_ANY_PRODUCT . '</div></div>';
                    }

                    for ($i = 0; $i < 4 - $tot; $i++)
                        echo '<div class="MemberBoxItem">&nbsp;</div>';

                    echo '<div class="SeeMore"><a href="' . SCRIPT_ROOT . 'member_product_rating.php">' . SEE_ALL_RATINGS . '</a></div>';
                    ?>
                </div>
            </div>
            <div class="col-xs-12 col-sm-6 col-md-3 col-ld-3">
                <div class="MemberBox GradDark2">
                    <div class="Heading"><?php echo YOUR_STORE_RATINGS?></div>
                    <?php
                    $tot = 0;
                    $res = preparedQuery("SELECT UI.USERID, UI.NAME, UR.RATING FROM " . PREFIX . "USER_RATING UR, " . PREFIX . "USERINFO UI WHERE UR.USERID = ? AND UI.USERID=UR.MERCHANTID ORDER BY UR.DATE_ADDED DESC LIMIT 4", array($visitorId));
                    while ( ($row = getRow($res)) )
                    {
                    $tot++;
                    $urLink = SCRIPT_ROOT . 'user_rating.php?userId=' . $row['USERID'];
                    ?>
                    <div class="MemberBoxItem" style="cursor:pointer;" onclick="location.href='<?php echo $urLink?>'">
                        <div style="width:100px; margin-top:7px; margin-left:10px; margin-right:10px; text-align:center; float:left;">
                            <img src="<?php echo getMerchantLogoThumbUrl($row['USERID'], '', 30, $row['NAME'])?>"
                                 border="0" height="30" alt="<?php echo $row['NAME']?>"
                                 title="<?php echo $row['NAME']?>">
                        </div>
                        <div style="width:90px; padding-top:5px; line-height:18px; float:left;">
                            <font class='tiny'><?php echo YOUR_RATING?>
                                :<br><?php echo getRatingStars($row['RATING'], 7, 13, 'Sm')?></font>
                        </div>
                        <div style="clear:both;"></div>
                    </div>
                    <?php
                    }

                    if ($tot == 0) {
                        $tot++;
                        echo '<div class="MemberBoxItem"><div style="padding:5px; text-align:center;">' . YOU_HAVE_NOT_REVIEWED_ANY_STORE . '</div></div>';
                    }

                    for ($i = 0; $i < 4 - $tot; $i++)
                        echo '<div class="MemberBoxItem">&nbsp;</div>';

                    echo '<div class="SeeMore"><a href="' . SCRIPT_ROOT . 'member_user_rating.php">' . SEE_ALL_RATINGS . '</a></div>';
                    ?>
                </div>
            </div>
            <div class="col-xs-12 col-sm-6 col-md-3 col-ld-3">
                <div class="MemberBox GradDark4">
                    <div class="Heading"><?php echo YOUR_WISHLIST?></div>
                    <?php
                    $tot = 0;
                    $res = preparedQuery("SELECT P.ID, P.CATEGORY_ID, P.TITLE, P.FILENAME, PL.NAME, P.MIN_PRICE, P.MAX_PRICE FROM " . PREFIX . "VISITOR_PRODUCT_LIST PL, " . PREFIX . "PRODUCT P WHERE PL.USERID = ? AND P.ID=PL.PRODUCT_ID AND P.ISVALID='Y' LIMIT 4", array($visitorId));
                    while ( ($row = getRow($res)) )
                    {
                    $tot++;
                    $prLink = SCRIPT_ROOT . 'member_productlist.php';
                    ?>
                    <div class="MemberBoxItem" style="cursor:pointer;" onclick="location.href='<?php echo $prLink?>'">
                        <div style="width:40px; margin-top:4px; margin-left:10px; margin-right:10px; float:left;">
                            <?php echo getProductThumbnail($row['ID'], $prLink, $row['FILENAME'], $row['CATEGORY_ID'], 40, 40, '', '', '', '', $row['FILENAME'])?>
                        </div>
                        <div style="width:150px; padding-top:5px; line-height:18px; float:left;">
                            <div class='tiny TxtOverflowControl'
                                 style="height:18px"><?php echo strip_tags($row['TITLE'])?></div>
                            <font class='tiny'
                                  style="color:#AA0101"><?php echo getFormattedPrice($row['MIN_PRICE'], $currencySymbol, $currencyRate)?>
                                - <?php echo getFormattedPrice($row['MAX_PRICE'], $currencySymbol, $currencyRate)?></font>
                        </div>
                        <div style="clear:both;"></div>
                    </div>
                    <?php
                    }

                    if ($tot == 0) {
                        $tot++;
                        echo '<div class="MemberBoxItem"><div style="padding:px; text-align:center;">' . YOU_HAVE_NOT_ADDED_ANY_PRODUCT_TO_YOUR_WISHLIST . '</div></div>';
                    }

                    for ($i = 0; $i < 4 - $tot; $i++)
                        echo '<div class="MemberBoxItem">&nbsp;</div>';

                    echo '<div class="SeeMore"><a href="' . SCRIPT_ROOT . 'member_productlist.php">' . MORE_WISHLIST . '</a></div>';
                    ?>
                </div>
            </div>
            <div class="col-xs-12 col-sm-6 col-md-3 col-ld-3">
                <div class="MemberBox GradDark4">
                    <div class="Heading"><?php echo YOUR_PRICE_ALERTS?></div>
                    <?php
                    $tot = 0;
                    $res = preparedQuery("SELECT P.ID, P.CATEGORY_ID, P.TITLE, P.FILENAME, PA.MIN_PRICE FROM " . PREFIX . "PRICE_ALERT PA, " . PREFIX . "PRODUCT P WHERE PA.EMAIL = ? AND P.ID=PA.PRODUCT_ID AND P.ISVALID='Y' ORDER BY PA.CREATED_ON DESC LIMIT 4", array($visitorEmail));
                    while ( ($row = getRow($res)) )
                    {
                    $tot++;
                    $prLink = SCRIPT_ROOT . 'member_price_alerts.php';
                    ?>
                    <div class="MemberBoxItem" style="cursor:pointer;" onclick="location.href='<?php echo $prLink?>'">
                        <div style="width:40px; margin-top:4px; margin-left:10px; margin-right:10px; float:left;">
                            <?php echo getProductThumbnail($row['ID'], $prLink, $row['FILENAME'], $row['CATEGORY_ID'], 40, 40, '', '', '', '', $row['FILENAME'])?>
                        </div>
                        <div style="width:150px; padding-top:5px; line-height:18px; float:left;">
                            <div class='tiny TxtOverflowControl'
                                 style="height:18px;"><?php echo strip_tags($row['TITLE'])?></div>
                            <div class="tiny" style="text-align:right;">
                                <font style="font-size:9px;"><?php echo YOUR_PRICE?>:</font>
                                <font style="font-size:11px; color:#AA0101"><?php echo getFormattedPrice($row['MIN_PRICE'], $currencySymbol, $currencyRate)?></font>
                            </div>
                        </div>
                        <div style="clear:both;"></div>
                    </div>
                    <?php
                    }

                    if ($tot == 0) {
                        $tot++;
                        echo '<div class="MemberBoxItem"><div style="padding:px; text-align:center;">' . YOU_HAVE_NOT_ADDED_ANY_PRICE_ALERTS . '</div></div>';
                    }

                    for ($i = 0; $i < 4 - $tot; $i++)
                        echo '<div class="MemberBoxItem">&nbsp;</div>';

                    echo '<div class="SeeMore"><a href="' . SCRIPT_ROOT . 'member_price_alerts.php">' . MORE_PRICE_ALERTS . '</a></div>';
                    ?>
                </div>
            </div>
        </div>
        <div style="clear:both; height:10px;"></div>

        <div class="col-xs-12 col-sm-12 col-md-12 col-ld-12">
            <center><font class='normal'><?php echo PLEASE_USE_LINKS?></font></center>
        </div>
        <div style="clear:both; height:10px;"></div>
    </div>

@endsection
