@extends('merchants.base')

@section('content')

    <h1>{{ BECOME_A_FEATURED_MERCHANT }}</h1>

    {{ PAGE_WRITEUP }}
    <br><br>

    @if( $userRec['ISFEATURED'] == 'Y' )
        {{ YOU_ARE_ALREADY_FEATURED }}
    @elseif( $userRec['ISFEATURED_REQUESTED'] == 'Y' )
        {{ YOU_HAVE_ALREADY_SENT_FEATURED_REQUEST }}
    @else
        <div class="row">
            <div class="col-xs-12 col-md-offset-3 col-md-6">

                <form name="F" method=post action="merchant_controller.php" onsubmit="return validateForm(this);">
                    <input type=hidden name="task" value="Merchant">
                    <input type=hidden name="action" value="BecomeFeaturedPayment">
                    <input type=hidden name="return" value="merchant_become_featured.php?">

                    @if( $featuredFee > 0 )
                        <table width="100%" cellspacing="1" cellpadding="5" align="center" class="table">
                            <tr>
                                <td colspan="2" class="td">
                                    <b><?php echo FEATURED_MERCHANT_FEE?>
                                        :</b> <?php echo getFormattedPrice($featuredFee, SCRIPT_DOLLAR)?>
                                </td>
                            </tr>

                            <tr>
                                <td class="td" colspan="2" height="4"><b><?php echo SELECT_A_PAYMENT_OPTION?></b></td>
                            </tr>
                        </table>

                        @include('merchants.payment-methods', [
                                'paymentMethodFieldName' => 'paymentMethod',
                            ])

                    @else

                        <div class="alert alert-success">{{ REQUEST_FOR_FEATURED_MERCHANT }}</div>

                    @endif

                    <br>

                    <table width="100%" cellspacing="1" cellpadding="5" align="center" class="table">
                        <tr>
                            <td class="td" align="center">
                                <input type="submit" id="idPaymentSubmit" value="{{ _CONTINUE }}" class="baseeffect">
                            </td>
                        </tr>
                    </table>

                </form>

            </div>
        </div>

    @endif

@endsection
