@extends('merchants.base')

@section('merchant-content')

    <h1>{{ MERCHANT_PRODUCT_SALES_PAYMENT }}</h1>

    <div class="row">
        <div class="col-xs-12 col-md-offset-3 col-md-6">

            <form name="F" method=post action="merchant_user_product_sales_controller.php"
                  onsubmit="return validateForm(this);">
                <input type=hidden name="task" value="Payment">
                <input type=hidden name="action" value="Make">
                <input type=hidden name="return" value="merchant_user_product_sales_payment.php?">
                <table width="400" cellspacing="1" cellpadding="5" align="center" class="table">
                    <?php
                    // Find total approved commissions
                    $res = preparedQuery("SELECT SUM(COMMISSION_AMOUNT) AS AMT FROM " . PREFIX . "USER_PRODUCT_SALE WHERE MERCHANTID = ? AND APPROVED='Y'", array($merchantId));
                    $row = getRow($res);
                    $tac = (float)$row['AMT'];

                    // Find total payments made
                    $res = preparedQuery("SELECT SUM(AMOUNT) AS AMT FROM " . PREFIX . "USER_PRODUCT_SALE_PAYMENT WHERE MERCHANTID = ? AND AMOUNT>0", array($merchantId));
                    $row = getRow($res);
                    $top = (float)$row['AMT'];

                    $pay = $top - $tac < 0 ? $top - $tac : 0;
                    ?>
                    <tr>
                        <th class="th" colspan="2">
                            <?php echo YOUR_AMOUNT_DUE_IS?> <?php echo getFormattedPrice($pay, SCRIPT_DOLLAR, 1)?>
                        </th>
                    </tr>
                    <tr>
                        <td class="td" width="50%" align="right"><?php echo AMOUNT_TO_BE_PAYED?> :</td>
                        <td class="td"
                            width="50%"><?php echo showPriceInputField('amount', $pay, 5, 10, 'effect', 'alt="numeric"')?></td>
                    </tr>
                    <tr>
                        <th class="th" colspan="2" height="4"></th>
                    </tr>
                    <tr>
                        <td class="td" colspan="2" height="4"><b><?php echo SELECT_A_PAYMENT_OPTION?></b></td>
                    </tr>

                    @include('merchants.payment-methods')

                    <tr>
                        <td class="td" align="center" colspan="2">
                            <br>
                            <input type="submit" id="idPaymentSubmit" value="{{ MAKE_PAYMENT }}" class="baseeffectEx">
                        </td>
                    </tr>
                </table>
            </form>

            <br><br>

            <a href="merchant_user_product_sales.php"><img src="<?php echo SCRIPT_ROOT?>merchant/images/icon_back.gif"
                                                           border=0 alt=""
                                                           align="absmiddle"> <?php echo GO_BACK_SALES_PAGE?></a>

        </div>
    </div>

@endsection
