@extends(ACTIVE_TEMPLATE.'.base')

@section('content')

    @if( is_array($prodPOD) && count($prodPOD) > 0 )
        <div class="PODGrayArea">
            <div class="container">

                <div class="HeadingBar1">{{ PRODUCT_OF_THE_DAY }}</div>
                <div class="row">
                    <?php
                    for ( $i = 0; $i < 3; $i ++ )
                    {
                    $row = $prodPOD[ $i ];
                    if ( ! isset( $row['ID'] ) )
                        continue;
                    $rLink = getOneStoreRedirectLink( $row );
                    $pLink = $rLink != '' ? $rLink : getProductPath( $row['LINK_ID'] == '' ? $row['ID'] : $row['LINK_ID'], $row['PFILENAME'], $row['CATEGORY_ID'], $row['CFILENAME'], '', '', $row['API_TYPE'] );
                    $lTarg = $rLink == '' ? '' : 'target="_blank"';
                    ?>
                    <div class="col-xs-12 col-sm-4" itemscope itemtype="http://schema.org/Product">
                        <div class="DexPODBox">
                            <div class="GenericThumbBox">
                                <div>
                                    {!! getProductThumbnail($row['ID'], $pLink, $row['TITLE'], $row['CATEGORY_ID'], 350, 250, 'IndexPODThumb', '', '', $row['IMAGE_URL']) !!}
                                </div>
                            </div>
                            <a href="{{ $pLink }}" {{ $lTarg }} class="PODTitle"
                               title="{{ strip_tags($row['TITLE']) }}">
                                <div class="OverflowHidden" style="height:47px">{{ $row['TITLE'] }}</div>
                            </a>
                            <div class="PODDetail">
                                <div class="OverflowHidden"
                                     style="height:55px">{!! getPartialString($row['DETAIL'], 80) !!}</div>
                            </div>
                            <div class="PODPrice visible-xs">{{ getFormattedPrice($row['PRICE_MIN'], $currencySymbol, $currencyRate) }}</div>
                            <a href="{{ $pLink }}" {{ $lTarg }} class="visible-xs btn btn-sm btn-dark1"
                               style="float:right;margin-top:5px">{{ COMPARE_PRICE }}</a>
                            <div style="clear:both"></div>
                        </div>
                    </div>
                    <?php
                    }
                    ?>
                </div>
                <div style="clear:both;height:20px"></div>

            </div>
        </div>
    @endif

    <div class="container">
        <div class="row">

            @if( defined('IS_POPULAR_INSTALLED') && IS_POPULAR_INSTALLED == 1 && is_array($prodPOP) && count($prodPOP) > 0 )
                <div class="container">
                    <div class="HeadingBarLine"></div>
                    <div class="HeadingBar"><span>{{ POPULAR_PRODUCTS }}</span></div>
                    <div class="row">
                        <?php
                        $tot = 0;
                        foreach ( $prodPOP as $row )
                        {
                        if ( $tot ++ >= 12 )
                            break;
                        $rLink = getOneStoreRedirectLink( $row );
                        $pLink = $rLink != '' ? $rLink : getProductPath( $row['LINK_ID'] == '' ? $row['ID'] : $row['LINK_ID'], $row['PFILENAME'], $row['CATEGORY_ID'], $row['CFILENAME'], '', '', $row['API_TYPE'] );
                        $lTarg = $rLink == '' ? '' : 'target="_blank"';
                        ?>
                        <div class="col-xs-6 col-sm-3 PPBoxInvdividual" style="text-align:center;min-height:310px"
                             itemscope
                             itemtype="http://schema.org/Product">
                            {!! getProductThumbnail($row['ID'], $pLink, $row['TITLE'], $row['CATEGORY_ID'], 200, 200, 'IndexPPThumb', '', '', $row['IMAGE_URL']) !!}
                            <div class="DexPPBoxButton"><a href="{{ $pLink }}"
                                                           {{ $lTarg }} class="btn btn-sm btn-dark1">{{ COMPARE }}</a>
                            </div>
                            <a href="{{ $pLink }}" {{ $lTarg }} class="PPPTitle"
                               title="{{ strip_tags($row['TITLE']) }}">
                                <div class="OverflowHidden"
                                     style="height:40px;margin-bottom:2px">{{ $row['TITLE'] }}</div>
                            </a>
                            <div class='PPPrice'>{{ getFormattedPrice($row['PRICE_MIN'], $currencySymbol, $currencyRate) }}</div>
                        </div>
                        <?php
                        }
                        ?>
                    </div>
                    <div style="clear:both;height:20px"></div>
                </div>
            @endif

            @if( is_array($prodArr) && count($prodArr) > 0 )
                <div class="container">
                    <div class="HeadingBarLine"></div>
                    <div class="HeadingBar"><span>{{ FEATURED_PRODUCTS }}</span></div>
                    <?php
                    $tot = 0;
                    foreach ( $prodArr as $row )
                    {
                    if ( $tot ++ >= 6 )
                        break;
                    $rLink = getOneStoreRedirectLink( $row );
                    $pLink = $rLink != '' ? $rLink : getProductPath( $row['LINK_ID'] == '' ? $row['ID'] : $row['LINK_ID'], $row['PFILENAME'], $row['CATEGORY_ID'], $row['CFILENAME'], '', '', $row['API_TYPE'] );
                    $lTarg = $rLink == '' ? '' : 'target="_blank"';
                    ?>
                    <div class="col-xs-4 col-sm-2 PFBoxInvdividual" style="text-align:left" itemscope
                         itemtype="http://schema.org/Product">
                        {!! getProductThumbnail($row['ID'], $pLink, $row['TITLE'], $row['CATEGORY_ID'], 150, 150, 'IndexPFThumb', '', '', $row['IMAGE_URL']) !!}
                        <a href="{{ $pLink }}" {{ $lTarg }} class="PPTitle" title="{{ strip_tags($row['TITLE']) }}">
                            <div class="OverflowHidden" style="height:32px;margin-bottom:8px">{{ $row['TITLE'] }}</div>
                        </a>
                        <div class='PPrice'>{{ getFormattedPrice($row['PRICE_MIN'], $currencySymbol, $currencyRate) }}</div>
                        <a href="{{ $pLink }}" {{ $lTarg }} class="btn btn-sm btn-dark1 btn-pfdex">{{ COMPARE }}</a>
                    </div>
                    <?php
                    }
                    ?>
                    <div style="clear:both;height:20px"></div>
                </div>
            @endif

            <div class="hidden-xs">
                <div class="HeadingBarLine"></div>
                <div class="HeadingBar"><span>{{ BRANDS }}</span></div>
                <div class="col-sm-12">
                    <div style="width:100%;height:100px;overflow:hidden"
                         id="divBrandPanel">{!! getBrandPanel(0, 4, 140, 100) !!}</div>
                </div>
                <div style="clear:both;height:20px;"></div>
            </div>

            <div class="hidden-xs">
                <div class="col-sm-4">
                    <div class="HeadingBar2">{{ NEWS }}</div>
                    <div class="IndexBox">
                        <div style="height:160px;overflow:hidden">
                            <?php
                            if ( is_array( $newsArr ) )
                            {
                            $dex = 0;
                            foreach ( $newsArr as $rec )
                            {
                            if ( $dex ++ > 2 )
                                break;
                            ?>
                            <a href="{{ getNewsUrl($rec['ID'], $rec['FILENAME']) }}"
                               class="linkLarge">{{ $rec['HEADLINE'] }}</a>
                            <div style="height:5px;"></div>
                            <i style="font-size:10px;">{{ formatDateTime($rec['NEWS_DATE']) }}</i>
                            <div style="height:20px;"></div>
                            <?php
                            }
                            }
                            ?>
                        </div>
                    </div>
                </div>
                <div class="col-sm-4">
                    <div class="HeadingBar2">{{ TOP_SEARCHES }}</div>
                    <div class="IndexBox">
                        <div style="height:160px;overflow:hidden">
                            @if( is_array($searchCloudArr) )
                                @foreach( $searchCloudArr as $rec )
                                    <a href="{{ getSearchUrl($rec['T']) }}" class="linkSrchCloud"
                                       style="font-size:{{ $rec['C'] }}px;">{{ $rec['T'] }}</a> &nbsp;
                                @endforeach
                            @endif
                        </div>
                    </div>
                </div>
                <div class="col-sm-4">
                    <div class="HeadingBar2">{{ NEWSLETTER }}</div>
                    <div class="IndexBox">
                        <div style="text-align:left">{{ EMAIL_ADDRESS }}</div>
                        <div style="height:15px;"></div>
                        <input type="text" name="email" placeholder="{{ EMAIL_ADDRESS }}"
                               onfocus="popNewsletter();" autocomplete="off" class="form-control">
                        <div style="height:10px;"></div>
                        <div style="text-align:center">
                            <button type="button" class="btn btn-search"
                                    onclick="popNewsletter();">{{ SIGNUP }}</button>
                        </div>
                    </div>
                </div>
                <div style="clear:both;height:20px;"></div>

                <div id="idNLContent" style="display:none">

                    <div id="idNLMsgs" style="display:none"></div>

                    <form id="frmNewsletter" name="frmNewsletter" action="{{ SCRIPT_ROOT }}" method="POST"
                          onSubmit="return newsletterSubmitForm()" class="form-horizontal">
                        <input type="hidden" name="return" value="newsletter-subscribe.php?">
                        <input type="hidden" name="isSubscribed" value="Y">

                        <div class="form-group">
                            <label for="idNLEmail" class="col-sm-4 control-label">{{ EMAIL }}</label>
                            <div class="col-sm-8"><input type="email" class="form-control" id="idNLEmail" name="email"
                                                         placeholder="{{ JSMSG_PLEASE_PROVIDE_EMAIL_ADDRESS }}"
                                                         required></div>
                        </div>
                        <div class="form-group">
                            <label for="idFName" class="col-sm-4 control-label">{{ FIRST_NAME }}</label>
                            <div class="col-sm-8"><input type="text" class="form-control" id="idFName" name="fname"
                                                         placeholder="{{ JSMSG_PLEASE_PROVIDE_FIRST_NAME }}">
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="idLName" class="col-sm-4 control-label">{{ LAST_NAME }}</label>
                            <div class="col-sm-8"><input type="text" class="form-control" id="idLName" name="lname"
                                                         placeholder="{{ JSMSG_PLEASE_PROVIDE_LAST_NAME }}">
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-sm-8 col-sm-offset-4">
                                <!-- Commented below so that the actual script does not get called here, and we can call it in pop-win for the 1st time -->
                            <!--GOOGLE_RECAPTCHA_START <?php showCaptcha() ?> GOOGLE_RECAPTCHA_END-->
                            </div>
                        </div>
                        <?php
                        $resNL = executeQuery( "SELECT ID, TITLE FROM " . PREFIX . "MAILINGLIST_CATEGORY WHERE ISVALID='Y' ORDER BY TITLE" );
                        if ( getTotalRows( $resNL ) > 1 )
                        {
                        ?>
                        <div class="form-group">
                            <label for="idCats" class="col-sm-4 control-label">{{ MAILING_CATEGORIES }}</label>
                            <div class="col-sm-8">
                                <select name="categories[]" size="5" class="effect" multiple style="width:200px;">
                                    @while( $rowNL = getRow($resNL) )
                                        <option value="{{ $rowNL['ID'] }}">{{ $rowNL['TITLE'] }}</option>
                                    @endwhile
                                </select>
                            </div>
                        </div>
                        <?php
                        }
                        else
                        {
                        if ( ( $rowNL = getRow( $resNL ) ) )
                        {
                        ?>
                        <input type="hidden" name="categories[]" value="{{ $rowNL['ID'] }}">
                        <?php
                        }
                        }
                        ?>

                    </form>

                    <script type="text/javascript">
                        <!--
                        function newsletterSubmitForm() {
                            newsletterSubmit();
                            return false;
                        }
                        //-->
                    </script>

                    <div style="clear:both;"></div>
                </div>

                @if( defined('IS_CASHBACK_INSTALLED') && IS_CASHBACK_INSTALLED == 1 )
                    <?php $popcb_outerCssClass = 'col-sm-6 col-lg-4'; ?>
                    <?php $popcb_innerCssClass = 'well well-white'; ?>
                    <div class="col-xs-12">
                        <div style="text-align:left;">
                            <h3>{{ POPULAR_CASHBACKS }}</h3>
                            <?php include( PATH . 'member_cashback_index_popular.php' ); ?>
                        </div>
                    </div>
                    <div style="clear:both;height:20px;"></div>
                @endif

            </div>

            @if( defined('IS_COUPONS_INSTALLED') && IS_COUPONS_INSTALLED == 1 )
                <?php $fcoup_outerCssClass = 'col-sm-6 col-lg-4'; ?>
                <?php $fcoup_innerCssClass = 'well well-white'; ?>
                <?php include( PATH . 'coupons_index_featured.php' ); ?>
            @endif
        </div>
    </div>

@endsection
