@extends(ACTIVE_TEMPLATE.'.base')

@section('content')

    <div class="row">

        <div class="col-xs-12">
            <div class="well ProdBoxWell"><h1><?php echo REVIEWS_ON_PRODUCT . $prod['TITLE']?></h1></div>
        </div>

        <div class="col-xs-12 col-md-3 pull-right">
            <div class="well">
                <div class="ProdThumbBox" style="margin:auto;">
                    <?php echo getProductThumbnail($productId, $productLink, $prod['TITLE'], $categoryId, 150, 150, '', '', '', $apiType == API_TYPE_MYSQL ? '' : ($productThumbUrl == '' ? $productImageUrl : $productThumbUrl), $productFilename)?>
                </div>
                <br>
                <div style="text-align:left; line-height:25px; text-align:center;">
                    <b><?php echo AVERAGE?>
                        :</b> <?php echo getProductRating($productId, $prod['PRODUCT_RATING'], $productFilename, $categoryId, $categoryFilename, '', $apiType)?>
                    <font size=1><?php echo $prod['PRODUCT_RATING'] < 0 ? '' : $prod['PRODUCT_RATING'] . '/10'?></font>
                    <br>
                    <?php echo TOTAL?> <?php echo $totReviews?> <?php echo REVIEW_S?><br>
                    <br>
                    <?php if ( $apiType == API_TYPE_MYSQL ) { ?>
                    <a href="javascript:showReviewBox();">
                        <button class="btn btn-lg btn-dark2"><span
                                    class="glyphicon glyphicon-edit"></span> <?php echo REVIEW?></button>
                    </a>
                    <?php } ?>
                </div>
            </div>
        </div>

        <div class="col-xs-12 col-md-9">
            <?php
            foreach ( $ratingArr as $row )
            {
            ?>
            <div class="well">
                <div class="col-xs-12 col-md-9">
                    <?php echo isset($row['TITLE']) ? '<h2>' . $row['TITLE'] . '</h2>' : ''?>
                    <?php echo BY?> <b><?php echo $row['NAME']?></b>
                    <?php echo $row['LOCATION'] == '' ? '' : '(' . FROM . ' <b>' . $row['LOCATION'] . '</b>)'?>
                    <?php echo ON?> <b><i><?php echo formatDate($row['DATE_ADDED'])?></i></b>
                </div>
                <div class="col-xs-12 col-md-3">
                    <?php echo getProductRating($productId, $row['RATING'], $prod['FILENAME'], $prod['CATEGORY_ID'], '', '', $apiType)?>
                    <?php echo $row['RATING']?>/10
                </div>
                <div class="col-xs-12">
                    <div class="DivHr"></div>
                    <?php echo nl2br($row['REVIEW']) ?>
                </div>
                <div style="clear:both;"></div>
            </div>
            <?php
            }

            if ( $totReviews == 0 )
            {
            ?>
            <div class="well"><?php echo NO_REVIEW_FOUND?></div>
            <div style="clear:both;height:10px"></div>
            <?php
            }
            ?>

            <div class="text-center">
                <div style="clear:both;height:10px"></div>
                @if($prod['STORE_COUNT'] > 0)
                    <a href="{{ getSeoUrl('redirect', 'prod_id='.$prod['ID'].'&amp;isProduct=Y&amp;isBuy=Y') }}"
                       target="_blank">
                        <button type="button"
                                class="btn btn-dark1">{!! MIN_PRICE. ' <b>' . getFormattedPrice($prod['MIN_PRICE'], $currencySymbol, $currencyRate). '</b> - '.GO_TO_STORE !!}
                            <i class="fa fa-arrow-right"></i></button>
                    </a>
                    <div style="clear:both;height:10px"></div>
                @endif
                <a href="{{ $productLink }}">
                    <button type="button" class="btn btn-dark1"><i
                                class="fa fa-arrow-left"></i> {{ BACK_TO . ' ' . $prod['TITLE'] }}</button>
                </a>
                <div style="clear:both;height:10px"></div>
            </div>

        </div>

    </div>

    <script type="text/javascript" language="JavaScript"
            src="<?php echo getResourceUrl('product_rating.js.php?productId=' . $productId, 'js', false, false)?>"></script>

@endsection
