<?php
// Get the data
$data = require( PATH . 'products_price_history_graph_data.php' );

// If no data then show banner
if ( ! is_array( $data ) || count( $data ) < 1 ) {
    echo '<div class="text-center">' . getBanner( 1000, 'R1', $categoryTitle ) . '</div>';
} // End-if

// Draw the chart
else {
    drawLineChart( [
            'id'           => 'prHistGr',
            'title'        => 'Price History Graph',
            'main_label'   => 'Day',
            'width'        => 320,
            'height'       => 220,
            'chart_area'   => [
                    'left'   => '10%',
                    'top'    => '15%',
                    'width'  => '90%',
                    'height' => '70%',
            ],
            'value_labels' => [ MIN_PRICE, MAX_PRICE, AVG_PRICE ],
            'data'         => $data,
    ] );
}
